package jastex;

import java.io.*;
import java.util.*;

import jastex.*;
import jastex.old.gui.MainWindow;


public class Configuration {
    public static String language = "english";
    public static String antialiasing = "on";
    public static String modedebug = "off";
    public static String lowXServerMode = "off";
    public static String magneticGrid = "on";
    public static double tailleGrille = 4;
    public static String splash="on";
    public static String snapToGrid="off";
    public static double scale = 1;
    public static double unitLength = 1.0;
    public static String unitName = "cm";
    public static String latexCmd = "latex";
    public static boolean enableLH = true;
    public static boolean oldparsing = false;

    //For Gastex Code Generation
    public static double ratioJ2G = 3.83;
    public static double roundDecal = 100.0;

    public Configuration (String confFile) {
	loadConfiguration(confFile);
    }
    public Configuration () {
    }
    public static void loadConfiguration(String confFile) {
    	Properties prop;
	InputStream is = null;
	
	if (MainWindow.isAppli) {
	    try {
		is = new FileInputStream(confFile);
	    } catch (FileNotFoundException e) {
		return;
	    }
	} else {
	    is = Configuration.class.getResourceAsStream(confFile);
	}
	prop = new Properties();
       
	try {
	    prop.load(is);
	} catch (IOException e) {
	    try { is.close(); } catch (IOException e1) {}
	    return;
	}
     	loadProperties(prop);
	try { is.close(); } catch (IOException e1) {}
	return;	
    }
    
    public static void loadProperties(Properties prop) {
	language = prop.getProperty("language", language);

	// Teo property
	String temp="";
	antialiasing = prop.getProperty("antialiasing", antialiasing);
	modedebug = prop.getProperty("modedebug", modedebug);
	lowXServerMode = prop.getProperty("lowXServerMode", lowXServerMode);
	magneticGrid = prop.getProperty("magneticGrid", magneticGrid);
	temp= prop.getProperty("gridWH", temp);
	try {
	    tailleGrille=Double.parseDouble(temp);
	    //(double) (new Integer(temp).intValue());
	} catch (Exception e) { 

	    tailleGrille=10;
	    System.out.println("--- ---");
	}
	splash=prop.getProperty("splash", splash);
	snapToGrid=prop.getProperty("snapToGrid", snapToGrid);
	
	temp= prop.getProperty("unitLength", temp);
	try {
	    unitLength= Double.parseDouble(temp);

	    //(double) (new Integer(temp).intValue());
	} catch (Exception e) { unitLength=1.0;
	System.out.println("/:/");
	}
	
	unitName = prop.getProperty("unitName", unitName);

	if (MainWindow.isAppli) {
	    latexCmd = prop.getProperty("latex_cmd", latexCmd);
	    String latexHandler = prop.getProperty("latexHandler", "on");
	    enableLH = latexHandler.equals("on")?true:false;
	} else {
	    enableLH = false;
	}

	String oldp = "off";
	oldp = prop.getProperty("oldparsing",oldp);
	oldparsing = oldp.equals("on")?true:false;
    }
}





