package jastex;
import java.io.*;
import java.util.*;
import jastex.old.gui.MainWindow;

public class Languages {
    /** General JasToolbar Tooltips */
    public static final int G_TBTOOLTIP_NEW    = 0;
    public static final int G_TBTOOLTIP_OPEN    = 1;
    public static final int G_TBTOOLTIP_SAVE    = 2;
    public static final int G_TBTOOLTIP_SAVEAS  = 3;
    public static final int G_TBTOOLTIP_POINTER = 4;
    public static final int G_TBTOOLTIP_COPY    = 5;
    public static final int G_TBTOOLTIP_CUT     = 6;
    public static final int G_TBTOOLTIP_PASTE   = 7;
    public static final int G_TBTOOLTIP_DELETE  = 8;
    public static final int G_TBTOOLTIP_PREF    = 9;
    public static final int G_TBTOOLTIP_HELP    = 10;
    public static final int G_TBTOOLTIP_NODE    = 11;
    public static final int G_TBTOOLTIP_EDGE    = 12;
    public static final int G_TBTOOLTIP_MARK    = 13;
    public static final int G_TBTOOLTIP_OTHER   = 14;
    public static String[] g_tbToolTips = {
	"New", "Open ...",
	"Save", "Save As...",
	"Select", "Copy", "Cut","Paste",
	"Delete", "Objects default properties",
	"Help", "Nodes",
	"Edges", "Marks",
	"Others"
    };

    /** JasToolbar Tooltips and Menu for Nodes */
    public static final int N_TBTOOLTIP_ROUND      = 0;
    public static final int N_TBTOOLTIP_RECT       = 1;
    public static final int N_TBTOOLTIP_ROUND_RECT = 2;

    public static String[] n_tbToolTips= {
	"Oval Node", "Rectangular Node",
	"Round Rectangular Node"
    };

    /** JasToolbar Tooltips and Menu for Edges */
    public static final int E_TBTOOLTIP_STRAIGHT     = 0;
    public static final int E_TBTOOLTIP_CURVE        = 1;
    public static final int E_TBTOOLTIP_CURVENEG     = 2;
    public static final int E_TBTOOLTIP_QBEZIER      = 3;
    public static final int E_TBTOOLTIP_CBEZIER      = 4;
    public static final int E_TBTOOLTIP_LOOP         = 5;

    public static String[] e_tbToolTips = {
	"Straight Line", "Positive Curve", "Negative Curve", 
	"Quadratic Bezier Curve",
	"Cubic Bezier Curve", "Loop"
    };

    /** JasToolbar Tooltips and Menu for Marks */
    public static final int M_TBTOOLTIP_INITIAL      = 0;
    public static final int M_TBTOOLTIP_FINAL        = 1;
    public static final int M_TBTOOLTIP_REPEATED     = 2;

    public static String[] m_tbToolTips = {
	"Initial Mark", "Final Mark", "Round Mark"
    };
    

    /* JasToolbar Tooltips and Menu for Free Objects */
    public static final int FO_TOOLTIPS_CIRCLE  = 0;
    public static final int FO_TOOLTIPS_RECT    = 1;
    public static final int FO_TOOLTIPS_OVAL    = 2;
    public static final int FO_TOOLTIPS_LINE    = 3;
    public static final int FO_TOOLTIPS_QBEZIER = 4;
    public static final int FO_TOOLTIPS_CBEZIER = 5;

    public static String[] fo_tbToolTips = {
	"Circle", "Oval", "Rectangle",
	"Line", "Quadratic Bezier Curve",
	"Cubic Bezier Curve"
    };
    /** MainWindow Title */
    public static String mw_Title = "Jastex[en]";
    
    /** Document tab title */
     public static String document_Title = "Untitled";
   
    /** MessageBox Messages */
    public static String mb_Question_Overwrite_Title = "Question";
    public static String mb_Question_Overwrite_Text  = "Do You want to overwrite ";
    public static String mb_Question_TextChanged_Title = "Warning";
    public static String mb_Question_TextChanged_Text = "The text has been modified. Do you really want to discard the modifications?";
    public static String mb_Question_Quit_Title = "Quit?";
    public static String mb_Question_Quit_Text  = "Do you really want to quit?\n(All modifications since last save will be discarded)";
    
    public static String mb_Question_CloseDoc_Title = "Close the current Document?";
    public static String mb_Question_CloseDoc_Text = "Do you really want to close this document?\n(all modifications since last save will be discarded)";
    /** MessageBox Buttons Messages */
    public static final int MB_BUTTON_OK     = 0;
    public static final int MB_BUTTON_YES    = 1;
    public static final int MB_BUTTON_NO     = 2;

    public static String[] mb_buttonText = {"OK", "YES", "NO" };
    
    /** MyButtonComboBox Tooltips */
    public static String mbcb_ToolTip = "Choose...";

    /** JasTabbedPane */
    public static final int TP_TAB_DRAW  = 0;
    public static final int TP_TAB_LATEX = 1;

    public static String[] tp_tab_names ={ "Drawing",
					   "Latex Code"};

    public static String[] tp_tab_tooltips = {
	"Click to access to the drawing surface",
	"Click to view the latex code generated"};


    /** JasMenu */
    public static final int MBAR_MENU_FILE = 0;
    public static final int MBAR_MENU_EDIT = 1;
    public static final int MBAR_MENU_UTIL = 2;
    public static final int MBAR_MENU_CFG  = 3;
    public static final int MBAR_MENU_DOC  = 4;
    public static final int MBAR_MENU_HELP = 5;

    public static final int MBAR_FILEITEM_OPEN = 0;
    public static final int MBAR_FILEITEM_SAVE = 1;
    public static final int MBAR_FILEITEM_SAVEAS = 2;
    public static final int MBAR_FILEITEM_QUIT = 3;

    public static final int MBAR_HELPITEM_HELP = 0;
    public static final int MBAR_HELPITEM_ABOUT = 1;

    public static final int MBAR_EDITITEM_COPY = 0;
    public static final int MBAR_EDITITEM_CUT = 1;
    public static final int MBAR_EDITITEM_PASTE = 2;
    public static final int MBAR_EDITITEM_DEL = 3;
    public static final int MBAR_EDITITEM_SELALL = 4;

    public static final int MBAR_UTIL_SELECT = 0;
    public static final int MBAR_UTIL_NODE   = 1;
    public static final int MBAR_UTIL_EDGE   = 2;
    public static final int MBAR_UTIL_MARK   = 3;
    public static final int MBAR_UTIL_FOBJ   = 4;
   
    public static final int MBAR_CONFIG_JASTEX   = 0;

    public static final int MBAR_DOCITEM_NEW = 0;
    public static final int MBAR_DOCITEM_CLOSE = 1;

    public static final int MBAR_CFGITEM_JASTEX = 0;
    public static final int MBAR_CFGITEM_GGP    = 1;
    public static final int MBAR_CFGITEM_GGPTITLE    = 2;
    public static final int MBAR_CFGITEM_JASTEXTITLE = 3;
    
    
    public static String[] mbar_menuItems = {"File","Edit", "Utils", "Configuration","Documents","Help"};
    public static String[] mbar_fileItems = {g_tbToolTips[G_TBTOOLTIP_OPEN],
					     g_tbToolTips[G_TBTOOLTIP_SAVE],
					     g_tbToolTips[G_TBTOOLTIP_SAVEAS],
					     "Quit"};
    public static String[] mbar_helpItems = {g_tbToolTips[G_TBTOOLTIP_HELP],
					     "About JasTeX"};



    public static String[] mbar_editItems = {g_tbToolTips[G_TBTOOLTIP_COPY],
					     g_tbToolTips[G_TBTOOLTIP_CUT],
					     g_tbToolTips[G_TBTOOLTIP_PASTE],
					     g_tbToolTips[G_TBTOOLTIP_DELETE],
					     "Select All"
    };
    public static String[] mbar_util = {g_tbToolTips[G_TBTOOLTIP_POINTER],
					g_tbToolTips[G_TBTOOLTIP_NODE],
					g_tbToolTips[G_TBTOOLTIP_EDGE],
					g_tbToolTips[G_TBTOOLTIP_MARK],
					g_tbToolTips[G_TBTOOLTIP_OTHER]
    };
    public static String[] mbar_docItems = { g_tbToolTips[G_TBTOOLTIP_NEW],
					     "Close"};
    public static String[] mbar_cfgItems = { "Configure JasTeX",
					     "Configure the default properties",
					     "Default properties",
					     "JasTeX configuration"};
    
    public static String[][] mbar_utilItems = {
	//WARNING: don't put the same name twice, it will broke everything
	{}, //select is not a submenu
	n_tbToolTips,
	e_tbToolTips,
	m_tbToolTips,
	fo_tbToolTips,
    };

    public static final int CONTEXT_POPUP_COPY = 0;
    public static final int CONTEXT_POPUP_PASTE = 1;
    public static final int CONTEXT_POPUP_DELETE = 2;
    public static final int CONTEXT_POPUP_BACKGROUND = 3;
    public static final int CONTEXT_POPUP_FOREGROUND = 4;
    public static final int CONTEXT_POPUP_GLOBPROP = 6;
    public static final int CONTEXT_POPUP_CUT = 7;
    public static final int CONTEXT_POPUP_SELECTALL = 8;
    public static final int CONTEXT_POPUP_OBJPROP = 9;
    public static final int CONTEXT_POPUP_ORIGIN = 10;
    
    public static String[] context_popup = {
	"Copy",
	"Paste",
	"Delete",
	"Background",
	"Foreground",
	"Make it straight!",
	"Global Properties",
	"Cut",
	"Select All",
	"Object Properties",
	"Set Origin Here"
    };
    

    public static String[] arrowZoom = 
    {
	"Right keypad arrow : zoom in",
	"Left keypad arrow : zoom out"
    };

    /** JasScrollBox */
    public static String[] sb_tooltip =
    {
	"Decrease the value",
	"Increase the value"
    };

    /** JasColorComboBox */
    public static String ccb_customcolor="Choose a custom color...";


    /** JasToolBox */
    public static String tb_ApplyBtn = "Apply";
    public static String tb_OkBtn = "OK";
    public static String tb_CancelBtn = "Cancel";


    public static final int TB_TABTITLE_LINES =0;
    public static final int TB_TABTITLE_NODE  =1;
    public static final int TB_TABTITLE_LABEL =2;
    public static final int TB_TABTITLE_IFMARK=3;
    public static final int TB_TABTITLE_RMARK=4;
    public static final int TB_TABTITLE_ARROW=5;
    public static final int TB_TABTITLE_ELABEL=6;
    public static final int TB_TABTITLE_LOOP=7;
    public static final int TB_TABTITLE_OFFSET=8;

    public static String[] tb_tabtitle = {
	"Lines",
	"Node",
	"Label",
	"Initial and Final Marks",
	"Repeated Marks",
	"Arrow",
	"Edge Label",
	"Loop",
	"Offset"
    };




    public static String[] tb_tabtooltip = {
	"Lines properties (color, width ...)",
	"Node properties (color, size ...)",
	"Label properties (color, size ...)",
	"Initial and Final Marks properties (color, size ...)",
	"Repeated Marks properties (color, size ...)",
	"Arrows properties(number, distance, direction)",
	"Position/side of Edge Label"
    };



    /** LineTab */
    public static String[] tb_lineTab =  {
	"Display Frame",
	"Grayscale Line",
	"Color Line",
	"Line Width",
	"Line Pattern",
	"Curve Depth"
    };
    
    /** NodeTab */
    public static String[] tb_nodeTab = {
	"Internal Name",
	"X",
	"Y",
	"Node Width",
	"Node Heigth",
	"Circle Node",
	"Fill with grayscale",
	"Fill with color",
	"Diameter"
    };

    /** labelTab */
    public static String[] tb_labelTab ={
	"Node adjustment",
	"Adjustment distance",
	"Node label",
	"Label external position",
	"Label angle",
	"Label distance",
	"Align this label",
	"New label",
	"Enable latex preview",
	"Node Labels"
    };
    
     public static String[] tb_labelTab_adjust ={
	 "None",
	 "Width",
	 "Heigth",
	 "Both"
     };
    
    

    /** IFMark tab */
    public static String[] tb_ifmarkTab = {
	"Select a [I-F]Mark",
	"Width",
	"Arrow Length",
	"Arrow number",
	"Arrow angle",
	"Line pattern",
	"No Mark in this Node",
	"Arrow distance"
    };

    public static String[] tb_rmarkTab = {
	"Distance",
	"Grayscale Line",
	"Color Line",
	"Line Width",
	"Line Pattern",
	"No repeated mark for this node",
	"Rmark distance"
    };


    /** Arrow Tab */
    public static String[] tb_arrowTab = {
	"Number of arrow",
	"Arrow distance",
	"Edge direction",
	"Flip !"
    };



    /** labelTab */
    public static String[] tb_edgeLabelTab ={
	"Label",
	"Preview latex",
	"Label on the",
	"left",
	"right",
	"Position",
	"Start",
	"Middle",
	"End",
	"Distance",
	"Edge Labels"
	
    };


    /** Transition Tab */
    public static String[] tb_transTab = {
	"Starting node",
	"Ending node"
    };


    public static String[] tb_loopTab = {
	"Diameter",
	"Angle"
    };
    
    public static String[] tb_offsetTab = {
	"Starting Node : X",
	"Starting Node : Y",
	"Ending Node : X",
	"Ending Node : Y"
    };
   
    

    /** JasTex Configuration Dialog */
    public static String[] jcd_tab = {
	"Global options",
	"Drawing area",
	"Advanced options"
    };
	

    public static String[] jcd_global = {
	"Language",
	"Default unitlength",
	"Show splashscreen on startup"
    };

    public static String[] jcd_draw = {
	"Antialiasing enabled",
	"Magnetic grid enabled",
	"Snap to grid",
	"grid step"
    };

    public static String[] jcd_advanced = {
	"lowXserverMode enabled",
	"Debug mode enabled",
	"Enable latex preview",
	"Latex command"
    };
    
    /** Status Bar **/
    public static final int STATUS_BAR_0      = 0;
    public static final int STATUS_BAR_1      = 1;
    public static final int STATUS_BAR_2      = 2;
    public static final int STATUS_BAR_3      = 3;
    public static final int STATUS_BAR_4      = 4;
    public static final int STATUS_BAR_5      = 5;
    public static final int STATUS_BAR_6      = 6;
    public static final int STATUS_BAR_10     = 10;
    public static final int STATUS_BAR_11     = 10;

    public static String[] status_bar={
	"Choose the starting Node for the curve",
	"Choose the destination Node for the curve",
	"Set the Control point of the curve",
	"Set the first Control point of the curve",
	"Set the second Control point of the curve",
	"Choose a Node",
	" ",
	" ",
	" ",
	" ",
	"Set the starting point of the curve",
	"Set the ending point of the curve"
    };

    public static String[] arrowChooser={
	"New",
	"Save",
	"Delete",
	"Arrow Head #"
    };

    public static String[] tbTitle={
	"Object properties",
	"Global properties"
    };



    public Languages(String langFile) {
	loadLanguage(langFile);
    }

    public static void loadLanguage(String langFile) {
	Properties prop;
	InputStream is = null;
	if (MainWindow.isAppli) {
	    try {
		is = new FileInputStream(langFile);
	    } catch (FileNotFoundException e) {
		return;
	    }
	}else {
	    is = Languages.class.getResourceAsStream(langFile);
	}	    

	
	prop = new Properties();
       
	try {
	    prop.load(is);
	} catch (IOException e) {
	    try { is.close(); } catch (IOException e1) {}
	    return;
	}
     	loadProperties(prop);
	try { is.close(); } catch (IOException e1) {}
	return;	
    }
    
    public static void loadProperties(Properties prop) {
	/* General JasToolbar Tooltips */
	g_tbToolTips[G_TBTOOLTIP_NEW] = prop.getProperty("g_tbToolTip.new", g_tbToolTips[G_TBTOOLTIP_NEW]);
	g_tbToolTips[G_TBTOOLTIP_OPEN] = prop.getProperty("g_tbToolTip.open", g_tbToolTips[G_TBTOOLTIP_OPEN]);
	g_tbToolTips[G_TBTOOLTIP_SAVE] = prop.getProperty("g_tbToolTip.save", g_tbToolTips[G_TBTOOLTIP_SAVE]);
	g_tbToolTips[G_TBTOOLTIP_SAVEAS] = prop.getProperty("g_tbToolTip.saveas", g_tbToolTips[G_TBTOOLTIP_SAVEAS]);
	g_tbToolTips[G_TBTOOLTIP_POINTER] = prop.getProperty("g_tbToolTip.select", g_tbToolTips[G_TBTOOLTIP_POINTER]);
	g_tbToolTips[G_TBTOOLTIP_COPY] = prop.getProperty("g_tbToolTip.copy", g_tbToolTips[G_TBTOOLTIP_COPY]);
	g_tbToolTips[G_TBTOOLTIP_CUT] = prop.getProperty("g_tbToolTip.cut", g_tbToolTips[G_TBTOOLTIP_CUT]);
	g_tbToolTips[G_TBTOOLTIP_PASTE] = prop.getProperty("g_tbToolTip.paste", g_tbToolTips[G_TBTOOLTIP_PASTE]);
	g_tbToolTips[G_TBTOOLTIP_DELETE] = prop.getProperty("g_tbToolTip.delete", g_tbToolTips[G_TBTOOLTIP_DELETE]);
	g_tbToolTips[G_TBTOOLTIP_PREF] = prop.getProperty("g_tbToolTip.pref", g_tbToolTips[G_TBTOOLTIP_PREF]);
	g_tbToolTips[G_TBTOOLTIP_HELP] = prop.getProperty("g_tbToolTip.help", g_tbToolTips[G_TBTOOLTIP_HELP]);
	g_tbToolTips[G_TBTOOLTIP_NODE] = prop.getProperty("g_tbToolTip.node", g_tbToolTips[G_TBTOOLTIP_EDGE]);
	g_tbToolTips[G_TBTOOLTIP_EDGE] = prop.getProperty("g_tbToolTip.edge", g_tbToolTips[G_TBTOOLTIP_EDGE]);
	g_tbToolTips[G_TBTOOLTIP_MARK] = prop.getProperty("g_tbToolTip.mark", g_tbToolTips[G_TBTOOLTIP_MARK]);
	g_tbToolTips[G_TBTOOLTIP_OTHER] = prop.getProperty("g_tbToolTip.other", g_tbToolTips[G_TBTOOLTIP_OTHER]);


	/** JasToolbar Tooltips and Menu for Nodes */
	n_tbToolTips[N_TBTOOLTIP_ROUND] = prop.getProperty("n_tbToolTip.oval", n_tbToolTips[N_TBTOOLTIP_ROUND]);
	n_tbToolTips[N_TBTOOLTIP_RECT] = prop.getProperty("n_tbToolTip.rect", n_tbToolTips[N_TBTOOLTIP_RECT ]);
	n_tbToolTips[N_TBTOOLTIP_ROUND_RECT] = prop.getProperty("n_tbToolTip.roundrect", n_tbToolTips[N_TBTOOLTIP_ROUND_RECT]);
	
	/** JasToolbar Tooltips and Menu for Edges */
	e_tbToolTips[E_TBTOOLTIP_STRAIGHT] = prop.getProperty("e_tbToolTips.straight", e_tbToolTips[E_TBTOOLTIP_STRAIGHT]);
	e_tbToolTips[E_TBTOOLTIP_CURVE] = prop.getProperty("e_tbToolTips.curve", e_tbToolTips[E_TBTOOLTIP_CURVE]);
	e_tbToolTips[E_TBTOOLTIP_CURVENEG] = prop.getProperty("e_tbToolTips.curveneg", e_tbToolTips[E_TBTOOLTIP_CURVENEG]);
	e_tbToolTips[E_TBTOOLTIP_CBEZIER] = prop.getProperty("e_tbToolTips.cbezier", e_tbToolTips[E_TBTOOLTIP_CBEZIER]);
	e_tbToolTips[E_TBTOOLTIP_QBEZIER] = prop.getProperty("e_tbToolTips.qbezier", e_tbToolTips[E_TBTOOLTIP_QBEZIER]);
	e_tbToolTips[E_TBTOOLTIP_LOOP] = prop.getProperty("e_tbToolTips.loop", e_tbToolTips[E_TBTOOLTIP_LOOP]);

	/** JasToolbar Tooltips and Menu for Mark */
	m_tbToolTips[M_TBTOOLTIP_INITIAL] = prop.getProperty("m_tbToolTips.initial", e_tbToolTips[M_TBTOOLTIP_INITIAL]);
	m_tbToolTips[M_TBTOOLTIP_FINAL] = prop.getProperty("m_tbToolTips.final", e_tbToolTips[M_TBTOOLTIP_FINAL]);
	m_tbToolTips[M_TBTOOLTIP_REPEATED] = prop.getProperty("m_tbToolTips.repeated", e_tbToolTips[M_TBTOOLTIP_REPEATED]);

	/** JasToolbar Tooltips and Menu for Free Objects */
	fo_tbToolTips[FO_TOOLTIPS_CIRCLE] =  prop.getProperty("fo_tbToolTips.circle", fo_tbToolTips[FO_TOOLTIPS_CIRCLE]);
	fo_tbToolTips[FO_TOOLTIPS_RECT] =  prop.getProperty("fo_tbToolTips.rect", fo_tbToolTips[FO_TOOLTIPS_RECT]);
	fo_tbToolTips[FO_TOOLTIPS_OVAL] =  prop.getProperty("fo_tbToolTips.oval", fo_tbToolTips[FO_TOOLTIPS_OVAL]);
	fo_tbToolTips[FO_TOOLTIPS_LINE] =  prop.getProperty("fo_tbToolTips.line", fo_tbToolTips[FO_TOOLTIPS_LINE]);
	fo_tbToolTips[FO_TOOLTIPS_QBEZIER] =  prop.getProperty("fo_tbToolTips.qbezier", fo_tbToolTips[FO_TOOLTIPS_QBEZIER]);
	fo_tbToolTips[FO_TOOLTIPS_CBEZIER] =  prop.getProperty("fo_tbToolTips.cbezier", fo_tbToolTips[FO_TOOLTIPS_CBEZIER]);

	/** MainWindow Title */
	mw_Title = prop.getProperty("mw_Title", mw_Title);
	/** Document tab Title */
	document_Title = prop.getProperty("document_Title", document_Title);

	/** MessageBox Messages */
	mb_Question_Overwrite_Title = prop.getProperty("mb_Question_Overwrite_Title", mb_Question_Overwrite_Title);
	mb_Question_Overwrite_Text  = prop.getProperty("mb_Question_Overwrite_Text", mb_Question_Overwrite_Text);
	mb_Question_TextChanged_Title = prop.getProperty("mb_Question_TextChanged_Title", mb_Question_TextChanged_Title);
	mb_Question_TextChanged_Text = prop.getProperty("mb_Question_TextChanged_Text", mb_Question_TextChanged_Text);
	mb_Question_CloseDoc_Title = prop.getProperty("mb_Question_CloseDoc_Title", mb_Question_CloseDoc_Title);
	mb_Question_CloseDoc_Text = prop.getProperty("mb_Question_CloseDoc_Text", mb_Question_CloseDoc_Text);
	mb_Question_Quit_Title = prop.getProperty("mb_Question_Quit_Title", mb_Question_Quit_Title);
	mb_Question_Quit_Text = prop.getProperty("mb_Question_Quit_Text", mb_Question_Quit_Text);

	mb_buttonText[MB_BUTTON_OK] = prop.getProperty("mb_buttonText.ok", mb_buttonText[MB_BUTTON_OK]);
	mb_buttonText[MB_BUTTON_YES] = prop.getProperty("mb_buttonText.yes", mb_buttonText[MB_BUTTON_YES]);
	mb_buttonText[MB_BUTTON_NO] = prop.getProperty("mb_buttonText.no", mb_buttonText[MB_BUTTON_NO]);

	/** MyButtonComboBox Tooltips */
	mbcb_ToolTip = prop.getProperty("mbcb_ToolTip", mbcb_ToolTip);

	/** JasTabbedPane */
	tp_tab_names[TP_TAB_DRAW] = prop.getProperty("tp_tab_names.draw", tp_tab_names[TP_TAB_DRAW]);
	tp_tab_names[TP_TAB_LATEX] = prop.getProperty("tp_tab_names.latex", tp_tab_names[TP_TAB_LATEX]);

	tp_tab_tooltips[TP_TAB_DRAW] = prop.getProperty("tp_tab_tooltips.draw", tp_tab_tooltips[TP_TAB_DRAW]);
	tp_tab_tooltips[TP_TAB_LATEX] = prop.getProperty("tp_tab_tooltips.latex", tp_tab_tooltips[TP_TAB_LATEX]);

	/** JasMenu */
	mbar_menuItems[MBAR_MENU_FILE] = prop.getProperty("mbar_menuItems.file", mbar_menuItems[MBAR_MENU_FILE]);
	mbar_menuItems[MBAR_MENU_EDIT] = prop.getProperty("mbar_menuItems.edit", mbar_menuItems[MBAR_MENU_EDIT]);
	mbar_menuItems[MBAR_MENU_UTIL] = prop.getProperty("mbar_menuItems.util", mbar_menuItems[MBAR_MENU_UTIL]);
	mbar_menuItems[MBAR_MENU_CFG] = prop.getProperty("mbar_menuItems.cfg", mbar_menuItems[MBAR_MENU_CFG]);
mbar_menuItems[MBAR_MENU_DOC] = prop.getProperty("mbar_menuItems.doc", mbar_menuItems[MBAR_MENU_DOC]);
	mbar_menuItems[MBAR_MENU_HELP] = prop.getProperty("mbar_menuItems.help", mbar_menuItems[MBAR_MENU_HELP]);


// 	mbar_fileItems[MBAR_FILEITEM_NEW] = prop.getProperty("mbar_fileItems.new", mbar_fileItems[MBAR_FILEITEM_NEW]);
// 	mbar_fileItems[MBAR_FILEITEM_OPEN] = prop.getProperty("mbar_fileItems.open", mbar_fileItems[MBAR_FILEITEM_OPEN]);
// 	mbar_fileItems[MBAR_FILEITEM_SAVE] = prop.getProperty("mbar_fileItems.save", mbar_fileItems[MBAR_FILEITEM_SAVE]);
// 	mbar_fileItems[MBAR_FILEITEM_SAVEAS] = prop.getProperty("mbar_fileItems.saveas", mbar_fileItems[MBAR_FILEITEM_SAVEAS]);
	mbar_fileItems[MBAR_FILEITEM_QUIT] = prop.getProperty("mbar_fileItems.quit", mbar_fileItems[MBAR_FILEITEM_QUIT]);

// 	mbar_helpItems[MBAR_HELPITEM_HELP] = prop.getProperty("mbar_helpItems.help", mbar_helpItems[MBAR_HELPITEM_HELP]);

	mbar_fileItems[MBAR_FILEITEM_OPEN] = g_tbToolTips[G_TBTOOLTIP_OPEN];
	mbar_fileItems[MBAR_FILEITEM_SAVE] = g_tbToolTips[G_TBTOOLTIP_SAVE];
	mbar_fileItems[MBAR_FILEITEM_SAVEAS] = g_tbToolTips[G_TBTOOLTIP_SAVEAS];
	
	mbar_editItems[MBAR_EDITITEM_COPY] = g_tbToolTips[G_TBTOOLTIP_COPY];
	mbar_editItems[MBAR_EDITITEM_CUT] = g_tbToolTips[G_TBTOOLTIP_CUT];
	mbar_editItems[MBAR_EDITITEM_PASTE] = g_tbToolTips[G_TBTOOLTIP_PASTE];
	mbar_editItems[MBAR_EDITITEM_DEL] = g_tbToolTips[G_TBTOOLTIP_DELETE];
	mbar_editItems[MBAR_EDITITEM_SELALL] = prop.getProperty("mbar_editItems.selall", mbar_editItems[MBAR_EDITITEM_SELALL]);
	
	mbar_util[MBAR_UTIL_SELECT] = g_tbToolTips[G_TBTOOLTIP_POINTER];
	mbar_util[MBAR_UTIL_NODE] = g_tbToolTips[G_TBTOOLTIP_NODE];
	mbar_util[MBAR_UTIL_EDGE] = g_tbToolTips[G_TBTOOLTIP_EDGE];
	mbar_util[MBAR_UTIL_MARK] = g_tbToolTips[G_TBTOOLTIP_MARK];
	mbar_util[MBAR_UTIL_FOBJ] = g_tbToolTips[G_TBTOOLTIP_OTHER];
	
	mbar_cfgItems[MBAR_CFGITEM_JASTEX] = prop.getProperty("mbar_cfgItems.jastex", mbar_cfgItems[MBAR_CFGITEM_JASTEX]);
	mbar_cfgItems[MBAR_CFGITEM_GGP] = prop.getProperty("mbar_cfgItems.ggp", mbar_cfgItems[MBAR_CFGITEM_GGP]);
	mbar_cfgItems[MBAR_CFGITEM_GGPTITLE] = prop.getProperty("mbar_cfgItems.ggptitle", mbar_cfgItems[MBAR_CFGITEM_GGPTITLE]);
	mbar_cfgItems[MBAR_CFGITEM_JASTEXTITLE] = prop.getProperty("mbar_cfgItems.jastextitle", mbar_cfgItems[MBAR_CFGITEM_JASTEXTITLE]);
	
	mbar_docItems[MBAR_DOCITEM_NEW] = g_tbToolTips[G_TBTOOLTIP_NEW];
	mbar_docItems[MBAR_DOCITEM_CLOSE] = prop.getProperty("mbar_docItems.close", mbar_docItems[MBAR_DOCITEM_CLOSE]);

	mbar_helpItems[MBAR_HELPITEM_HELP] = g_tbToolTips[G_TBTOOLTIP_HELP];
	mbar_helpItems[MBAR_HELPITEM_ABOUT] = prop.getProperty("mbar_helpItems.about", mbar_helpItems[MBAR_HELPITEM_ABOUT]);

    /** the context-popup */
	context_popup[CONTEXT_POPUP_COPY] = prop.getProperty("context_popup.copy", context_popup[CONTEXT_POPUP_COPY]);
	context_popup[CONTEXT_POPUP_PASTE] = prop.getProperty("context_popup.paste", context_popup[CONTEXT_POPUP_PASTE]);
	context_popup[CONTEXT_POPUP_DELETE] = prop.getProperty("context_popup.delete", context_popup[CONTEXT_POPUP_DELETE]);
	context_popup[CONTEXT_POPUP_CUT] = prop.getProperty("context_popup.cut", context_popup[CONTEXT_POPUP_CUT]);
	context_popup[CONTEXT_POPUP_SELECTALL] = prop.getProperty("context_popup.selectall", context_popup[CONTEXT_POPUP_SELECTALL]);

	context_popup[CONTEXT_POPUP_BACKGROUND] = prop.getProperty("context_popup.background", context_popup[CONTEXT_POPUP_BACKGROUND]);
	context_popup[CONTEXT_POPUP_FOREGROUND] = prop.getProperty("context_popup.foreground", context_popup[CONTEXT_POPUP_FOREGROUND]);
	context_popup[CONTEXT_POPUP_OBJPROP] = prop.getProperty("context_popup.objprop", context_popup[CONTEXT_POPUP_OBJPROP]);
	context_popup[CONTEXT_POPUP_GLOBPROP] = prop.getProperty("context_popup.globprop", context_popup[CONTEXT_POPUP_GLOBPROP]);
	context_popup[CONTEXT_POPUP_ORIGIN] = prop.getProperty("context_popup.origin", context_popup[CONTEXT_POPUP_ORIGIN]);

	/** JasScrollBox */
	sb_tooltip[0] = prop.getProperty("sb_tooltip.minus",sb_tooltip[0]);
	sb_tooltip[1] = prop.getProperty("sb_tooltip.plus",sb_tooltip[1]);

	/** JasColorComboBox */
	ccb_customcolor = prop.getProperty("ccb_customcolor",ccb_customcolor);


	/** The JasToolBox */
	tb_ApplyBtn = prop.getProperty("tb_ApplyBtn",tb_ApplyBtn);
	tb_OkBtn = prop.getProperty("tb_OkBtn",tb_OkBtn);
	tb_CancelBtn = prop.getProperty("tb_CancelBtn",tb_CancelBtn);
	


	tb_tabtitle[TB_TABTITLE_LINES] = prop.getProperty("tb_tabtitle.line", tb_tabtitle[TB_TABTITLE_LINES]);
	tb_tabtitle[TB_TABTITLE_NODE] = prop.getProperty("tb_tabtitle.node", tb_tabtitle[TB_TABTITLE_NODE]);
	tb_tabtitle[TB_TABTITLE_LABEL] = prop.getProperty("tb_tabtitle.label", tb_tabtitle[TB_TABTITLE_LABEL]);
	tb_tabtitle[TB_TABTITLE_IFMARK] = prop.getProperty("tb_tabtitle.ifmark", tb_tabtitle[TB_TABTITLE_IFMARK]);
	tb_tabtitle[TB_TABTITLE_RMARK] = prop.getProperty("tb_tabtitle.rmark", tb_tabtitle[TB_TABTITLE_RMARK]);
	tb_tabtitle[TB_TABTITLE_ARROW] = prop.getProperty("tb_tabtitle.arrow", tb_tabtitle[TB_TABTITLE_ARROW]);
	tb_tabtitle[TB_TABTITLE_ELABEL] = prop.getProperty("tb_tabtitle.elabel", tb_tabtitle[TB_TABTITLE_ELABEL]);
	tb_tabtitle[TB_TABTITLE_LOOP] = prop.getProperty("tb_tabtitle.loop", tb_tabtitle[TB_TABTITLE_LOOP]);
	tb_tabtitle[TB_TABTITLE_OFFSET] = prop.getProperty("tb_tabtitle.offset", tb_tabtitle[TB_TABTITLE_OFFSET]);

	/** tooltip */
	tb_tabtooltip[TB_TABTITLE_LINES] = prop.getProperty("tb_tabtooltip.line", tb_tabtooltip[TB_TABTITLE_LINES]);
	tb_tabtooltip[TB_TABTITLE_NODE] = prop.getProperty("tb_tabtooltip.node", tb_tabtooltip[TB_TABTITLE_NODE]);
	tb_tabtooltip[TB_TABTITLE_LABEL] = prop.getProperty("tb_tabtooltip.label", tb_tabtooltip[TB_TABTITLE_LABEL]);
	tb_tabtooltip[TB_TABTITLE_IFMARK] = prop.getProperty("tb_tabtooltip.ifmark", tb_tabtooltip[TB_TABTITLE_IFMARK]);
	tb_tabtooltip[TB_TABTITLE_RMARK] = prop.getProperty("tb_tabtooltip.rmark", tb_tabtooltip[TB_TABTITLE_RMARK]);
	tb_tabtooltip[TB_TABTITLE_ARROW] = prop.getProperty("tb_tabtooltip.arrow", tb_tabtooltip[TB_TABTITLE_ARROW]);
	tb_tabtooltip[TB_TABTITLE_ELABEL] = prop.getProperty("tb_tabtooltip.elabel", tb_tabtooltip[TB_TABTITLE_ELABEL]);

	/** LineTab */
	tb_lineTab[0] = prop.getProperty("tb_lineTab.frame",tb_lineTab[0]);
	tb_lineTab[1] = prop.getProperty("tb_lineTab.gray",tb_lineTab[1]);
	tb_lineTab[2] = prop.getProperty("tb_lineTab.color",tb_lineTab[2]);
	tb_lineTab[3] = prop.getProperty("tb_lineTab.width",tb_lineTab[3]);
	tb_lineTab[4] = prop.getProperty("tb_lineTab.pattern",tb_lineTab[4]);
	tb_lineTab[5] = prop.getProperty("tb_lineTab.curve",tb_lineTab[5]);

	/** NodeTab */
	tb_nodeTab[0] = prop.getProperty("tb_nodeTab.name",tb_nodeTab[0]);
	tb_nodeTab[1] = prop.getProperty("tb_nodeTab.x",tb_nodeTab[1]);
	tb_nodeTab[2] = prop.getProperty("tb_nodeTab.y",tb_nodeTab[2]);
	tb_nodeTab[3] = prop.getProperty("tb_nodeTab.width",tb_nodeTab[3]);
	tb_nodeTab[4] = prop.getProperty("tb_nodeTab.heigth",tb_nodeTab[4]);
	tb_nodeTab[5] = prop.getProperty("tb_nodeTab.circle",tb_nodeTab[5]);
	tb_nodeTab[6] = prop.getProperty("tb_nodeTab.gray",tb_nodeTab[6]);
	tb_nodeTab[7] = prop.getProperty("tb_nodeTab.color",tb_nodeTab[7]);
	tb_nodeTab[8] = prop.getProperty("tb_nodeTab.diam",tb_nodeTab[8]);





	/** labelTab */
	tb_labelTab[0] = prop.getProperty("tb_labelTab.adjust",tb_labelTab[0]);
	tb_labelTab[1] = prop.getProperty("tb_labelTab.adjdist",tb_labelTab[1]);
	tb_labelTab[2] = prop.getProperty("tb_labelTab.label",tb_labelTab[2]);
	tb_labelTab[3] = prop.getProperty("tb_labelTab.external",tb_labelTab[3]);
	tb_labelTab[4] = prop.getProperty("tb_labelTab.angle",tb_labelTab[4]);
	tb_labelTab[5] = prop.getProperty("tb_labelTab.distance",tb_labelTab[5]);
	tb_labelTab[6] = prop.getProperty("tb_labelTab.align",tb_labelTab[6]);
    	tb_labelTab[7] = prop.getProperty("tb_labelTab.new",tb_labelTab[7]);
       	tb_labelTab[8] = prop.getProperty("tb_labelTab.enableLH",tb_labelTab[8]);
	tb_labelTab[9] = prop.getProperty("tb_labelTab.label",tb_labelTab[9]);

	tb_labelTab_adjust[0] = prop.getProperty("tb_labelTab_adjust.none",tb_labelTab_adjust[0]);
	tb_labelTab_adjust[1] = prop.getProperty("tb_labelTab_adjust.width",tb_labelTab_adjust[1]);
	tb_labelTab_adjust[2] = prop.getProperty("tb_labelTab_adjust.heigth",tb_labelTab_adjust[2]);
	tb_labelTab_adjust[3] = prop.getProperty("tb_labelTab_adjust.both",tb_labelTab_adjust[3]);



	/** IFmark tab */
	tb_ifmarkTab[0] = prop.getProperty("tb_ifmarkTab.select",tb_ifmarkTab[0]);
	tb_ifmarkTab[1] = prop.getProperty("tb_ifmarkTab.width",tb_ifmarkTab[1]);
	tb_ifmarkTab[2] = prop.getProperty("tb_ifmarkTab.alength",tb_ifmarkTab[2]);
	tb_ifmarkTab[3] = prop.getProperty("tb_ifmarkTab.anumber",tb_ifmarkTab[3]);
	tb_ifmarkTab[4] = prop.getProperty("tb_ifmarkTab.aangle",tb_ifmarkTab[4]);
	tb_ifmarkTab[5] = prop.getProperty("tb_ifmarkTab.pattern",tb_ifmarkTab[5]);
	tb_ifmarkTab[6] = prop.getProperty("tb_ifmarkTab.nomark",tb_ifmarkTab[6]);
	tb_ifmarkTab[7] = prop.getProperty("tb_ifmarkTab.distance",tb_ifmarkTab[7]);



	/** RMarkTab */
	tb_rmarkTab[0] = prop.getProperty("tb_rmarkTab.distance",tb_rmarkTab[0]);
	tb_rmarkTab[1] = prop.getProperty("tb_rmarkTab.gray",tb_rmarkTab[1]);
	tb_rmarkTab[2] = prop.getProperty("tb_rmarkTab.color",tb_rmarkTab[2]);
	tb_rmarkTab[3] = prop.getProperty("tb_rmarkTab.width",tb_rmarkTab[3]);
	tb_rmarkTab[4] = prop.getProperty("tb_rmarkTab.pattern",tb_rmarkTab[4]);
	tb_rmarkTab[5] = prop.getProperty("tb_rmarkTab.normark",tb_rmarkTab[5]);
	tb_rmarkTab[6] = prop.getProperty("tb_rmarkTab.rd",tb_rmarkTab[6]);


	/** arrowTab */
	tb_arrowTab[0] = prop.getProperty("tb_arrowTab.number",tb_arrowTab[0]);
	tb_arrowTab[1] = prop.getProperty("tb_arrowTab.distance",tb_arrowTab[1]);
	tb_arrowTab[2] = prop.getProperty("tb_arrowTab.direction",tb_arrowTab[2]);
	tb_arrowTab[3] = prop.getProperty("tb_arrowTab.flip",tb_arrowTab[3]);


	/** edgeLabelTab */
	tb_edgeLabelTab[0] = prop.getProperty("tb_edgeLabelTab.label",tb_edgeLabelTab[0]);
	tb_edgeLabelTab[1] = prop.getProperty("tb_edgeLabelTab.latex",tb_edgeLabelTab[1]);
	tb_edgeLabelTab[2] = prop.getProperty("tb_edgeLabelTab.onthe",tb_edgeLabelTab[2]);
	tb_edgeLabelTab[3] = prop.getProperty("tb_edgeLabelTab.left",tb_edgeLabelTab[3]);
	tb_edgeLabelTab[4] = prop.getProperty("tb_edgeLabelTab.right",tb_edgeLabelTab[4]);
	tb_edgeLabelTab[5] = prop.getProperty("tb_edgeLabelTab.position",tb_edgeLabelTab[5]);
	tb_edgeLabelTab[6] = prop.getProperty("tb_edgeLabelTab.start",tb_edgeLabelTab[6]);
	tb_edgeLabelTab[7] = prop.getProperty("tb_edgeLabelTab.middle",tb_edgeLabelTab[7]);
	tb_edgeLabelTab[8] = prop.getProperty("tb_edgeLabelTab.end",tb_edgeLabelTab[8]);
	tb_edgeLabelTab[9] = prop.getProperty("tb_edgeLabelTab.distance",tb_edgeLabelTab[9]);
	tb_edgeLabelTab[10] = prop.getProperty("tb_edgeLabelTab.elabel",tb_edgeLabelTab[10]);
	  
	
	/** loop tab */
	tb_loopTab[0] = prop.getProperty("tb_loopTab.diameter",tb_loopTab[0]);
	tb_loopTab[1] = prop.getProperty("tb_loopTab.angle",tb_loopTab[1]);

	/**offset Tab */
	tb_offsetTab[0] = prop.getProperty("tb_offsetTab.sx",tb_offsetTab[0]);
	tb_offsetTab[1] = prop.getProperty("tb_offsetTab.sy",tb_offsetTab[1]);
	tb_offsetTab[2] = prop.getProperty("tb_offsetTab.ex",tb_offsetTab[2]);
	tb_offsetTab[3] = prop.getProperty("tb_offsetTab.ey",tb_offsetTab[3]);



	/** JasTeX Config Dialog */
        jcd_tab[0] = prop.getProperty("jcd_tab.global",jcd_tab[0]);
        jcd_tab[1] = prop.getProperty("jcd_tab.draw",jcd_tab[1]);
	jcd_tab[2] = prop.getProperty("jcd_tab.advanced",jcd_tab[2]);


	jcd_global[0] = prop.getProperty("jcd_global.lang",jcd_global[0]);
	jcd_global[1] = prop.getProperty("jcd_global.unit",jcd_global[1]);
	jcd_global[2] = prop.getProperty("jcd_global.splash",jcd_global[2]);


	jcd_draw[0] = prop.getProperty("jcd_draw.antialiasing",jcd_draw[0]);
	jcd_draw[1] = prop.getProperty("jcd_draw.magnetic",jcd_draw[1]);
	jcd_draw[2] = prop.getProperty("jcd_draw.snap",jcd_draw[2]);
	jcd_draw[3] = prop.getProperty("jcd_draw.step",jcd_draw[3]);

	jcd_advanced[0] = prop.getProperty("jcd_advanced.lowxserver",jcd_advanced[0]);
	jcd_advanced[1] = prop.getProperty("jcd_advanced.debug",jcd_advanced[1]);
	jcd_advanced[2] = prop.getProperty("jcd_advanced.latexHandler",jcd_advanced[2]); ;
	jcd_advanced[3] = prop.getProperty("jcd_advanced.latexCmd",jcd_advanced[3]); ;


	/** Status Bar **/
	status_bar[0] = prop.getProperty("status_bar.msg0",status_bar[0]);
	status_bar[1] = prop.getProperty("status_bar.msg1",status_bar[1]);
	status_bar[2] = prop.getProperty("status_bar.msg2",status_bar[2]);
	status_bar[3] = prop.getProperty("status_bar.msg3",status_bar[3]);
	status_bar[4] = prop.getProperty("status_bar.msg4",status_bar[4]);
	status_bar[5] = prop.getProperty("status_bar.msg5",status_bar[5]);
	status_bar[10] = prop.getProperty("status_bar.msg10",status_bar[10]);
	status_bar[11] = prop.getProperty("status_bar.msg11",status_bar[11]);

	arrowZoom[0]= prop.getProperty("arrowZoom.zoomin",arrowZoom[0]);
	arrowZoom[1]= prop.getProperty("arrowZoom.zoomout",arrowZoom[1]);

	arrowChooser[0]= prop.getProperty("arrowZoom.new",arrowChooser[0]);
	arrowChooser[1]= prop.getProperty("arrowZoom.save",arrowChooser[1]);
	arrowChooser[2]= prop.getProperty("arrowZoom.del",arrowChooser[2]);
	arrowChooser[3]= prop.getProperty("arrowZoom.head",arrowChooser[3]);

	tbTitle[0]= prop.getProperty("tbTitle.tb",tbTitle[0]);
	tbTitle[1]= prop.getProperty("tbTitle.ggp",tbTitle[1]);


	
  }
}




