package jastex;
import java.io.*;
import java.util.*;
import java.awt.*;

public class LatexHandler {
    public static boolean enable = true;
    private String header = "Jastex Information:";
    public double width;
    public double height;
    
    private static String top;
    private String middle;
    private static String bottom;
    private String all;
    private boolean done;

    public LatexHandler(String s) {
	if (top == null) {
	    top  = "\\documentclass{article}\n";
	    top += "\\usepackage[usenames]{color}";
	    top += "\\usepackage{calc}";
	    top += "\\begin{document}\n";
	    top += "\\newbox\\tempbox\n";
	    top += "\\newcounter{cnta}\n";
	    top += "\\newcounter{cntb}\n";
	    top += "\\newdimen\\monpt\n";
	    top += "\\monpt=0.01mm\n";
	}

	middle = "\\setbox\\tempbox\\hbox{"+s+"}\n";

	if (bottom == null) {
	    bottom = "\\setcounter{cnta}{(\\ht\\tempbox+\\dp\\tempbox)/\\monpt}\n";
	    bottom += "\\setcounter{cntb}{\\wd\\tempbox / \\monpt}\n";
	    bottom += "\\typeout{"+header+"h=\\thecnta,w=\\thecntb}\n";
	    bottom += "\\end{document}\n";
	}
	
	all = top + middle + bottom;
	width = -1;
	height = -1;
	done = false;
    }
   
    public Dimension getDimension() {
	if (enable && !done) {
	    try {
		Process p = Runtime.getRuntime().exec(Configuration.latexCmd);
		OutputStream output =p.getOutputStream();
		InputStream input=p.getInputStream();
		BufferedReader br = null;
		PrintWriter out = 
		    new PrintWriter(new BufferedWriter(new OutputStreamWriter(output)));
		br = new BufferedReader(new InputStreamReader(input));
		//send the latex code
		out.println(all);
		//  in case of malformed latex code
		out.println("x");
		out.close();
		try {
		    String str = null;
		    while (null != (str = br.readLine())) {
			if (str.startsWith("*"+header) ||
			    str.startsWith(header)) {
			    String str2 = str.substring(header.length()+3);
			    int commaIndex = str2.indexOf(',');
			    String h = str2.substring(0,commaIndex);
			    String w = str2.substring(commaIndex+1+2);
			    try {
				width  = Integer.parseInt(w);
				height = Integer.parseInt(h);
			    } catch (NumberFormatException e) {}
			    br.close();
			    done = true;
			    return (new Dimension((int)width, (int)height));
			}
		    }
		    br.close();
		} catch (IOException e) {
		    enable = false;
		    done = false;
		}
	    } catch (IOException e) {
		enable = false;
		done = false;
	    }
	}
	return (new Dimension((int)width, (int)height));
    }
    
    public double convert(double v,double unitLength, String unitName) {
	double value;
	if (unitName.equals("in")) {
	    value = v*0.03937;
	} else {
	    value = v;
	}
	value /=  unitLength/0.01;
	return value;
    }

    public double getWidth(double unitLength, String unitName) {
	Dimension d = getDimension();
	double w = d.getWidth();
	if (w != -1) {
	    return convert(w,unitLength,unitName);
	} else {
	    return -1;
	}
    }
    
    public double getHeight(double unitLength, String unitName) {
	Dimension d = getDimension();
	double h = d.getHeight();
	if (h != -1) {
	    return convert(h,unitLength,unitName);
	} else {
	    return -1;
	}
    }

    public boolean isDone() { return done; }
}
