package jastex;

import java.awt.*;
import java.util.Vector;
import java.awt.geom.*;
import jastex.old.obj.SelectBox;
import jastex.old.obj.Selection;
import jastex.old.gui.SurfaceDessin;
import jastex.old.gui.JasObjectToolBox;
import jastex.old.obj.AEdge;
import jastex.old.obj.ExtendedQuad;
import jastex.old.obj.JasRectangle;
import jastex.old.obj.MiniBox;
import jastex.old.obj.Node;
import jastex.old.obj.BezierQuadCurve;
import jastex.old.obj.IFMark;
import jastex.old.obj.BezierCubicCurve;
import jastex.old.obj.InvisibleNode;
import jastex.old.obj.JasObject;
import jastex.old.obj.SimpleObject;
import jastex.old.obj.Circle;
import jastex.old.obj.Loop;
import jastex.old.obj.SimpleObjectN;
import jastex.old.obj.Edge;
import jastex.old.obj.ExtendedEdge;
import jastex.old.obj.NodeLabel;
import jastex.old.obj.SimpleObjectE;
import jastex.old.obj.EdgeLabel;
import jastex.old.obj.ExtendedCubic;
import jastex.old.obj.Oval;
import jastex.old.obj.ANode;

public class ObjetManager {

    // All object created are in this Vector
    public Vector allobject;
    private Vector linkNodeEdge;
    public Vector indexSelectedObject;   // if a selection is made, this Vector contain all object selected
    private Vector indexSelectedObjectBackup;

    private Vector vectorControlMode;     // used in mode!=0 for control point
                                          // it will contain MiniBox
    private double sensitivity=2.0;       // defines the sensibility mouse pointer
    private Rectangle selection;          // contain the area of the zone selected
    private MiniBox b1,b2,b3,b4;          // for test
    public Selection currentselect;      // the Selection Object to draw
    private int mode=0; // 0 is normal select mode
                        // 1 is straight-edge mode
    private Vector controlPointClicked;
    private boolean takemode=false; // false design a waiting Node-mode
                                    // true waiting Point-mode
    public static JasObjectToolBox tb;
    private int msgIndex=-1; // for statusBar


    private Vector globalGasset; // GassetProperty
    public GastexGlobalProperties actualProp;

    private int allobjectindex=0;
    private int selectobjectnature=0;


    private Vector nodeBeforeEdge;

    public boolean slide=false;
   
    public ObjetManager() {
	allobject = new Vector();
	indexSelectedObject = new Vector();
	controlPointClicked = new Vector();
	vectorControlMode = new Vector();
	globalGasset = new Vector();
	createNewProp(); // the default one
	createNewProp(); // the actual one
    }


    public int countObject(){
	return allobject.size();
    }

    public void drawAllObject(Graphics g){
	// draw all object
	int i=0;
	int max=allobject.size();
	JasObject comp;
	while (i<max) {
	    comp=(JasObject) allobject.elementAt(i);
	    if (comp instanceof ANode) {
		// first , draw the Node
		// then drow the xMark
		// and finaly the Nodelabel
		
		comp.draw(g);
		drawVectorOfObject(((ANode) comp).getImarks(),g);
		drawVectorOfObject(((ANode) comp).getFmarks(),g);
		drawVectorOfObject(((ANode) comp).getNodeLabels(),g);		
	    }
	    if (!(comp instanceof IFMark ||
		  comp instanceof NodeLabel || 
		  comp instanceof ANode)) {
		comp.draw(g);
	    }
	    i++;
	}
        // TODO : utilisation des nouvelles structures
        // TODO : ow.draw((Graphics2D)g);
    }

    public void drawVectorOfObject(Vector v,Graphics g){
	int sz=v.size();
	for(int i=0;i<sz;i++){
	    ((JasObject) v.elementAt(i)).draw(g);
	}
    }

    public double roundDouble(double value) {
	return ((Math.round(value*Configuration.roundDecal))/Configuration.roundDecal);
    }

    public String getAllGastexCode(double oriX, double oriY){
	String codeGastex=new String();
	String temp;
	nodeBeforeEdge=new Vector(); // this contribute to eliminate edge bugs
	int i=0;
	int max=allobject.size();
	JasObject comp;
	Rectangle r = new Rectangle(0,0,1,1);
	while (i < max) {
	    comp=(JasObject) allobject.elementAt(i);
	    if (comp instanceof ANode || 
		(comp instanceof AEdge) ||
		(comp instanceof SimpleObjectN)||
		(comp instanceof SimpleObjectE)) {
		r.add(comp.getBounds());
	    }
	    i++;
	}
	r.grow((int)(2*Configuration.tailleGrille),
	       (int)(2*Configuration.tailleGrille));
	double width = r.getWidth();
	double height = r.getHeight();
	String fgasset;
	
	GastexGlobalProperties ggp1 = (GastexGlobalProperties)(globalGasset.elementAt(0));
	if( !((fgasset=ggp1.getLatexCodeProperties(new GastexGlobalProperties())).equals("")) ){
	    codeGastex += "\\gasset" + fgasset +"\n";
	}
	double arr=Math.ceil(-(ggp1.internal2UnitLength(height)+oriY));
	//System.out.println((-(ggp1.internal2UnitLength(height)+oriY))+" "+arr);
	codeGastex += "\\begin{picture}("
	    +(int)(ggp1.internal2UnitLength(width))+","
	    +(int)(ggp1.internal2UnitLength(height))+")("
	    +(int)(-oriX)+","
	    +(int)(arr)+")\\nullfont\n";
	codeGastex += "\\put("+(int)-oriX+","
	    +(int)(arr)+"){\\framebox("
	    +(int)(ggp1.internal2UnitLength(width))+","
	    +(int)(ggp1.internal2UnitLength(height))+"){}}\n";


	max=getPropV().size();
	i=1;
	GastexGlobalProperties gtemp1,gtemp2;
	Vector gvect;
	while (i<max) {
	    gtemp1=(GastexGlobalProperties)(globalGasset.elementAt(i-1));
	    gtemp2=(GastexGlobalProperties)(globalGasset.elementAt(i));
	    if( !((fgasset=gtemp2.getLatexCodeProperties(gtemp1)).equals("")) ){
		codeGastex += "\\gasset" + fgasset +"\n";
	    }
	    
	    gvect = gtemp2.whichBelongsTo(allobject);
	    if(gvect.size()>0){
		codeGastex += ggpObjectCode(gvect, oriX, oriY);
	    }
	    i++;
	}
	// Gastex code .... starts here
	/*
	i = 0;
	while (i<max) {
	    comp=(JasObject) allobject.elementAt(i);
	    if (comp instanceof ANode || 
		(comp instanceof AEdge && !(comp instanceof IFMark)) ||
		(comp instanceof SimpleObject)) { 
		temp=comp.getLatexCode();
		if (temp!=null) {
		    codeGastex+=temp+"\n";
		}
	    }
	    i++;
	}
	*/
	// ---------
	return codeGastex;
    }

    public String ggpObjectCode(Vector v, double oriX, double oriY){
	int i=0;
	int max=v.size();
	JasObject comp;
	String temp,codeGastex="";
	while (i<max) {
	    comp=(JasObject) v.elementAt(i);
	    if (comp instanceof ANode || 
		//(comp instanceof AEdge && !(comp instanceof IFMark)) || // REMOVE FOR BETA
		(comp instanceof SimpleObject)) { 
		temp=comp.getLatexCode(oriX, oriY);
		if (temp!=null) {
		    codeGastex+=temp+"\n";
		}
		// Hack
		if (comp instanceof ANode) nodeBeforeEdge.add(comp);
	    } else if (comp instanceof AEdge && !(comp instanceof IFMark)) {
		((AEdge)comp).setMarked(true);
		if(nodeBeforeEdge.contains(((AEdge)comp).startingpoint)
		   && nodeBeforeEdge.contains(((AEdge)comp).endingpoint) ){
		    temp=comp.getLatexCode(oriX, oriY);
		    if (temp!=null) {
			codeGastex+=temp+"\n";
		    }
		    ((AEdge)comp).setMarked(false);
		}
	    }
	    i++;
	}

	// BETA below
	i=0;
	while (i<max) {
	    comp=(JasObject) v.elementAt(i);
	    if (comp instanceof AEdge && !(comp instanceof IFMark)){
		if (((AEdge)comp).getMarked()){
		    temp=comp.getLatexCode(oriX,oriY);
		    if (temp!=null) {
			codeGastex+=temp+"\n";
		    }
		}
	    }
	    i++;
	}
	// END BETA

	return codeGastex;
    }


    public JasObject addObject(int type,int ref) {
	// type = 0 Node
	// type = 1 Edge
	// type = 2 xMark
	// type = 3 fObjects
 
	// ref = 0 OvalNode
	//       1 RectangularNode
	//       2 Round Rectangular Node
	
	// ref = 0 Straight Edge
	//       1 Bezier Courbe
	//       2 Simple Courbe
	//       3 Boucle

	// ref = 0 iMark
	//       1 fMark
	//       2 rMark

	// ref = 0 Circle
	//       1 Rectangle
	//       2 Oval
	//       3 line
	//       4 Bezier Quad
	//       5 Bezier Cubic
	// 
	//System.out.println("type : " + type + " ref : " + ref);
	if (type==-1 && ref==-1) return null;
	JasObject comp=null;
	if (type==0) {
	    // type Node
	    switch(ref){
	    case 0:
		comp=new Node(actualProp);
		((Node) comp).updateVector(allobject);
		break;
	    case 1:
		comp=new Node(actualProp,8,8,0);
		((Node) comp).updateVector(allobject);
		break;
	    case 2:
		comp=new Node(actualProp,8,8,2);
		((Node) comp).updateVector(allobject);
		break;
	    }
	} 

	else if (type==1) {
	    // type Edge
	    takemode=false;
	    switch(ref){
	    case 0:
		controlPointClicked.clear();
		//comp=new UnObjetTest();

		// setting mode
		mode=1;
		msgIndex=0;
		//System.out.println("Manager mode = "+mode);
		break;
	    case 1:
		// simple cub
		controlPointClicked.clear();
		mode=2;
		msgIndex=0;
		//System.out.println("Manager mode = "+mode);
		break;
	    case 2:
		// simple negative cub
		controlPointClicked.clear();
		mode=3;
		msgIndex=0;
		//System.out.println("Manager mode = "+mode);
		break;
	    case 3:
		// Quadratic Bezier
		controlPointClicked.clear();
		mode=4;
		msgIndex=0;
		//System.out.println("Manager mode = "+mode);
		break;
	    case 4:
		// Cubic Bezier
		controlPointClicked.clear();
		mode=5;
		msgIndex=0;
		//System.out.println("Manager mode = "+mode);
		break;
	    case 5:
// 		comp=new UnObjetTest();
		controlPointClicked.clear();
		mode=6;
		//takemode=true;// a enlever avec le test
		msgIndex=5;
		break;
		//case 6:
		// extended cubic
		//controlPointClicked.clear();
		//mode=7;
		//msgIndex=0;
		//takemode=true;
		//break;
	    }
	} 
	else if (type==2) {
	    // type == 2
	    takemode=false;
	    controlPointClicked.clear();
	    switch(ref){
	    case 0:
		mode=10;
		msgIndex=5;
		break;
	    case 1:
		mode=11;
		msgIndex=5;
		break;
	    case 2:
		mode=12;
		msgIndex=5;
		break;
	    }
	}

	else if (type==3) {
	    // type == 3
	    switch(ref){
	    case 0:
		// 0 Circle
		// no need to set the takemode 
		comp=new Circle(actualProp);
		break;
	    case 1:
		// 1 Rectangle
		// no need to set the takemode 
		comp=new JasRectangle(actualProp);
		break;
	    case 2:
		// 2 Oval
		// no need to set the takemode 
		comp=new Oval(actualProp);
		break;
	    case 3:
		// 3 line
		controlPointClicked.clear();
		mode=33;
		msgIndex=10;
		takemode=true;
		break;
	    case 4:
		// 4 Bezier Quad
		controlPointClicked.clear();
		mode=34;
		msgIndex=10;
		takemode=true;
		break;
	    case 5:
		// 5 Bezier Cubic
		controlPointClicked.clear();
		mode=35;
		msgIndex=10;
		takemode=true;
		break;
	    }
	}


	if (comp!=null)
	    allobject.addElement(comp);
	//System.out.println(allobject.size());
	return comp;
    }

    public void addObject(JasObject comp) {
	allobject.addElement(comp);
	// added for cloneable ****
	if (comp instanceof ANode) ((ANode) comp).updateVector(allobject);
    }
    public void addObject(Vector objects,Point pt) {
	// there are no Selection in the vector allobject at this time
	int sz2=allobject.size();

	// added for cloneable ----
	allobject.addAll(objects);	
	int sz=objects.size();
	for (int i=0;i<sz;i++) {
	    if (objects.elementAt(i) instanceof ANode){
		((ANode) objects.elementAt(i)).updateVector(allobject);
		((ANode) objects.elementAt(i)).moveIt((Point) pt);
		//((Node) objects.elementAt(i)).calcNodeGeom();
	    } else if (objects.elementAt(i) instanceof SimpleObject) {
		((SimpleObject) objects.elementAt(i)).moveIt((Point) pt);
	    }
	}
	// ------------------------

	sz=allobject.size();
	//System.out.println("sz2 : " + sz2+ " sz : " + sz);
	indexSelectedObject.clear();
	for (int j=sz2;j<sz;j++) {
	    indexSelectedObject.add(allobject.elementAt(j));
	}
	/*
	    if (j==sz2) {
		// first element
		selection=new Rectangle(((JasObject) allobject.elementAt(j)).getBounds());
	    }
	    else {
		selection=selection.union(((JasObject) allobject.elementAt(j)).getBounds());
	    }
	}
	sz=indexSelectedObject.size();
	if(sz!=1){
	    selection.grow(10,10);
	    currentselect=new SelectBox(selection);
	    ((SelectBox) currentselect).setResizable(false);
	    addObject((JasObject)currentselect);
	    currentselect.updateVector(allobject);
	} else {
	    JasObject temp=(JasObject) indexSelectedObject.elementAt(0);
       	    selectArea(indexObject(temp));
	    return;
	    } */
	   
    }

    public void reSelectSelection(){//Point pt){
	int sz=indexSelectedObject.size();
	for(int j=0;j<sz;j++){
	   if (j==0) {
		// first element
		selection=new Rectangle(((JasObject) indexSelectedObject.elementAt(j)).getBounds());
	    }
	    else {
		selection=selection.union(((JasObject) indexSelectedObject.elementAt(j)).getBounds());
	    }
	   ((JasObject) indexSelectedObject.elementAt(j)).selectObject();
	}
	sz=indexSelectedObject.size();
	if(sz!=1){
	    selection.grow(10,10);
	    currentselect=new SelectBox(selection);
	    ((SelectBox) currentselect).setResizable(false);
	    addObject((JasObject)currentselect);
	    currentselect.updateVector(allobject);
	} else {
	    JasObject temp=(JasObject) indexSelectedObject.elementAt(0);
       	    selectArea(indexObject(temp));
	    return;
	}
	//currentselect.moveIt(pt);
    }



    public void rmvObject(JasObject comp) {
	// this method rmv a object to the vector
	allobject.removeElement(comp);
    }

    public void rmvDefinitivelySelection(){
	int sz=indexSelectedObject.size();
	for(int i=0;i<sz;i++){
	    JasObject temp=(JasObject) indexSelectedObject.elementAt(i);
	    if(temp instanceof Node ||
	       temp instanceof AEdge ||
	       temp instanceof NodeLabel ||
	       temp instanceof JasRectangle ||
	       temp instanceof Oval ||
	       temp instanceof Circle)
		rmvDefinitivelyObject(temp);
	}
    }

    public void rmvDefinitivelyObject(JasObject comp){
	if (comp==null) return;
	if (comp instanceof ANode) {
	    // in that case , we must remove first all xMark
	    Vector temp;
	    int sz,i;
	    // delete IMark
	    temp=((ANode) comp).getImarks();
	    sz=temp.size();
	    for (i=0;i<sz;i++)
		rmvObject((JasObject) temp.elementAt(i));
	    // delete FMark
	    temp=((ANode) comp).getFmarks();
	    sz=temp.size();
	    for (i=0;i<sz;i++)
		rmvObject((JasObject) temp.elementAt(i));
	    // delete RMark
	    temp=((ANode) comp).getRmarks();
	    sz=temp.size();
	    for (i=0;i<sz;i++)
		rmvObject((JasObject) temp.elementAt(i));
	    // delete NodeLabel
	    temp=((ANode) comp).getNodeLabels();
	    sz=temp.size();
	    for (i=0;i<sz;i++)
		rmvObject((JasObject) temp.elementAt(i));

	    // delete the neibourg Edges...
	    temp=((ANode) comp).getEdges();
	    sz=temp.size();
	    for (i=0;i<sz;i++) {
		JasObject oyo=(JasObject) temp.elementAt(i);
		// removnind edge label
		rmvObject(((AEdge) oyo).getLabel());
		//System.out.println(oyo+" "+temp.size());
		ANode start=((AEdge) oyo).startingpoint;
		ANode end=((AEdge) oyo).endingpoint;
		ANode opposite;
		// We have to remove from the vector of the opposite Node
		if (start==(ANode) comp) opposite=end;
		else opposite=start;
		// Removing from the opposite Node
		if (!(oyo instanceof Loop))
		    opposite.rmvEdges((AEdge) oyo);
		rmvObject(oyo);
	    }
	    // TODO if there are Binode Edge delete them too
	    // TODO if there are self-return Edge delete them too
	}
	else if (comp instanceof IFMark) {
	    ((IFMark) comp).removeFromNode();
	    tb.updateImarkTab();
	   
	}
	else if (comp instanceof NodeLabel) {
	    ((NodeLabel) comp).removeFromNode();
	}
	else if (comp instanceof AEdge) {
	    // deletethe label if necessary
	    rmvObject(((AEdge) comp).getLabel());
	}
	else if (comp instanceof EdgeLabel) {
	    ((EdgeLabel) comp).getEdge().removeLabel();
	}
	rmvObject(comp);
	//System.out.println("------");
    }

    public void rmvDefinitivelyObject(JasObject comp,SurfaceDessin sfd){
	if(comp!=null){
	    rmvDefinitivelyObject(comp);
	    sendNextObj(sfd,comp);
	}
    }

    public boolean rmvObject(int itemnb) {
	// this method rmv a object to the vectorArrayIndexOutOfBoundsException
	try {
	    allobject.removeElementAt(itemnb);
	} 
	catch (ArrayIndexOutOfBoundsException e)
	    { return false;}  
	return true;
    }


    public int indexObject(JasObject comp) {
	// give the specified object index
	return allobject.indexOf(comp);
    }

    public JasObject myObjectAt(int index) {
	return ((JasObject) allobject.elementAt(index));
    }

    public boolean selectArea(int supleX,int supleY,int coteX,int coteY) {
	// return all objects in the selected area
	Rectangle zone=new Rectangle(supleX,supleY,coteX,coteY);
	int max =  allobject.size();
	int i,j=0;
	boolean anyobject=false;
	JasObject jonat;
	indexSelectedObject.clear(); // clear the Vector
	selectobjectnature=0;
	for (i=0;i<max;i++){
	    jonat=(JasObject) allobject.elementAt(i);
	    // this check if there are some object inside the rectangle
	    if (jonat.isInsideRectangle(zone)){
		// in that case , it intersects so we have to
		// add this iten in the selected Vector
		indexSelectedObject.addElement(jonat);
		jonat.selectObject();
		// describing selection nature
		if(jonat instanceof ANode) selectobjectnature|=1;
		else if(jonat instanceof AEdge) selectobjectnature|=2;
		// --
		if (!anyobject) {
		    // first element
		    selection=new Rectangle(((JasObject) indexSelectedObject.elementAt(j)).getBounds());
		}
		else {
		    selection=selection.union(((JasObject) indexSelectedObject.elementAt(j)).getBounds());
		}
		j++;
		anyobject=true;
		// System.out.println("hihi "+ i);
	    }
	}
	if (anyobject) {
	    int sz=indexSelectedObject.size();
	    
	    selection.grow(10,10);
	    //currentselect=new SelectBox(selection);
	    if (!(sz==1)) {
		currentselect=new SelectBox(selection);
		((SelectBox) currentselect).setResizable(false);
	    } else {
		// if the number of object selected is 1
		// then we should test which object it is
		JasObject temp=(JasObject) indexSelectedObject.elementAt(0);
		
		selectArea(indexObject(temp));
		indexSelectedObjectBackup=(Vector) indexSelectedObject.clone();
		return anyobject;
		/*switch(objectInformation(temp)) {
		case 21:
		    currentselect=new SelectIMark((IFMark) temp);
		    break;
		default:
		    currentselect=new SelectBox(selection);
		    }*/
	    }
	    
	    // Warning , the order of the two following line is important
	    addObject((JasObject)currentselect);
	    currentselect.updateVector(allobject);
	}
	indexSelectedObjectBackup=(Vector) indexSelectedObject.clone();
	return anyobject;
    }

    public boolean selectArea(int index) {
	if (index>countObject()) return false;
	JasObject jo=myObjectAt(index);
	indexSelectedObject.clear();
	// since version 1.15 , the seleted Object can be the 
	// selecbox itself or a Minibox
	// in that case wa have to return false
	if (jo instanceof MiniBox || jo instanceof Selection) return false;
	
	jo.selectObject();
	indexSelectedObject.addElement(jo);
	selection=new Rectangle(jo.getBounds());

	currentselect=jo.getObjectSelection(selection);
	// Warning , the order of the two following line is important
	addObject((JasObject)currentselect);
	currentselect.updateVector(allobject);
	
	return true;
	
    }


    public void moveSelectedObject(int pasX,int pasY){
	int max = indexSelectedObject.size();
	int i = 0;
	while (i<max) {
	    ((JasObject) indexSelectedObject.elementAt(i)).moveIt(pasX,pasY);
	    i++;
	}
    }

    public JasObject getFirstSelectedObject(){
	if (indexSelectedObject.size()==0) return null;
	return ((JasObject) indexSelectedObject.elementAt(0));
    }

    public Vector getSelectedObject() {
	return indexSelectedObject;
    }

    public int getNumberSelectedObject(){
	return indexSelectedObject.size();
    }


    public boolean removeAreaSelected(boolean stat_s){
	// remove miniBox
	if(stat_s) {
	    /*
	rmvObject(b1);
	rmvObject(b2);
	rmvObject(b3);
	rmvObject(b4);
	    */
	    //System.out.println("efface");
	    currentselect.removeFromVector(allobject);
	    rmvObject((JasObject)currentselect);
	    currentselect=null;
	}
	int sz=indexSelectedObject.size();
	for(int i=0;i<sz;i++){
	    ((JasObject) (indexSelectedObject.elementAt(i))).deselectObject();
	}
	indexSelectedObject.clear();
	return false;
    }

    public void drawAreaSelected(Graphics2D g){
	// DEPRECIATED
    }


    public int nearestObject(int x,int y) {
	// retrun the index of the nearest Object from the position given
	boolean found = false;
	//int max = indexObject((JasObject) allobject.lastElement()) + 1;
	int max =  allobject.size();
	int i=max-1;
	JasObject comp;
	while (i>=0) {
	    comp=(JasObject) allobject.elementAt(i);
	    if(comp!=null){
		double distance=comp.getMinDistance(x,y);
		if (distance<sensitivity) return i;
	    }
	    i--;
	}
	return -1;
    }

    public int nearestObject(int x,int y,int ind) {
	// retrun the index of the nearest Object from the position given
	// and from the index ind given
	boolean found = false;
	//int max = indexObject((JasObject) allobject.lastElement()) + 1;
	int max =  allobject.size();
	int i=max-1;
	if (ind<=i) i=ind;
	else return -1;

	JasObject comp;
	while (i>=0) {
	    comp=(JasObject) allobject.elementAt(i);
	    if(comp!=null){
		double distance=comp.getMinDistance(x,y);
		if (distance<sensitivity) return i;
	    }
	    i--;
	}
	return -1;
    }

    public Rectangle getInvalideRectangle(JasObject jo){
	// this method return the invalide area to redraw
	int tolerance=2; // effet de bord 
	Rectangle r;
	//if (jo==null) System.out.println("Big pb!");

	// 1 - if it is a node, then return the Union of the Node Boundary + its attached Edge
	if (jo instanceof Node) {
	    //System.out.println("Yes it is a Node!");
	    r=jo.getBounds();
	    Vector toInvalideIMark=((Node) jo).getImarks();
	    int sz=toInvalideIMark.size();
	    int i;
	    // IMark
	    for (i=0;i<sz;i++)
		r.add(((IFMark) toInvalideIMark.elementAt(i)).getBounds());

	    // FMark
	    toInvalideIMark=((Node) jo).getFmarks(); 
	    sz=toInvalideIMark.size();
	    for (i=0;i<sz;i++)
		r.add(((IFMark) toInvalideIMark.elementAt(i)).getBounds());


	    Vector toInvalideLabel=((Node) jo).getNodeLabels();
	    // label
	    sz=toInvalideLabel.size();
	    for (i=0;i<sz;i++)
		r.add(((NodeLabel) toInvalideLabel.elementAt(i)).getBounds());

	    Vector toInvalideEdge=((Node) jo).getEdges();
	    sz=toInvalideEdge.size();
	    for (i=0;i<sz;i++)
		r.add(((AEdge) toInvalideEdge.elementAt(i)).getBounds());
	    r.grow(tolerance,tolerance);
	    return r;
	    // -->TODO , the attached Node
	} else

	// 2 - if it is an Edge then the invalide is the boundary of this Edge
	if (jo instanceof AEdge) {
	    //System.out.println("Yes it is an Edge!");
	    r=jo.getBounds();
	    r.grow(tolerance,tolerance);
	    return r;
	} else if (jo instanceof MiniBox) {
	    r=jo.getBounds();
	    r.grow(tolerance,tolerance);
	    return r;
	} else if (jo instanceof SimpleObjectN){
	    //System.out.println("SimpleObjectN");
	    r=jo.getBounds();
	    r.grow(tolerance,tolerance);
	    return r;
	} else

	// 3 - the final case is when a selected area.
	//     The invalide Area is the Union of the Node Boundary + Union of the Edge Boundary +
	//     the Node's attached Edge boundary.

	// --> TODO
	if ((currentselect!=null) && (jo instanceof Selection)){
	    r=jo.getBounds();
	    r.grow(tolerance+3,tolerance+3);
	    return r;
	}  

	// default : return null
	return null;
    }

    public int objectInformation(JasObject jo){
	// 1 is a ANode type
	// 2 is a AEdge type
	// 21 is a IFMark
	if (jo instanceof IFMark) return 21;
	if (jo instanceof ANode) return 1;
	if (jo instanceof AEdge) return 2;
	return -1;
    }

    public void putZForeground(JasObject jo){
	rmvObject(jo);
	addObject(jo);
    }

    public void putZBackground(JasObject jo){
	int actualJoIndex=indexObject(jo);
	JasObject first=myObjectAt(0);
	// switching
	rmvObject(first);
	rmvObject(jo);
	allobject.insertElementAt(jo,0);
	allobject.insertElementAt(first,actualJoIndex);
    }

    public int getMode(){
	return mode;
    }

    public int getNumberPointClicked(){
	return controlPointClicked.size();
    }

    public Node getNeareastNode(int px,int py){
	// getting the nearest Node
	//boolean found=false;
	int sz=allobject.size()-1;
	int control;
	JasObject jo;
	
	while(sz>=0){
	    sz=nearestObject(px,py,sz);
	    if(sz!=-1){
		// then we found an object,
		// we must test if it is a node
		if ((jo=myObjectAt(sz)) instanceof Node) {
		    // good I found one !
		    return ((Node) jo); 
       		}
		else sz--;
		// earch for next Object
	    }
	}

	// Not found
	return null;
    }

    public boolean addPointZone(int px,int py,SurfaceDessin sfd){
	// return true if changing mode to 0 is needed

	// add a control zone
	boolean test=false;
	JasObject no;
	int nbclick;
	MiniBox miniControl;

	if (takemode) {
	    // we are waiting a point
	    miniControl=new MiniBox(px,py);
	    miniControl.setSensitive(false);
	    no=miniControl;
	} else {
	    no=getNeareastNode(px,py);
	    if (no==null) return test; // aborted, no Node athis coordinate
	    miniControl=new MiniBox(no.deprecated_getX(),no.deprecated_getY());
	    miniControl.setDepends(no);
	    miniControl.setSensitive(false);
	}

	//if (no==null) return test; // aborted, no Node athis coordinate
	
	// adding
	controlPointClicked.add(no);
	nbclick=getNumberPointClicked();
	vectorControlMode.add(miniControl);
	addObject(miniControl);
	msgIndex=1;

	// control
	switch(mode){
	case 1:
	    // Straight Node
	    // Need exactely 2 Node
	    if (nbclick==2) {
		Edge se;
		Node start=(Node) controlPointClicked.elementAt(0);
		Node end  =(Node) controlPointClicked.elementAt(1);
		// creating the new Edge
		se = new Edge(actualProp, start, end);
		// adding to the Vector
		addObject(se);
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;
		msgIndex=6;
		addObject(1,0);
	    }	    
	    break;


	case 2:
	    // Simple Curve
	    // Need exactely 2 Node
	    if (nbclick==2) {
		Edge se;
		Node start=(Node) controlPointClicked.elementAt(0);
		Node end  =(Node) controlPointClicked.elementAt(1);
		// creating the new Edge
		se = new Edge(actualProp, start, end, 8);
		// adding to the Vector
		addObject(se);
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;
		msgIndex=6;
		addObject(1,1);
	    }	    
	    break;

	case 3:
	    // Simple Curve
	    // Need exactely 2 Node
	    if (nbclick==2) {
		Edge se;
		Node start=(Node) controlPointClicked.elementAt(0);
		Node end  =(Node) controlPointClicked.elementAt(1);
		// creating the new Edge
		se = new Edge(actualProp, start, end, -8);
		// adding to the Vector
		addObject(se);
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;
		msgIndex=6;
		addObject(1,2);
	    }	    
	    break;
	    

	case 5:
	    // Bezier curve
	    // Need exactely 
	    // 4 parameters 2 Nodes - 2 Controlpoints
	    if (nbclick==4) {
		BezierCubicCurve bc;
		Node start=(Node) controlPointClicked.elementAt(0);
		Node end  =(Node) controlPointClicked.elementAt(1);
		Point2D pc1=((MiniBox) controlPointClicked.elementAt(2)).pos2Point2D();
		Point2D pc2=((MiniBox) controlPointClicked.elementAt(3)).pos2Point2D();

		bc=new BezierCubicCurve (actualProp, start, pc1, end, pc2);
		addObject(bc);

		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;msgIndex=6;
		addObject(1,4);
	    } else {
		if (nbclick>=2) {
		    takemode=true;
		    msgIndex=nbclick+1; // 3 and 4
		}
	    }
	    break;

	case 4:
	    // Round curve
	    // Need exactely 
	    // 3 parameters 2 Nodes - 1 Controlpoint
	    if (nbclick==3) {
		BezierQuadCurve rc;
		Node start=(Node) controlPointClicked.elementAt(0);
		Node end  =(Node) controlPointClicked.elementAt(1);
		Point2D pc1=((MiniBox) controlPointClicked.elementAt(2)).pos2Point2D();
		//		System.out.println(vectorControlMode.size());
		rc=new BezierQuadCurve(actualProp, start, end, pc1);
		addObject(rc);

		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;msgIndex=6;
		addObject(1,3);
	    } else {
		if (nbclick>=2) {
		    takemode=true;
		    msgIndex=2;
		}
	    }
	    break;

	case 6:
	    // Loop
	    // Need exactely 1
	    if (nbclick==1) {
		Loop le;
		Node start=(Node) controlPointClicked.elementAt(0);
		// creating the new Loop
		le = new Loop(actualProp, start);//, 8, 150, true);
		// adding to the Vector
		addObject(le);
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;
		msgIndex=6;
		addObject(1,5);
	    }	    
	    break;

	case 7:
	    break;


	case 10:
	    if (nbclick==1) {		
		Node nd=(Node) controlPointClicked.elementAt(0);	
		nd.addImark();
		nd.updateVector(allobject);
		sfd.tooBox.send2Toolbox(nd,sfd);
		sfd.tooBox.updateImarkTab();
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;msgIndex=6;
		addObject(2,0);
	    }
	    // Imark
	    break;
	case 11:
	    // FMark
	    
	    if (nbclick==1) {
		Node nd=(Node) controlPointClicked.elementAt(0);
		nd.addFmark();
		nd.updateVector(allobject);
		sfd.tooBox.send2Toolbox(nd,sfd);
		sfd.tooBox.updateImarkTab();
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;msgIndex=6;
		addObject(2,1);
	    }
	    break;
	case 12:
	    // MMark

	    if (nbclick==1) {
		Node nd=(Node) controlPointClicked.elementAt(0);
		nd.addRmark();
		nd.updateVector(allobject);
 		sfd.tooBox.send2Toolbox(nd,sfd);
 		sfd.tooBox.updateRMarkList();
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;msgIndex=6;
		addObject(2,2);
	    }
	    break;


	case 33:
	    // line
	    if (nbclick==2) {
		ExtendedEdge se;
		Point2D src=((MiniBox) controlPointClicked.elementAt(0)).pos2Point2D();
		Point2D dst=((MiniBox) controlPointClicked.elementAt(1)).pos2Point2D();
		ANode start=new InvisibleNode(actualProp);
		ANode end  =new InvisibleNode(actualProp);
		//addObject(start);
		//addObject(end);

		start.setPos((int) src.getX(),
			     (int) src.getY());
		
		end.setPos((int) dst.getX(),
			   (int) dst.getY());

		// creating the new Edge
		se = new ExtendedEdge(actualProp, start, end);
		// adding to the Vector
		addObject(se);
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;
		msgIndex=6;
		addObject(3,3);
	    } else {
		msgIndex=11;
	    }
	    break;
	case 34:
	    // quad
	    if (nbclick==3) {
		ExtendedQuad se;
		Point2D src=((MiniBox) controlPointClicked.elementAt(0)).pos2Point2D();
		Point2D dst=((MiniBox) controlPointClicked.elementAt(1)).pos2Point2D();
		Point2D pc1=((MiniBox) controlPointClicked.elementAt(2)).pos2Point2D();
		ANode start=new InvisibleNode(actualProp);
		ANode end  =new InvisibleNode(actualProp);

		start.setPos((int) src.getX(),
			     (int) src.getY());
		
		end.setPos((int) dst.getX(),
			   (int) dst.getY());

		// creating the new Edge
		se = new ExtendedQuad(actualProp, start, end, pc1);
		// adding to the Vector
		addObject(se);
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;
		msgIndex=6;
		addObject(3,4);
	    } else {
		msgIndex++;
		if (msgIndex>11) msgIndex=3;
	    }	   
	    break;
	case 35:
	    // cubic
	    if (nbclick==4) {
		ExtendedCubic se;
		Point2D src=((MiniBox) controlPointClicked.elementAt(0)).pos2Point2D();
		Point2D dst=((MiniBox) controlPointClicked.elementAt(1)).pos2Point2D();
		Point2D pc1=((MiniBox) controlPointClicked.elementAt(2)).pos2Point2D();
		Point2D pc2=((MiniBox) controlPointClicked.elementAt(3)).pos2Point2D();
		ANode start=new InvisibleNode(actualProp);
		ANode end  =new InvisibleNode(actualProp);
		start.setPos((int) src.getX(),
			     (int) src.getY());
		
		end.setPos((int) dst.getX(),
			   (int) dst.getY());

		// creating the new Edge
		se = new ExtendedCubic(actualProp, start, pc1, end, pc2);
		// adding to the Vector
		addObject(se);
		// reseting mode
		removeControlPoint();
		mode=0;
		takemode=false;
		test=true;
		msgIndex=6;
		addObject(3,5);
	    } else {
		msgIndex++;
		if (msgIndex>11) msgIndex=2;
	    }	   
	    break;

	}


	return false; //test;  // decomment if you want lockmode inactive 
	
    }

    public void refreshNew(JasObject jo){
	//System.out.println(jo);
	if (jo instanceof Node){
	    ((Node) jo).updateVector(allobject);
	}
	if (jo instanceof AEdge){
	    // label of Edge ...
	    if (((AEdge)jo).newlabeladded){
		((AEdge)jo).newlabeladded=false;
		allobject.add(((AEdge)jo).getLabel());
		//System.out.println("added");
	    }
	}
    }

    public void removeControlPoint() {
	int sz=vectorControlMode.size();
	for (int i=0;i<sz;i++) {
	    rmvObject((JasObject) vectorControlMode.elementAt(i));
	}
	vectorControlMode.clear();
    }

    /*    void updateToolBox(){
	 tb.updateImarkTab();
	}*/

    public int getMsgIndex() { return msgIndex; }
    public void reset2NodeMode(){
	mode=0;
	msgIndex=6;
	removeControlPoint();
    }

    
    
    // Some method for Gasset / GlobalProp
    public void createNewProp(){
	if(globalGasset.size()==0){
	    actualProp=new GastexGlobalProperties();
	} else {
	    actualProp=new GastexGlobalProperties(actualProp);
	}
	globalGasset.add(actualProp);
    }

    public void selectProp(GastexGlobalProperties gp){
	if (globalGasset.contains(gp))
	    actualProp=gp;
	else createNewProp();
    }

    public void removeProp(GastexGlobalProperties gp){
	globalGasset.remove(gp);
    }

    public Vector getPropV(){ return globalGasset; }

    public GastexGlobalProperties getActualProp(){
	return actualProp;
    }

    
    public GastexGlobalProperties getFirstProp(){
	return ((GastexGlobalProperties) globalGasset.elementAt(0));
    }

    public void addProp(GastexGlobalProperties gp){
	globalGasset.add(gp);
	actualProp=gp;
    }

    public void resetProp(){
	globalGasset.clear();
    }

    // *****

    public void updateVector(Node anode){
	anode.updateVector(allobject);
    }





    public void sendNextObj(SurfaceDessin sfd,JasObject jo){
	JasObject joN=null;
	resetAllObjectIndex();
	if(jo instanceof Node){
	    joN=getNextNode();
	} else if (jo instanceof IFMark) {
	    IFMark mem=null;
	    while((mem=getNextIFMark())!=null){
		if( mem.startingpoint==((IFMark)jo).startingpoint ){
		    System.out.println("Found another IFMark on Node 1");
		    break;
		}
		joN=mem;
		allobjectindex++;
	    }
	    if(mem!=null){
		joN=mem;
	    }
	} else if (jo instanceof AEdge) {
	    joN=getNextAEdge();
	} 
	/** **/
	if(joN==null && allobject.size()!=0){
	    joN=(JasObject) allobject.elementAt(0);
	}

	if(joN instanceof Selection || joN instanceof MiniBox || joN==null) {
	    sfd.tooBox.setVisible(false);
	    return;
	}
	sfd.tooBox.send2Toolbox(joN,sfd);
    }

    /**
     * this method get the next IFMark in the Vector allobject
     * return null if none
     */
    private IFMark getNextIFMark(){
	JasObject jo;
	int sz=allobject.size();
	if(sz==0) return null;

	while(allobjectindex<sz){
	    jo=myObjectAt(allobjectindex);
	    if(jo instanceof IFMark) return ((IFMark)jo);
	    allobjectindex++;
	}
	return null;
    }

    private Node getNextNode(){
	JasObject jo;
	int sz=allobject.size();
	if(sz==0) return null;

	while(allobjectindex<sz){
	    jo=myObjectAt(allobjectindex);
	    if(jo instanceof Node) return ((Node)jo);
	    allobjectindex++;
	}
	return null;
    }

    private AEdge getNextAEdge(){
	JasObject jo;
	int sz=allobject.size();
	if(sz==0) return null;

	while(allobjectindex<sz){
	    jo=myObjectAt(allobjectindex);
	    if(jo instanceof AEdge) return ((AEdge)jo);
	    allobjectindex++;
	}
	return null;
    }

    private void resetAllObjectIndex(){ allobjectindex=0; }

    public int getSelectionNature(){
	// 0 nothing
	// 1 ANode
	// 2 AEdge
	// 3 Mix
	return selectobjectnature;
    }

    public Vector getSelectedObjectB(){
	return indexSelectedObjectBackup;
    }

    public void setSlide(boolean b) { slide=b; }
    public boolean getSlide() {return slide;}

    public boolean isSFEmpty(){
	int sz=allobject.size();
	int i=0;
	JasObject comp;
	while(i<sz){
	    comp=(JasObject) allobject.elementAt(i);
	    if (comp instanceof ANode || 
		(comp instanceof AEdge && !(comp instanceof IFMark)) ||
		(comp instanceof SimpleObject)) { 
		return false;	
	    }
	    i++;
	}
	return true;
    }

    public void updateEdge(AEdge aed){
	aed.updateLabelManager(allobject);
    }

    public Rectangle getBounds(){
	int i=0;
	int max=allobject.size();
	JasObject comp;
	Rectangle r = new Rectangle(0,0,1,1);
	while (i < max) {
	    comp=(JasObject) allobject.elementAt(i);
	    if (comp instanceof ANode || 
		(comp instanceof AEdge)) {
		r.add(comp.getBounds());
	    }
	    i++;
	}
	r.grow(10, 10);
	return r;
    }

}



 






