package jastex.gui;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import jastex.JasDash;
import jastex.old.gui.*;

/** This class implement a new composant composed 
 * by a JComboBox containing an IconImage & a String
 */
public class JasComboBox extends JPanel {
    public ImageIcon images[];
    public JComboBox comboList;
    public String[] imageName;
    public String[] imageCaption;
    public JasDash[] dash;
    
    public JasComboBox(String[] imageName, String[] imageCaption) {
	this.imageName = imageName;
	this.imageCaption = imageCaption;
        images = new ImageIcon[imageName.length];
	boolean isAppli = MainWindow.isAppli;
	
	
	/* Create the ImageIcon table */
       	if(isAppli)
	    {	
		for (int i = 0; i < imageName.length; i++) {
		    images[i] = new ImageIcon("images/" + imageName[i] + ".gif");
		    images[i].setDescription(imageCaption[i]);
		}
	    }
	else 
	    {
		URL location;
		for (int i = 0; i < imageName.length; i++) {
		    location = JasComboBox.class.getResource("images/"+imageName[i]+ ".gif");
		    images[i] = new ImageIcon(location);
		    images[i].setDescription(imageCaption[i]);
		}
	    }
		
        // Create the combo box
	comboList = new JComboBox(images);
        ComboBoxRenderer renderer= new ComboBoxRenderer();
	comboList.setRenderer(renderer);
        comboList.setMaximumRowCount(5);
	
	setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
        add(comboList);
	
    }


   public JasComboBox(String[] imageName, JasDash[] dash) {
	this.imageName = imageName;
	this.imageCaption = imageName;
	this.dash = dash;
        images = new ImageIcon[imageName.length];
	boolean isAppli = MainWindow.isAppli;
	
	
	/* Create the ImageIcon table */
       	if(isAppli)
	    {	
		for (int i = 0; i < imageName.length; i++) {
		    images[i] = new ImageIcon("images/" + imageName[i] + ".gif");
		    images[i].setDescription(imageCaption[i]);
		}
	    }
	else 
	    {
		URL location;
		for (int i = 0; i < imageName.length; i++) {
		    location = JasComboBox.class.getResource("images/"+imageName[i]+ ".gif");
		    images[i] = new ImageIcon(location);
		    images[i].setDescription(imageCaption[i]);
		}
	    }
		
        // Create the combo box
	comboList = new JComboBox(images);
        ComboBoxRenderer renderer= new ComboBoxRenderer();
	comboList.setRenderer(renderer);
        comboList.setMaximumRowCount(5);
	
	setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
        add(comboList);
	
    }






    public JasComboBox(String[] imageName) {
	this.imageName = imageName;
	this.imageCaption = imageCaption;
        images = new ImageIcon[imageName.length];
	boolean isAppli = MainWindow.isAppli;

	
	/* Create the ImageIcon table */
	if(isAppli)
	    {	
		for (int i = 0; i < imageName.length; i++) {
		    images[i] = new ImageIcon("images/" + imageName[i] + ".gif");
		    images[i].setDescription(imageCaption[i]);
		}
	    }
	else 
	    {
		URL location;
		for (int i = 0; i < imageName.length; i++) {
		    location = JasComboBox.class.getResource("images/"+imageName[i]);
		    images[i] = new ImageIcon(location);
		}
	    }
	
        // Create the combo box
        comboList = new JComboBox(images);
	comboList.setMaximumRowCount(5);
	
	setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
        add(comboList);
	
    }

    public String getSelected()
    {
	return imageCaption[comboList.getSelectedIndex()];
    }


    public JasDash getSelectedDash()
    {
	return dash[comboList.getSelectedIndex()];
    }

    public void setSelectedItem(String item)
    {
	boolean ok = false ;
	int num = comboList.getItemCount();
	for(int i=0; i< num; i++)
	    {
	  	if ( ((ImageIcon) comboList.getItemAt(i)).getDescription() == item )
		    {
			comboList.setSelectedIndex(i);
			ok = true;
		    }
		
		if(!ok)
		    {
			comboList.removeItemAt(num-1);
			images[num-1].setDescription(item);		
			comboList.insertItemAt(images[num-1],num-2);
		    }
	    }
    }

    public void setEnabled(boolean bool)
    {
	comboList.setEnabled(bool);
    }

    
    public int getSelectedIndex()
    {
	return comboList.getSelectedIndex();
    }

    public void setselectedIndex(int index)
    {
	comboList.setSelectedIndex(index);
    }
    
    /* Combo Renderer*/
    class ComboBoxRenderer extends JLabel implements ListCellRenderer {
        public ComboBoxRenderer() {
            setOpaque(true);
            setHorizontalAlignment(LEFT);
  
        }

        public Component getListCellRendererComponent(
                                           JList list,
                                           Object value,
                                           int index,
                                           boolean isSelected,
                                           boolean cellHasFocus) {
            if (isSelected) {
                setBackground(list.getSelectionBackground());
                setForeground(list.getSelectionForeground());
            } else {
                setBackground(list.getBackground());
                setForeground(list.getForeground());
            }

            ImageIcon icon = (ImageIcon)value;
            setText(icon.getDescription());
            setIcon(icon);
            return this;
        }
    }

}
