package jastex.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import jastex.*;
import java.util.Enumeration;


/** This class create the toolbox in order to modify
 * Node or Edge properties
 */
public class JasObjectToolBox extends JasToolBox implements ActionListener {

    /** JasObject being modify through the ToolBox */
    private IEditable object;
    /** SurfaceDessin sending the object */
    // FIXME public SurfaceDessin sd; 
    /** the value and the name of the unitlength */
    private JLabel unitNameLabel;


    /** Constructor which initializes a toolBox
     * unvisible and empty
     * @param parentFrame the Parent frame of the ToolBox dialog
     * @param toolBoxTitle the title of the toolbox dialogbox
     * */
    public JasObjectToolBox(Frame parentFrame, String toolBoxTitle)
    {
	/* Creation of the ToolBox of the death */
	super(parentFrame, toolBoxTitle);
	
	/* Apply Buton */
	JButton applyButton = new JButton(Languages.tb_ApplyBtn);
	applyButton.setActionCommand("apply");
	applyButton.addActionListener(this);

	/* unitLength / unitName label */
	unitNameLabel = new JLabel();
	
	JPanel buttonPane = new JPanel(); 
	buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.X_AXIS));
	buttonPane.add(unitNameLabel);
	buttonPane.add(Box.createHorizontalGlue());
	buttonPane.add(applyButton);
	
	GridBagLayout layout = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	c.fill = GridBagConstraints.BOTH;	
	getContentPane().setLayout(layout);
	
	c.gridx = 0;
	c.gridy = 0;
	layout.setConstraints(tabbedPane, c);
	getContentPane().add(tabbedPane);
	
	c.gridx = 0;
	c.gridy = 1;
	c.insets = new Insets(5, 0, 0, 0);
	layout.setConstraints(buttonPane, c);
	getContentPane().add(buttonPane);
    }

    public void actionPerformed(ActionEvent ev) {
        String command = ev.getActionCommand();
        
        if (command == "apply") {
            for (Enumeration<JasTab> e = onglets.elements(); e.hasMoreElements() ;) {
                JasTab tab = e.nextElement();
                tab.apply();
            }
        }
    }
    
    public void sendObject(IEditable obj) {
        if (obj != object) {
            destroyTabs();
            object = obj;
            object.updateToolBox(this);
            pack();
        }
    }
}
