package jastex.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import jastex.old.gui.*;
import jastex.*;


public class JasScrollBox extends JPanel implements ActionListener, MouseListener {
    public int valueInt;
    public int minInt=0;
    public int maxInt=Integer.MAX_VALUE;
    public int pasInt=1;
    
    public int numTimer = 0;
    public int stepTimer = 4;
    public int pasIntTimer =  pasInt;

    public double valueDouble;
    public double minDouble=0.0;
    public double maxDouble=Double.MAX_VALUE;
    public double pasDouble=0.1;

    public double pasDoubleTimer = pasDouble;

    public boolean hold = false;
    
    public final JTextField text;
    public JButton plusButton ;
    public JButton minusButton ;
    public ImageIcon minusIcon;
    public ImageIcon plusIcon;

    public Timer timer_plus;
    public Timer timer_minus;

    private final static int INTEGER = 0, DOUBLE = 1;
    private int type;  
    public static String[] icon_filename={ "images/minus.gif", "images/plus.gif"};
    
    protected GridBagLayout layout;
    protected GridBagConstraints c;
    
    /** Constructor: instanciate a new ScrollBox Composant
     * initialized with an integer value
     * @param value the initial value
     */
    public JasScrollBox(int value)
    {
	super();	
	type = INTEGER;
	
	Configuration config = new Configuration("configuration.properties");
	boolean isAppli = MainWindow.isAppli;
	//setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
	layout = new GridBagLayout();
	c = new GridBagConstraints();
	
	if (isAppli)
	    {
		minusIcon = new ImageIcon(icon_filename[0]);
		plusIcon = new ImageIcon(icon_filename[1]);
	
	    }
	else 
	    {
		URL location;
		location = JasScrollBox.class.getResource(icon_filename[0]);
		minusIcon = new ImageIcon(location);
		location = JasScrollBox.class.getResource(icon_filename[1]);
		plusIcon = new ImageIcon(location);
	
		
	    }
	
	minusButton = new JButton(minusIcon);
	minusButton.setName("minus");
	minusButton.setActionCommand("minus");
	minusButton.addActionListener(this);
	minusButton.addMouseListener(this);
	minusButton.setToolTipText(Languages.sb_tooltip[0]);
	plusButton = new JButton(plusIcon);
	plusButton.setName("plus");
	plusButton.setActionCommand("plus");
	plusButton.addActionListener(this);
	plusButton.addMouseListener(this);
	plusButton.setToolTipText(Languages.sb_tooltip[1]);
	minusButton.setPreferredSize(new Dimension(20,20));
	plusButton.setPreferredSize(new Dimension(20,20));
	text = new JTextField(4);	
	text.setHorizontalAlignment(SwingConstants.RIGHT);

	c.gridx=0;
	layout.setConstraints(minusButton,c);
	add(minusButton);

	c.gridx=1;
	layout.setConstraints(text,c);
	add(text);

	c.gridx=2;
	layout.setConstraints(plusButton,c);
	add(plusButton);
	setValue(value);


	timer_plus = new Timer(100, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    incInt();
		} 
	    });
	timer_plus.setRepeats(true);




	timer_minus =  new Timer(100, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    decInt();
		} 
	    });
	timer_minus.setRepeats(true);


    }
    



    /** Constructor: instanciate a new ScrollBox Composant
     * initialized with an integer value
     * @param value the initial value
     */
    public JasScrollBox(double value)
    {
	super();	
	type = DOUBLE;

	boolean isAppli = true; //MainWindow.isAppli;	
	layout = new GridBagLayout();
	c = new GridBagConstraints();


	if (isAppli)
	    {
		minusIcon = new ImageIcon(icon_filename[0]);
		plusIcon = new ImageIcon(icon_filename[1]);
	    }
	else 
	    {
		URL location;
		location = JasScrollBox.class.getResource(icon_filename[0]);
		minusIcon = new ImageIcon(location);
		location = JasScrollBox.class.getResource(icon_filename[1]);
		plusIcon = new ImageIcon(location);
	    }
	
	
	minusButton = new JButton(minusIcon);
	minusButton.setName("minus");
	minusButton.setActionCommand("minus");
	minusButton.addActionListener(this);
	minusButton.addMouseListener(this);
	minusButton.setToolTipText(Languages.sb_tooltip[0]);
	plusButton = new JButton(plusIcon);
	plusButton.setName("plus");
	plusButton.setActionCommand("plus");
	plusButton.addActionListener(this);
	plusButton.addMouseListener(this);
	plusButton.setToolTipText(Languages.sb_tooltip[1]);
	minusButton.setPreferredSize(new Dimension(20,20));
	plusButton.setPreferredSize(new Dimension(20,20));
	text = new JTextField(4);
	text.setHorizontalAlignment(SwingConstants.RIGHT);

	c.gridx=0;
	layout.setConstraints(minusButton,c);
	add(minusButton);

	c.gridx=1;
	layout.setConstraints(text,c);
	add(text);

	c.gridx=2;
	layout.setConstraints(plusButton,c);
	add(plusButton);
	setValue(value);


	timer_plus = new Timer(100, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    incDouble();
		} 
	    });
	timer_plus.setRepeats(true);

	timer_minus = new Timer(100, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    decDouble();
		} 
	    });
	timer_minus.setRepeats(true);
    }


    /** constructor :instanciate a new int ScrollBox 
     * with a specific increment step
     * @param int initial value
     * @param pas increment step
     */
    public JasScrollBox(int value , int pas)
    {
	this(value);
	setPas(pas);
    }  


    /** constructor :instanciate a new int ScrollBox 
     * with a specific increment step, and max & min limit
     * @param int initial integer value
     * @param min minimum value allowed
     * @param max maximum value allowed
     * @param pas increment step
     */
    public JasScrollBox(int value , int min, int max , int pas)
    {
	this(value,pas);
	setMin(min);
	setMax(max);
    }  


    

    /** constructor :instanciate a new double ScrollBox 
     * with a specific increment step
     * @param int initial value
     * @param pas increment step
     */
    public JasScrollBox(double value , double pas)
    {
	this(value);
	setPas(pas);
    }  

    /** constructor :instanciate a new double ScrollBox 
     * with a specific increment step, and max & min limit
     * @param int initial double value
     * @param min minimum value allowed
     * @param max maximum value allowed
     * @param pas increment step
     */
    public JasScrollBox(double value , double min, double max , double pas)
    {
	this(value,pas);
	setMin(min);
	setMax(max);
    }  

  
  
    /** set the minimum value of the scrollbox
     * @param min minimum value
     */
    public void setMin(int min)   { 
	if(type == INTEGER)
	    this.minInt = min; 
	else if(type == DOUBLE)
	    this.minDouble = min;
    }

    /** set the minimum value of the scrollbox 
     * @param min minimum value
     */
    public void setMin(double min)   { this.minDouble = min;    }

    
    /** set the maximum value of the scrollbox
     * @param max maximum value
     */
    public void setMax(int max)  { 
	if(type == INTEGER)
	    this.maxInt = max;
	else if(type == DOUBLE)
	    this.maxDouble = max;
    }

    /** set the maximum value of the scrollbox
     * @param max maximum value
     */
    public void setMax(double max)  { this.maxDouble = max; }

    /** set the increment step of the scrollbox
     * @param pas increment step
     */
    public void setPas(int pas)  { 
	this.pasInt = pas;    
	this.pasIntTimer = pas;
    }


    /** set the increment step of the scrollbox
     * @param pas increment step
     */
    public void setPas(double pas) { 
	this.pasDouble = pas; 
	this.pasDoubleTimer = pas;
    }



    /** return the increment step of the scrollbox
     */
    public double getPas()  { 
	if(type == INTEGER)
	    return this.pasInt;
	else return this.pasDouble;
	
    }



    /** set the value of the Scrollbox
     * @param value the new value
     */
    public void setValue(double value)
    {
	type=DOUBLE;
	double decal = Math.pow(10, 2);
	Double valueArr =new Double(((Math.round(value*decal))/decal));
	text.setText(valueArr.toString());
    }

    /** set the value of the Scrollbox
     * @param value the new value
     */
    public void setValue(int value)
    {
	type=INTEGER;
	int decal = (int) Math.pow(10,2);
	Integer valueArr = new Integer( ((Math.round(value*decal))/decal) );
	text.setText(valueArr.toString(value));
    }



    /** increment the value */
    private void incDouble()
    {
	if(numTimer == stepTimer) {
	    pasDoubleTimer+=pasDouble;
	    numTimer = 0;
	}
	else numTimer++;

	double num;
	try {
	    num = stringToDouble(text.getText());
	} catch (NumberFormatException e1) {
	    System.out.println("Exception");
	    num = 0.0; }
	
	if(num < minDouble)
	    num =  minDouble + pasDoubleTimer;
	else 
	    {
		if((num+pasDoubleTimer) <maxDouble) 
		    num += pasDoubleTimer;
		else 
		    num = maxDouble;
	    }
	
	num = (double)Math.round(num *1000)/1000;			 
	
	text.setText(java.lang.Double.toString(num));
    }
    

    /** decrement the value */
    private void decDouble()
    {
	if(numTimer == stepTimer) {
	    pasDoubleTimer+=pasDouble;
	    numTimer = 0;
	}
	else numTimer++;

	double num;
	try {
	    num = stringToDouble(text.getText());
	} catch (NumberFormatException e1) {
	    System.out.println("Exception");
	    num = 0.0; }

	if((num-pasDoubleTimer) > minDouble) 
	    num-= pasDoubleTimer;
	else 
	    num = minDouble;
	num = (double)Math.round(num *1000)/1000;	
	text.setText(java.lang.Double.toString(num));
    }

    /** increment the value */
    private void incInt()
    {
	if(numTimer == stepTimer) {
	    pasIntTimer+=pasInt;
	    numTimer = 0;
	}
	else numTimer++;

	int num;
	try {
	    num = stringToInt(text.getText());
	} catch (NumberFormatException e1) {
	    System.out.println("Exception");
	    num = 0; }
	
	if(num+ pasIntTimer < minInt)
	    num = minInt+pasIntTimer;
	else 
	    {
		if(num + pasIntTimer< maxInt) num+=pasIntTimer;
		else num = maxInt;
	    }
	text.setText(java.lang.Integer.toString(num));
    }

    /** decrement the value */
    private void decInt()
    {
	if(numTimer == stepTimer) {
	    pasIntTimer+=pasInt;
	    numTimer = 0;
	}
	else numTimer++;

	int num;
	try {
	    num = stringToInt(text.getText());
	} catch (NumberFormatException e1) {
	    System.out.println("Exception");
	    num = 0; }
	
	if(num-pasIntTimer > minInt) 
	    num-=pasIntTimer;
	else 
	    num = minInt;
	text.setText(java.lang.Integer.toString(num));
    }


    /** convert a string to an int */
    private static int stringToInt(String stringObject)
    {
	return Integer.parseInt(stringObject.trim());
    }
    
    /** cinvert a string to a double */
    private static double stringToDouble(String stringObject)
    {
	return Double.parseDouble(stringObject.trim());
    }


    /** return the scrollbox value */
    public double getValue()
    {
	if(type == DOUBLE)
	    {
		try {
		    return Double.parseDouble(text.getText());
		} catch (NumberFormatException e1) { return 0; }
	    }
	else 
	    try {
		return Integer.parseInt(text.getText());
	    }catch (NumberFormatException e1){ 	return 0.0;    }

    }

    
    /** Enable or disable the JasScrollBox component */
    public void setEnabled(boolean enable)
    {
	plusButton.setEnabled(enable);
	minusButton.setEnabled(enable);
	text.setEnabled(enable);
    }


    /** Set the action command one of the SrollBox button 
     * @param btn the button (value: plus or minus)
     * @param command the action command
     */
    public void setActionCommand(String btn , String command)
    {
	if(btn.equals("plus"))
	    plusButton.setActionCommand(command);
	else if(btn.equals("minus"))
	    minusButton.setActionCommand(command);
    }
    

    public void addActionListener(String btn, ActionListener listener)
    {
	if(btn.equals("plus"))
	    plusButton.addActionListener(listener);
	else if(btn.equals("minus"))
	    minusButton.addActionListener(listener);

    }


    public void setName(String btn, String name)
    {
	if(btn.equals("plus"))
	    plusButton.setName(name);
	else if(btn.equals("minus"))
	    minusButton.setName(name);
    }


    public void mouseClicked(MouseEvent m)  { }

    public void mouseReleased(MouseEvent e)
    {
	if( e.getComponent().getName().startsWith("plus")){
	    if(timer_plus.isRunning()) 
		timer_plus.stop();
	}
	else if( e.getComponent().getName().startsWith("minus")) {
	    if(timer_minus.isRunning()) 
		timer_minus.stop();  
	}

	pasIntTimer = pasInt;
	pasDoubleTimer = pasDouble;
	numTimer = 0;
    }

    public void mouseEntered(MouseEvent m)   { }

    public void mouseExited(MouseEvent e)  {
    	if( e.getComponent().getName().startsWith("plus")){
	    if(timer_plus.isRunning()) 
		timer_plus.stop();
	}
	else if( e.getComponent().getName().startsWith("minus")) {
	    if(timer_minus.isRunning()) 
		timer_minus.stop();  
	}

	pasIntTimer = pasInt;
	pasDoubleTimer = pasDouble;
	numTimer = 0;
    }

    public void mousePressed(MouseEvent e) {
	if( e.getComponent().getName().startsWith("plus")) {
	    if(!timer_plus.isRunning()) 
		timer_plus.start();	
	} 
	else if( e.getComponent().getName().startsWith("minus")){
	    if(!timer_minus.isRunning()) 
		timer_minus.start();	
	}
    }
    

     public void actionPerformed(ActionEvent e)
     {
	 if(type == INTEGER)
	     {
		 int num;
		 try {
		     num = stringToInt(text.getText());
		 } catch (NumberFormatException e1) {
		     System.out.println("Exception");
		     num = 0; }
		 
		 if(e.getActionCommand().startsWith("minus"))
		     {
			 if(num-pasInt > minInt) 
			     num-=pasInt;
			 else 
			     num = minInt;
			 text.setText(java.lang.Integer.toString(num));
		     }
		 else if(e.getActionCommand().startsWith("plus"))
		     {
			 if(num+ pasInt < minInt)
			     num = minInt+pasInt;
			 else 
			     {
				 if(num + pasInt< maxInt) num+=pasInt;
				 else num = maxInt;
			     }
			 text.setText(java.lang.Integer.toString(num));
		     }
	     }
	 else if(type==DOUBLE)
	     {
		 double num;
		 try {
		     num = stringToDouble(text.getText());
		 } catch (NumberFormatException e1) {
		     System.out.println("Exception");
		     num = 0.0; }

		 if(e.getActionCommand().startsWith("minus"))
		     {
			 if((num-pasDouble) > minDouble) 
			     num-= pasDouble;
			 else 
			     num = minDouble;
			 num = (double)Math.round(num *1000)/1000;
			 text.setText(java.lang.Double.toString(num));
		     }
		 else if(e.getActionCommand().startsWith("plus"))
		     {
			 if(num < minDouble)
			     num =  minDouble + pasDouble;
			 else 
			     {
				 if((num+pasDouble) <maxDouble) 
				     num += pasDouble;
				 else 
				     num = maxDouble;
			     }
			 
			 num = (double)Math.round(num *1000)/1000;			 
			
			 text.setText(java.lang.Double.toString(num));
		     }

	     }
	 
     }



}
