package jastex.gui;

import javax.swing.*;
import java.awt.*;


public abstract class JasTab extends JPanel {
    public String title;
    public boolean debug = false;
    
    private GridBagLayout layout;
    private GridBagConstraints constraints;
    private int numElements;

    /* filename*/
    protected String[] colorStrings = {
        "color_black", "color_blue", "color_brown", "color_cyan", 
        "color_gray", "color_green", "color_magenta", "color_red",
        "color_yellow", "color_white", "color_blank" };
    
    /*caption in the JasComboBox */
    protected String[] colorCaption = {
        "Black", "Blue", "Brown", "Cyan",
	"Gray", "Green", "Magenta", "Red",
	"Yellow", "White", "Custom" };

    
    /** Constructor : Instanciate a new Tab
     * @param title the tab caption
     */
    public JasTab(String title)
    {
	super();
	numElements = 0;

	layout = new GridBagLayout();
	constraints = new GridBagConstraints();
	setLayout(layout);
	this.title = title;
	constraints.anchor = GridBagConstraints.WEST;
    }

    
    /*public JasObject object;
    public Vector objects;

    public JasTab(String title, JasObject object)
    {
    }
    
    public JasTab(String title, Vector objects)
    {
    }*/
    
    /** Add a new couple (caption, component) */
    public void insertProperty(String libelle, JComponent champs)
    {
	JLabel label = new JLabel(libelle);
	constraints.gridx = 0;
	constraints.gridy = numElements;
	layout.setConstraints(label, constraints);
	add(label);
	constraints.gridx = 1;
	constraints.gridy = numElements;
	constraints.insets = new Insets(1, 0, 1, 1);
	layout.setConstraints(champs, constraints);
	add(champs);
	numElements++;
    }

    /** add a new caption in the tab */
    public void insertPropertie(String libelle)
    {
	JLabel label = new JLabel(libelle);
	constraints.gridx = 0;
	constraints.gridy = numElements;
	layout.setConstraints(label,constraints);
	add(label);
	numElements++;
    }

    /** add a new component in the tab */
    public void insertProperty(JComponent champs)
    {
	constraints.gridx = 0;
	constraints.gridy = numElements;
	constraints.insets = new Insets(1, 0, 1, 1);
	layout.setConstraints(champs, constraints);
	add(champs);
        numElements++;
    }

    /** add a couple of caption to the tab */
    public void insertProperty(JComponent champs1, JComponent champs2)
    {
	constraints.gridx = 0;
	constraints.gridy = numElements;
	layout.setConstraints(champs1, constraints);
	add(champs1);
	
	constraints.gridx = 1;
	constraints.gridy = numElements;
	constraints.insets = new Insets(1, 0, 1, 1);
	layout.setConstraints(champs2, constraints);
	add(champs2);
	
	numElements++;
    }

    public <T extends JasTab> T findTab(Class<T> type) {
        Object obj = null;
        if (type.isInstance(obj)) return type.cast(obj);
        return null;
    }
    
    public abstract void apply();
    
    /* There is nothing interesting below... */

    /** return the tab title */
    public String getTabTitle()
    {
        return title;
    }

    public void  setTabTitle(String title)
    {
        this.title = title ;
    }

    protected void debug(String msg)
    {
	if(debug) System.out.println(msg);
    }
}
