package jastex.gui;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import jastex.*;


/** This class create the toolbox in order to modify
 * Node or Edge properties
 */
public class JasToolBox extends JDialog {

    public boolean debug = false;
    /** tabbed panel contaning the properties */
    protected JTabbedPane tabbedPane;
    /** Vector containing each tab */
    protected Vector<JasTab> onglets;
    /** the parent frame of the toolbox typically Mainwindow */
    protected Frame parentFrame;
    

    /** Constructor which initializes a toolBox
     * unvisible and empty
     *  @param parentFrame the Parent frame of the ToolBox dialog
     *  @param toolBoxTitle the title of the toolbox dialogbox
     *  @param modal true if the toolbox is modal, false either
     */
    public JasToolBox(Frame parentFrame, String toolBoxTitle, boolean modal)
    {
	/* Creation of the JDialog of the death */
	super(parentFrame, toolBoxTitle, modal);
	this.parentFrame = parentFrame;
	onglets = new Vector<JasTab>();
	tabbedPane = new JTabbedPane();
        setResizable(false);
    }
    
    
    /** Constructor which initializes a toolBox
     * unvisible and empty
     *  @param parentFrame the Parent frame of the ToolBox dialog
     *  @param toolBoxTitle the title of the toolbox dialogbox
     */
    public JasToolBox(Frame parentFrame, String toolBoxTitle)
    {
	this(parentFrame, toolBoxTitle, false);
    }


    /** 
     *  Resize the toolbox
     */
    public void updateSize()
    {
	setResizable(true);
	pack();
	setResizable(false);
    }


    /** Method detroying all the tabs
     *  of the toolbox
     */
    public void destroyTabs() {
        tabbedPane.removeAll();
        onglets.clear();
    }
    

    /** Add a tab in the vector
     * @param tab the JasTab to add
     */
    public void addTab(JasTab tab) {
        onglets.add(tab);
        tabbedPane.addTab(tab.title, tab);
    }
    
    protected void debug(String msg)
    {
	if(Configuration.modedebug.equals("on"))
	    System.out.println(msg);
    }

    protected void debug(int i)
    {
	if(Configuration.modedebug.equals("on"))
	    System.out.println(i);
    }
}
