/*
 * PointEdit.java
 *
 * Created on 20 mars 2005, 14:51
 */

package jastex.gui;

import java.awt.Color;
import java.awt.Cursor;

import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;


/**
 * based on MiniBox
 * @author steph
 */
public class MouseablePoint extends Rectangle2D.Double {

    private static final double boxDim = 3;
    
    public double curX, curY;
    public Color color = Color.BLUE;
    public Cursor cursor;
    public double granularity = 0;
    
    private double oldX, oldY;
    protected double dx, dy;
    
    /** Creates a new instance of PointEdit */
    public MouseablePoint(int cur) {
        cursor = Cursor.getPredefinedCursor(cur);
    }
    
    public MouseablePoint() {
        this(Cursor.MOVE_CURSOR);
    }

    public void updateGeom(double zoomFactor) {
        width = height = (2*boxDim+1)*zoomFactor;
        x = curX-boxDim*zoomFactor;
        y = curY-boxDim*zoomFactor;
    }
    
    public void setPosition(double x, double y) {
        curX = x;
        curY = y;
    }
    
    public boolean startDrag(double x, double y) {        
        if (contains(x, y)) {
            oldX = curX;
            oldY = curY;
            dx = curX-x;
            dy = curY-y;
            return true;
        } else {
            return false;
        }
    }
    
    public void onDrag(double x, double y) {
        curX = x+dx;
        curY = y+dy;
    }
}
