/*
 * AbstractJasObject.java
 *
 * Created on 17 mars 2005, 07:49
 */

package jastex.obj;
import jastex.*;


/**
 * Abstract class which implements IJasObject provides standard behavior
 * of JasTeX objects.
 * @author sglondu
 */
public abstract class AbstractJasObject implements IJasObject {

    protected GastexGlobalProperties globalProp;

    /** Constructor initializing the field with 
     * GastexGlobalProperties default value
     * @param _ggp The GastexGlobalProperties used to init
     * @see GastexGlobalProperties
     */
    protected AbstractJasObject(GastexGlobalProperties _ggp) {
        setGgp(_ggp);
    }
    
    protected abstract String getLatexCodeProperties();
    
    protected String formatLatexCodeProperties() {
        String lProp = getLatexCodeProperties();
	if (lProp.equals("")) {
	    return "";
	} else {
            // cut the first comma
            return ("[" + lProp.substring(1) + "]");
	}
    }
    
    /* There is nothing interesting below... */

    public GastexGlobalProperties getGgp() {
	return globalProp;
    }

    public void setGgp(GastexGlobalProperties _ggp) {
        globalProp = _ggp;
        setFromGgp(_ggp);
    }
}
