/*
 * JasObject.java
 *
 * Created on 7 mars 2005, 21:27
 */

package jastex.obj;
import java.awt.*;
import jastex.*;


/**
 * This interface represents all the item that can be put on the Drawing
 * Surface and define all the necessary methods plus some of the properties
 * common to all Gastex object
 * @author steph
 * @version 2.0.2
 */
public interface IJasObject {

    /** Set the internal value to the one of the GastexGlobalProperties
     * @param _ggp the GastexGlobaProperties used to initialize values
     * @see GastexGlobalProperties
     */ 
    public void setFromGgp(GastexGlobalProperties _ggp);

    /** Function which is used to get the Gastex Code
     * associated with the JasObject
     * @param oriX the X coordinate of the origin
     * @param oriY the Y coordinate of the origin
     * @return the associated latex code
     */     
    public String getLatexCode(double oriX, double oriY);
    
    /** Draw the object
     * @param g the Graphics2D instance on which to draw
     */
    public void draw(Graphics2D g);
    
    /**
     * Setter for property ggp.
     * @param ggp New value of property ggp.
     */
    public void setGgp(GastexGlobalProperties ggp);

    /**
     * Getter for property ggp.
     * @return Value of property ggp.
     */
    public GastexGlobalProperties getGgp();
    
}
