/*
 * RMark.java
 *
 * Created on 19 avril 2005, 10:04
 */

package jastex.obj.graph;

import jastex.GastexGlobalProperties;
import jastex.obj.AbstractLine;
import java.awt.Graphics2D;


/**
 *
 * @author sglondu
 */
public class RMark extends AbstractLine {
    
    protected float prdist;
    protected INode node;    
    
    /** Creates a new instance of RMark */
    public RMark(GastexGlobalProperties _ggp, INode n, float d) {
        super(_ggp);
        node = n;
        prdist = d;
    }
    
    public void setFromGgp(GastexGlobalProperties _ggp) {
        super.setFromGgp(_ggp);
        prdist = (float)_ggp.prdist;
    }
    
    public float getExternalRadius() {
        return prdist + plinewidth/2;
    }
    
    public void draw(Graphics2D g) {
        node.drawRMark(g, this);
    }
    
    public String getLatexCode(double oriX, double oriY) {
        // TODO
        return "% TODO [RMark]\n";
    }
}
