package jastex.old.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import javax.swing.SwingUtilities;
import java.awt.Cursor;

import jastex.*;


import jastex.old.obj.MiniBox2;


public class ArrowEdit extends SurfaceDessin { //implements MouseMotionListener, MouseListener {
    public Line2D.Double axe;

    public MiniBox2 b1;

    public MiniBox2 b2;
    //Cursor defaultC=new Cursor(Cursor.CROSSHAIR_CURSOR);
    public double demiW;
    public double verticaldistance=20;
    public double scaldistance=40;
    public double angle=0.5; // unit : radian
    public Point2D center;

    public Point2D firstcontrol;

    public Point2D secondcontrol;

    public Point2D sym;
    public boolean isDrag=false;
    public double h=1;
    public boolean firstime=true;
    public double scaling=20;
    public double step=5;
    public boolean isEnabled=true;

    public ArrowEdit(){
	super();
	setLayout(null);  // placement absolu
	setPreferredSize(new Dimension(100,70));
	addMouseMotionListener(this);
	addMouseListener(this);
	//demiW= getSize().width/2;
	axe=new Line2D.Double(); //demiW,0,demiW,getHeight());
	Cursor cur=new Cursor(Cursor.HAND_CURSOR);
	b1=new MiniBox2(cur, (int) demiW, 20); // arbitrary value = 20
	b2=new MiniBox2(cur, (int) demiW+10, 30); 
	b1.setSensitive(true);
	b2.setSensitive(true);
	//System.out.println(demiW);
	setCursor(defaultC);
	manager.addObject(b1);
	manager.addObject(b2);
	//center=new Point2D.Double();
	//firstcontrol=new Point2D.Double();
	//secondcontrol=new Point2D.Double();
	//sym=new Point2D.Double();
    }


    public void adjust(){
	center=new Point2D.Double(getSize().width/2,h);
	firstcontrol=new Point2D.Double(getSize().width/2,h+verticaldistance);
	secondcontrol=new Point2D.Double(getSize().width/2+Math.sin(angle)*scaldistance,
					 h+Math.cos(angle)*scaldistance);
	sym=new Point2D.Double(getSize().width/2+Math.sin(-angle)*scaldistance,
					 h+Math.cos(angle)*scaldistance);
    }

    public void fromAdjust2MiniBox(){
	b1.setPos((int) (getSize().width/2),(int) (h+verticaldistance));
	b2.setPos((int) (getSize().width/2+Math.sin(angle)*scaldistance),
		  (int) (h+Math.cos(angle)*scaldistance));
    }

    protected void paintComponent(Graphics g) {
	adjust();
	if(firstime){
	    fromAdjust2MiniBox();
	    firstime=false;
	}
	demiW= getSize().width/2;
	axe.setLine(demiW,0,demiW,getHeight());
	Graphics2D g2 = (Graphics2D)g;
	g.setColor(Color.white);
	g.fillRect(0, 0, getSize().width, getSize().height);
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.blue);
	if (!isEnabled) g2.setColor(Color.gray);
	g2.draw(axe);
	g2.setStroke(new BasicStroke());
	b1.draw(g);
	b2.draw(g);
	g2.setColor(Color.black);
	if (!isEnabled) g2.setColor(Color.gray);
	g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
	//manager.drawAllObject(g);
	g2.draw(new Line2D.Double(center,sym));
	g2.draw(new Line2D.Double(sym,firstcontrol));
	g2.draw(new Line2D.Double(firstcontrol,secondcontrol));
	g2.draw(new Line2D.Double(secondcontrol,center));
	g2.drawString("x"+((int)(scaling/5)),5, 10);
	g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);
	
    }
    //getHeight
    //getWidth
    //public void mouseEntered(MouseEvent e) {}
    //public void mouseExited(MouseEvent e) {}
    //public void mouseMoved(MouseEvent e) {}



    public void mouseClicked(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {
	if (!isEnabled) return;
	if (indexObject!=-1 && !isDrag) {
	    isDrag=true;
	}
    }

    public void mouseReleased(MouseEvent e) {
	if (!isEnabled) return;
	isDrag=false;
	fromAdjust2MiniBox();
	repaint();
    }

    public void mouseDragged(MouseEvent e) {
	if (!isEnabled) return;
	if(isDrag){
	    if(indexObject==0){
		// we have b1
		b1.setPos(b1.deprecated_getX(),e.getY());
	    } else {
		// we have b2
		b2.setPos(e.getX(),e.getY());
	    }
	    fromMiniBox2Adjust();
	    repaint();
	}
    }

    public void fromMiniBox2Adjust() {
	Point2D p1=new Point2D.Double(b1.deprecated_getX(),b1.deprecated_getY());
	Point2D p2=new Point2D.Double(b2.deprecated_getX(),b2.deprecated_getY());
	if (indexObject==0){
	    verticaldistance=center.distance(p1);
	    if(b1.deprecated_getY()<center.getY()) verticaldistance=-verticaldistance;
	} else {
	    scaldistance=center.distance(p2);
	    double distance2axe=axe.ptSegDist(p2);
	    distance2axe=distance2axe/Math.sqrt(scaldistance*scaldistance-distance2axe*distance2axe);
	    if (b2.deprecated_getX()<center.getX()) distance2axe=-distance2axe;   
	    angle=Math.atan(distance2axe);
	    if (b2.deprecated_getY()<center.getY()) angle=Math.PI-angle;
	    //System.out.println(angle);
	}
    }

    public void setScalDistance(double d){
	scaldistance=d*scaling;
	fromAdjust2MiniBox();
	repaint();
    };
    public double getScalDistance(){return scaldistance/scaling;}
    public void setVerticalDistance(double d){
	verticaldistance=d*scaling;
	fromAdjust2MiniBox();
	repaint();
    };
    public double getVerticalDistance(){return verticaldistance/scaling;}
    public void setAngle(double ang){
	// conversion
	angle=ang*Math.PI/180;
	fromAdjust2MiniBox();
	repaint();
    }
    public double getAngle(){
	// conversion to Degre
	return angle*180/Math.PI;
    }

    public void setScaling(double sc){
	scaling=sc;
    }
    public double getScaling(){ return scaling; }


    public void keyPressed(KeyEvent e){
	if (!isEnabled) return;
	int keyCode = e.getKeyCode();
	double temp1,temp2;
	//System.out.println("Oyooo");
	if (keyCode == KeyEvent.VK_LEFT){
	    if (scaling-step<=0) return;
	    temp1=getScalDistance();
	    temp2=getVerticalDistance();
	    //System.out.println(Math.abs(temp1)*scaling);
	    //System.out.println(Math.abs(temp2)*scaling);
	    //if (Math.abs(temp1)*scaling <14 ||
	    //	Math.abs(temp2)*scaling <14) return;
	    setScaling(scaling-step);
	    setVerticalDistance(temp2);	
	    setScalDistance(temp1);    
	} else if (keyCode == KeyEvent.VK_RIGHT) {
	    temp1=getScalDistance();
	    temp2=getVerticalDistance();
	    setScaling(scaling+step);
	    setVerticalDistance(temp2);	
	    setScalDistance(temp1); 
	}
    }

    public void setEnabled(boolean b){
	isEnabled=b;
    }

}






