package jastex.old.gui;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

import jastex.*;
import jastex.old.gui.ArrowEdit;
import jastex.old.gui.tabs.JasArrowTab;

public class JasArrowChooser extends JDialog implements ActionListener {

    protected GridBagLayout layout;
    protected GridBagConstraints c;
    public JComboBox arrowList;
    public JButton okBtn;
    public JButton saveBtn;
    public JButton newBtn;
    public JButton delBtn;
    public ArrowEdit arrowEditor;
    public boolean newArrow=false;
    public ArrowEdit invoker;
    public double newAngle=20; 
    public double newScalDistance= 1.5;
    public double newVerticalDistance=1.41;
    
    public JasArrowChooser(ArrowEdit inv)
    {
	super();
	invoker = inv;
	setModal(false);
	boolean isAppli = MainWindow.isAppli;
	
	ImageIcon save;
	if(isAppli){
	    save  = new ImageIcon("images/ico_save.gif");
	}
	else   {
	    URL location; 
	    location = JasArrowTab.class.getResource("images/ico_save.gif");
	    save  = new ImageIcon(location);
	}

	int numLine = 0;
	try {
	    numLine = getNumLine();
	} 
	catch (FileNotFoundException e1){} catch(IOException e){ }
	int j;



	arrowEditor = new ArrowEdit();
	arrowList = new JComboBox();
	arrowList.setActionCommand("arrow_list");
	arrowList.addActionListener(this);

	saveBtn = new JButton(Languages.arrowChooser[1]);
	saveBtn.setActionCommand("save");
	saveBtn.addActionListener(this);


	newBtn = new JButton(Languages.arrowChooser[0]);
	newBtn.setActionCommand("new_arrow");
	newBtn.addActionListener(this);


	delBtn = new JButton(Languages.arrowChooser[2]);
	delBtn.setActionCommand("delete");
	delBtn.addActionListener(this);

	okBtn = new JButton("OK");
	okBtn.setActionCommand("ok");
	okBtn.addActionListener(this);
	
	if(numLine > 0){
	    for (int i=0; i< numLine ; i++){
		j=i+1;
		arrowList.addItem(Languages.arrowChooser[3]+j);
	    }
	}
	else 
	    {
		arrowList.setEnabled(false);
		arrowEditor.setEnabled(false);
		saveBtn.setEnabled(false);
		delBtn.setEnabled(false);
		okBtn.setEnabled(false);
	    }
	getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.X_AXIS));
	JPanel paner = new JPanel();
//	JPanel panel = new JPanel();
	//	panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
	paner.setLayout(new BoxLayout(paner, BoxLayout.Y_AXIS));

 	paner.add(saveBtn);
 	paner.add(newBtn);
 	paner.add(delBtn);


	layout = new GridBagLayout();
	c = new GridBagConstraints();
	getContentPane().setLayout(layout);

	c.anchor = GridBagConstraints.WEST;
	
	c.gridx=0;
	c.gridy=0;
	layout.setConstraints(arrowEditor,c);
	getContentPane().add(arrowEditor);

	c.gridx=0;
	c.gridy=1;
	layout.setConstraints(arrowList,c);
	getContentPane().add(arrowList);

	c.gridx=1;
	c.gridy=0;
	layout.setConstraints(paner,c);
	getContentPane().add(paner);


	c.gridx=1;
	c.gridy=1;
	layout.setConstraints(okBtn,c);
	getContentPane().add(okBtn);

	pack();
	setResizable(false);
        setVisible(true);
	
    }
    

    public int getNumLine() throws FileNotFoundException,IOException
    {
	FileReader ff = new FileReader("arrowhead.conf");
	BufferedReader br = new BufferedReader(ff);
	String ss ;
	double a[] = new double[3];
	Vector v = new Vector();
	int index= 0;
	while ((ss = br.readLine()) != null)
	    index++;
	return index;
	
    }

    public void ReadFile() throws FileNotFoundException,IOException
    {

	FileReader ff = new FileReader("arrowhead.conf");
	BufferedReader br = new BufferedReader(ff);
	String ss ;
	double a[] = new double[3];
	Vector v = new Vector();
	while ((ss = br.readLine()) != null)
	    {
		StringTokenizer str = new StringTokenizer(ss);
		while(str.hasMoreTokens())
		    v.addElement(str.nextToken());
	    }
	int index= 0;
	for (int i = 0; i <= 2; i++)
	    {
		
		if (index > v.size())
		    break;
		
		for (int j = 0; j <= 2; j++)
		    {
			String pp = (String)v.elementAt(index);
			index++;
			double b;
			b = Double.parseDouble(pp);
			a[j]=b;
		    }
		
	    }
	
    }


    public double[] getLine(int line) throws FileNotFoundException,IOException
    {
		double a[] = new double[3];
	if(getNumLine()>line)
	    {
		FileReader ff = new FileReader("arrowhead.conf");
		BufferedReader br = new BufferedReader(ff);
		String ss ;
		int lineNum=0;
		Vector v = new Vector();
		while ((ss = br.readLine()) != null)
		    {
			if(line == lineNum){
			    StringTokenizer str = new StringTokenizer(ss);
			    while(str.hasMoreTokens())
				v.addElement(str.nextToken());
			}
			lineNum++;
		    }
		
		for (int j = 0; j <= 2; j++)
		    {
			String pp = (String)v.elementAt(j);
			double b;
			b = Double.parseDouble(pp);
			a[j]=b;
		    }
	    }
	return a;
    }
    
    public void delLine(int line) throws FileNotFoundException,IOException
    {
	double a[] = new double[3];
	if(getNumLine()>line)
	    {
		File f = new File("arrowhead.conf");
		FileReader ff = new FileReader("arrowhead.conf");

		BufferedReader br = new BufferedReader(ff);

		String ss ;
		int lineNum=0;
		Vector v = new Vector();
		while ((ss = br.readLine()) != null)
		    {
			if(line != lineNum){
			    StringTokenizer str = new StringTokenizer(ss);
			    while(str.hasMoreTokens())
				v.addElement(str.nextToken());
			}
			lineNum++;
		    }
		br.close();
		f.delete();
		f.createNewFile(); 
		FileWriter fw = new FileWriter("arrowhead.conf");
		BufferedWriter bw = new BufferedWriter(fw);
		int index=0;
		while(index < v.size()){
		    for (int j = 0; j <= 2; j++)
			{
			    String pp = (String)v.elementAt(index);
			    index++;
			    double b = Double.parseDouble(pp);
			    a[j]=b;
			}
		    bw.write(a[0]+" "+a[1]+" "+a[2]+System.getProperty("line.separator"));
		}
		bw.flush();
		bw.close();
	    }
	
	arrowList.removeActionListener(this);
	
	
	int j=0;
	int numLine = 0;
	try {
	    numLine = getNumLine();
	} 
	catch (FileNotFoundException e1){} catch(IOException e){ }
	
	if( arrowList.getItemCount() != 0) arrowList.removeAllItems();
	for (int i=0; i< numLine ; i++){
	    j=i+1;
	    arrowList.addItem("Tête n°"+j);
	}
	
	arrowList.addActionListener(this);
	if(numLine ==0) {
	    arrowList.setEnabled(false);
	    arrowEditor.setEnabled(false);
	    delBtn.setEnabled(false);
	    saveBtn.setEnabled(false);
	    okBtn.setEnabled(false);
	}
	else  arrowList.setSelectedIndex(0);
	
    }
    

    public void writeAtLine(int line) throws FileNotFoundException,IOException
    {
	double a[] = new double[3];
	if(getNumLine()>line)
	    {
		File f = new File("arrowhead.conf");
		FileReader ff = new FileReader("arrowhead.conf");
		
		BufferedReader br = new BufferedReader(ff);
		
		String ss ;
		int lineNum=0;
		Vector v = new Vector();
		while ((ss = br.readLine()) != null)
		    {
			if(line != lineNum){
			    StringTokenizer str = new StringTokenizer(ss);
			    while(str.hasMoreTokens())
				v.addElement(str.nextToken());
			}
			else{
			    v.addElement(strround(arrowEditor.getAngle()));
			    v.addElement(strround(arrowEditor.getScalDistance()));
			    v.addElement(strround(arrowEditor.getVerticalDistance()));
			}
			lineNum++;
		    }
		br.close();
		f.delete();
		f.createNewFile(); 
		FileWriter fw = new FileWriter("arrowhead.conf");
		BufferedWriter bw = new BufferedWriter(fw);
		int index=0;
		while(index < v.size()){
		    for (int j = 0; j <= 2; j++)
			{
			    String pp = (String)v.elementAt(index);
			    index++;
			    double b = Double.parseDouble(pp);
			    a[j]=b;
			}
		    bw.write(a[0]+" "+a[1]+" "+a[2]+System.getProperty("line.separator"));
		}
		bw.flush();
		bw.close();
	    }
    }
    


    public void writeAtEnd() throws FileNotFoundException,IOException
    {
	double a[] = new double[3];
		File f = new File("arrowhead.conf");
		int l = (int)f.length();
		System.out.println(l);
		
		FileWriter fw = new FileWriter("arrowhead.conf",true);
		String str = strround(arrowEditor.getAngle())+" "+strround(arrowEditor.getScalDistance()) +" " +strround(arrowEditor.getVerticalDistance())+System.getProperty("line.separator");
		fw.write(str);
 		fw.flush();
 		fw.close();
 	    
    }

    
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();

	if(cmd.equals("arrow_list"))
	    {

			double value[] = new double[3];
			int i = arrowList.getSelectedIndex();
			
			if(!newArrow){
			    try{
				value = getLine(i);
				arrowEditor.setAngle(value[0]);
				arrowEditor.setScalDistance(value[1]);
				arrowEditor.setVerticalDistance(value[2]);
			    }
			    catch (FileNotFoundException e1){} catch(IOException e2){ }
			}
			
			else if(newArrow){
			    
			    if(i == arrowList.getItemCount()-1){
			      	arrowEditor.setAngle(newAngle);
				arrowEditor.setScalDistance(newScalDistance);
				arrowEditor.setVerticalDistance(newVerticalDistance);
			    }
			    else{
				try{
				    value = getLine(i);
				    arrowEditor.setAngle(value[0]);
				    arrowEditor.setScalDistance(value[1]);
				    arrowEditor.setVerticalDistance(value[2]);
				}
				catch (FileNotFoundException e1){} catch(IOException e2){ }
			    }
			}
			
	    }
	else if(cmd.equals("delete"))
	    {
		try{
		    delLine(arrowList.getSelectedIndex());
		}
		catch (FileNotFoundException e1){
		    System.out.println("File Not Found");
		} catch(IOException e2){
		    System.out.println("Unable to read/write");
		}	
	    }
	else if(cmd.equals("save"))
	    {
		if(newArrow)
		    {
			
			/** ecriture à la fin du fichier, insertion dans la combo */
			newBtn.setEnabled(true);
			try{
			    writeAtEnd();
			    newArrow = false;
			    newBtn.setEnabled(true);
			    okBtn.setEnabled(true);
			    delBtn.setEnabled(true);
			}
			catch (FileNotFoundException e1){
			    System.out.println("File Not Found");
			} catch(IOException e2){
			    System.out.println("Unable to read/write");
			}	
			

			
		    }
		else {
		    try{
			writeAtLine(arrowList.getSelectedIndex());
		    }
		    catch (FileNotFoundException e1){} catch(IOException e2){ } 
		}
	    }
	else if(cmd.equals("ok"))
	    {
		invoker.setAngle(arrowEditor.getAngle());
		invoker.setScalDistance(arrowEditor.getScalDistance());
		invoker.setVerticalDistance(arrowEditor.getVerticalDistance());
		dispose();
	    }
	
	else if(cmd.equals("new_arrow"))
	    {
		newArrow = true;
		newBtn.setEnabled(false);
		saveBtn.setEnabled(true);
		int j =  arrowList.getItemCount()+1;
		arrowList.addItem("Tête n°"+j);
		arrowEditor.setAngle(20);
		arrowEditor.setScalDistance(1.5);
		arrowEditor.setVerticalDistance(1.41);
		arrowEditor.setEnabled(true);
		arrowList.setEnabled(true);
		
		
		arrowList.setSelectedIndex(arrowList.getItemCount()-1);
		
	    }
    }


    public String strround(double value)
    {
	double decal = Math.pow(10, 2);
	Double valueArr =new Double(((Math.round(value*decal))/decal));
	return valueArr.toString();
    }


     
}
