package jastex.old.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import jastex.*;



public class JasColorChooser extends JDialog {

    // Les couleurs autorisees
    public final static JasColorName COLOR[] = {
	new JasColorName(new Color(216, 255, 79),   "GreenYellow"),
	new JasColorName(new Color(255, 255, 0),    "Yellow"),
	new JasColorName(new Color(255, 229, 40),   "Goldenrod"),
	new JasColorName(new Color(255, 181, 40),   "Dandelion"),
	new JasColorName(new Color(255, 173, 122),  "Apricot"),
	new JasColorName(new Color(255, 127, 76),   "Peach"),
	new JasColorName(new Color(255, 137, 127),  "Melon"),
	new JasColorName(new Color(255, 147, 0),    "YellowOrange"),
	new JasColorName(new Color(255, 99, 33),    "Orange"),
	new JasColorName(new Color(255, 124, 0),    "BurntOrange"),
	new JasColorName(new Color(193, 2, 0),      "Bittersweet"),
	new JasColorName(new Color(255, 58, 33),    "RedOrange"),
	new JasColorName(new Color(165, 0, 0),      "Mahogany"),
	new JasColorName(new Color(173, 0, 0),      "Maroon"),
	new JasColorName(new Color(183, 0, 0),      "BrickRed"),
	new JasColorName(new Color(255, 0, 0),      "Red"),
	new JasColorName(new Color(255, 0, 127),    "OrangeRed"),
	new JasColorName(new Color(255, 0, 221),    "RubineRed"),
	new JasColorName(new Color(255, 10, 155),   "WildStrawberry"),
	new JasColorName(new Color(255, 119, 158),  "Salmon"),
	new JasColorName(new Color(255, 94, 255),   "CarnationPink"),
	new JasColorName(new Color(255, 0, 255),    "Magenta"),
	new JasColorName(new Color(255, 48, 255),   "VioletRed"),
	new JasColorName(new Color(255, 45, 255),   "Rhodamine"),
	new JasColorName(new Color(163, 20, 249),   "Mulberry"),
	new JasColorName(new Color(150, 0, 168),    "RedViolet"),
	new JasColorName(new Color(114, 2, 234),    "Fuchsia"),
	new JasColorName(new Color(255, 132, 255),  "Lavender"),
	new JasColorName(new Color(224, 104, 255),  "Thistle"),
	new JasColorName(new Color(173, 91, 255),   "Orchid"),
	new JasColorName(new Color(153, 51, 204),   "DarkOrchid"),
	new JasColorName(new Color(140, 35, 255),   "Purple"),
	new JasColorName(new Color(127, 0, 255),    "Plum"),
	new JasColorName(new Color(53, 30, 255),    "Violet"),  // couleur bizarre
	new JasColorName(new Color(63, 25, 255),    "RoyalPurple"),
	new JasColorName(new Color(25, 12, 244),    "BlueViolet"),
	new JasColorName(new Color(109, 114, 255),  "Periwinkle"),
	new JasColorName(new Color(96, 109, 196),   "CadetBlue"),
	new JasColorName(new Color(89, 221, 255),   "CornflowerBlue"),
	new JasColorName(new Color(0, 112, 145),    "MidnightBlue"),
	new JasColorName(new Color(15, 117, 255),   "NavyBlue"),
	new JasColorName(new Color(0, 127, 255),    "RoyalBlue"),
	new JasColorName(new Color(0, 0, 255),      "Blue"),
	new JasColorName(new Color(15, 226, 255),   "Cerulean"),
	new JasColorName(new Color(0, 255, 255),    "Cyan"),
	new JasColorName(new Color(10, 255, 255),   "ProcessBlue"),
	new JasColorName(new Color(96, 255, 224),   "SkyBlue"),
	new JasColorName(new Color(38, 255, 204),   "Turquoise"),
	new JasColorName(new Color(30, 249, 163),   "TealBlue"),
	new JasColorName(new Color(45, 255, 178),   "Aquamarine"),
	new JasColorName(new Color(38, 255, 170),   "BlueGreen"),
	new JasColorName(new Color(0, 255, 127),    "Emerald"),
	new JasColorName(new Color(2, 255, 122),    "JungleGreen"),
	new JasColorName(new Color(79, 255, 127),   "SeaGreen"),
	new JasColorName(new Color(0, 255, 0),      "Green"),
	new JasColorName(new Color(0, 224, 0),      "ForestGreen"),
	new JasColorName(new Color(0, 191, 40),     "PineGreen"),
	new JasColorName(new Color(127, 255, 0),    "LimeGreen"),
	new JasColorName(new Color(142, 255, 66),   "YellowGreen"),
	new JasColorName(new Color(188, 255, 61),   "SpringGreen"),
	new JasColorName(new Color(0, 153, 0),      "OliveGreen"),
	new JasColorName(new Color(140, 0, 0),      "RawSienna"),
	new JasColorName(new Color(76, 0, 0),       "Sepia"),
	new JasColorName(new Color(102, 0, 0),      "Brown"),
	new JasColorName(new Color(219, 147, 112),  "Tan"),
	new JasColorName(new Color(127, 127, 127),  "Gray"),
	new JasColorName(new Color(0, 0, 0),        "Black"),
	new JasColorName(new Color(255, 255, 255),  "White")
	    };

    private final int TAILLE_COLOR = COLOR.length;  // pour ne pas avoir a faire +ieurs appels

    private final int
	TAILLE = 10,  // la taille de chaque carre de couleur
	ESPACE = 4;   // l'espacement entre chaque carre de couleur

    private static int NB_COL;  // le nombre de carre de couleur par ligne

    private static int selectedNumber, selectedColor;
    private JLabel colorName = new JLabel(" ");

    private JasColorComboBox invoker;
//    private JFrame container;


    /**
     * Constructeur principal.
     * Dessine une liste de toutes les couleurs predefinies dans COLOR
     */
    public JasColorChooser(JasColorComboBox inv) {
	super();
	setModal(true);
	invoker = inv;
	int width = 200;
	int height = 150;
	//	invoker.colorBtn.setEnabled(false);
	
	NB_COL = width/(TAILLE+ESPACE);
	setSize(width, height+50);
	getContentPane().setLayout(new BorderLayout());
	JPanel pColor = new JPanel() {
		protected void paintComponent(Graphics g) {
		    Graphics2D g2 = (Graphics2D)g;
		    
		    for (int i=0; i<TAILLE_COLOR; i++) {
			Rectangle r = new Rectangle((i%NB_COL)*(TAILLE+ESPACE),
						    (i/NB_COL)*(TAILLE+ESPACE), TAILLE, TAILLE);
			g2.setColor(COLOR[i].getColor());
			g2.fill(r);
		    }
		}
	    };
	pColor.setPreferredSize(new Dimension(NB_COL*(TAILLE+ESPACE), (TAILLE_COLOR*(TAILLE+ESPACE))/NB_COL));

	// pour designer un carre de couleur par sa couleur qd la souris passe dessus
	pColor.addMouseMotionListener(new MouseMotionAdapter() {
		public void mouseMoved(MouseEvent e) {
		    int x = e.getX()/(TAILLE+ESPACE),
			y = NB_COL*Math.round(e.getY()/(TAILLE+ESPACE));
		    if (x<NB_COL && y<TAILLE_COLOR && x+y<TAILLE_COLOR) {
			int i = x + y;
			colorName.setText(COLOR[i].getColorName());
			selectedNumber = i;
		    }
		}
	    });

	// pour choisir une couleur en cliquant sur sa representation
	pColor.addMouseListener(new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		    selectedColor = selectedNumber;

		    if (invoker != null) {
			ImageIcon i = (ImageIcon)invoker.comboList.getItemAt(invoker.comboList.getItemCount()-1);
			invoker.comboList.setSelectedIndex(invoker.comboList.getItemCount()-1);
			i.setDescription(COLOR[selectedColor].getColorName());
			invoker.comboList.setSelectedItem(i);
			//	invoker.colorBtn.setEnabled(true);
			dispose();
		    }
		}
	    });


	getContentPane().setLayout(new BorderLayout());
	getContentPane().add(new JLabel("Selectionner une couleur: "), BorderLayout.NORTH);
	getContentPane().add(pColor, BorderLayout.CENTER);
	getContentPane().add(colorName, BorderLayout.SOUTH);
	Dimension chooserSize=new Dimension(getPreferredSize());
	chooserSize.width+=20;
	chooserSize.height+=40;
	setSize(chooserSize);
	pack();
        setVisible(true);

    }
    public JasColorName getSelectedColor() { return COLOR[selectedColor]; }


} // end of class
