package jastex.old.gui;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

import jastex.*;
import jastex.old.gui.tabs.OJasTab;
import jastex.gui.JasScrollBox;



/** This class create the configuration dialog
 * in order to modify JasTeX general config
 */
class JasConfigDialog extends JasToolBox implements ActionListener{

    public OJasTab configTab ;
    public JComboBox langCombo;
    public JLabel langLabel;
    public JComboBox unitCombo;
    public JasScrollBox unitField;
    public JLabel unitLabel;
    public JCheckBox splash;
  
    public OJasTab sdTab;
    public JCheckBox antialiasing;
    public JCheckBox magnetic;
    public JCheckBox snap;
    public JasScrollBox gridStep;
    public JLabel gridStepLabel;


    public OJasTab acTab;
    public JCheckBox lowXServerMode;
    public JCheckBox modeDebug;
    public JCheckBox latexHandler;
    public JLabel latexCmdLabel;
    public JTextField latexCmd;
    

    public JButton okButton ;

    public JButton applyButton;

    public JButton cancelButton;
    public MainWindow mainWindow;

    public File tab[];

    public JasConfigDialog(Frame parentFrame , String toolBoxTitle)
    {
	super(parentFrame,toolBoxTitle);
	mainWindow = (MainWindow) parentFrame;

	Configuration config = new Configuration();

	/* OK Buton */
	okButton = new JButton(Languages.tb_OkBtn);
	okButton.setActionCommand("ok_cfg");
	okButton.addActionListener(this);

	/* Apply Buton */
	applyButton = new JButton(Languages.tb_ApplyBtn);
	applyButton.setActionCommand("apply_cfg");
	applyButton.addActionListener(this);

	/* Cancel Buton */
	cancelButton = new JButton(Languages.tb_CancelBtn);
	cancelButton.setActionCommand("cancel_cfg");
	cancelButton.addActionListener(this);

	
	JPanel buttonPane = new JPanel(); 
	buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.X_AXIS));
	buttonPane.add(Box.createHorizontalGlue());
	buttonPane.add(okButton);
	buttonPane.add(applyButton);
	buttonPane.add(cancelButton);

	
	GridBagLayout layout = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	c.fill = GridBagConstraints.BOTH;	
	getContentPane().setLayout(layout);
	
	c.gridx=0;
	c.gridy=0;
	layout.setConstraints(tabbedPane,c);
	getContentPane().add(tabbedPane);
	
	c.gridx=0;
	c.gridy=2;
	c.insets = new Insets(5,0,0,0);
	layout.setConstraints(buttonPane,c);
	getContentPane().add(buttonPane);

	Vector langVector = new Vector();

	boolean isAppli = MainWindow.isAppli;
	
	if(isAppli){
	    File fd = new File("lang/");
	    tab = fd.listFiles();
	    for (int i=0; i<tab.length; i++)
		{
		    if(! (tab[i].getName().equals("CVS")))
			langVector.add(tab[i].getName());
		}   
	}
	else 
	    {
		langVector.add("english");
		langVector.add("francais");
	    }
	
	/** Global options tab **/
	configTab = new OJasTab(Languages.jcd_tab[0]);
	langCombo = new JComboBox(langVector);
	langLabel = new JLabel(Languages.jcd_global[0]);
	configTab.insertPropertie(langLabel,langCombo);
	langCombo.setSelectedItem(config.language);
	
	
	Vector unitVector = new Vector();
	unitVector.add("mm");
	unitVector.add("cm");
	unitVector.add("pix");
	unitVector.add("inch");
	unitCombo = new JComboBox(unitVector);
	unitCombo.setSelectedItem(config.unitName);

	
	JPanel unitPanel = new JPanel();
	unitField = new JasScrollBox(0.1,0.01);
	unitField.setValue(config.unitLength);


	unitPanel.add(unitField);
	unitPanel.add(unitCombo);
	unitLabel = new JLabel(Languages.jcd_global[1]);
	configTab.insertPropertie(unitLabel,unitPanel);

	splash = new JCheckBox(Languages.jcd_global[2]);
	if(config.splash.equals("on"))
	    splash.setSelected(true);
	else 
	    splash.setSelected(false);


	
	configTab.insertPropertie(splash);
	addTab(configTab);
	tabbedPane.insertTab(configTab.getTabTitle(),null,configTab.getPanel(),null,0);



	
	/** drawing area Tab **/
	sdTab = new OJasTab(Languages.jcd_tab[1]);

	antialiasing = new JCheckBox(Languages.jcd_draw[0]);
	if(config.antialiasing.equals("on"))
	    antialiasing.setSelected(true);
	else 
	    antialiasing.setSelected(false);

        magnetic = new JCheckBox(Languages.jcd_draw[1]);
	if(config.magneticGrid.equals("on"))
	    magnetic.setSelected(true);
	else 
	    magnetic.setSelected(false);
	
	snap = new JCheckBox(Languages.jcd_draw[2]);
	if(config.snapToGrid.equals("on"))
	    snap.setSelected(true);
	else 
	    snap.setSelected(false);

        gridStep = new JasScrollBox(0,0.1);
	gridStep.setValue(config.tailleGrille);

	sdTab.insertPropertie(antialiasing);
	sdTab.insertPropertie(magnetic);
	sdTab.insertPropertie(snap);
	gridStepLabel = new JLabel(Languages.jcd_draw[3]);
	sdTab.insertPropertie(gridStepLabel,gridStep);
	addTab(sdTab);
	tabbedPane.insertTab(sdTab.getTabTitle(),null,sdTab.getPanel(),null,1);


	
	/** advanced options Tab **/
	acTab = new OJasTab(Languages.jcd_tab[2]);
	lowXServerMode = new JCheckBox(Languages.jcd_advanced[0]);
	if(config.lowXServerMode.equals("on"))
	    lowXServerMode.setSelected(true);
	else 
	    lowXServerMode.setSelected(false);


	modeDebug = new JCheckBox(Languages.jcd_advanced[1]);
	if(config.modedebug.equals("on"))
	    modeDebug.setSelected(true);
	else 
	    modeDebug.setSelected(false);

	latexHandler = new JCheckBox(Languages.jcd_advanced[2]);
	if(config.enableLH)
	    latexHandler.setSelected(true);
	else 
	    latexHandler.setSelected(false);
	
	latexCmdLabel = new JLabel(Languages.jcd_advanced[3]);
	latexCmd = new JTextField(config.latexCmd,20);

	acTab.insertPropertie(lowXServerMode);
	acTab.insertPropertie(modeDebug);
	acTab.insertPropertie(latexHandler);
	acTab.insertPropertie(latexCmdLabel,latexCmd);

	addTab(acTab);
	tabbedPane.insertTab(acTab.getTabTitle(),null,acTab.getPanel(),null,2);

	
	pack();
	//setResizable(false);
	setVisible(true);
    }


   public void applyConfig() {
	Configuration.language = langCombo.getSelectedItem().toString();

	if(antialiasing.isSelected()) {
	    Configuration.antialiasing = "on";
	} else { 
	    Configuration.antialiasing = "off";
	}

	if(lowXServerMode.isSelected()) {
	    Configuration.lowXServerMode = "on";
	} else {
	    Configuration.lowXServerMode = "off";
	}

 	if(modeDebug.isSelected()) {
	    Configuration.modedebug = "on";
	} else { 
	    Configuration.modedebug = "off";
	}

	if(magnetic.isSelected()) {
	    Configuration.magneticGrid = "on";
	} else { 
	    Configuration.magneticGrid = "off";
	}

	Configuration.tailleGrille = gridStep.getValue();

	if(splash.isSelected()) {
	    Configuration.splash = "on";
	} else { 
	    Configuration.splash = "off";
	}
	if(snap.isSelected()) {
	    Configuration.snapToGrid = "on";
	} else { 
	    Configuration.snapToGrid = "off";
	}

      
	Configuration.unitLength = unitField.getValue();
	Configuration.unitName = unitCombo.getSelectedItem().toString();

	Configuration.latexCmd  =latexCmd.getText();
	Configuration.enableLH = latexHandler.isSelected();

   }

    public void saveConfig(String configFile)
    {
	PrintWriter pw = null;
	FileWriter fw = null;
	
	try {
	    fw = new FileWriter(configFile);
	} catch (IOException e) {
	    System.out.println("Impossible d'ouvrir le fichier : "+configFile);
	    return;
	}
	
	pw = new PrintWriter(fw);
	pw.write("language : "+langCombo.getSelectedItem());
	pw.println();
	
	if(antialiasing.isSelected())
	    pw.write("antialiasing : on");
	else 
	    pw.write("antialiasing : off");
	
	pw.println();
	
	
	if(lowXServerMode.isSelected())
	    pw.write("lowXServerMode : on");
	else 
	    pw.write("lowXServerMode : off");
	
	pw.println();
	
	
	if(modeDebug.isSelected())
	    pw.write("modedebug : on");
	else 
	    pw.write("modedebug : off");
	
	pw.println();
	
	
	if(magnetic.isSelected())
	    pw.write("magneticGrid : on");
	else 
	    pw.write("magneticGrid : off");
	
	pw.println();
	
	
	pw.write("gridWH : " + gridStep.getValue());
	pw.println();
	
	if(splash.isSelected())
	    pw.write("splash : on");
	else 
	    pw.write("splash : off");
	
	pw.println();
	
	
	if(snap.isSelected())
	    pw.write("snapToGrid : on");
	else 
	    pw.write("snapToGrid : off");
	
	pw.println();
	
	pw.write("unitLength : "+unitField.getValue());
	pw.println();
	pw.write("unitName : "+ unitCombo.getSelectedItem());
	pw.println();
	
	pw.write("latex_cmd : "+ latexCmd.getText());
	pw.println();
	pw.write("latexHandler : ");
	pw.write(latexHandler.isSelected()? "on" : "off");
	pw.println();
	
	try { fw.close(); 
	pw.close();
	} catch (IOException e) {}
	
	
	
    }



   public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if(cmd.equals("cancel_cfg"))
	    {
		dispose();
	    }
	else if(cmd.equals("ok_cfg"))
	    {
		if (MainWindow.isAppli) {
		    saveConfig("configuration.properties");
		}
		applyConfig();
		Languages.loadLanguage("lang/" +
				       Configuration.language);
		mainWindow.initLanguage();
		dispose();
	    }
	else if(cmd.equals("apply_cfg"))
	    {
		if (MainWindow.isAppli) {
		    saveConfig("configuration.properties");
		}
		applyConfig();
		Languages.loadLanguage("lang/" +
				       Configuration.language);
		mainWindow.initLanguage();
		initLanguage();
	    }
	else 
	    debug(cmd);
    }

 public  void initLanguage() {
     tabbedPane.setTitleAt(0, Languages.jcd_tab[0]);
     tabbedPane.setTitleAt(1, Languages.jcd_tab[1]);
     tabbedPane.setTitleAt(2, Languages.jcd_tab[2]);

     langLabel.setText(Languages.jcd_global[0]);
     unitLabel.setText(Languages.jcd_global[1]);
     splash.setText(Languages.jcd_global[2]);
     
     antialiasing.setText(Languages.jcd_draw[0]);
     magnetic.setText(Languages.jcd_draw[1]);
     snap.setText(Languages.jcd_draw[2]);
     gridStepLabel.setText(Languages.jcd_draw[3]);
     
     
     lowXServerMode.setText(Languages.jcd_advanced[0]);
     modeDebug.setText(Languages.jcd_advanced[1]);
     
     latexHandler.setText(Languages.jcd_advanced[2]);
     latexCmdLabel.setText(Languages.jcd_advanced[3]);
     
     okButton.setText(Languages.tb_OkBtn) ;
     applyButton.setText(Languages.tb_ApplyBtn) ;
     cancelButton.setText(Languages.tb_CancelBtn) ;     
 }



}
