package jastex.old.gui;

import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.*;

import jastex.*;



class JasMenuBar extends JMenuBar {
    public static final int MENUITEM_FILE = 0;
    public static final int MENUITEM_HELP = 1;
    public static final int MENUITEM_EDIT = 2;
    public static final int MENUITEM_UTIL = 3;

    public static final int FILEITEM_NEW = 0;
    public static final int FILEITEM_OPEN = 1;
    public static final int FILEITEM_QUIT = 2;

    public static final int UTIL_SELECT = 0;
    public static final int UTIL_NODE   = 1;
    public static final int UTIL_EDGE   = 2;
    public static final int UTIL_MARK   = 3;
    public static final int UTIL_FOBJ   = 4;

    public static final int HELPITEM_HELP = 0;
    public static final int HELPITEM_ABOUT = 1;

    private JMenu utilMenu; 

    private static final String[] file_actions = {
	"open", "save", "saveas", "quit"
    };

    private static final String[] edit_actions = {
	"copy", "cut", "paste", "del", "selectall"
    };

    private static final String[] help_actions = {
	"help", "about"
    };
    private static final String[] window_actions = {
	"new", "close_window"
    };

    private static final String[] cfg_actions = {
	"configure_jastex",  "configure_default_ggp"
    };

    private static final String[] util_actions = {
	"select", "node", "edge", "mark", "fobj"
    };

    private static JMenu menus[];
    private static JMenuItem[][] menuItems;
    private static JMenuItem[][] util_menuItems;

    public JasMenuBar(MainWindow mw) {
	super();
	JMenu menu, submenu;
	JMenuItem menuItem;
	MenuToolBarListener listen = new MenuToolBarListener(mw);

	menuItems = new JMenuItem[6][];
	menus = new JMenu[6];
	
	// File
	menu = new JMenu(Languages.mbar_menuItems[Languages.MBAR_MENU_FILE]);
	add(menu);
	menus[0] = menu;
	menuItems[0] = new JMenuItem[4];

	for (int i = 0; i < 4; i++) {
	    menuItem = new JMenuItem(Languages.mbar_fileItems[i]);
	    menuItem.setActionCommand(file_actions[i]);
	    menuItem.addActionListener(listen);
	    menu.add(menuItem);
	    menuItems[0][i] = menuItem;
	    if(!MainWindow.isAppli) {
		menuItem.setEnabled(false);
	    }
	}

	//Edit
	menu = new JMenu(Languages.mbar_menuItems[Languages.MBAR_MENU_EDIT]);
	add(menu);
	menus[1] = menu;
	menuItems[1] = new JMenuItem[5];
	for (int i = 0; i < 5; i++) {
	    menuItem = new JMenuItem(Languages.mbar_editItems[i]);
	    menuItem.setActionCommand(edit_actions[i]);
	    menuItem.addActionListener(listen);
	    if (i == 4) {
		menu.addSeparator();
	    }
	    menu.add(menuItem);
	    menuItems[1][i] = menuItem;
	}

	//Utils
	menu = new JMenu(Languages.mbar_menuItems[Languages.MBAR_MENU_UTIL]);
	utilMenu = menu;
	add(menu);
	menus[2] = menu;
	menuItems[2] = new JMenuItem[5];
	menuItem = new JMenuItem(Languages.mbar_util[0]);
	menuItem.setActionCommand(util_actions[0]);
	menuItem.addActionListener(listen);
	menu.add(menuItem);
	menuItems[2][0] = menuItem;
        util_menuItems = new JMenuItem[5][];
	for (int i = 1; i < 5; i++) {
	    submenu = new JMenu(Languages.mbar_util[i]);
	    int max = Languages.mbar_utilItems[i].length;
	    util_menuItems[i] = new JMenuItem[max];
		for (int j = 0; j < max; j++) {
		menuItem = new JMenuItem(Languages.mbar_utilItems[i][j]);
		menuItem.setActionCommand(util_actions[i]+j);
		menuItem.addActionListener(listen);
		submenu.add(menuItem);
		util_menuItems[i][j] = menuItem;
	    }
	    menu.add(submenu);
	    menuItems[2][i] = submenu;
	}
	
	/** Config **/
	menu = new JMenu(Languages.mbar_menuItems[3]);
	add(menu);
	menus[3] = menu;
	menuItems[3] = new JMenuItem[2];
	menuItem = new JMenuItem(Languages.mbar_cfgItems[0]);
	menuItem.setActionCommand(cfg_actions[0]);
	menuItem.addActionListener(listen);
	menu.add(menuItem);
	menuItems[3][0] = menuItem;
	menuItem = new JMenuItem(Languages.mbar_cfgItems[1]);
	menuItem.setActionCommand(cfg_actions[1]);
	menuItem.addActionListener(listen);
	menu.add(menuItem);
	menuItems[3][1] = menuItem;
	
	// Documents
	menu = new JMenu(Languages.mbar_menuItems[4]);
	add(menu);
	menus[4] = menu;
	menuItems[4] = new JMenuItem[2];
	menuItem = new JMenuItem(Languages.mbar_docItems[0]);
	menuItem.setActionCommand(window_actions[0]);
	menuItem.addActionListener(listen);
	menu.add(menuItem);
	menuItems[4][0] = menuItem;
	menuItem = new JMenuItem(Languages.mbar_docItems[1]);
	menuItem.setActionCommand(window_actions[1]);
	menuItem.addActionListener(listen);
	menu.add(menuItem);
	menuItems[4][1] = menuItem;
	
	/** Help */
	menu = new JMenu(Languages.mbar_menuItems[Languages.MBAR_MENU_HELP]);
	add(menu);
	menus[5] = menu;
	menuItems[5] = new JMenuItem[2];
	menuItem = new JMenuItem(Languages.mbar_helpItems[0]);
	menuItem.setActionCommand(help_actions[0]);
	menuItem.addActionListener(listen);
	menu.add(menuItem);
	menuItems[5][0] = menuItem;
	menuItem = new JMenuItem(Languages.mbar_helpItems[1]);
	menuItem.setActionCommand(help_actions[1]);
	menuItem.addActionListener(listen);
	menu.add(menuItem);
	menuItems[5][1] = menuItem;
	//FIXME: remove congi the default ggp
    }

	
    public void changeDrawingItemsState(boolean state) {
	if (state == false && utilMenu.isPopupMenuVisible()) {
	    utilMenu.setPopupMenuVisible(false); 
	}
	utilMenu.setEnabled(state);
    }
    public void changeDocumentItemsState(boolean state) {
	changeDrawingItemsState(state);
	//edit
	if (state == false && menus[1].isPopupMenuVisible()) {
	    menus[1].setPopupMenuVisible(false); 
	}
	menus[1].setEnabled(state);
	//some of File
	if(MainWindow.isAppli) {
	    menuItems[0][1].setEnabled(state);
	    menuItems[0][2].setEnabled(state);
	}
	
	 //some of Config
	 menuItems[3][1].setEnabled(state);
    }
    public static void initLanguage() {
	//File
	menus[0].setText(Languages.mbar_menuItems[Languages.MBAR_MENU_FILE]); 
	for (int i = 0; i < 4; i++) {
	    menuItems[0][i].setText(Languages.mbar_fileItems[i]);
	    menuItems[0][i].updateUI();
	}
	//Edit
	menus[1].setText(Languages.mbar_menuItems[Languages.MBAR_MENU_EDIT]);
	for (int i = 0; i < 5; i++) {
	    menuItems[1][i].setText(Languages.mbar_editItems[i]);
	    menuItems[1][i].updateUI();
	}

	//Utils
	menus[2].setText(Languages.mbar_menuItems[Languages.MBAR_MENU_UTIL]);
	menuItems[2][0].setText(Languages.mbar_util[0]);
	for (int i = 1; i < 5; i++) {
	    int max = Languages.mbar_utilItems[i].length;
	    for (int j = 0; j < max; j++) {
		util_menuItems[i][j].setText(Languages.mbar_utilItems[i][j]);
		util_menuItems[i][j].updateUI();
	    }
	    menuItems[2][i].setText(Languages.mbar_util[i]);
	    menuItems[2][i].updateUI();
	}
	//Configuration
	menus[3].setText(Languages.mbar_menuItems[Languages.MBAR_MENU_CFG]);
	menuItems[3][0].setText(Languages.mbar_cfgItems[0]);
	menuItems[3][0].updateUI();
	menuItems[3][1].setText(Languages.mbar_cfgItems[1]);
	menuItems[3][1].updateUI();
	

	//Documents
	menus[4].setText(Languages.mbar_menuItems[Languages.MBAR_MENU_DOC]);
	menuItems[4][0].setText(Languages.mbar_docItems[0]);
	menuItems[4][0].updateUI();
	menuItems[4][1].setText(Languages.mbar_docItems[1]);
	menuItems[4][1].updateUI();

	//Help
	menus[5].setText(Languages.mbar_menuItems[Languages.MBAR_MENU_HELP]);
	menuItems[5][0].setText(Languages.mbar_helpItems[0]);
	menuItems[5][0].updateUI();
	menuItems[5][1].setText(Languages.mbar_helpItems[1]);
	menuItems[5][1].updateUI();
    }

}
