package jastex.old.gui;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

import jastex.*;

/** This class create the toolbox in order to modify
 * Node or Edge properties
 */
class JasTextDlg extends JDialog {
    
    public JTextArea textArea;
    public JButton okBtn;

    public JasTextDlg(Frame parentFrame , String title,boolean modal)
    {
	super(parentFrame,title,modal);
	
	textArea = new JTextArea("",20,40);
	okBtn = new JButton("OK");
	JScrollPane sp = new JScrollPane (textArea,
					  JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
					  JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

	GridBagLayout layout = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	c.fill = GridBagConstraints.BOTH;	
	getContentPane().setLayout(layout);
	
	c.gridx=0;
	c.gridy=0;
	layout.setConstraints(textArea,c);
	getContentPane().add(sp);
	
	c.gridx=0;
	c.gridy=1;
	c.insets = new Insets(5,0,0,0);
	layout.setConstraints(okBtn,c);
	getContentPane().add(okBtn);

	
    }

    public void display() {
	pack();
	centerComponent(this);
	setVisible(true);
    }
	

    public void addText(String text) {
	textArea.append(text);
    }

    public void setText(String text) {
	textArea.setText(text);
	textArea.setCaretPosition(0);
    }
 
    public String getText() {
	return textArea.getText();
    }

    public int setTextFromFile(String file) {
	BufferedReader br = null;
	InputStream is = null;
	InputStreamReader isr = null;
	try {
	    if (MainWindow.isAppli) {
		is = new FileInputStream(file);
	    } else {
		is = Configuration.class.getResourceAsStream(file);
	    }
	    isr = new InputStreamReader(is);
	    br = new BufferedReader(isr);
	    
	} catch (FileNotFoundException e) {
	    return -1;
	}
	String text = "";
	String str = null;
	String ls = System.getProperty("line.separator");
	try {
	    while (null != (str = br.readLine())) {
		text = text + str + ls;
	    }
	    br.close();
	    isr.close();
	    is.close();
	} catch (IOException e) {
	    try { 
		br.close(); isr.close(); is.close(); 
	    } catch (IOException ex) {}
	    return -2;
	}
	
	setText(text);
	return (0);
	
    }


    public void addActionListener(ActionListener listener)
    {
	okBtn.addActionListener(listener);
    }

    public Dimension getScreenDimension()
    {
	return Toolkit.getDefaultToolkit().getScreenSize();
    }

    public void centerComponent(Component compo)
    {
	compo.setLocation(new Point((getScreenDimension().width - compo.getSize().width) / 2,
				    (getScreenDimension().height - compo.getSize().height) / 2));
    }
}
