package jastex.old.gui;

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import jastex.*;
import jastex.old.gui.tabs.OJasTab;


/** This class create the toolbox in order to modify
 * Node or Edge properties
 */
public class JasToolBox extends JDialog {

    public boolean debug=false;
    /** tabbed panel contaning the properties */
    public JTabbedPane tabbedPane;
    /** Vector containing each tab */
    protected Vector onglets;
    /** the parent frame of the toolbox typically Mainwindow */
    public Frame parentFrame;
    

    /** Constructor which initializes a toolBox
     * unvisible and empty
     *  @param parentFrame the Parent frame of the ToolBox dialog
     *  @param toolBoxTitle the title of the toolbox dialogbox
     *  @param modal true if the toolbox is modal, false either
     */
    public JasToolBox(Frame parentFrame , String toolBoxTitle,boolean modal)
    {
	/* Creation of the JDialog of the death */
	super(parentFrame,toolBoxTitle,modal);
	this.parentFrame = parentFrame;
	onglets = new Vector();
	tabbedPane = new JTabbedPane();
    }
    
    
    /** Constructor which initializes a toolBox
     * unvisible and empty
     *  @param parentFrame the Parent frame of the ToolBox dialog
     *  @param toolBoxTitle the title of the toolbox dialogbox
     */
    public JasToolBox(Frame parentFrame , String toolBoxTitle)
    {
	this(parentFrame,toolBoxTitle,false);
    }


    /** 
     *  Resize the toolbox
     */
    public void updateSize()
    {
	setResizable(true);
	pack();
	//setResizable(false);
    }


    /** Method detroying all the tabs
     *  of the toolbox
     */
    protected void destroyTab() { tabbedPane.removeAll();   }
    

    /** Add a tab in the vector
     * @param tab the JasTab to add
     */
    protected void addTab(OJasTab tab)    {	this.onglets.add(tab);    }
    
    
    
    /** Removing the tab at the giving index
     * @param  object to remove from the vector
     * @param index of the object in the tabbedPane
     */
    protected void deleteTab(Object obj, int index)
    {
	onglets.removeElement(obj);
	tabbedPane.removeTabAt(index);
    }


    protected void debug(String msg)
    {
	if(Configuration.modedebug.equals("on"))
	    System.out.println(msg);
    }

     protected void debug(int i)
    {
	if(Configuration.modedebug.equals("on"))
	    System.out.println(i);
     }
}
