package jastex.old.gui;

import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.*;
import java.net.*;
import java.awt.image.*;

import jastex.*;



/** The toolbar */
class JasToolbar extends JToolBar {
    
    /** Declaration of some constant */
    public static final int TOOLBUTTON_NEW     = 0;
    public static final int TOOLBUTTON_OPEN    = 1;
    public static final int TOOLBUTTON_SAVE    = 2;
    public static final int TOOLBUTTON_SAVEAS  = 3;
    public static final int TOOLBUTTON_POINTER = 4;
    public static final int TOOLBUTTON_COPY    = 5;
    public static final int TOOLBUTTON_CUT     = 6;
    public static final int TOOLBUTTON_PASTE   = 7;
    public static final int TOOLBUTTON_DELETE  = 8;
    public static final int TOOLBUTTON_PREF    = 9;
    public static final int TOOLBUTTON_HELP    = 10;
    public static final int TOOLCOMBO_NODE     = 11;
    public static final int TOOLCOMBO_EDGE     = 12;
    public static final int TOOLCOMBO_MARK     = 13;
    public static final int TOOLCOMBO_OTHER    = 14;
    /** To store the icon */
    public static ImageIcon[] icons = null;
    /** filename and path of the icon file */
    public static String[] icon_filenames = { 
	"images/ico_file.gif", "images/ico_open.gif",
	"images/ico_save.gif", "images/ico_save_as.gif",
	"images/ico_pointer.gif",
	"images/ico_copy.gif","images/ico_cut.gif",
	"images/ico_coller.gif",
	"images/ico_delete.gif", "images/ico_ggp.gif",
	"images/ico_help.gif", "images/ico_node_round.gif",
	"images/ico_edge_line_round.gif",
	"images/ico_node_initial.gif",
	"images/ico_edge_bezier.gif"
    };

    /** Action name associate with each button */
    public static String[] button_actions = {
	"new", "open",
	"save", "saveas",
	"select", 
	"copy", "cut","paste",
	"del", "pref",
	"help", "node",
	"edge", "mark",
	"fobj"
    };
    
    /** Icons for the Node combo box */
    public static ImageIcon[] node_dropdown_icons = null;
    /** Filename of the Icon of the Node Combo Box */
    public static String[] node_filenames = {
	"images/ico_node_round.gif", "images/ico_node_rect.gif",
	"images/ico_node_round_rect.gif"
    };

    /** Icons for the Edge combo box */
    public static ImageIcon[] edge_dropdown_icons = null;
    /** Filename of the Icon of the Edge Combo Box */
    public static String[] edge_filenames = {
	"images/ico_edge_line.gif","images/ico_edge_line_round.gif", 
	"images/ico_edge_line_round_neg.gif",
	"images/ico_edge_line_round.gif", "images/ico_edge_bezier.gif"
	, "images/ico_loop.gif"
    };

    /** Icons for the Mark combo box */
    public static ImageIcon[] mark_dropdown_icons = null;
    /** Filename of the Icon of the Mark Combo Box */
    public static String[] mark_filenames = {
	"images/ico_node_initial.gif", "images/ico_node_final.gif",
	"images/ico_node_double.gif"
    };
    
    /* Icon for the FreeObjects Combo */
    public static ImageIcon[] fobjects_dropdown_icons = null;
    /** Filename for the Icon of the Free Objects Combo Box */
    public static String[] fobjects_filenames = {
	"images/ico_circle.gif", "images/ico_rect.gif",
	"images/ico_oval.gif",
	"images/ico_line.gif","images/ico_line_round.gif",
	"images/ico_bezier.gif"
    };

    /** List of all the component of the toolbox
     *	(some JButton and Some MyButtonComboBox) */
    private static JComponent[] toolbar_elements = null;

    /** Store the last select element */
    private int lastSelected = -1;
    private int lastNum = -1;

    /** Simple constructeur which build the ToolBar */
    public JasToolbar(MainWindow mw) {
	super();
	int nbIcons = icon_filenames.length;
	boolean isAppli = MainWindow.isAppli;
	toolbar_elements = new JComponent[nbIcons];
	MenuToolBarListener listen = new MenuToolBarListener(mw);
	
	// Load Buttons pictures
	if (icons == null) {
	    icons = new ImageIcon[nbIcons];
	    if (isAppli) {
		for (int i = 0; i < nbIcons; i++) {
		    icons[i] = new ImageIcon(icon_filenames[i]);
		    icons[i].setDescription(Languages.g_tbToolTips[i]);
		}
	    } else {
		URL location; 
		for (int i = 0; i < nbIcons; i++) {
		    location = JasToolbar.class.getResource(icon_filenames[i]);
		    icons[i] = new ImageIcon(location);
		    icons[i].setDescription(Languages.g_tbToolTips[i]);
		}
	    }	    
	}
	//create real buttons (JButton)
	for (int i = 0; i < nbIcons; i++) {
	    toolbar_elements[i] = new JButton(icons[i]);
	    toolbar_elements[i].setToolTipText(icons[i].getDescription());
	    ((JButton)toolbar_elements[i]).setActionCommand(button_actions[i]);
	    ((JButton)toolbar_elements[i]).addActionListener(listen);
	}
	
	//create the MyButtonComboBox for the nodes
	//load images
	if (node_dropdown_icons == null) {
	    node_dropdown_icons = new ImageIcon[3];
	    if (isAppli) {
		for (int i = 0; i < 3; i++) {
		    node_dropdown_icons[i] = new ImageIcon(node_filenames[i]);
		    node_dropdown_icons[i].setDescription(Languages.n_tbToolTips[i]);
		}
	    } else {
		URL location; 
		for (int i = 0; i < 3; i++) {
		    location = JasToolbar.class.getResource(node_filenames[i]);
		    node_dropdown_icons[i] = new ImageIcon(location);
		    node_dropdown_icons[i].setDescription(Languages.n_tbToolTips[i]);
		}
	    }
	}
	//create it
	toolbar_elements[TOOLCOMBO_NODE] = new MyButtonComboBox(node_dropdown_icons);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_NODE]).addListener(listen,button_actions[TOOLCOMBO_NODE]);
	
	//create the MyButtonComboBox for the edges
	//load images
	if (edge_dropdown_icons == null) {
	    edge_dropdown_icons= new ImageIcon[6];
	    if (isAppli) {
		for (int i = 0; i < 6; i++) {
		    edge_dropdown_icons[i] = new ImageIcon(edge_filenames[i]);
		    edge_dropdown_icons[i].setDescription(Languages.e_tbToolTips[i]);
		}
	    } else {
		URL location; 
		for (int i = 0; i < 6; i++) {
		    location = JasToolbar.class.getResource(edge_filenames[i]);
		    edge_dropdown_icons[i] = new ImageIcon(location);
		    edge_dropdown_icons[i].setDescription(Languages.e_tbToolTips[i]);
		}
	    }
	}
	//create it
	toolbar_elements[TOOLCOMBO_EDGE] = new MyButtonComboBox(edge_dropdown_icons);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_EDGE]).addListener(listen,button_actions[TOOLCOMBO_EDGE]);
	
	//create the MyButtonComboBox for the mark
	//load images
	if (mark_dropdown_icons == null) {
	    mark_dropdown_icons= new ImageIcon[3];
	    if (isAppli) {
		for (int i = 0; i < 3; i++) {
		    mark_dropdown_icons[i] = new ImageIcon(mark_filenames[i]);
		    mark_dropdown_icons[i].setDescription(Languages.m_tbToolTips[i]);
		}
	    } else {
		URL location; 
		for (int i = 0; i < 3; i++) {
		    location = JasToolbar.class.getResource(mark_filenames[i]);
		    mark_dropdown_icons[i] = new ImageIcon(location);
		    mark_dropdown_icons[i].setDescription(Languages.m_tbToolTips[i]);
		}
	    }
	}
	//create it
	toolbar_elements[TOOLCOMBO_MARK] = new MyButtonComboBox(mark_dropdown_icons);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_MARK]).addListener(listen,button_actions[TOOLCOMBO_MARK]);
	    
	//create the MyButtonComboBox for the free objects
	//load images
	if (fobjects_dropdown_icons == null) {
	    fobjects_dropdown_icons= new ImageIcon[6];
	    if (isAppli) {
		for (int i = 0; i < 6; i++) {
		    fobjects_dropdown_icons[i] = new ImageIcon(fobjects_filenames[i]);
		    fobjects_dropdown_icons[i].setDescription(Languages.fo_tbToolTips[i]);
		}
	    } else {
		URL location; 
		for (int i = 0; i < 6; i++) {
		    location = JasToolbar.class.getResource(fobjects_filenames[i]);
		    fobjects_dropdown_icons[i] = new ImageIcon(location);
		    fobjects_dropdown_icons[i].setDescription(Languages.fo_tbToolTips[i]);
		}
	    }
	}
	//create it
	toolbar_elements[TOOLCOMBO_OTHER] = new MyButtonComboBox(fobjects_dropdown_icons);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_OTHER]).addListener(listen,button_actions[TOOLCOMBO_OTHER]);
	
	//make the pointer icon able to change color when selected
	Image src = ((ImageIcon)icons[TOOLBUTTON_POINTER]).getImage();
	ImageFilter colorfilter = new ImageSelectedFilter();
	Image img = createImage(new FilteredImageSource(src.getSource(),
							colorfilter));
	((JButton)toolbar_elements[TOOLBUTTON_POINTER]).setSelectedIcon(new ImageIcon(img));

	setFloatable(false);
	setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));
	//Put the different element of the JToolbar

	if (!isAppli) {
	    toolbar_elements[TOOLBUTTON_OPEN].setEnabled(false);
	    toolbar_elements[TOOLBUTTON_SAVE].setEnabled(false);
	    toolbar_elements[TOOLBUTTON_SAVEAS].setEnabled(false);
	}
	add(toolbar_elements[TOOLBUTTON_NEW]);
	add(toolbar_elements[TOOLBUTTON_OPEN]);
	add(toolbar_elements[TOOLBUTTON_SAVE]);
	add(toolbar_elements[TOOLBUTTON_SAVEAS]);
	addSeparator();
	add(toolbar_elements[TOOLBUTTON_POINTER]);
	addSeparator();
	add(toolbar_elements[TOOLBUTTON_COPY]);
	add(toolbar_elements[TOOLBUTTON_CUT]);
	add(toolbar_elements[TOOLBUTTON_PASTE]);
	add(toolbar_elements[TOOLBUTTON_DELETE]);
	addSeparator();
	add(toolbar_elements[TOOLCOMBO_NODE]);
	addSeparator();
 	add(toolbar_elements[TOOLCOMBO_EDGE]);
	addSeparator();
 	add(toolbar_elements[TOOLCOMBO_MARK]);
	addSeparator();
 	add(toolbar_elements[TOOLCOMBO_OTHER]);
	addSeparator();
	add(toolbar_elements[TOOLBUTTON_PREF]);
	addSeparator();
	add(toolbar_elements[TOOLBUTTON_HELP]);
	changesSelected(TOOLCOMBO_NODE);
    }

    public void changesSelected(int newSelected, int num) {
	if (lastSelected != newSelected || num != lastNum) {
	    if (lastSelected != -1 && lastSelected != newSelected) {
		if (toolbar_elements[lastSelected] instanceof JButton)
		    ((JButton)(toolbar_elements[lastSelected])).setSelected(false);
		else 
		    ((MyButtonComboBox)(toolbar_elements[lastSelected])).setSelected(false);
	    }
	    if (toolbar_elements[newSelected] instanceof JButton)
		((JButton)(toolbar_elements[newSelected])).setSelected(true);
	    else 
		((MyButtonComboBox)(toolbar_elements[newSelected])).setSelected(true, num);
	    lastSelected = newSelected;
	    lastNum = num;
	}
    }
	    
    public void changesSelected(int newSelected) {
	changesSelected(newSelected, 0);
   }

    public void changeDrawingItemsState(boolean state) {
	((JButton)toolbar_elements[TOOLBUTTON_POINTER]).setEnabled(state);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_NODE]).setEnabled(state);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_EDGE]).setEnabled(state);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_MARK]).setEnabled(state);
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_OTHER]).setEnabled(state);
   }

    public void changeDocumentItemsState(boolean state) {
	changeDrawingItemsState(state);
	if (MainWindow.isAppli) {
	    ((JButton)toolbar_elements[TOOLBUTTON_SAVE]).setEnabled(state);
	    ((JButton)toolbar_elements[TOOLBUTTON_SAVEAS]).setEnabled(state);
	}
	((JButton)toolbar_elements[TOOLBUTTON_COPY]).setEnabled(state);
	((JButton)toolbar_elements[TOOLBUTTON_CUT]).setEnabled(state);
	((JButton)toolbar_elements[TOOLBUTTON_PASTE]).setEnabled(state);
	((JButton)toolbar_elements[TOOLBUTTON_DELETE]).setEnabled(state);
	((JButton)toolbar_elements[TOOLBUTTON_PREF]).setEnabled(state);
    }

    public void initLanguage() {
	int sz;
	sz = icons.length;
	for (int i = 0; i < sz; i++) {
	    icons[i].setDescription(Languages.g_tbToolTips[i]);
	    
	}
	//Button
	for (int i = 0; i < 11; i++) {
	    toolbar_elements[i].setToolTipText(icons[i].getDescription());
	}
	//Nodes
	for (int i = 0; i < 3; i++) {
	    node_dropdown_icons[i].setDescription(Languages.n_tbToolTips[i]);
	}
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_NODE]).initLanguage();
	//Edges
	for (int i = 0; i < 6; i++) {
	    edge_dropdown_icons[i].setDescription(Languages.e_tbToolTips[i]);
	}
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_EDGE]).initLanguage();
	//Marks
	for (int i = 0; i < 3; i++) {
	    mark_dropdown_icons[i].setDescription(Languages.m_tbToolTips[i]);
	}
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_MARK]).initLanguage();
	//Others
	for (int i = 0; i < 6; i++) {
	    fobjects_dropdown_icons[i].setDescription(Languages.fo_tbToolTips[i]);
	}
	((MyButtonComboBox)toolbar_elements[TOOLCOMBO_OTHER]).initLanguage();
    }
}
