package jastex.old.gui;

import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

import jastex.*;
import jastex.parsing.JasTabbedPane;



public class MDITabbedPane extends JTabbedPane implements ChangeListener {
    private Vector tabs;
    private int currentTab;
    /** Context Menu Popup */
    private Vector contextMenus;
    private JLabel status;
    /** The Main Window */
    private MainWindow mw;

    /** last mode */
    public int lastMode;
    public int lastNum;

    private String initDocTitle;
    public MDITabbedPane(MainWindow mainWindow, JLabel status) {
	super(JTabbedPane.BOTTOM);
	tabs = new Vector();
	contextMenus = new Vector();
	this.status = status;
	currentTab = 0;
	addChangeListener(this);
	mw = mainWindow;
	initDocTitle = Languages.document_Title;
	addDocument();
    }	
  
    public void addDocument() {
	JasTabbedPane tab;
	ObjectControlMenu contextMenu;

	JPanel panel = new JPanel(new BorderLayout());
	tab = new JasTabbedPane(mw);
	panel.add(tab,BorderLayout.CENTER);
	contextMenu = new ObjectControlMenu(tab.getDrawing());
	tab.getDrawing().setContextMenu(contextMenu);
	tab.getDrawing().setStatusBar(status);
	tabs.add(tab);
	contextMenus.add(contextMenus);
	addTab(Languages.document_Title, null, panel);
	int count = getTabCount();
	setSelectedIndex(count-1);
	if (count == 1) {
	    mw.changeDocumentItemsState(true);
	}	    
    }
	
    public JasTabbedPane  getJasTabbedPane() {
	return ((JasTabbedPane) tabs.elementAt(currentTab));
    }

    public void stateChanged(ChangeEvent e) {
	JTabbedPane source = (JTabbedPane)e.getSource();
	currentTab = source.getSelectedIndex();
	if (currentTab >= 0) {
	    if (getJasTabbedPane().isDrawingArea()) {
		mw.changeDrawingItemsState(true);
	    } else {
		mw.changeDrawingItemsState(false);
	    }	    
	    getJasTabbedPane().getDrawing().setItemToDraw(lastMode, lastNum);
	    getJasTabbedPane().getDrawing().updateScale();
	} else {
	    mw.changeDocumentItemsState(false);
	}
    }

    public File getCurrentFile() {
	return getJasTabbedPane().getCurrentFile();
    }

    public void setCurrentFile(File f) {
	getJasTabbedPane().setCurrentFile(f);
    }

    public void setDocumentTitle(String t) {
	setTitleAt(currentTab, t);	
    }

    public String getDocumentTitle(){
	return getTitleAt(currentTab); 
    }
    public void closeCurrentDocument() {
	String lastCode = getJasTabbedPane().getLastLatexCode();
	String newCode = getJasTabbedPane().getLatexCode();
	boolean b = true;
	if (!newCode.equals(lastCode)) {
	    MessageBox mb =
		new MessageBox(Languages.mb_Question_CloseDoc_Title,
			       Languages.mb_Question_CloseDoc_Text,1);
	    if (!(mb.reply == 1)) {
		b = false;
	    }
	}
	if (b) { 
	    int lastTab = currentTab;
	    remove(currentTab);
	    tabs.removeElementAt(lastTab);
	    if (lastTab == 0 && getTabCount()>0)
		setSelectedIndex(lastTab);
	}
    }
    public void setItemToDraw(int mode, int num) {
	lastMode = mode;
	lastNum  = num;
	getJasTabbedPane().getDrawing().setItemToDraw(mode,num);
    }

    public JasTabbedPane getLastCreated(){
	int sz=tabs.size();
	return ((JasTabbedPane) tabs.elementAt(sz-1));
    }

    public ObjetManager getManager(){
	return getJasTabbedPane().getDrawing().getManager();
    }

    public void initLanguage() {
	int sz=tabs.size();
	for (int i = 0; i < sz; i++) {
	    ((JasTabbedPane) tabs.elementAt(i)).initLanguage();
	    String s = getTitleAt(i);
	    if (s.equals(initDocTitle)) {
		setTitleAt(i,Languages.document_Title);
	    }
	}
 	initDocTitle = Languages.document_Title;
   }
}
