package jastex.old.gui;

import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;

import jastex.*;
import jastex.parsing.JasTabbedPane;



public class MainWindow extends JFrame {
    private static String jasTeXVersion="1.0";
    /* to say if this is an application or an applet */
    public static boolean isAppli = true;
    /** The ToolBar */
    private static int numInstance = 0;
    private JasToolbar toolbar;
    /** The TabbedPane which hold the the Drawing area and the text area*/
//     private JasTabbedPane tab;
    /** The status bar */
    private JLabel status;
    /** the Menu Bar */
    private JasMenuBar menu;
    /** Context Menu Popup */
//     private ObjectControlMenu contextMenu;
    /** The toolBox */
    static private JasObjectToolBox tooBox;

    private MDITabbedPane mdiTabbedPane;

    public static JasGGPToolBox ggpToolBox;

    public void setLatexCode(String s) {
	mdiTabbedPane.getJasTabbedPane().setLatexCode(s);
    }

    public String getLatexCode() {
	return mdiTabbedPane.getJasTabbedPane().getLatexCode();
   }

    public File getCurrentFile() {
	return mdiTabbedPane.getCurrentFile();
    }

    public void setCurrentFile(File f) {
	mdiTabbedPane.setCurrentFile(f);
    }

    /** Main Constructor which create the user environnement*/
    public MainWindow() {
	super();
	numInstance++;
	if (isAppli) {
	    setTitle(Languages.mw_Title);
	}

	toolbar = new JasToolbar(this);
 	menu = new JasMenuBar(this);
	status = new JLabel("Welcome to JasTeX "+jasTeXVersion+" version ...  Ready !");
// 	contextMenu = new ObjectControlMenu(this,tab.getDrawing());
	//temp
	//	if (isAppli) {

	mdiTabbedPane = new MDITabbedPane(this,status);
	
	if (tooBox == null) {
	    tooBox = new JasObjectToolBox(this,Languages.tbTitle[0]);
	    mdiTabbedPane.getJasTabbedPane().sDrawing.setToolBox(tooBox);
	}

	if (ggpToolBox == null)
	    ggpToolBox = new JasGGPToolBox(this,Languages.tbTitle[1]);
	
	    //}
 	menu = new JasMenuBar(this);
	setJMenuBar(menu);

	getContentPane().add(toolbar, BorderLayout.NORTH);
	getContentPane().add(mdiTabbedPane, BorderLayout.CENTER);
	getContentPane().add(status, BorderLayout.SOUTH);

	if (isAppli) {
	/** Listener to exit program when the main window in closed */
	    this.addWindowListener(new WindowAdapter() {
		    public void windowClosing(WindowEvent e) {
			if(--numInstance == 0) {
			    System.exit(0);
			} else {
			    e.getWindow().dispose();
			}
		    }
		});
	}

    }

    public JasTabbedPane getJasTabbedPane() {
	return mdiTabbedPane.getJasTabbedPane();
    }

    public ObjetManager getManager(){
	return mdiTabbedPane.getManager();
    }

    public JasToolbar getJasToolbar() {
	return toolbar;
    }
    public JasMenuBar getJasMenuBar() {
	return menu;
    }

    public static MainWindow createMainWindow() {
	MainWindow mw = new MainWindow();
	mw.pack();
	centerComponent(mw);
	mw.setVisible(true);
	return mw;
    }

    public static MainWindow createMainWindow(String latexCode) {
	MainWindow mw = new MainWindow();
	mw.pack();
	centerComponent(mw);
	mw.setVisible(true);
	mw.getMDI().getJasTabbedPane().setSelectedIndex(1);
	mw.setLatexCode(latexCode);
	return mw;
    }

    public void addDocument() {
	mdiTabbedPane.addDocument();
    }

    public void setDocumentTitle(String t) {
	mdiTabbedPane.setDocumentTitle(t);
    }

    public void closeCurrentDocument() {
	    mdiTabbedPane.closeCurrentDocument();
    } 
    public static Dimension getScreenDimension() {
	return Toolkit.getDefaultToolkit().getScreenSize();
    }
    
    public void changeDrawingItemsState(boolean state) {
	toolbar.changeDrawingItemsState(state);
	menu.changeDrawingItemsState(state);
    }

    public void changeDocumentItemsState(boolean state) {
	toolbar.changeDocumentItemsState(state);
	menu.changeDocumentItemsState(state);
    }
    public void setItemToDraw(int mode, int num) {
	mdiTabbedPane.setItemToDraw(mode,num);
    }
    
  public static void centerComponent(Component compo)
  {
    compo.setLocation(new Point((getScreenDimension().width - compo.getSize().width) / 2,
                      (getScreenDimension().height - compo.getSize().height) / 2));
  }

    public MDITabbedPane getMDI(){
	return mdiTabbedPane;
    }

    public void initLanguage() {
	JasMenuBar.initLanguage();
	toolbar.initLanguage();
	mdiTabbedPane.initLanguage();
    }

}

    
