package jastex.old.gui;

import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.lang.*;

import jastex.*;
import jastex.parsing.JasTabbedPane;



class MenuToolBarListener implements ActionListener {
    public MainWindow mainWindow;
    public JasMenuBar menubar;
    public JasToolbar toolbar;
    public JasTabbedPane tabbedPane;
    public SurfaceDessin surface;
    public boolean initDone;
    public MenuToolBarListener(MainWindow mw) {
	mainWindow = mw;
	initDone = false;
    }

    public void init() {
	menubar = mainWindow.getJasMenuBar();
	toolbar = mainWindow.getJasToolbar();
// 	tabbedPane = mainWindow.getJasTabbedPane();
// 	surface = tabbedPane.getDrawing();
    }
    private boolean openFile() {
	final JFileChooser fc = new JFileChooser();
	fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
	fc.setMultiSelectionEnabled(false);
	int ret = fc.showOpenDialog(mainWindow);

	if (ret == JFileChooser.APPROVE_OPTION ) {
	    File f = fc.getSelectedFile();
	    if (f.exists() && f.canRead()) {
		BufferedReader br = null;
		FileReader fr = null;
		try {
		    br = new BufferedReader(fr = new FileReader(f));
		} catch (FileNotFoundException e) {
		    return false;
		}
		String text = "";
		String str = null;
		String ls = System.getProperty("line.separator");
		try {
		    while (null != (str = br.readLine())) {
			text = text + str + ls;
		    }
		    br.close();
		    fr.close();
		} catch (IOException e) {
		    try { br.close(); fr.close(); } catch (IOException ex) {}
		    return false;
		}
		mainWindow.addDocument();
		mainWindow.getJasTabbedPane().setSelectedIndex(1);
		mainWindow.setLatexCode(text);
// 		mainWindow.getJasTabbedPane().parseText(text);
		mainWindow.setDocumentTitle(f.getName());
		mainWindow.setCurrentFile(f);
		return true;
	    }
	    return false;
	}
	return false;
    }

    private boolean openFile(String path) {
	final JFileChooser fc = new JFileChooser(path);
	fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
	fc.setMultiSelectionEnabled(false);
	int ret = fc.showOpenDialog(mainWindow);

	if (ret == JFileChooser.APPROVE_OPTION ) {
	    File f = fc.getSelectedFile();
	    if (f.exists() && f.canRead()) {
		BufferedReader br = null;
		FileReader fr = null;
		try {
		    br = new BufferedReader(fr = new FileReader(f));
		} catch (FileNotFoundException e) {
		    return false;
		}
		String text = "";
		String str = null;
		String ls = System.getProperty("line.separator");
		try {
		    while (null != (str = br.readLine())) {
			text = text + str + ls;
		    }
		    br.close();
		    fr.close();
		} catch (IOException e) {
		    try { br.close(); fr.close(); } catch (IOException ex) {}
		    return false;
		}
		mainWindow.addDocument();
		mainWindow.getJasTabbedPane().setSelectedIndex(1);
		mainWindow.setLatexCode(text);
// 		mainWindow.getJasTabbedPane().parseText(text);
		mainWindow.setDocumentTitle(f.getName());
		mainWindow.setCurrentFile(f);
		return true;
	    }
	    return false;
	}
	return false;
    }


    private boolean saveFile(File f) {
	PrintWriter pw = null;
	FileWriter fw = null;
	try {
	    pw = new PrintWriter (fw = new FileWriter(f));
	} catch (FileNotFoundException e) {
	    return false;
	} catch (IOException e) {
	    try { fw.close(); } catch (IOException ex) {}
	    return false;
	}
	try {
	    String s = mainWindow.getLatexCode();
	    pw.print(s);
	    mainWindow.getJasTabbedPane().setLastLatexCode(s);
	    pw.close();
	    fw.close();
	} catch (IOException e) {
	    try { pw.close(); fw.close();} catch (IOException ex) {}
	    return false;
	}
	return true;
    }

    private boolean saveFileas() {
	final JFileChooser fc = new JFileChooser();
	fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
	fc.setMultiSelectionEnabled(false);
	File cf = mainWindow.getCurrentFile();
	if (cf != null) {
	    fc.setSelectedFile(cf);
	}
	int ret = fc.showSaveDialog(mainWindow);

	if (ret == JFileChooser.APPROVE_OPTION ) {
	    File f = fc.getSelectedFile();
	    boolean b = !f.exists();
	    if (!b) {
		MessageBox mb =
		    new MessageBox(Languages.mb_Question_Overwrite_Title,
				   Languages.mb_Question_Overwrite_Text
				   + f.getName() +" ?", 1);
		if (mb.reply == 1) {
		    b = true;
		}
	    }
	    if (b) {
		if (saveFile(f)) {
		mainWindow.setDocumentTitle(f.getName());
		    mainWindow.setCurrentFile(f);
		    return true;
		}
		return false;
	    }
	    return false;
	}
	return false;
    }
    
    public void actionPerformed(ActionEvent e) {
	if (!initDone) {
	    init();
	}
 	String cmd = e.getActionCommand();

	int index = -1;
	if (cmd.equals("new")) {
	    mainWindow.addDocument();
	} else if (cmd.equals("open")) {
	    openFile();
	} else if (cmd.equals("save")) {
	    File cf = mainWindow.getCurrentFile();
	    if (cf != null) {
		saveFile(cf);
	    } else {
		saveFileas();
	    }
	} else if (cmd.equals("saveas")) {
	    saveFileas();
	} else if (cmd.equals("select")) {
	    toolbar.changesSelected(JasToolbar.TOOLBUTTON_POINTER);
	    mainWindow.setItemToDraw(-1,-1);
	} else if (cmd.equals("copy")) {
	    if (mainWindow.getJasTabbedPane().isDrawingArea())
		mainWindow.getJasTabbedPane().getDrawing().copy();
	    else {
		mainWindow.getJasTabbedPane().getTextArea().copy();
	    }
	    
	} else if (cmd.equals("cut")) {
	    if (!mainWindow.getJasTabbedPane().isDrawingArea())
		mainWindow.getJasTabbedPane().getTextArea().cut();
	    else{
		mainWindow.getJasTabbedPane().getDrawing().copy();
		mainWindow.getJasTabbedPane().getDrawing().deleteZone();
	    }
	    
	} else if (cmd.equals("paste")) {
	    if (mainWindow.getJasTabbedPane().isDrawingArea())
		mainWindow.getJasTabbedPane().getDrawing().paste(true);
	    else
		mainWindow.getJasTabbedPane().getTextArea().paste();

	} else if (cmd.equals("del")) {
	    if (mainWindow.getJasTabbedPane().isDrawingArea())
		mainWindow.getJasTabbedPane().getDrawing().rmvDefinitivelyObject();
	    else
		mainWindow.getJasTabbedPane().getTextArea().replaceSelection("");
	} else if (cmd.equals("selectall")) {
	    if (!mainWindow.getJasTabbedPane().isDrawingArea())
		mainWindow.getJasTabbedPane().getTextArea().selectAll();
	    else
		mainWindow.getJasTabbedPane().getDrawing().selectAll();
	} else if (cmd.equals("help")) {
	    final JasTextDlg jdlg =
		new JasTextDlg(mainWindow,
		    Languages.mbar_helpItems[Languages.MBAR_HELPITEM_HELP],
			       false);
	    jdlg.addActionListener(new AbstractAction() {
		    public void actionPerformed(ActionEvent e) {
			jdlg.dispose();
		    }
		});
	    int res = jdlg.setTextFromFile("help/help."+ Configuration.language);
	    if (res == -1) { //help in this language does not exist
		res = jdlg.setTextFromFile("help/help.english");
	    }
	    if (res == 0) {
		jdlg.display();
	    }

	    // * ********************
	    /* Un bo Help : pour lap rochaine version surement
	    final JasHelpDlg jhdlg =
		 new JasHelpDlg(mainWindow,
		    Languages.mbar_helpItems[Languages.MBAR_HELPITEM_HELP],
			        false);
	    //jhdlg.addActionListener(new AbstractAction() {
	    //    public void actionPerformed(ActionEvent e) {
	    //	jhdlg.dispose();
	    //    }
	    //});
	     jhdlg.display();
	    */
	    // ******************* 

	} else if (cmd.equals("close_window")) {
	    mainWindow.closeCurrentDocument();
	} else if (cmd.startsWith("node")) {
	    int num = -1;
	    String sNum = cmd.substring(cmd.length() - 1);
	    try {
		num = Integer.parseInt(sNum);
	    } catch (NumberFormatException exp) {}
	    if (num == -1) return;
	    
	    toolbar.changesSelected(JasToolbar.TOOLCOMBO_NODE, num);
	    mainWindow.setItemToDraw(0,num);
	} else if (cmd.startsWith("edge")) {
	    int num = -1;
	    String sNum = cmd.substring(cmd.length() - 1);
	    try {
		num = Integer.parseInt(sNum);
	    } catch (NumberFormatException exp) {}
	    if (num == -1) return; 
	    
	    toolbar.changesSelected(JasToolbar.TOOLCOMBO_EDGE, num);
	    mainWindow.setItemToDraw(1,num);
	} else if (cmd.startsWith("mark")) {
	    int num = -1;
	    String sNum = cmd.substring(cmd.length() - 1);
	    try {
		num = Integer.parseInt(sNum);
	    } catch (NumberFormatException exp) {}
	    if (num == -1) return; 
	    toolbar.changesSelected(JasToolbar.TOOLCOMBO_MARK, num);
	    mainWindow.setItemToDraw(2,num);
	} else if (cmd.startsWith("fobj")) {
	    int num = -1;
	    String sNum = cmd.substring(cmd.length() - 1);
	    try {
		num = Integer.parseInt(sNum);
	    } catch (NumberFormatException exp) {}
	    if (num == -1) return; 

	    toolbar.changesSelected(JasToolbar.TOOLCOMBO_OTHER, num);
	    mainWindow.setItemToDraw(3,num);
	} else if (cmd.equals("quit")) {
	    MessageBox mb =
		new MessageBox(Languages.mb_Question_Quit_Title,
			       Languages.mb_Question_Quit_Text, 1);
	    if (mb.reply == 1) {
		System.exit(0);
		
	    }
	}  else if (cmd.equals("configure_jastex")) {
	    JasConfigDialog cd = new JasConfigDialog(mainWindow,Languages.mbar_cfgItems[3]);
	}  else if (cmd.equals("pref") ||
		    cmd.equals("configure_default_ggp")) {
	    JasDefaultGGP ggpdefault =  new JasDefaultGGP(mainWindow,Languages.mbar_cfgItems[2] ,mainWindow.getManager());
	} else if (cmd.equals("about")) {
	    JasAboutBox ab = new JasAboutBox(mainWindow, "About");
	}
	else {
	    System.out.println(cmd);
	}	    
    }
}
