package jastex.old.gui;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import java.net.*;

import jastex.*;
import jastex.old.obj.SelectBox;
import jastex.old.obj.Selection;
import jastex.old.obj.JasObject;

public class ObjectControlMenu extends JPopupMenu implements PopupMenuListener,ActionListener {

    public static ImageIcon[] context_icons;
    public static String[] context_filenames = {
	"images/mini_copier.gif",
	"images/mini_coller.gif",
	"images/mini_delete.gif",
	"images/mini_arriere_plan.gif",
	"images/mini_avant_plan.gif",
	"images/mini_avant_plan.gif",
	"images/ggp.gif",
	"images/mini_cut.gif", // cut
	"images/mini_selectall.gif",
	"images/ggp.gif",
	"images/mini_repere.gif"
    }; 
    public static String[] context_actions = {
	"Copy",
	"Paste",
	"Delete",
	"Background",
	"Foreground",
	"Make it straight!",
	"GlobalProperties",
	"Cut",
	"Select All",
	"Object Properties",
	"Set Origin Here"
    };
    public JMenuItem[] context;
    public Component comp;
    public JasObject currentObject;
    public Vector collection;

    public int erz=11;

    public ObjectControlMenu(SurfaceDessin dessin){
	super();
	boolean isAppli = MainWindow.isAppli;

	if (context_icons == null || context == null) {
	    // load images
	    context_icons=new ImageIcon[erz];
	    context=new JMenuItem[erz];

	    if (isAppli) {
		for (int i = 0; i < erz; i++) {
		    context_icons[i] = new ImageIcon(context_filenames[i]);
		}
	    } else {
		URL location; 
		for (int i = 0; i < erz; i++) {
		    location = ObjectControlMenu.class.getResource(context_filenames[i]);
		    context_icons[i] = new ImageIcon(location);
		}
	    }
	    // End loading images
	}
	

	for (int i = 0; i < erz; i++) {
	    context[i]=new JMenuItem(Languages.context_popup[i],context_icons[i]);
	}	    

	// define the popup
	add(context[0]);
	add(context[1]);
	add(context[7]);
	add(new JPopupMenu.Separator());
	add(context[2]);
	add(context[8]);
	add(context[10]);
	add(new JPopupMenu.Separator());
	add(context[3]);
	add(context[4]);
	add(new JPopupMenu.Separator());
	//add(context[5]);
	add(context[6]);
//	add(context[9]);
	// end

	addPopupMenuListener(this);
	Font f = new Font("Dialog", Font.PLAIN, 12);
	for (int i=0; i<erz; i++) {
	    context[i].setFont(f);
      	    context[i].setActionCommand(context_actions[i]);
	    context[i].addActionListener(this);
	}
	 
	// set the invoker of this popupMenu
	comp=dessin;
	setInvoker(comp);
	setVisible(false);
    }

    public void showPopup(boolean b,int x,int y){
	if (b) {
	    show(comp,x,y);
	    setVisible(true);
	} else {
	    setVisible(false);
	}
	currentObject=null;
    }

    public void showPopup(boolean b,int x,int y,JasObject jo){
	showPopup(b,x,y);
	currentObject=jo;
	int nb=0;
	SurfaceDessin sf=(SurfaceDessin) comp;
	if (jo != null) {
	    if (jo instanceof Selection){
		nb=sf.getManager().indexSelectedObject.size();
	    }
	    context[0].setEnabled(true);
	    context[1].setEnabled(false);
	    context[2].setEnabled(true);
	    context[3].setEnabled(true);
	    context[4].setEnabled(true);
	    
	    context[7].setEnabled(true);
	    context[8].setEnabled(true);
	    context[9].setEnabled(true);
	    if(nb>1) {
		context[9].setEnabled(false);
		context[6].setEnabled(true);
	    } else {
		context[6].setEnabled(false);
	    }
	    context[10].setEnabled(true);
	} else {
	    context[0].setEnabled(false);
	    context[1].setEnabled(true);
	    context[2].setEnabled(false);
	    context[3].setEnabled(false);
	    context[4].setEnabled(false);
	    context[6].setEnabled(false);
	    context[7].setEnabled(false);
	    context[8].setEnabled(true);
	    context[9].setEnabled(false);
	    context[10].setEnabled(true);
	}
    }

    
    // popupMenuListener
    public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
	if(currentObject instanceof Selection){
	    //System.out.println("oyo");
	    SurfaceDessin sf=(SurfaceDessin) comp;
	    //sf.select=sf.manager.removeAreaSelected(true);
	    sf.repaint();
	}
    }
    public void popupMenuWillBecomeVisible(PopupMenuEvent e) {}
    public void popupMenuCanceled(PopupMenuEvent e) { System.out.println("Canceled");}
    // endpopupMenuListener
    
    // actionListener
    public void actionPerformed(ActionEvent ae) {
	SurfaceDessin sf=(SurfaceDessin) comp;
	String cmd = ae.getActionCommand();


	// if we have a JasObject
	if (currentObject!=null) {
	    
	    /** ForeGround Facilities */    
	    if (cmd.equals("Foreground")) {
		sf.manager.putZForeground(currentObject);
		sf.fromContextRefresh(currentObject);
	    }
	    /** BackGround Facilities */ 
	    if (cmd.equals("Background")) {
		sf.manager.putZBackground(currentObject);
		sf.fromContextRefresh(currentObject);
	    }
	    /** Delete Facilities */
	    if (cmd.equals("Delete")) {
		if (currentObject instanceof SelectBox){
		    if(sf.getManager().getNumberSelectedObject()==1){
			sf.rmvDefinitivelyObject(sf.getManager().getFirstSelectedObject());
			sf.select=sf.getManager().removeAreaSelected(sf.select);
			return;
		    } else {
			sf.getManager().rmvDefinitivelySelection();
			sf.select=sf.getManager().removeAreaSelected(sf.select);
			return;
		    }
		}
		sf.getManager().rmvDefinitivelyObject(currentObject);
		sf.fromContextRefresh(currentObject);
	    }

	    //** Copy **/
	    if (cmd.equals("Copy")) {
		//if(currentObject instanceof Selection){
		//    int sz = collection.size();
		//    System.out.println(sz);
		//    sf.copy(collection);
		//} else {
		sf.copy(currentObject);
		//}
	    }

	    if (cmd.equals("Cut")) {
		sf.copy();
		sf.deleteZone();
	    }
	    // paste

	    if (cmd.equals("GlobalProperties")) {
		//quick hack to test the ggpToolBox
		Vector tmp;
		if (currentObject instanceof Selection) {
		    System.out.println(currentObject);
		    tmp = sf.getManager().getSelectedObject();
		} else {
		    tmp=new Vector();
		    tmp.add(currentObject);
		}
		MainWindow.ggpToolBox.send2Toolbox(tmp,(SurfaceDessin) comp);
	    }

	    
	   


	}
	// paste
	if (cmd.equals("Paste")) {
	    sf.paste(false);
	} else if (cmd.equals("Select All")) {
	    sf.selectAll();
	} else if (cmd.equals("Set Origin Here")) {
	    sf.setRelativeCoordsOriginSurf();
	    sf.repaint();
	}

    }
    // endActionListener


    public void setVector(Vector collection){
	this.collection=collection;
    }

}



