package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import jastex.*;
import jastex.old.obj.JasObject;
import jastex.old.obj.AEdge;
import jastex.old.obj.ANode;
import jastex.old.obj.Loop;
import jastex.old.gui.ArrowEdit;


import jastex.old.gui.MainWindow;
import jastex.gui.JasScrollBox;
import jastex.old.gui.SurfaceDessin;
import jastex.old.gui.JasArrowChooser;

public class JasArrowTab extends OJasTab  implements ActionListener {

    public JasScrollBox AHnb;
    public JasScrollBox AHdist;
    public JButton loadBtn;
    public ArrowEdit arrowEditor;
    public SurfaceDessin sd;

    public JasArrowTab(String title, JasObject object,  SurfaceDessin sd)
    {
	super(title, object);
	this.sd = sd;

	boolean isAppli = MainWindow.isAppli;
	ImageIcon zoomIn,zoomOut,load;
	if(isAppli){
	     zoomIn  = new ImageIcon("images/mini_zoom+.gif");
	     zoomOut  = new ImageIcon("images/mini_zoom-.gif");
	     load = new ImageIcon("images/ico_open.gif");
	}
	else   {
	    URL location; 
	    location = JasArrowTab.class.getResource("images/mini_zoom+.gif");
	    zoomIn  = new ImageIcon(location);
	    
	    location = JasArrowTab.class.getResource("images/mini_zoom-.gif");
	    zoomOut  = new ImageIcon(location);

	    location = JasArrowTab.class.getResource("images/ico_open.gif");
	    load  = new ImageIcon(location);

	}
	
	AHnb = new JasScrollBox((int)((AEdge)object).getpAHnb(),1);
	AHdist = new JasScrollBox(((AEdge)object).getpAHdistTB(),0.01);
	arrowEditor = new ArrowEdit();
	arrowEditor.setAngle(((AEdge)object).getpAHangle());
	arrowEditor.setScalDistance(((AEdge)object).getpAHLength());
	arrowEditor.setVerticalDistance(((AEdge)object).getpAHlength());

	loadBtn = new JButton(load);
	loadBtn.addActionListener(this);
	loadBtn.setActionCommand("load_arrow");
	loadBtn.setPreferredSize(new Dimension(24,24));
	if(!isAppli) loadBtn.setEnabled(false); //

	JPanel zoom = new JPanel();
	zoom.setLayout(new BoxLayout(zoom, BoxLayout.Y_AXIS));
	zoom.add(new JLabel(Languages.arrowZoom[0],zoomIn,0));
	zoom.add(new JLabel(Languages.arrowZoom[1],zoomOut,0));
	zoom.add(loadBtn);

	JButton flipButton = new JButton(Languages.tb_arrowTab[3]);
	flipButton.setActionCommand("switch");
	flipButton.addActionListener(this);
	insertPropertie(Languages.tb_arrowTab[0],AHnb);
	insertPropertie(Languages.tb_arrowTab[1],AHdist);
	insertPropertie(arrowEditor,zoom);
	insertPropertie(Box.createRigidArea(new Dimension(0,5)));
	insertPropertie(new JLabel(Languages.tb_arrowTab[2]), flipButton);
    }


    public JasArrowTab(String title, Vector objects)
    {
	super(title, objects);

	GastexGlobalProperties myGgp = ((JasObject)objects.firstElement()).getGgp();
	boolean isAppli = MainWindow.isAppli;
	ImageIcon zoomIn,zoomOut,load;
	if(isAppli){
	     zoomIn  = new ImageIcon("images/mini_zoom+.gif");
	     zoomOut  = new ImageIcon("images/mini_zoom-.gif");
	       load = new ImageIcon("images/ico_open.gif");
	}
	else   {
	    URL location; 
	    
	    location = JasArrowTab.class.getResource("images/mini_zoom+.gif");
	    zoomIn  = new ImageIcon(location);
	    
	    location = JasArrowTab.class.getResource("images/mini_zoom-.gif");
	    zoomOut  = new ImageIcon(location);
	    
	    location = JasArrowTab.class.getResource("images/ico_open.gif");
	    load  = new ImageIcon(location);
	}


	AHnb = new JasScrollBox(myGgp.pAHnb,1);
	AHdist = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pAHdist) * myGgp.unitlength,0.01);
	arrowEditor = new ArrowEdit();
	arrowEditor.setAngle(Math.toDegrees(myGgp.pAHangle));
	arrowEditor.setScalDistance(myGgp.internal2UnitLength(myGgp.pAHLength) * myGgp.unitlength);
	arrowEditor.setVerticalDistance(myGgp.internal2UnitLength(myGgp.pAHlength) * myGgp.unitlength);
	JPanel zoom = new JPanel();

	loadBtn = new JButton(load);
	loadBtn.addActionListener(this);
	loadBtn.setActionCommand("load_arrow");
	loadBtn.setPreferredSize(new Dimension(24,24));
	if(!isAppli) loadBtn.setEnabled(false);

	zoom.setLayout(new BoxLayout(zoom, BoxLayout.Y_AXIS));
	zoom.add(new JLabel(Languages.arrowZoom[0],zoomIn,0));
	zoom.add(new JLabel(Languages.arrowZoom[1],zoomOut,0));
	zoom.add(loadBtn);
	
	insertPropertie(Languages.tb_arrowTab[0],AHnb);
	insertPropertie(Languages.tb_arrowTab[1],AHdist);
	insertPropertie(arrowEditor,zoom);
    }


    
    public JasArrowTab(String title, GastexGlobalProperties myGgp)
    {
	super(title);
	
	boolean isAppli = MainWindow.isAppli;
	ImageIcon zoomIn,zoomOut,load;
	if(isAppli){
	    zoomIn  = new ImageIcon("images/mini_zoom+.gif");
	    zoomOut  = new ImageIcon("images/mini_zoom-.gif");
	    load = new ImageIcon("images/ico_open.gif");
	}
	else   {
	    URL location; 
	    location = JasArrowTab.class.getResource("images/mini_zoom+.gif");
	    zoomIn  = new ImageIcon(location);
	    
	    location = JasArrowTab.class.getResource("images/mini_zoom-.gif");
	    zoomOut  = new ImageIcon(location);

	    location = JasArrowTab.class.getResource("images/ico_open.gif");
	    load  = new ImageIcon(location);

	}
	
	
	AHnb = new JasScrollBox(myGgp.pAHnb,1);
	AHdist = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pAHdist) * myGgp.unitlength,0.01);
	arrowEditor = new ArrowEdit();
	arrowEditor.setAngle(Math.toDegrees(myGgp.pAHangle));
	arrowEditor.setScalDistance(myGgp.internal2UnitLength(myGgp.pAHLength) * myGgp.unitlength);
	arrowEditor.setVerticalDistance(myGgp.internal2UnitLength(myGgp.pAHlength) * myGgp.unitlength);

	JPanel zoom = new JPanel();

	loadBtn = new JButton(load);
	loadBtn.addActionListener(this);
	loadBtn.setActionCommand("load_arrow");
	loadBtn.setPreferredSize(new Dimension(24,24));	
	if(!isAppli) loadBtn.setEnabled(false);

	zoom.setLayout(new BoxLayout(zoom, BoxLayout.Y_AXIS));
	zoom.add(new JLabel(Languages.arrowZoom[0],zoomIn,0));
	zoom.add(new JLabel(Languages.arrowZoom[1],zoomOut,0));
	zoom.add(loadBtn);
	insertPropertie(Languages.tb_arrowTab[0],AHnb);
	insertPropertie(Languages.tb_arrowTab[1],AHdist);
	insertPropertie(arrowEditor,zoom);
    }

    
    
    public void saveGgp(GastexGlobalProperties ggp)
    {
	ggp.pAHnb = (int)AHnb.getValue();
	ggp.pAHdist = ggp.unitLength2Internal(AHdist.getValue())/ ggp.unitlength;
	ggp.pAHangle = Math.toRadians(arrowEditor.getAngle());
	ggp.pAHLength = ggp.unitLength2Internal(arrowEditor.getScalDistance())/ ggp.unitlength;
	ggp.pAHlength = ggp.unitLength2Internal(arrowEditor.getVerticalDistance())/ ggp.unitlength;
    }
    
    
    /* FIXME protected */ public void updateContent(JasObject object)
    {
	this.object = object;
	AHnb.setValue((int)((AEdge)object).getpAHnb());
	AHdist.setValue(((AEdge)object).getpAHdistTB());
	arrowEditor.setAngle(((AEdge)object).getpAHangle());
	arrowEditor.setScalDistance(((AEdge)object).getpAHLength());
	arrowEditor.setVerticalDistance(((AEdge)object).getpAHlength());
    }
    
    public void writeArrowProperties(JasObject object)
    {
	debug("Edge : Sauvegarde des propriétés des fleches");
	debug("[Mise à jour de AHnb] >"+ ((AEdge)object).getpAHnb() +" --> " + AHnb.getValue());
	((AEdge)object).setpAHnb((int)AHnb.getValue());
	debug("[Mise à jour de AHdist] >"+ ((AEdge)object).getpAHdistTB() +" --> " + AHdist.getValue());
	((AEdge)object).setpAHdistTB(AHdist.getValue());
	((AEdge)object).setpAHangle(arrowEditor.getAngle());
	((AEdge)object).setpAHLength(arrowEditor.getScalDistance());
	((AEdge)object).setpAHlength(arrowEditor.getVerticalDistance());
    }
    
    
    
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	
	if(cmd.equals("switch")){
	    if(object instanceof AEdge && !(object instanceof Loop)){
		ANode sn = ((AEdge)object).getStartingNode();
		ANode en = ((AEdge)object).getEndingNode();
		((AEdge)object).setStartingNode(en);
		((AEdge)object).setEndingNode(sn);
		sd.repaint();
	    }
	    
	    else if (object instanceof AEdge && (object instanceof Loop)) {
		((Loop)object).setploopCW(!((Loop)object).getploopCW());
		sd.repaint();
	    }
	}
	else if(cmd.equals("load_arrow")){
	    JasArrowChooser ac = new JasArrowChooser(arrowEditor);
	}
    }
}
