package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import jastex.*;
import jastex.gui.JasScrollBox;
import jastex.old.gui.SurfaceDessin;
import jastex.old.obj.AEdge;
import jastex.old.obj.JasObject;
import jastex.old.obj.EdgeLabel;



public class JasEdgeLabelTab extends OJasTab {


    public JTextField labelField;
    public JRadioButton leftside;    
    public JRadioButton rightside;
    public JSlider position;
    public JasScrollBox distance;
    public JCheckBox enableLH;

    public SurfaceDessin sd;


    public JasEdgeLabelTab(String title, JasObject object, SurfaceDessin sd)
    {
	super(title, object);
	this.sd=sd;
	EdgeLabel el = ((AEdge) object).getLabel();
	labelField = new JTextField(15);
	try {
	    labelField.setText(el.getLabel());
	}
	catch (NullPointerException e){ }

	enableLH = new JCheckBox(Languages.tb_labelTab[8]);
	if(el != null ) 
	    enableLH.setSelected(el.getLHstate());
	
	Hashtable positionValues = new Hashtable();
	positionValues.put(new Integer(0),  new JLabel(Languages.tb_edgeLabelTab[6]));
	positionValues.put(new Integer(50), new JLabel(Languages.tb_edgeLabelTab[7]));
	positionValues.put(new Integer(100),new JLabel(Languages.tb_edgeLabelTab[8]));
	
	ButtonGroup btnGroup = new ButtonGroup();
	leftside = new JRadioButton(Languages.tb_edgeLabelTab[3]);
	rightside = new JRadioButton(Languages.tb_edgeLabelTab[4]);
	try{
	if(el.getpELside() == 0.0) leftside.setSelected(true);
	else if(el.getpELside() == 1.0) rightside.setSelected(true);
	}
	catch (NullPointerException e) {
	    if(object.getGgp().pELside == 0) leftside.setSelected(true);
	    else rightside.setSelected(true);
	}

	btnGroup.add(leftside);
	btnGroup.add(rightside);
	JPanel radioPanel = new JPanel();
	radioPanel.add(leftside);
 	radioPanel.add(rightside);
	
	position = new JSlider();
	try {
	    position.setValue((int)el.getpELpos());}
	catch (NullPointerException e) {}
	position.setMajorTickSpacing(50);
	position.setMinorTickSpacing(5);
	position.setPaintTicks(true);
	position.setSnapToTicks(true);
	position.setPaintTrack(true);
	position.setLabelTable(positionValues);
	position.setPaintLabels(true);

	distance = new JasScrollBox(1.0);
	try {
	    distance.setValue(el.getpELdist()); }
	catch (NullPointerException e) {}
	
	insertPropertie(Languages.tb_edgeLabelTab[0],labelField);
	insertPropertie(enableLH);
	insertPropertie(Languages.tb_edgeLabelTab[2], radioPanel);
	insertPropertie(Languages.tb_edgeLabelTab[5],position);
	insertPropertie(Languages.tb_edgeLabelTab[9],distance);
    }





    /* FIXME protected */ public void updateContent(JasObject object)
    {
	this.object = object;
	EdgeLabel el = ((AEdge) object).getLabel();
	try {
	    labelField.setText(el.getLabel());
	}
	catch (NullPointerException e){labelField.setText(""); }

	if(el != null)
	    enableLH.setSelected(el.getLHstate());
	try{
	    if(el.getpELside() == 0.0) leftside.setSelected(true);
	    else if(el.getpELside() == 1.0) rightside.setSelected(true);}
	catch (NullPointerException e) {
	    if(object.getGgp().pELside == 0) leftside.setSelected(true);
	    else rightside.setSelected(true);
	}
	
	try {
	    position.setValue((int)el.getpELpos());}
	catch (NullPointerException e) {}

	try {
	    distance.setValue(el.getpELdist()); }
	catch (NullPointerException e) {}

    }



  public void writeEdgeLabelProperties(JasObject object)
    {
	EdgeLabel myEL;
	boolean b;
	this.object = object ;
	if(((AEdge) object).getLabel() == null){
	    myEL = new EdgeLabel(((AEdge)object). getGgp(),(AEdge)object ,labelField.getText());
 	} else { 
	    myEL = ((AEdge) object).getLabel();
	    myEL.setLabel(labelField.getText());
	}
	if(leftside.isSelected())
	    myEL.setpELside(0.0);
	else 
	    myEL.setpELside(1.0);
	myEL.setpELpos((double)position.getValue());
	debug(position.getValue());
	myEL.setpELdist(distance.getValue());
	myEL.setLHstate(enableLH.isSelected()); 
	
	((AEdge)object).setLabel(myEL);
	sd.refreshNewAddedObject(object);
    }

    
    public void updateDistance(double dist)
    {
	distance.setValue(dist);
    }

    
    public void updatePosition(double pos)
    {
	position.setValue((int)pos);
    }

    public void updateSide(double side) {
	if (side == 0.0) leftside.setSelected(true);
	else if (side == 1.0) rightside.setSelected(true);
    }

    public void updateLabel(String text) {
	labelField.setText(text);
    }
}
