package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import jastex.*;
import jastex.old.obj.JasObject;


import jastex.old.gui.MyJComboBox;
import jastex.gui.JasScrollBox;

public class JasGGPLabelTab extends OJasTab {

    public MyJComboBox labelCombo;
    /** the gastex 'Nadjust' propertie */
    public JComboBox adjustCombo;
    /** the gastex 'Nadjustdist' propertie */
    public JasScrollBox adjustScroll;
    /** the gastex 'ExtNL' propertie */
    public JCheckBox externalCheck;
    /** the gastex 'NLangle' propertie */
    public JasScrollBox labelAngleScroll ;	
    /** the gastex 'NLdist' propertie */
    public JasScrollBox distanceScroll;	
    
    public JRadioButton leftside;    
    public JRadioButton rightside;
    public JSlider position;
    public JasScrollBox distance;
   

    

    /** Constructor : Instanciate a new Tab for the Line (for initial ggp)
     * @param title : the tab caption 
     * @param objects : Objects vector filling the GGP Tab field
     */
    public JasGGPLabelTab(String title, Vector objects)
    {
	super(title,objects);
	String[] adjustString = Languages.tb_labelTab_adjust;

	GastexGlobalProperties myGgp = ((JasObject)objects.firstElement()).getGgp();

	adjustCombo = new JComboBox(adjustString);
	adjustCombo.setSelectedIndex(myGgp.pNadjust);
	adjustScroll = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNadjustdist) * myGgp.unitlength,0.01);
	externalCheck = new JCheckBox();
	externalCheck.setSelected(myGgp.pExtNL);
	labelAngleScroll = new JasScrollBox(Math.toDegrees(myGgp.pNLangle),0.0,360.0,0.1);
	distanceScroll = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNLdist) * myGgp.unitlength);
	
	Hashtable positionValues = new Hashtable();
	positionValues.put(new Integer(0),  new JLabel(Languages.tb_edgeLabelTab[6]));
	positionValues.put(new Integer(50), new JLabel(Languages.tb_edgeLabelTab[7]));
	positionValues.put(new Integer(100),new JLabel(Languages.tb_edgeLabelTab[8]));
	
	ButtonGroup btnGroup = new ButtonGroup();
	leftside = new JRadioButton(Languages.tb_edgeLabelTab[3]);
	rightside = new JRadioButton(Languages.tb_edgeLabelTab[4]);


	if(myGgp.pELside == 0)
	    leftside.setSelected(true);
	else 
	    rightside.setSelected(true);

	btnGroup.add(leftside);
	btnGroup.add(rightside);
	JPanel radioPanel = new JPanel();
	radioPanel.add(leftside);
 	radioPanel.add(rightside);
	
	position = new JSlider();
	position.setMaximum(100);
	position.setMinimum(0);
	position.setValue((int)myGgp.pELpos);
	position.setMajorTickSpacing(50);
	position.setMinorTickSpacing(5);
	position.setPaintTicks(true);
	position.setSnapToTicks(true);
	position.setPaintTrack(true);
	position.setLabelTable(positionValues);
	position.setPaintLabels(true);

	distance = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pELdist) * myGgp.unitlength);


	insertPropertie(new JLabel(Languages.tb_labelTab[9]+" :"));
	insertPropertie(Languages.tb_labelTab[0],adjustCombo);
	insertPropertie(Languages.tb_labelTab[1],adjustScroll);
	insertPropertie(Languages.tb_labelTab[3],externalCheck);
	insertPropertie(Languages.tb_labelTab[4],labelAngleScroll);
	insertPropertie(Languages.tb_labelTab[5],distanceScroll);
	insertPropertie(new JLabel(""));
	insertPropertie(new JLabel(Languages.tb_edgeLabelTab[10]+ " :"));
	insertPropertie(Languages.tb_edgeLabelTab[2], radioPanel);
	insertPropertie(Languages.tb_edgeLabelTab[5],position);
	insertPropertie(Languages.tb_edgeLabelTab[9],distance);
	
    }



    /** Constructor : Instanciate a new Tab for the Line (for initial ggp)
     * @param title : the tab caption 
     * @param myGgp : GGP filling the GGP Tab field
     */
    public JasGGPLabelTab(String title, GastexGlobalProperties myGgp)
    {
	super(title);
	String[] adjustString = Languages.tb_labelTab_adjust;

	adjustCombo = new JComboBox(adjustString);
	adjustCombo.setSelectedIndex(myGgp.pNadjust);
	adjustScroll = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNadjustdist) * myGgp.unitlength,0.01);
	externalCheck = new JCheckBox();
	externalCheck.setSelected(myGgp.pExtNL);
	labelAngleScroll = new JasScrollBox(Math.toDegrees(myGgp.pNLangle),0.0,360.0,0.1);
	distanceScroll = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNLdist) * myGgp.unitlength);
	
	Hashtable positionValues = new Hashtable();
	positionValues.put(new Integer(0),  new JLabel(Languages.tb_edgeLabelTab[6]));
	positionValues.put(new Integer(50), new JLabel(Languages.tb_edgeLabelTab[7]));
	positionValues.put(new Integer(100),new JLabel(Languages.tb_edgeLabelTab[8]));
	
	ButtonGroup btnGroup = new ButtonGroup();
	leftside = new JRadioButton(Languages.tb_edgeLabelTab[3]);
	rightside = new JRadioButton(Languages.tb_edgeLabelTab[4]);


	if(myGgp.pELside == 0)
	    leftside.setSelected(true);
	else 
	    rightside.setSelected(true);

	btnGroup.add(leftside);
	btnGroup.add(rightside);
	JPanel radioPanel = new JPanel();
	radioPanel.add(leftside);
 	radioPanel.add(rightside);
	
	position = new JSlider();
	position.setMaximum(100);
	position.setMinimum(0);
	position.setValue((int)myGgp.pELpos);
	position.setMajorTickSpacing(50);
	position.setMinorTickSpacing(5);
	position.setPaintTicks(true);
	position.setSnapToTicks(true);
	position.setPaintTrack(true);
	position.setLabelTable(positionValues);
	position.setPaintLabels(true);

	distance = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pELdist) * myGgp.unitlength);


	insertPropertie(new JLabel(Languages.tb_labelTab[9]+" :"));
	insertPropertie(Languages.tb_labelTab[0],adjustCombo);
	insertPropertie(Languages.tb_labelTab[1],adjustScroll);
	insertPropertie(Languages.tb_labelTab[3],externalCheck);
	insertPropertie(Languages.tb_labelTab[4],labelAngleScroll);
	insertPropertie(Languages.tb_labelTab[5],distanceScroll);
	insertPropertie(new JLabel(""));
	insertPropertie(new JLabel(Languages.tb_edgeLabelTab[10]+" :"));
	insertPropertie(Languages.tb_edgeLabelTab[2], radioPanel);
	insertPropertie(Languages.tb_edgeLabelTab[5],position);
	insertPropertie(Languages.tb_edgeLabelTab[9],distance);
    }




    public void saveGgp(GastexGlobalProperties ggp)
    {
	ggp.pExtNL = externalCheck.isSelected();
	ggp.pNLangle = Math.toRadians(labelAngleScroll.getValue());
	ggp.pNLdist = ggp.unitLength2Internal(distanceScroll.getValue()) / ggp.unitlength;
	ggp.pNadjust = adjustCombo.getSelectedIndex();
	ggp.pNadjustdist = ggp.unitLength2Internal(adjustScroll.getValue()) / ggp.unitlength;
	if(leftside.isSelected())
	    ggp.pELside=0.0;
	else 
	    ggp.pELside = 1.0;
	ggp.pELpos = position.getValue();
	ggp.pELdist = ggp.unitLength2Internal(distance.getValue()) / ggp.unitlength;
    }
    
}
