package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import jastex.*;
import jastex.old.obj.JasObject;
import jastex.old.obj.ANode;
import jastex.old.obj.IFMark;
import jastex.old.obj.Node;
import jastex.old.gui.ArrowEdit;

import jastex.JasDash;


import jastex.old.gui.MainWindow;
import jastex.old.gui.JasColorComboBox;
import jastex.gui.JasScrollBox;
import jastex.old.gui.SurfaceDessin;
import jastex.gui.JasComboBox;
import jastex.old.gui.JasArrowChooser;

public class JasIFMarkTab extends OJasTab implements ActionListener {

    public JRadioButton wbImarkline;
    public JLabel imarkGray;
    public JRadioButton colorImark ;
    public JasColorComboBox imarkcolorlist;
    public JButton imarkColorBtn;
    public JComboBox imarksCombo;
    public JasScrollBox widthIMarks;
    public JasScrollBox arrowImarkLength;
    public JasScrollBox arrowImarkAngle;
    public JasScrollBox arrowFmarkLength;
    public JasScrollBox arrowFmarkAngle;
    public JasScrollBox AHdist;
    public JasComboBox imarkdashlist ;
    public JSlider wbImarkLevel;
    public JasScrollBox nbArrowImark;
    public ArrowEdit arrowEditor;
    public JButton delBtn;
   public JButton loadBtn;
    public JasScrollBox prdist;
    public SurfaceDessin sd;

   public float[] dash0 = null;
    public float[] dash1 = {2,2,2,3};
    public float[] dash2 = {5,3};
    public float[] dash3 = {9,3};
    public float[] dash4 = {13,3,5,3};
    

    public String[] lineStrings = { "dash_0","dash_1","dash_2","dash_3","dash_4" };
    public JasDash[] dash = { 	new JasDash(dash0,0),
			new JasDash(dash1,0),
			new JasDash(dash2,0),
			new JasDash(dash3,0),
			new JasDash(dash4,0)
    };

 


   /** Constructor : Instanciate a new IFMark Tab
     * @param title : the tab caption
     * @param object : the JasObject filling the Tab field
     */
    public JasIFMarkTab(String title , JasObject object, SurfaceDessin sd)
    {
	super(title,object);
	this.sd = sd;

	Vector imarks = new Vector();
	for (int i=0; i< ((Node)object).getImarks().size(); i++)   {	    
	    int j= i+1;
	    imarks.addElement("Imark n°" + j);
	}
		
	for (int i=0; i< ((Node)object).getFmarks().size(); i++) {	    
	    int j= i+1;
	    imarks.addElement("Fmark n°" + j);
	}
		
	imarksCombo = new JComboBox(imarks);
	imarksCombo.setActionCommand("update");
	imarksCombo.addActionListener(this);
	
	boolean isAppli = MainWindow.isAppli;
	ImageIcon delIcon,zoomIn,zoomOut,load;
	if(isAppli){
	     delIcon = new ImageIcon("images/delete.gif");
	     zoomIn  = new ImageIcon("images/mini_zoom+.gif");
	     zoomOut  = new ImageIcon("images/mini_zoom-.gif");
	     load = new ImageIcon("images/ico_open.gif");
	}
	else   {
	    URL location; 
	    location = JasIFMarkTab.class.getResource("images/delete.gif");
	    delIcon = new ImageIcon(location);
	    
	    location = JasIFMarkTab.class.getResource("images/mini_zoom+.gif");
	    zoomIn  = new ImageIcon(location);
	    
	    location = JasIFMarkTab.class.getResource("images/mini_zoom-.gif");
	    zoomOut  = new ImageIcon(location);

	    location = JasIFMarkTab.class.getResource("images/ico_open.gif");
	    load  = new ImageIcon(location);
	}
	
	delBtn = new JButton(delIcon);
	delBtn.setPreferredSize(new Dimension(24,24));
	delBtn.setActionCommand("del_ifmark");
	delBtn.addActionListener(this);

	widthIMarks = new JasScrollBox(2.0);
	arrowImarkLength = new JasScrollBox(1.0,0.01);
	arrowImarkLength.setMin(-1000.0);
		
	AHdist = new JasScrollBox(0.5,0.01);
	AHdist.setMin(0);
		
	arrowEditor = new ArrowEdit();
	arrowImarkAngle = new JasScrollBox(0.0,1.0);
	arrowImarkAngle.setMax(360.0);

	loadBtn = new JButton(load);
	loadBtn.addActionListener(this);
	loadBtn.setActionCommand("load_arrow");
	loadBtn.setPreferredSize(new Dimension(24,24));

	if(!isAppli) loadBtn.setEnabled(false);

	JPanel zoom = new JPanel();
	zoom.setLayout(new BoxLayout(zoom, BoxLayout.Y_AXIS));
	zoom.add(new JLabel(Languages.arrowZoom[0],zoomIn,0));
	zoom.add(new JLabel(Languages.arrowZoom[1],zoomOut,0));
	zoom.add(loadBtn);


	wbImarkline = new JRadioButton(Languages.tb_lineTab[1]);
	imarkGray = new JLabel();

	wbImarkLevel = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbImarkLevel.setMajorTickSpacing(5);
	wbImarkLevel.setMinorTickSpacing(1);
	wbImarkLevel.setPaintTicks(true) ;	
	
	
	wbImarkLevel.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    imarkGray.setText(java.lang.Double.toString((wbImarkLevel.getValue())/10.0));
		}
	    });

	colorImark = new JRadioButton(Languages.tb_lineTab[2]);
	imarkcolorlist = new JasColorComboBox(colorStrings,colorCaption);
		
	wbImarkline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    colorImark.setSelected(false);
		    imarkcolorlist.setEnabled(false);
		    wbImarkLevel.setEnabled(true);
		    if(imarkGray.getText().length()==0)
			imarkGray.setText("1.0");
		}
	    });
	
	colorImark.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    wbImarkline.setSelected(false);
		    wbImarkLevel.setEnabled(false);
		    imarkcolorlist.setEnabled(true);
		}
	    });

	String[] lineStrings = { "dash_0","dash_1","dash_2","dash_3","dash_4" };
	String[] lineNames = { "dash_0","dash_1","dash_2","dash_3","dash_4" };
	imarkdashlist = new JasComboBox(lineStrings,dash);
	
	nbArrowImark = new JasScrollBox(0);
	
	JPanel comboPanel = new JPanel();
	comboPanel.add(imarksCombo);
	comboPanel.add(delBtn);
	insertPropertie(Languages.tb_ifmarkTab[0]);
	insertPropertie(comboPanel);
	insertPropertie(Languages.tb_ifmarkTab[1],widthIMarks);
	insertPropertie(Languages.tb_ifmarkTab[2],arrowImarkLength);
	insertPropertie(Languages.tb_ifmarkTab[3],nbArrowImark);
	insertPropertie(Languages.tb_ifmarkTab[7],AHdist);
	insertPropertie(arrowEditor,zoom);
	insertPropertie(wbImarkline);
	insertPropertie(wbImarkLevel,imarkGray);
	insertPropertie(colorImark);
	insertPropertie(imarkcolorlist);
	insertPropertie(Languages.tb_ifmarkTab[5]);
	insertPropertie(imarkdashlist);
		
		
	if( ((Node)object).getImarks().size() !=0)
	    updateImark((IFMark) ((Node)object).getImarks().elementAt(0) );
	else if( ((Node)object).getFmarks().size() !=0)
	    updateImark((IFMark) ((Node)object).getFmarks().elementAt(0) );


	if(((Node)object).getImarks().size() == 0 && ((Node)object).getFmarks().size() ==0) {
	    imarksCombo.setEnabled(false);
	    widthIMarks.setEnabled(false);
	    delBtn.setEnabled(false);
	    AHdist.setEnabled(false);
	    arrowImarkLength.setEnabled(false);
	    nbArrowImark.setEnabled(false);
	    arrowEditor.setEnabled(false);
	    wbImarkline.setEnabled(false);
	    wbImarkLevel.setEnabled(false);
	    imarkGray.setEnabled(false);
	    colorImark.setEnabled(false);
	    imarkcolorlist.setEnabled(false);
	    imarkdashlist.setEnabled(false);
	}



    }


    
    /** Constructor : Instanciate a new Tab for the IFmark
     * @param title : the tab caption 
     * @param objects : Vector objects filling the GGP Tab field
     */
    public JasIFMarkTab(String title , Vector objects)
    {
	super(title,objects);

	GastexGlobalProperties myGgp = ((JasObject)objects.firstElement()).getGgp();
	
	arrowImarkLength = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pilength) * myGgp.unitlength,0.01);
	arrowImarkLength.setMin(-1000.0);

	arrowFmarkLength = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pflength) * myGgp.unitlength,0.01);
	arrowFmarkLength.setMin(-1000.0);
	
	arrowImarkAngle = new JasScrollBox(Math.toDegrees(myGgp.piangle),1.0);
	arrowImarkAngle.setMax(360.0);

	arrowFmarkAngle = new JasScrollBox(Math.toDegrees(myGgp.pfangle),1.0);
	arrowFmarkAngle.setMax(360.0);
	
	prdist = new JasScrollBox(myGgp.internal2UnitLength(myGgp.prdist) * myGgp.unitlength,0.01);
	
	insertPropertie("Longueur des Imarks",arrowImarkLength);
	insertPropertie("Angle des Imarks",arrowImarkAngle);
	insertPropertie("Longueur des Fmarks",arrowFmarkLength);
	insertPropertie("Angle des Fmarks",arrowFmarkAngle);
	
	insertPropertie(Languages.tb_rmarkTab[6],prdist);
    }




    
    /** Constructor : Instanciate a new Tab for the IFmark
     * @param title : the tab caption 
     * @param myGgp : initial myGgp filling the GGP Tab field
     */
    public JasIFMarkTab(String title , GastexGlobalProperties myGgp)
    {
	super(title);
	

	arrowImarkLength = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pilength) * myGgp.unitlength,0.01);
	arrowImarkLength.setMin(-1000.0);
	
	arrowFmarkLength = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pflength) * myGgp.unitlength,0.01);
	arrowFmarkLength.setMin(-1000.0);
	
	arrowImarkAngle = new JasScrollBox(Math.toDegrees(myGgp.piangle),1.0);
	arrowImarkAngle.setMax(360.0);
	
	arrowFmarkAngle = new JasScrollBox(Math.toDegrees(myGgp.pfangle),1.0);
	arrowFmarkAngle.setMax(360.0);
	
	prdist = new JasScrollBox(myGgp.internal2UnitLength(myGgp.prdist) * myGgp.unitlength,0.01);
	
	insertPropertie("Longueur des Imarks",arrowImarkLength);
	insertPropertie("Angle des Imarks",arrowImarkAngle);
	insertPropertie("Longueur des Fmarks",arrowFmarkLength);
	insertPropertie("Angle des Fmarks",arrowFmarkAngle);
	
	insertPropertie(Languages.tb_rmarkTab[6],prdist);
    }



    
    /** Save the fields in the ggp given in parameter
     * @param ggp the target GastexGlobalProperties 
     */
    public void saveGgp(GastexGlobalProperties ggp)
    {
	ggp.pilength = ggp.unitLength2Internal(arrowImarkLength.getValue())/ ggp.unitlength;
	ggp.pflength = ggp.unitLength2Internal(arrowFmarkLength.getValue())/ ggp.unitlength;
	ggp.piangle = Math.toRadians(arrowImarkAngle.getValue());
	ggp.pfangle = Math.toRadians(arrowFmarkAngle.getValue());

	ggp.prdist = ggp.unitLength2Internal( prdist.getValue())/ ggp.unitlength;
    }    



    /** update the fields with the properties of the given IFMark
     * @param label : the source IFMark
     */
    private void updateImark(IFMark imark)
    {
	widthIMarks.setValue(imark.getplinewidthTB());
	arrowImarkLength.setValue(imark.getplengthTB());
	arrowImarkAngle.setValue(imark.getpangle());
	AHdist.setValue(imark.getpAHdistTB());
		
	if(imark.getplinecolor() != null)
	    {
		colorImark.setSelected(true);
		wbImarkline.setSelected(false);
		imarkcolorlist.setEnabled(true);
		imarkcolorlist.setSelectedItem(imark.getplinecolor());
		wbImarkLevel.setEnabled(false);
	    }
	else 
	    {
		wbImarkline.setSelected(true);
		colorImark.setSelected(false);
		wbImarkLevel.setEnabled(true);
		imarkcolorlist.setEnabled(false);
		imarkGray.setText(Double.toString(imark.getplinegray()));
		wbImarkLevel.setValue((int) (imark.getplinegray() * 10));
	    }
	nbArrowImark.setValue((int)imark.getpAHnb());

	arrowEditor.setAngle(imark.getpAHangle());
	arrowEditor.setScalDistance(imark.getpAHLength());
	arrowEditor.setVerticalDistance(imark.getpAHlength());



    }


    /** Save the object
     * Write the IFMark fields value in the Object given in parameter
     * @param object the target object
     */
    public void writeIFMarkProperties(JasObject object)
    {
	/** IFmark */
	if ( ((Node)object).getImarks().size() > 0 || ((Node)object).getFmarks().size()  >0 )
	    {
		IFMark myImark;
		if( imarksCombo.getSelectedIndex() < ((Node)object).getImarks().size() )
		    {
			debug("IMark");
			myImark = (IFMark) ((Node)object).getImarks().elementAt(imarksCombo.getSelectedIndex());
		    }
		else 
		    {
			debug("FMark");
			int tmp = ( imarksCombo.getSelectedIndex() - ((Node)object).getImarks().size());
			myImark = (IFMark) ((Node)object).getFmarks().elementAt(tmp);
			
		    }
		
		debug("\t[Mise à jour d'un Imark de ce Noeud]");
		debug("\t[Mise à jour de linewitdth] >" + myImark.getplinewidthTB() + " --> "+ widthIMarks.getValue()      );
		myImark.setplinewidthTB( widthIMarks.getValue());
		debug("\t[Mise à jour de ilength] >" + myImark.getplengthTB() + " --> " + arrowImarkLength.getValue());
		myImark.setplengthTB(arrowImarkLength.getValue());
		debug("\t[Mise à jour de ilangle] >" + myImark.getpangle() + " --> " + arrowImarkAngle.getValue());
		myImark.setpangle(arrowImarkAngle.getValue());

		myImark.setpAHangle(arrowEditor.getAngle());
		myImark.setpAHLength(arrowEditor.getScalDistance());
		myImark.setpAHlength(arrowEditor.getVerticalDistance());
		
		debug("\t[Mise à jour de AHdist] >" + myImark.getpAHdistTB() + " --> " + AHdist.getValue());
		myImark.setpAHdistTB(AHdist.getValue());
		
		if(wbImarkline.isSelected())
		    {
			debug("\t[Mise à jour de linegray] >"+ myImark.getplinecolor() + " --> " + imarkGray.getText());
			myImark.setplinegray(Double.parseDouble(imarkGray.getText()));
			myImark.setplinecolor(null);
		    }
		
		else if(colorImark.isSelected())
		    {
			debug("\t[Mise à jour de linecolor] >"+ myImark.getplinecolor() + " --> " + imarkcolorlist.getSelected());
			myImark.setplinecolor(imarkcolorlist.getSelected());
		    }		   
		
		debug("\t[Mise à jour de AHnb] >"+ myImark.getpAHnb() + " --> " + nbArrowImark.getValue());
		myImark.setpAHnb((int)nbArrowImark.getValue());

		

		debug("[Mise à jour des dash]");
		JasDash tmp =  imarkdashlist.getSelectedDash();
		myImark.setpdash_length(tmp.getDashLength());
		myImark.setpdash_empty(tmp.getDashEmpty());

	    }
    }



    /** Set the ifmark in parameter selected in the combobox 
    * @param object the ifmrak to select in the combobox 
    */
    public void setSelectedIFMark(IFMark object)
    {
	if ( object.isInitial() )
	    {
		ANode myObj = object.getNode();
		Vector myIMarks = myObj.getImarks();
		for(int i = 0 ; i< myIMarks.size();i++)
		    if (object == (IFMark) myIMarks.elementAt(i))
			imarksCombo.setSelectedIndex(i);
	    }
	else 
	    {
		ANode myObj = object.getNode();
		Vector myFMarks = myObj.getFmarks();
		for(int i = 0 ; i< myFMarks.size();i++)
		    if (object == (IFMark) myFMarks.elementAt(i))
			imarksCombo.setSelectedIndex(i + myObj.getImarks().size());
	    }
    }
    
    
    /** Update the IFMarkAngle propertie 
    * @param angle the new value
    */
    public void updateIFMarkAngle(double angle) { arrowImarkAngle.setValue(angle); };

    
    /** Update the IFMarkLength propertie 
     * @param length the new value 
     */
    public void updateIFMarkLength(double length) { arrowImarkLength.setValue(length); };





  public void updateIFMarkList(JasObject object)
    {
	this.object = object;
	imarksCombo.removeActionListener(this);
	if( imarksCombo.getItemCount() != 0) imarksCombo.removeAllItems();


	for (int i=0; i< ((Node)object).getImarks().size(); i++)   {	    
	    int j= i+1;
	    imarksCombo.addItem("Imark n°" + j);
	}
	
	for (int i=0; i< ((Node)object).getFmarks().size(); i++) {	    
	    int j= i+1;
	    imarksCombo.addItem("Fmark n°" + j);
	}
	


	if(((Node)object).getImarks().size() == 0 && ((Node)object).getFmarks().size() ==0) {
	    imarksCombo.setEnabled(false);
	    widthIMarks.setEnabled(false);
	    delBtn.setEnabled(false);
	    AHdist.setEnabled(false);
	    arrowImarkLength.setEnabled(false);
	    nbArrowImark.setEnabled(false);
	    arrowEditor.setEnabled(false);
	    wbImarkline.setEnabled(false);
	    wbImarkLevel.setEnabled(false);
	    imarkGray.setEnabled(false);
	    colorImark.setEnabled(false);
	    imarkcolorlist.setEnabled(false);
	    imarkdashlist.setEnabled(false);
	} else {
	    delBtn.setEnabled(true);
	    imarksCombo.setSelectedIndex(0);
	}
	
    }




    
    /** Action Listener */
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if(cmd.equals("update"))
	    {
		//imarks
		if( imarksCombo.getSelectedIndex() < ((Node)object).getImarks().size() )
		    updateImark( (IFMark) ((Node)object).getImarks().elementAt(imarksCombo.getSelectedIndex()) );
		else
		    {	
			// fmarks
			int tmp = ( imarksCombo.getSelectedIndex() - ((Node)object).getImarks().size());
			updateImark( (IFMark) ((Node)object).getFmarks().elementAt( tmp ));
		    }
	    }
	
	else if(cmd.equals("del_ifmark")) 
	    {	
		JComboBox combo = imarksCombo;
		if( imarksCombo.getSelectedIndex() < ((Node)object).getImarks().size())
		    ((IFMark) ((Node)object).getImarks().elementAt(imarksCombo.getSelectedIndex())).removeFromNode();
		else
		    {	
			// fmarks
			int tmp = ( imarksCombo.getSelectedIndex() - ((Node)object).getImarks().size());
			((IFMark) ((Node)object).getFmarks().elementAt( tmp )).removeFromNode();
		    }
		
		updateIFMarkList(object);
		imarksCombo.addActionListener(this);
		if(((Node)object).getImarks().size() != 0 || ((Node)object).getFmarks().size() !=0) 
		    imarksCombo.setSelectedIndex(0);
		sd.fromToolBoxRefresh(object);
	    }
	else if(cmd.equals("load_arrow")){
	    JasArrowChooser ac = new JasArrowChooser(arrowEditor);
	}
    }
    

}
