package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import jastex.*;
import jastex.old.obj.JasObject;
import jastex.old.obj.Loop;


import jastex.gui.JasScrollBox;


public class JasLoopTab extends OJasTab {
    
    public JasScrollBox angle;
    public JasScrollBox diameter;


    /** Constructor : Instanciate a new Tab for the Line
     * @param title : the tab caption
     * @param object : the JasObject filling the Tab field
     */
    public JasLoopTab(String title , JasObject object)
    {
	super(title,object);
	diameter = new JasScrollBox(((Loop)object).getploopdiam(),0.01);
	angle = new JasScrollBox(((Loop)object).getploopangle(),0.01);
	angle.setMin(-360.0);
	angle.setMax(360.0);
	insertPropertie(Languages.tb_loopTab[0],diameter);
	insertPropertie(Languages.tb_loopTab[1],angle);
    }

    

    public JasLoopTab(String title , Vector objects)
    {
	super(title,objects);
	GastexGlobalProperties myGgp = ((JasObject)objects.firstElement()).getGgp();
	diameter = new JasScrollBox(myGgp.getploopdiam(),0.01);
	angle = new JasScrollBox(myGgp.getploopangle(),0.01);
	angle.setMin(-360.0);
	angle.setMax(360.0);
	insertPropertie(Languages.tb_loopTab[0],diameter);
	insertPropertie(Languages.tb_loopTab[1],angle);
    }

    public JasLoopTab(String title , GastexGlobalProperties myGgp)
    {
	super(title);
	diameter = new JasScrollBox(myGgp.getploopdiam(),0.01);
	angle = new JasScrollBox(myGgp.getploopangle(),0.01);
	angle.setMin(-360.0);
	angle.setMax(360.0);
	insertPropertie(Languages.tb_loopTab[0],diameter);
	insertPropertie(Languages.tb_loopTab[1],angle);
    }

    
    

    public void updateContent(JasObject object)
    {
	diameter.setValue(((Loop)object).getploopdiam());
	angle.setValue(((Loop)object).getploopangle());
	
    }

    
    public void writeLoopProperties(JasObject object)
    {
	((Loop)object).setploopdiam(diameter.getValue());
	((Loop)object).setploopangle(angle.getValue());
    }

    public void saveGgp(GastexGlobalProperties ggp)
    {
	ggp.setploopdiam(diameter.getValue());
	ggp.setploopangle(angle.getValue());
    }

    public void updateLoopAngle(double a)
    {
	angle.setValue(a);
    }

    public void updateLoopDiam(double diam)
    {
	diameter.setValue(diam);
    }

    
    
}

	
