package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import jastex.*;
import jastex.old.gui.MainWindow;
import jastex.old.gui.MyJComboBox;
import jastex.gui.JasScrollBox;
import jastex.old.gui.SurfaceDessin;
import jastex.old.obj.Node;
import jastex.old.obj.JasObject;
import jastex.old.obj.NodeLabel;



public class JasNodeLabelTab extends OJasTab implements ActionListener {

    public MyJComboBox labelCombo;
    public JTextField labelField;
    /** the gastex 'Nadjust' propertie */
    public JComboBox adjustCombo;
    /** the gastex 'Nadjustdist' propertie */
    public JasScrollBox adjustScroll;
    /** the gastex 'ExtNL' propertie */
    public JCheckBox externalCheck;
    /** the gastex 'NLangle' propertie */
    public JasScrollBox labelAngleScroll ;	
    /** the gastex 'NLdist' propertie */
    public JasScrollBox distanceScroll;	
    public JButton delLabelBtn;
    public JCheckBox insideCheckBox;
    public JCheckBox enableLH;
    public SurfaceDessin sd; 
    


    /** Constructor : Instanciate a new NodeLabel Tab
     * @param title : the tab caption
     * @param object : the JasObject filling the Tab field
     * @param sd : a reference on SurfaceDessin
     */
    public JasNodeLabelTab(String title, JasObject object, SurfaceDessin sd)
    {
	super(title,object);
	this.sd = sd;
	String[] adjustString = Languages.tb_labelTab_adjust;


	boolean isAppli = MainWindow.isAppli;
	ImageIcon delIcon;
	if(isAppli)
	     delIcon = new ImageIcon("images/delete.gif");

	else   {
	    URL location; 
	    location = JasNodeLabelTab.class.getResource("images/delete.gif");
	    delIcon = new ImageIcon(location);
	}

	adjustCombo = new JComboBox(adjustString);
	adjustCombo.setSelectedIndex(((Node)object).getpNadjust());
	adjustScroll = new JasScrollBox(((Node)object).getpNadjustdistTB());

	labelCombo = new MyJComboBox();


	labelCombo.setActionCommand("label");

	delLabelBtn = new JButton(delIcon);
	delLabelBtn.setActionCommand("del_label");
	delLabelBtn.addActionListener(this);
	delLabelBtn.setSize(new Dimension(24,24));
	delLabelBtn.setPreferredSize(new Dimension(24,24));

	insideCheckBox = new JCheckBox(Languages.tb_labelTab[6]);
	enableLH = new JCheckBox(Languages.tb_labelTab[8]);

	labelField = new JTextField(10);
	labelField.setHorizontalAlignment(SwingConstants.RIGHT);

	externalCheck = new JCheckBox();
	labelAngleScroll = new JasScrollBox(0.0,0.0,360.0,0.1);
	distanceScroll = new JasScrollBox(0.0);

	updateLabelList(object);
	labelCombo.addActionListener(this);
	
	insertPropertie(Languages.tb_labelTab[0],adjustCombo);
	insertPropertie(Languages.tb_labelTab[1],adjustScroll);
	insertPropertie(labelCombo,delLabelBtn);
	insertPropertie(insideCheckBox,enableLH);
	insertPropertie(Languages.tb_labelTab[2],labelField);
	insertPropertie(Languages.tb_labelTab[3],externalCheck);
	insertPropertie(Languages.tb_labelTab[4],labelAngleScroll);
	insertPropertie(Languages.tb_labelTab[5],distanceScroll);

	if(((Node)object).getNodeLabels().size() > 0)
	    updateLabelTab((NodeLabel)((Node)object).getNodeLabels().elementAt(0));
	else {
	    cleanLabelTab();
	    delLabelBtn.setEnabled(false);
	}

    }


    /** Update the labelCombo with the label of the object given in parameter
     * @param object The source object
     */
    public void updateLabelList(JasObject object)
    {
	this.object = object ;
	labelCombo.removeActionListener(this);
	if( labelCombo.getItemCount() != 0) labelCombo.removeAllItems();
	for (int i=0; i< ((Node)object).getNodeLabels().size() ; i++)
	    {
		NodeLabel label = (NodeLabel) ((Node)object).getNodeLabels().elementAt(i);
		if(label.getLabel().length() <=12)
		    labelCombo.addItem(label.getLabel());
		else 
		    labelCombo.addItem(label.getLabel().substring(0,11)+"...");
		
	    }
	labelCombo.addItem(Languages.tb_labelTab[7]);
	labelCombo.setSelectedIndex(0);
	if(labelCombo.getItemCount()==1) {
	    delLabelBtn.setEnabled(false);
	    cleanLabelTab();
	} else {
	    delLabelBtn.setEnabled(true);
	    updateLabelTab((NodeLabel) ((Node)object).getNodeLabels().elementAt(0));
	}
	
    }

    /** update the fields with the properties of the given NodeLabel
     * @param label : the source NodeLabel
     */
    public void updateLabelTab(NodeLabel label)
    {
	labelField.setText(label.getLabel());
	int NodeIndex = label.getNode().getNodeLabelIndex();
	int LabelIndex = labelCombo.getSelectedIndex();
	insideCheckBox.setSelected(LabelIndex == NodeIndex);
	enableLH.setSelected(label.getLHstate());
	externalCheck.setSelected(label.getpExtNL());
	labelAngleScroll.setValue(label.getpNLangle());
	distanceScroll.setValue(label.getpNLdistTB());
    }



    /** Update the content of the Label independant field of the Tab
     * @param object the source object
     */
    public void updateContent(JasObject object)
    {
	this.object = object ;
	adjustCombo.setSelectedIndex(((Node)object).getpNadjust());
	adjustScroll.setValue(((Node)object).getpNadjustdist());

    }

    
    /** refresh the labelcombo 
     * @param object the source object
     */
    public void refresh(JasObject object)
    {
	this.object = object ;
	labelCombo.addActionListener(this);
	if(((Node)object).getNodeLabels().size() > 0)
	    updateLabelTab((NodeLabel)((Node)object).getNodeLabels().elementAt(0));
    }

    
    /** clean the field  */
    public  void cleanLabelTab()
    {
	labelField.setText("");
	insideCheckBox.setSelected(false);
	enableLH.setSelected(false);
	externalCheck.setSelected(false);
	labelAngleScroll.setValue(0.0);
	distanceScroll.setValue(0.0);	
    }


    /** save the field values in the given object 
    * @param object the destination object 
    */
    public void writeNodeLabelProperties(JasObject object)
    {
	this.object = object ;
	debug("[Mise à jour de Nadjust] >"+ ((Node)object).getpNadjust() +" --> " +adjustCombo.getSelectedIndex() );
	((Node)object).setpNadjust(adjustCombo.getSelectedIndex());
	
	debug("[Mise à jour de Nadjustdist] >"+ ((Node)object).getpNadjustdistTB() +" --> " +adjustScroll.getValue() );
	((Node)object).setpNadjustdistTB(adjustScroll.getValue());


	/** Mise à jour des Labels*/
	NodeLabel myLabel;
	debug("\t[Mise à jour d'un label]");
	int si = labelCombo.getSelectedIndex();
	String newLabel = labelField.getText();
	
	if( si < ((Node)object).getNodeLabels().size())
	    {
		myLabel = (NodeLabel)((Node)object).getNodeLabels().elementAt(si);
		myLabel.setContext(sd.getSurfaceDGraphics());	
		debug("\t[Mise à jour de label] >" + myLabel.getLabel() + " --> " + labelField.getText());
		debug("\t[Mise à jour de ExtNL] >" + myLabel.getpExtNL() + " --> " + externalCheck.isSelected());
		myLabel.setpExtNL(externalCheck.isSelected());
		debug("\t[Mise à jour de NLAngle] >" + myLabel.getpNLangle() + " --> " +labelAngleScroll.getValue() );
		myLabel.setpNLangle(labelAngleScroll.getValue());
		debug("\t[Mise à jour de NLdist] >" + myLabel.getpNLdistTB() + " --> " + distanceScroll.getValue());
		myLabel.setpNLdistTB(distanceScroll.getValue());
		debug("\t>Mise à jour du texte<");
			
		debug("\t>Mise à jour de Inside<"+ insideCheckBox.isSelected() );
		if(insideCheckBox.isSelected())
		    ((Node)object).setNodeLabelIndex(si);
		else 
		    ((Node)object).setNodeLabelIndex(0);
		myLabel.setLHstate(enableLH.isSelected());

	if(myLabel.getLabel() != labelField.getText() && !labelField.getText().equals(""))
		    {
			myLabel.setLabel(labelField.getText());
			labelCombo.removeItemAt(si);
			if(newLabel.length()<=12)
			    labelCombo.insertItemAt(newLabel,si);
			else 
			    labelCombo.insertItemAt(newLabel.substring(0,11)+"...",si);
			labelCombo.setSelectedIndex(si);
		    }
		delLabelBtn.setEnabled(true);
	    }
		
	else 
	    {
		if(!labelField.getText().equals("")){
				
		    ((Node)object).addLabel(newLabel ,externalCheck.isSelected() ,labelAngleScroll.getValue() ,distanceScroll.getValue() / unitLength);
		    if(insideCheckBox.isSelected())
			((Node)object).setNodeLabelIndex(si);
		    else 
			((Node)object).setNodeLabelIndex(0);
		    
		    if(newLabel.length()<=12)
			labelCombo.insertItemAt(newLabel,si);
		    else 
			labelCombo.insertItemAt(newLabel.substring(0,11)+"...",si);
		    ((NodeLabel)((Node)object).getNodeLabels().lastElement()).setLHstate(enableLH.isSelected());
		    labelCombo.setSelectedIndex(si);
		    sd.refreshNewAddedObject(object);
		    delLabelBtn.setEnabled(true);
		}
	    }
	

    }


    /** Action Listener */
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	
	if(cmd.equals("label"))
	{
	    JComboBox combo = (JComboBox)e.getSource();
	    if(combo.getSelectedIndex() < ((Node)object).getNodeLabels().size())
		{
		    delLabelBtn.setEnabled(true);
		    updateLabelTab((NodeLabel) ((Node)object).getNodeLabels().elementAt(combo.getSelectedIndex()));
		}
	    else
		{
		    delLabelBtn.setEnabled(false);
		    cleanLabelTab();
		}
	    
	}
	else if(cmd.equals("del_label"))
	    {
		// deleting a node label
		if(labelCombo.getSelectedIndex() < ((Node)object).getNodeLabels().size())
		    {
			NodeLabel tmp = (NodeLabel) ((Node)object).getNodeLabels().elementAt(labelCombo.getSelectedIndex());
			if(insideCheckBox.isSelected()) 
			    ((Node)object).setNodeLabelIndex(0);
			sd.rmvDefinitivelyObject(tmp);
			
			updateLabelList(object);
			sd.fromToolBoxRefresh(object);
			labelCombo.addActionListener(this);			
		    }
	    }
	    

    }




}
