package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

import jastex.*;
import jastex.old.gui.JasColorComboBox;
import jastex.gui.JasScrollBox;
import jastex.gui.JasComboBox;
import jastex.old.obj.AEdge;
import jastex.old.obj.JasRectangle;
import jastex.old.obj.Node;
import jastex.old.obj.BezierCubicCurve;
import jastex.old.obj.JasObject;
import jastex.old.obj.Circle;
import jastex.old.obj.Loop;
import jastex.old.obj.Edge;
import jastex.old.obj.Oval;



public class OJasLineTab extends OJasTab {
    
    /** the gastex 'linewidth' propertie */
    public JasScrollBox lineWidth;
    /** the gastex 'linegray' propertie */
    public JLabel linegray ;
    /** selected if the line is in grayscale */
    public JRadioButton wbline ;
    public JSlider wbLevel ;
    /** selected if the line is in color */
    public JRadioButton colorline;
    /** the gastex 'colorline' propertie */
    public JasColorComboBox colorlist;
    /** the gastex 'dash' propertie */
    public JasComboBox linelist;
    /** the gastex 'Nframe' propertie */
    public JCheckBox nframeCheckBox;


    public JasScrollBox curve;

    public JCheckBox polarCheckBox;
    public float[] dash0 = null;
    public float[] dash1 = {2,2,2,3};
    public float[] dash2 = {5,3};
    public float[] dash3 = {9,3};
    public float[] dash4 = {13,3,5,3};
    

    public String[] lineStrings = { "dash_0","dash_1","dash_2","dash_3","dash_4" };
    public JasDash[] dash = { 	new JasDash(dash0,0),
			new JasDash(dash1,0),
			new JasDash(dash2,0),
			new JasDash(dash3,0),
			new JasDash(dash4,0)
    };


    /** Constructor : Instanciate a new Tab for the Line
     * @param title : the tab caption
     * @param object : the JasObject filling the Tab field
     */
    public OJasLineTab(String title , JasObject object)
    {
	super(title,object);
	/*Nframe*/
	JLabel nframeLabel = new JLabel(Languages.tb_lineTab[0]);
	nframeCheckBox = new JCheckBox();

	if(object instanceof Node || object instanceof Circle || object instanceof Oval || object instanceof JasRectangle)
	    {
		if( object.getpNframe() )
		    nframeCheckBox.setSelected(true);
	    }

	

	else if(object instanceof BezierCubicCurve)
	    {
		polarCheckBox = new JCheckBox("Coordonnées polaires",((BezierCubicCurve)object).isPolar());
	

		if ((object instanceof Edge) || (object instanceof Loop))
		    {
		    polarCheckBox.setVisible(false);
	
		    }
	    }
	
	lineWidth = new JasScrollBox(object.getplinewidthTB(),0.01);
	wbline = new JRadioButton(Languages.tb_lineTab[1]);
	linegray = new JLabel();

	wbLevel = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbLevel.setMajorTickSpacing(5);
	wbLevel.setMinorTickSpacing(1);
	wbLevel.setPaintTicks(true) ;
		
	wbLevel.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    linegray.setText(java.lang.Double.toString((wbLevel.getValue())/10.0));
		}
	    });

	
	colorline = new JRadioButton(Languages.tb_lineTab[2]);
	colorlist = new JasColorComboBox(colorStrings,colorCaption);

	wbline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    colorline.setSelected(false);
		    colorlist.setEnabled(false);
		    wbLevel.setEnabled(true);
		    if(linegray.getText().length()==0)
			{
			    linegray.setText("1.0");
			}
		}
	    });
	
	colorline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    wbline.setSelected(false);
		    wbLevel.setEnabled(false);
		    colorlist.setEnabled(true);
		}
	    });


	if(object instanceof Node || object instanceof Circle || object instanceof Oval || object instanceof JasRectangle )
	    {

		if(object.getpNframe() && (object.getplinecolor() != null))
		    {
			colorline.setSelected(true);
			colorlist.setEnabled(true);
			colorlist.setSelectedItem(object.getplinecolor());
			wbLevel.setEnabled(false);
			wbline.setSelected(false);
		    }
		
		else if(object.getpNframe() &&  (object.getplinecolor() == null)) 
		    {
			wbline.setSelected(true);
			wbLevel.setEnabled(true);
			colorlist.setEnabled(false);
			colorline.setSelected(false);
			linegray.setText(Double.toString(object.getplinegray()));
			wbLevel.setValue((int) (object.getplinegray() * 10));
		    }
		else
		    {
			wbline.setSelected(false);
			colorline.setSelected(false);
			colorlist.setEnabled(false);
			wbLevel.setEnabled(false);
		    }
		
	    }
	
	else if (object instanceof AEdge)
	    {
		
		if(object.getplinecolor() != null)
		    {
			colorline.setSelected(true);
			colorlist.setEnabled(true);
			colorlist.setSelectedItem(object.getplinecolor());
			wbLevel.setEnabled(false);
			wbline.setSelected(false);
		    }
		
		else if(object.getplinecolor() == null) 
		    {
			wbline.setSelected(true);
			wbLevel.setEnabled(true);
			colorlist.setEnabled(false);
			colorline.setSelected(false);
			linegray.setText(Double.toString(object.getplinegray()));
			wbLevel.setValue((int) (object.getplinegray() * 10));
		    }
		else
		    {
			wbline.setSelected(false);
			colorline.setSelected(false);
			colorlist.setEnabled(false);
			wbLevel.setEnabled(false);
		    }
	    }



	linelist = new JasComboBox(lineStrings,dash);
	
	if(object instanceof Node || object instanceof Circle || object instanceof Oval || object instanceof JasRectangle)
	    insertPropertie(nframeLabel,nframeCheckBox);
	if(object instanceof BezierCubicCurve)
	    {
		insertPropertie(polarCheckBox);
	
	    }
	
	insertPropertie(Languages.tb_lineTab[3],lineWidth);
	insertPropertie(wbline);
	insertPropertie(wbLevel,linegray);
	insertPropertie(colorline);
	insertPropertie(colorlist);
	insertPropertie(Languages.tb_lineTab[4]);
	insertPropertie(linelist);
	

	GastexGlobalProperties myGgp = object.getGgp();
	
	
	if(object.getDashIndex()!=-1)
	    linelist.setselectedIndex(object.getDashIndex());
	else if (myGgp.getDashIndex()!=-1)
	    linelist.setselectedIndex(myGgp.getDashIndex());
	else 
	    linelist.setselectedIndex(0);

    }


    /** Constructor : Instanciate a new Tab for the Line
     * @param title : the tab caption 
     * @param objects : Vector objects filling the GGP Tab field
     */
    public OJasLineTab(String title , Vector objects)
    {
	super(title,objects);
	/*Nframe*/
	
	JLabel nframeLabel = new JLabel(Languages.tb_lineTab[0]);
	GastexGlobalProperties myGgp = ((JasObject)objects.firstElement()).getGgp();
	nframeCheckBox = new JCheckBox();
	if(myGgp.pNframe)
	    nframeCheckBox.setSelected(true);
		
	curve = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pcurvedepth) * myGgp.unitlength,0.01);
	lineWidth = new JasScrollBox(myGgp.internal2UnitLength(myGgp.plinewidth) * myGgp.unitlength,0.01);
	wbline = new JRadioButton(Languages.tb_lineTab[1]);
	linegray = new JLabel();
	
	wbLevel = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbLevel.setMajorTickSpacing(5);
	wbLevel.setMinorTickSpacing(1);
	wbLevel.setPaintTicks(true) ;
	wbLevel.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    linegray.setText(java.lang.Double.toString((wbLevel.getValue())/10.0));
		}
	    });
	
	
	colorline = new JRadioButton(Languages.tb_lineTab[2]);
	colorlist = new JasColorComboBox(colorStrings,colorCaption);
	
	wbline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    colorline.setSelected(false);
		    colorlist.setEnabled(false);
		    wbLevel.setEnabled(true);
		    if(linegray.getText().length()==0)
			{
			    linegray.setText("1.0");
			}
		}
	    });
	
	colorline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    wbline.setSelected(false);
		    wbLevel.setEnabled(false);
		    colorlist.setEnabled(true);
		}
	    });
	
	if(myGgp.plinecolor != null)
	    {
		colorline.setSelected(true);
		colorlist.setEnabled(true);
		colorlist.setSelectedItem(myGgp.plinecolor);
		wbLevel.setEnabled(false);
		wbline.setSelected(false);
	    }
		
	else if(myGgp.plinecolor == null) 
	    {
		wbline.setSelected(true);
		wbLevel.setEnabled(true);
		colorlist.setEnabled(false);
		colorline.setSelected(false);
		linegray.setText(Double.toString(myGgp.plinegray));
		wbLevel.setValue((int) (myGgp.plinegray * 10));
	    }
	else
	    {
		wbline.setSelected(false);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		wbLevel.setEnabled(false);
	    }
		
	linelist = new JasComboBox(lineStrings,dash);

	insertPropertie(nframeLabel,nframeCheckBox);
	insertPropertie(Languages.tb_lineTab[3],lineWidth);
	insertPropertie("Curvedepth",curve);
	insertPropertie(wbline);
	insertPropertie(wbLevel,linegray);
	insertPropertie(colorline);
	insertPropertie(colorlist);
	insertPropertie(Languages.tb_lineTab[4]);
	insertPropertie(linelist);

	if(myGgp.getDashIndex()!=-1)
	    linelist.setselectedIndex(myGgp.getDashIndex());
	else 
	    linelist.setselectedIndex(0);

    }




   /** Constructor : Instanciate a new Tab for the Line (for initial ggp)
     * @param title : the tab caption 
     * @param myGgp : GGP filling the GGP Tab field
     */
    public OJasLineTab(String title , GastexGlobalProperties myGgp)
    {
	super(title);
	/*Nframe*/
	JLabel nframeLabel = new JLabel(Languages.tb_lineTab[0]);
	nframeCheckBox = new JCheckBox();
	if(myGgp.pNframe)
	    nframeCheckBox.setSelected(true);

	curve = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pcurvedepth) * myGgp.unitlength,0.01);		
	lineWidth = new JasScrollBox(myGgp.internal2UnitLength(myGgp.plinewidth) * myGgp.unitlength,0.01);
	wbline = new JRadioButton(Languages.tb_lineTab[1]);
	linegray = new JLabel();
	
	wbLevel = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbLevel.setMajorTickSpacing(5);
	wbLevel.setMinorTickSpacing(1);
	wbLevel.setPaintTicks(true) ;
	wbLevel.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    linegray.setText(java.lang.Double.toString((wbLevel.getValue())/10.0));
		}
	    });
	
	
	colorline = new JRadioButton(Languages.tb_lineTab[2]);
	colorlist = new JasColorComboBox(colorStrings,colorCaption);
	
	wbline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    colorline.setSelected(false);
		    colorlist.setEnabled(false);
		    wbLevel.setEnabled(true);
		    if(linegray.getText().length()==0)
			{
			    linegray.setText("1.0");
			}
		}
	    });
	
	colorline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    wbline.setSelected(false);
		    wbLevel.setEnabled(false);
		    colorlist.setEnabled(true);
		}
	    });
	
	if(myGgp.plinecolor != null)
	    {
		colorline.setSelected(true);
		colorlist.setEnabled(true);
		colorlist.setSelectedItem(myGgp.plinecolor);
		wbLevel.setEnabled(false);
		wbline.setSelected(false);
	    }
		
	else if(myGgp.plinecolor == null) 
	    {
		wbline.setSelected(true);
		wbLevel.setEnabled(true);
		colorlist.setEnabled(false);
		colorline.setSelected(false);
		linegray.setText(Double.toString(myGgp.plinegray));
		wbLevel.setValue((int) (myGgp.plinegray * 10));
	    }
	else
	    {
		wbline.setSelected(false);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		wbLevel.setEnabled(false);
	    }
		
	linelist = new JasComboBox(lineStrings,dash);

	insertPropertie(nframeLabel,nframeCheckBox);
	insertPropertie(Languages.tb_lineTab[3],lineWidth);
	insertPropertie("Curvedepth",curve);
	insertPropertie(wbline);
	insertPropertie(wbLevel,linegray);
	insertPropertie(colorline);
	insertPropertie(colorlist);
	insertPropertie(Languages.tb_lineTab[4]);
	insertPropertie(linelist);

	if(myGgp.getDashIndex()!=-1)
	    linelist.setselectedIndex(myGgp.getDashIndex());
	else 
	    linelist.setselectedIndex(0);
    }






    /** Save the fields in the ggp given in parameter
    * @param ggp the target GastexGlobalProperties 
    */
    public void saveGgp(GastexGlobalProperties ggp)
    {
	
	ggp.pcurvedepth = ggp.unitLength2Internal(curve.getValue())/ ggp.unitlength;
	if(nframeCheckBox.isSelected())
	    ggp.pNframe = true;
	else 
	    ggp.pNframe = false;
	
	if(wbline.isSelected()) {
	    ggp.plinegray = Double.parseDouble(linegray.getText());
	} else if(colorline.isSelected()) {
	    ggp.plinecolor = colorlist.getSelected();
	}
	
	ggp.plinewidth = ggp.unitLength2Internal(lineWidth.getValue())/ ggp.unitlength;
	JasDash tmp = linelist.getSelectedDash();
	ggp.setDashIndex(linelist.getSelectedIndex());
	ggp.setpdash_length(tmp.getDashLength());
	ggp.setpdash_empty (tmp.getDashEmpty());
    }


    /** Update the tab field with the Node object given in parameter
     * @param object the source Node
     */
    public void updateContent(Node object)
    {    
	this.object = (JasObject)object;
	lineWidth.setValue(object.getplinewidthTB());

	if( ((Node)object).getpNframe() )
	    nframeCheckBox.setSelected(true);
	else 
	    nframeCheckBox.setSelected(false);

	if( ((Node)object).getpNframe() && (object.getplinecolor() != null))
	    {
		colorline.setSelected(true);
		colorlist.setEnabled(true);
		wbline.setSelected(false);
		wbLevel.setEnabled(false);
		colorlist.setSelectedItem(object.getplinecolor());
	    }
	
	else if( ((Node)object).getpNframe() &&  (object.getplinecolor() == null))
	    {
		wbline.setSelected(true);
		wbLevel.setEnabled(true);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		linegray.setText(Double.toString(object.getplinegray()));
		wbLevel.setValue((int) (object.getplinegray() * 10));
	    }
	else
	    {
		wbline.setSelected(false);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		wbLevel.setEnabled(false);
	    }


	

	GastexGlobalProperties myGgp = object.getGgp();
	if(object.getDashIndex()!=-1)
	    linelist.setselectedIndex(object.getDashIndex());
	else if (myGgp.getDashIndex()!=-1)
	    linelist.setselectedIndex(myGgp.getDashIndex());
	else 
	    linelist.setselectedIndex(0);

    }
    

    /** Update the tab field with the AEdge object given in parameter
     * @param object the source AEdge
     */
    public void updateContent(AEdge object)
    {    
	this.object = (JasObject)object;
	if( object instanceof BezierCubicCurve  && !(object instanceof Edge) && !(object instanceof Loop))   {
	    polarCheckBox.setSelected(((BezierCubicCurve)object).isPolar());
	    polarCheckBox.setVisible(true);
	}
	else {
	    polarCheckBox.setVisible(false);
	}
	
	lineWidth.setValue(object.getplinewidthTB());
	if( object.getplinecolor() != null)
	    {
		colorline.setSelected(true);
		colorlist.setEnabled(true);
		wbline.setSelected(false);
		wbLevel.setEnabled(false);
		colorlist.setSelectedItem(object.getplinecolor());
	    }
	
	else if(object.getplinecolor() == null)
	    {
		wbline.setSelected(true);
		wbLevel.setEnabled(true);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		linegray.setText(Double.toString(object.getplinegray()));
		wbLevel.setValue((int) (object.getplinegray() * 10));
	    }
	else
	    {
		wbline.setSelected(false);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		wbLevel.setEnabled(false);
	    }

	GastexGlobalProperties myGgp = object.getGgp();
	if(object.getDashIndex()!=-1)
	    linelist.setselectedIndex(object.getDashIndex());
	else if (myGgp.getDashIndex()!=-1)
	    linelist.setselectedIndex(myGgp.getDashIndex());
	else 
	    linelist.setselectedIndex(0);
	

    }





    /** Update the tab field with the Node object given in parameter
     * @param object the source Node
     */
    public void updateContent(JasObject object)
    {    
	this.object = object;
	lineWidth.setValue(object.getplinewidthTB());

	if( object.getpNframe() )
	    nframeCheckBox.setSelected(true);
	else 
	    nframeCheckBox.setSelected(false);

	if( object.getpNframe() && (object.getplinecolor() != null))
	    {
		colorline.setSelected(true);
		colorlist.setEnabled(true);
		wbline.setSelected(false);
		wbLevel.setEnabled(false);
		colorlist.setSelectedItem(object.getplinecolor());
	    }
	
	else if( object.getpNframe() &&  (object.getplinecolor() == null))
	    {
		wbline.setSelected(true);
		wbLevel.setEnabled(true);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		linegray.setText(Double.toString(object.getplinegray()));
		wbLevel.setValue((int) (object.getplinegray() * 10));
	    }
	else
	    {
		wbline.setSelected(false);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		wbLevel.setEnabled(false);
	    }

	
	if(object.getDashIndex()!=-1)
	    linelist.setselectedIndex(object.getDashIndex());
	else 
	    linelist.setselectedIndex(0);

	GastexGlobalProperties myGgp = object.getGgp();
	if(object.getDashIndex()!=-1)
	    linelist.setselectedIndex(object.getDashIndex());
	else if (myGgp.getDashIndex()!=-1)
	    linelist.setselectedIndex(myGgp.getDashIndex());
	else 
	    linelist.setselectedIndex(0);

    }







    /** Save the object
     * Write the Node fields value in the Object given in parameter
     * @param object the target object
     */
    public void writeNodeLineProperties(JasObject object)
    {
	debug("[Mise à jour de linewidth] >"+ object.getplinewidthTB() +" --> " + lineWidth.getValue());
	object.setplinewidthTB(lineWidth.getValue());
	if(wbline.isSelected())
	    {
		debug("[Mise à jour de linegray] >"+ object.getplinegray() + " --> " + linegray.getText());
		object.setplinegray(Double.parseDouble(linegray.getText()));
		debug("[Mise à jour de linecolor] >"+ object.getplinecolor() + " --> null" );
		object.setplinecolor(null);
	    }
	else if(colorline.isSelected())
	    {
		debug("[Mise à jour de linecolor] >"+ object.getplinecolor() + " --> " + colorlist.getSelected());
		object.setplinecolor(colorlist.getSelected());
	    }
	debug("[Mise à jour de Nframe] >"+ object.getpNframe() + " --> " +nframeCheckBox.isSelected());
	object.setpNframe(nframeCheckBox.isSelected());

	debug("[Mise à jour des dash]");
	JasDash tmp = linelist.getSelectedDash();
	object.setDashIndex(linelist.getSelectedIndex());
	object.setpdash_length(tmp.getDashLength());
	object.setpdash_empty(tmp.getDashEmpty());
    }
    




    

    /** save the object
     * Write the Edge fields value in the Object given in parameter
     * @param object the target object
     */
    public void writeEdgeLineProperties(JasObject object)
    {      
	debug("[Mise à jour de linewidth] >"+ object.getplinewidthTB() +" --> " + lineWidth.getValue());
	object.setplinewidthTB(lineWidth.getValue());
	if(wbline.isSelected())
	    {
		debug("[Mise à jour de linegray] >"+ object.getplinegray() + " --> " + linegray.getText());
		object.setplinegray(Double.parseDouble(linegray.getText()));
		debug("[Mise à jour de linecolor] >"+ ((AEdge)object).getplinecolor() + " --> null" );
		object.setplinecolor(null);
	    }
	else if(colorline.isSelected())
	    {
		debug("[Mise à jour de linecolor] >"+ object.getplinecolor() + " --> " + colorlist.getSelected());
		object.setplinecolor(colorlist.getSelected());
	    }

	if(object instanceof BezierCubicCurve && !(object instanceof Edge) && !(object instanceof Loop))
	    ((BezierCubicCurve)object).setPolar(polarCheckBox.isSelected());	


	debug("[Mise à jour des dash]");
	JasDash tmp = linelist.getSelectedDash();
	object.setDashIndex(linelist.getSelectedIndex());
	object.setpdash_length(tmp.getDashLength());
	object.setpdash_empty(tmp.getDashEmpty());
    }
}
    
