package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

import jastex.*;
import jastex.old.gui.JasColorComboBox;
import jastex.gui.JasScrollBox;
import jastex.old.gui.SurfaceDessin;
import jastex.old.obj.JasRectangle;
import jastex.old.obj.Node;
import jastex.old.obj.JasObject;
import jastex.old.obj.Circle;
import jastex.old.obj.Oval;




public class OJasNodeTab extends OJasTab implements ActionListener {

    public JasScrollBox scrollX;
    public JasScrollBox scrollY;
    public JasScrollBox scrollH;
    public JasScrollBox scrollL;
    public JasScrollBox scrollDiameter;
    /** the gastex 'Nmr'propertie */
    public JTextField nmrField;
    /** selected if the node is grayscale filled */
    public JRadioButton wbFilled ;
    /** the gastex 'fillgray' propertie*/
    public JLabel wbFilledValue ;
    /** selected if the node is color filled */
    public JRadioButton colorFilled ;
    /** the gastex 'fillcolor' gastex propertie */
    public JasColorComboBox colorFilledCombo;
    public JSlider wbFilledSlider;
    /** the gastex 'NodeName' propertie */
    public JTextField internalNameField;
    public JLabel internalNameLabel;
    public JSlider circleSlider ;
    public JLabel circleLabel;
    public SurfaceDessin sd;




  public OJasNodeTab(String title, Node object, SurfaceDessin surf){
      super(title,object);
      sd = surf;

	internalNameLabel = new JLabel(Languages.tb_nodeTab[0] + " : " + ((Node)object).getNodeName());
	
	double unit = object.getGgp().unitlength;
 	double offX = sd.getRelativeCoordsOriginX()*Configuration.tailleGrille*unit;
 	double offY = - sd.getRelativeCoordsOriginY()*Configuration.tailleGrille*unit;

	scrollX = new JasScrollBox(object.deprecated_getXTB()-offX);
	scrollY = new JasScrollBox(object.deprecated_getYTB()-offY);
	
	scrollX.setMin(-1000);
	scrollY.setMin(-1000);
	
	scrollL = new JasScrollBox(((Node)object).getpNwTB());
	scrollL.addActionListener("plus",this);
	scrollL.addActionListener("minus",this);	
 	scrollL.setActionCommand("plus","plusL");
 	scrollL.setActionCommand("minus","minusL");	

	
	scrollH = new JasScrollBox(((Node)object).getpNhTB());
	scrollH.addActionListener("plus",this);
	scrollH.addActionListener("minus",this);	
 	scrollH.setActionCommand("plus","plusH");
 	scrollH.setActionCommand("minus","minusH");	
	
	circleSlider = new JSlider(JSlider.HORIZONTAL,0,100,100);
	circleLabel = new JLabel("(100%)");
	nmrField = new JTextField(Double.toString(((Node)object).getpNmr()),4);
	
	circleSlider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    JSlider a = (JSlider)e.getSource();
		    Double tmp;
		    if(scrollH.getValue() < scrollL.getValue())
			tmp = new Double(scrollH.getValue()/2);
		    else 
			tmp = new Double(scrollL.getValue()/2);
		    
		    Double pourcent = new Double(a.getValue());
		    circleLabel.setText("("+new Integer((int)pourcent.doubleValue())+"%)");
		    Double d1;
		    if(pourcent.doubleValue()==0) d1=new Double(0);
		    else d1= new Double ((pourcent.doubleValue() * tmp.doubleValue() ) / 100 );

		    
		    double decal = Math.pow(10,2);
		    Double valueNmr =new Double(((Math.round(d1.doubleValue()*decal))/decal));
		    nmrField.setText(String.valueOf(valueNmr));
		}
	    });	
	
        wbFilled = new JRadioButton(Languages.tb_nodeTab[6]);
	wbFilledSlider = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbFilledSlider.setMajorTickSpacing(5);
	wbFilledSlider.setMinorTickSpacing(1);
	wbFilledSlider.setPaintTicks(true) ;	
	wbFilledValue = new JLabel(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));
	
	wbFilledSlider.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    wbFilledValue.setText(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));

		}
	    });

 	colorFilled = new JRadioButton(Languages.tb_nodeTab[7]);
 	colorFilledCombo = new JasColorComboBox(colorStrings,colorCaption);
	
	
 	wbFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    colorFilled.setSelected(false);
 		    colorFilledCombo.setEnabled(false);
 		    wbFilledSlider.setEnabled(true);
 		}
 	    });
	
 	colorFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    wbFilled.setSelected(false);
 		    wbFilledSlider.setEnabled(false);
 		    colorFilledCombo.setEnabled(true);
 		}
 	    });

	if(((Node)object).getpNfill() &&  (((Node)object).getpfillcolor() != null))
	    {
		colorFilled.setSelected(true);
		colorFilledCombo.setEnabled(true);
		colorFilledCombo.setSelectedItem(((Node)object).getpfillcolor());
		wbFilledSlider.setEnabled(false);
		wbFilled.setSelected(false);
	    }
	else if(((Node)object).getpNfill() &&  (((Node)object).getpfillcolor() == null))
	    {
		wbFilled.setSelected(true);
		wbFilledSlider.setEnabled(true);
		colorFilledCombo.setEnabled(false);
		colorFilled.setSelected(false);
		wbFilledValue.setText(Double.toString(((Node)object).getpfillgray()));
		wbFilledSlider.setValue((int) (((Node)object).getpfillgray() * 10));
	    }
	else
	    {
		wbFilled.setSelected(false);
		colorFilled.setSelected(false);
		colorFilledCombo.setEnabled(false);
		wbFilledSlider.setEnabled(false);
	    }

	
	insertPropertie(internalNameLabel);
	insertPropertie(Languages.tb_nodeTab[1],scrollX);
	insertPropertie(Languages.tb_nodeTab[2],scrollY);
	insertPropertie(Languages.tb_nodeTab[3],scrollL);
	insertPropertie(Languages.tb_nodeTab[4],scrollH);
	insertPropertie(Languages.tb_nodeTab[5],circleLabel);
	insertPropertie(circleSlider,nmrField);
	insertPropertie(wbFilled);
	insertPropertie(wbFilledSlider,wbFilledValue);
	insertPropertie(colorFilled);
	insertPropertie(colorFilledCombo);
	
  }



    /** Constructor : Instanciate a new Node Tab
     * @param title : the tab caption
     * @param object : the Node filling the Tab field
    */
    public OJasNodeTab(String title, Node object)
    {
	super(title,object);
	internalNameLabel = new JLabel(Languages.tb_nodeTab[0] + " : " + ((Node)object).getNodeName());
	
	double unit = object.getGgp().unitlength;
	System.out.println(sd.getRelativeCoordsOriginX());
// 	double offX = sd.getRelativeCoordsOriginX()*Configuration.tailleGrille*unit;
// 	double offY = sd.getRelativeCoordsOriginY()*Configuration.tailleGrille*unit;

	scrollX = new JasScrollBox(object.deprecated_getXTB());
	scrollY = new JasScrollBox(object.deprecated_getYTB());
	
	scrollX.setMin(-1000);
	scrollY.setMin(-1000);
	
	scrollL = new JasScrollBox(((Node)object).getpNwTB());
	scrollL.addActionListener("plus",this);
	scrollL.addActionListener("minus",this);	
 	scrollL.setActionCommand("plus","plusL");
 	scrollL.setActionCommand("minus","minusL");	

	
	scrollH = new JasScrollBox(((Node)object).getpNhTB());
	scrollH.addActionListener("plus",this);
	scrollH.addActionListener("minus",this);	
 	scrollH.setActionCommand("plus","plusH");
 	scrollH.setActionCommand("minus","minusH");	
	
	circleSlider = new JSlider(JSlider.HORIZONTAL,0,100,100);
	circleLabel = new JLabel("(100%)");
	nmrField = new JTextField(Double.toString(((Node)object).getpNmr()),4);
	
	circleSlider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    JSlider a = (JSlider)e.getSource();
		    Double tmp;
		    if(scrollH.getValue() < scrollL.getValue())
			tmp = new Double(scrollH.getValue()/2);
		    else 
			tmp = new Double(scrollL.getValue()/2);
		    
		    Double pourcent = new Double(a.getValue());
		    circleLabel.setText("("+new Integer((int)pourcent.doubleValue())+"%)");
		    Double d1;
		    if(pourcent.doubleValue()==0) d1=new Double(0);
		    else d1= new Double ((pourcent.doubleValue() * tmp.doubleValue() ) / 100 );

		    
		    double decal = Math.pow(10,2);
		    Double valueNmr =new Double(((Math.round(d1.doubleValue()*decal))/decal));
		    nmrField.setText(String.valueOf(valueNmr));
		}
	    });	
	
        wbFilled = new JRadioButton(Languages.tb_nodeTab[6]);
	wbFilledSlider = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbFilledSlider.setMajorTickSpacing(5);
	wbFilledSlider.setMinorTickSpacing(1);
	wbFilledSlider.setPaintTicks(true) ;	
	wbFilledValue = new JLabel(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));
	
	wbFilledSlider.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    wbFilledValue.setText(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));

		}
	    });

 	colorFilled = new JRadioButton(Languages.tb_nodeTab[7]);
 	colorFilledCombo = new JasColorComboBox(colorStrings,colorCaption);
	
	
 	wbFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    colorFilled.setSelected(false);
 		    colorFilledCombo.setEnabled(false);
 		    wbFilledSlider.setEnabled(true);
 		}
 	    });
	
 	colorFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    wbFilled.setSelected(false);
 		    wbFilledSlider.setEnabled(false);
 		    colorFilledCombo.setEnabled(true);
 		}
 	    });

	if(((Node)object).getpNfill() &&  (((Node)object).getpfillcolor() != null))
	    {
		colorFilled.setSelected(true);
		colorFilledCombo.setEnabled(true);
		colorFilledCombo.setSelectedItem(((Node)object).getpfillcolor());
		wbFilledSlider.setEnabled(false);
		wbFilled.setSelected(false);
	    }
	else if(((Node)object).getpNfill() &&  (((Node)object).getpfillcolor() == null))
	    {
		wbFilled.setSelected(true);
		wbFilledSlider.setEnabled(true);
		colorFilledCombo.setEnabled(false);
		colorFilled.setSelected(false);
		wbFilledValue.setText(Double.toString(((Node)object).getpfillgray()));
		wbFilledSlider.setValue((int) (((Node)object).getpfillgray() * 10));
	    }
	else
	    {
		wbFilled.setSelected(false);
		colorFilled.setSelected(false);
		colorFilledCombo.setEnabled(false);
		wbFilledSlider.setEnabled(false);
	    }

	
	insertPropertie(internalNameLabel);
	insertPropertie(Languages.tb_nodeTab[1],scrollX);
	insertPropertie(Languages.tb_nodeTab[2],scrollY);
	insertPropertie(Languages.tb_nodeTab[3],scrollL);
	insertPropertie(Languages.tb_nodeTab[4],scrollH);
	insertPropertie(Languages.tb_nodeTab[5],circleLabel);
	insertPropertie(circleSlider,nmrField);
	insertPropertie(wbFilled);
	insertPropertie(wbFilledSlider,wbFilledValue);
	insertPropertie(colorFilled);
	insertPropertie(colorFilledCombo);
    }







    /** Constructor : Instanciate a new Node Tab for SimpleObject 
     * @param title : the tab caption
     * @param object : the JasObject filling the Tab field
     */
    public OJasNodeTab(String title, JasObject object,SurfaceDessin surf)
    {
	super(title,object);
	sd = surf;	
	//internalNameLabel = new JLabel(Languages.tb_nodeTab[0] + " : " + ((Node)object).getNodeName());

	double unit = object.getGgp().unitlength;
 	double offX = sd.getRelativeCoordsOriginX()*Configuration.tailleGrille*unit;
 	double offY = - sd.getRelativeCoordsOriginY()*Configuration.tailleGrille*unit;

	scrollX = new JasScrollBox(object.deprecated_getXTB()-offX);
	scrollY = new JasScrollBox(object.deprecated_getYTB()-offY);
	
	scrollX.setMin(-1000);
	scrollY.setMin(-1000);
	
	if(object instanceof Circle)
	    scrollDiameter = new JasScrollBox(((Circle)object).getDiameter(),0.01);
	else if(object instanceof JasRectangle)
	    {
		scrollL = new JasScrollBox(((JasRectangle)object).getWidth());
		scrollL.addActionListener("plus",this);
		scrollL.addActionListener("minus",this);	
		scrollL.setActionCommand("plus","plusL");
		scrollL.setActionCommand("minus","minusL");	
		
		scrollH = new JasScrollBox(((JasRectangle)object).getHeight());
		scrollH.addActionListener("plus",this);
		scrollH.addActionListener("minus",this);	
		scrollH.setActionCommand("plus","plusH");
		scrollH.setActionCommand("minus","minusH");	
	    }
	else if(object instanceof Oval)
	    {
		scrollL = new JasScrollBox(((Oval)object).getWidth());
		scrollL.addActionListener("plus",this);
		scrollL.addActionListener("minus",this);	
		scrollL.setActionCommand("plus","plusL");
		scrollL.setActionCommand("minus","minusL");	
		
		scrollH = new JasScrollBox(((Oval)object).getHeight());
		scrollH.addActionListener("plus",this);
		scrollH.addActionListener("minus",this);	
		scrollH.setActionCommand("plus","plusH");
		scrollH.setActionCommand("minus","minusH");	
	    }


	
        wbFilled = new JRadioButton(Languages.tb_nodeTab[6]);
	wbFilledSlider = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbFilledSlider.setMajorTickSpacing(5);
	wbFilledSlider.setMinorTickSpacing(1);
	wbFilledSlider.setPaintTicks(true) ;	
	wbFilledValue = new JLabel(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));
	
	wbFilledSlider.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    wbFilledValue.setText(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));

		}
	    });

 	colorFilled = new JRadioButton(Languages.tb_nodeTab[7]);
 	colorFilledCombo = new JasColorComboBox(colorStrings,colorCaption);
	
	
 	wbFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    colorFilled.setSelected(false);
 		    colorFilledCombo.setEnabled(false);
 		    wbFilledSlider.setEnabled(true);
 		}
 	    });
	
 	colorFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    wbFilled.setSelected(false);
 		    wbFilledSlider.setEnabled(false);
 		    colorFilledCombo.setEnabled(true);
 		}
 	    });

 	if(object.getpNfill() &&  (object.getpfillcolor() != null))
 	    {
 		colorFilled.setSelected(true);
		colorFilledCombo.setEnabled(true);
		colorFilledCombo.setSelectedItem(object.getpfillcolor());
		wbFilledSlider.setEnabled(false);
		wbFilled.setSelected(false);
	    }
 	else if(object.getpNfill() &&  (object.getpfillcolor() == null))
	    {
		wbFilled.setSelected(true);
		wbFilledSlider.setEnabled(true);
		colorFilledCombo.setEnabled(false);
		colorFilled.setSelected(false);
		wbFilledValue.setText(Double.toString(object.getpfillgray()));
		wbFilledSlider.setValue((int) (object.getpfillgray() * 10));
	    }
	else
	    {
		wbFilled.setSelected(false);
		colorFilled.setSelected(false);
		colorFilledCombo.setEnabled(false);
		wbFilledSlider.setEnabled(false);
	    }

	
	insertPropertie(Languages.tb_nodeTab[1],scrollX);
	insertPropertie(Languages.tb_nodeTab[2],scrollY);
	if (object instanceof Circle)
	    insertPropertie(Languages.tb_nodeTab[8],scrollDiameter);
	
	
	if (object instanceof JasRectangle || object instanceof Oval){
	    insertPropertie(Languages.tb_nodeTab[3],scrollL);
	    insertPropertie(Languages.tb_nodeTab[4],scrollH);
	}
	
	if(object instanceof Oval){

	circleSlider = new JSlider(JSlider.HORIZONTAL,0,100,100);
	circleLabel = new JLabel("(100%)");
	nmrField = new JTextField(Double.toString(((Oval)object).getMr()),4);
	
	circleSlider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    JSlider a = (JSlider)e.getSource();
		    Double tmp;
		    if(scrollH.getValue() < scrollL.getValue())
			tmp = new Double(scrollH.getValue()/2);
		    else 
			tmp = new Double(scrollL.getValue()/2);
		    
		    Double pourcent = new Double(a.getValue());
		    circleLabel.setText("("+new Integer((int)pourcent.doubleValue())+"%)");
		    Double d1;
		    if(pourcent.doubleValue()==0) d1=new Double(0);
		    else d1= new Double ((pourcent.doubleValue() * tmp.doubleValue() ) / 100 );

		    
		    double decal = Math.pow(10,2);
		    Double valueNmr =new Double(((Math.round(d1.doubleValue()*decal))/decal));
		    nmrField.setText(String.valueOf(valueNmr));
		}
	    });	



	insertPropertie(Languages.tb_nodeTab[5],circleLabel);
	insertPropertie(circleSlider,nmrField);

	updateNodeNmr(((Oval)object).getMr()) ;
	}

	insertPropertie(wbFilled);
	insertPropertie(wbFilledSlider,wbFilledValue);
	insertPropertie(colorFilled);
	insertPropertie(colorFilledCombo);
	
    }











    /** Constructor : Instanciate a new Tab for the Node
     * @param title : the tab caption 
     * @param objects : Vector objects filling the GGP Tab field
     */
    public OJasNodeTab(String title, Vector objects)
    {
	super(title,objects);

	GastexGlobalProperties myGgp = ((JasObject)objects.firstElement()).getGgp();

	scrollL = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNw) * myGgp.unitlength,0.01);
	scrollL.addActionListener("plus",this);
	scrollL.addActionListener("minus",this);	
 	scrollL.setActionCommand("plus","plusL");
 	scrollL.setActionCommand("minus","minusL");	

	
	scrollH = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNh) * myGgp.unitlength,0.01);
	scrollH.addActionListener("plus",this);
	scrollH.addActionListener("minus",this);	
 	scrollH.setActionCommand("plus","plusH");
 	scrollH.setActionCommand("minus","minusH");	

	
	circleSlider = new JSlider(JSlider.HORIZONTAL,0,100,100);
	circleLabel = new JLabel("(100%)");
	nmrField = new JTextField(java.lang.Double.toString(myGgp.internal2UnitLength(myGgp.pNmr)),4);

//	nmrField = new JTextField(Double.toString(((Node)object).getpNmr()),4);

	circleSlider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    JSlider a = (JSlider)e.getSource();
		    Double tmp;
		    if(scrollH.getValue() < scrollL.getValue())
			tmp = new Double(scrollH.getValue()/2);
		    else 
			tmp = new Double(scrollL.getValue()/2);
		    
		    Double pourcent = new Double(a.getValue());
		    circleLabel.setText("("+new Integer((int)pourcent.doubleValue())+"%)");
		    Double d1;
		    if(pourcent.doubleValue()==0) d1=new Double(0);
		    else d1= new Double ((pourcent.doubleValue() * tmp.doubleValue() ) / 100 );

		    double decal = Math.pow(10,2);
		    Double valueNmr =new Double(((Math.round(d1.doubleValue()*decal))/decal));

		    nmrField.setText(new String("").valueOf(valueNmr));
		}
	    });	
	
        wbFilled = new JRadioButton(Languages.tb_nodeTab[6]);
	wbFilledSlider = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbFilledSlider.setMajorTickSpacing(5);
	wbFilledSlider.setMinorTickSpacing(1);
	wbFilledSlider.setPaintTicks(true) ;	
	wbFilledValue = new JLabel(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));
	
	wbFilledSlider.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    wbFilledValue.setText(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));

		}
	    });

 	colorFilled = new JRadioButton(Languages.tb_nodeTab[7]);
 	colorFilledCombo = new JasColorComboBox(colorStrings,colorCaption);
	
	
 	wbFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    colorFilled.setSelected(false);
 		    colorFilledCombo.setEnabled(false);
 		    wbFilledSlider.setEnabled(true);
 		}
 	    });
	
 	colorFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    wbFilled.setSelected(false);
 		    wbFilledSlider.setEnabled(false);
 		    colorFilledCombo.setEnabled(true);
 		}
 	    });

 	if(myGgp.pNfill &&  myGgp.pfillcolor != null)
 	    {
		colorFilled.setSelected(true);
		colorFilledCombo.setEnabled(true);
		colorFilledCombo.setSelectedItem(myGgp.pfillcolor);
		wbFilledSlider.setEnabled(false);
		wbFilled.setSelected(false);
	    }
	else if(myGgp.pNfill &&  myGgp.pfillcolor == null)
	    {
		wbFilled.setSelected(true);
		wbFilledSlider.setEnabled(true);
		colorFilledCombo.setEnabled(false);
		colorFilled.setSelected(false);
		wbFilledValue.setText(Double.toString(myGgp.pfillgray));
		wbFilledSlider.setValue((int) (myGgp.pfillgray * 10));
	    }
	else
	    {
		wbFilled.setSelected(false);
		colorFilled.setSelected(false);
		colorFilledCombo.setEnabled(false);
		wbFilledSlider.setEnabled(false);
	    }

	insertPropertie(Languages.tb_nodeTab[3],scrollL);
	insertPropertie(Languages.tb_nodeTab[4],scrollH);
	insertPropertie(Languages.tb_nodeTab[5],circleLabel);
	insertPropertie(circleSlider,nmrField);
	insertPropertie(wbFilled);
	insertPropertie(wbFilledSlider,wbFilledValue);
	insertPropertie(colorFilled);
	insertPropertie(colorFilledCombo);

    }




 /** Constructor : Instanciate a new Tab for the Node
     * @param title : the tab caption 
     * @param myGgp : GGP filling the GGP Tab field
     */
    public OJasNodeTab(String title, GastexGlobalProperties myGgp)
    {
	super(title);

	scrollL = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNw) * myGgp.unitlength,0.01);
	scrollL.addActionListener("plus",this);
	scrollL.addActionListener("minus",this);	
 	scrollL.setActionCommand("plus","plusL");
 	scrollL.setActionCommand("minus","minusL");	

	
	scrollH = new JasScrollBox(myGgp.internal2UnitLength(myGgp.pNh) * myGgp.unitlength,0.01);
	scrollH.addActionListener("plus",this);
	scrollH.addActionListener("minus",this);	
 	scrollH.setActionCommand("plus","plusH");
 	scrollH.setActionCommand("minus","minusH");	


	
	circleSlider = new JSlider(JSlider.HORIZONTAL,0,100,100);
	circleLabel = new JLabel("(100%)");
	nmrField = new JTextField(java.lang.Double.toString(myGgp.internal2UnitLength(myGgp.pNmr)),4);
	
	circleSlider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    JSlider a = (JSlider)e.getSource();
		    Double tmp;
		    if(scrollH.getValue() < scrollL.getValue())
			tmp = new Double(scrollH.getValue()/2);
		    else 
			tmp = new Double(scrollL.getValue()/2);
		    
		    Double pourcent = new Double(a.getValue());
		    circleLabel.setText("("+new Integer((int)pourcent.doubleValue())+"%)");
		    Double d1;
		    if(pourcent.doubleValue()==0) d1=new Double(0);
		    else d1= new Double ((pourcent.doubleValue() * tmp.doubleValue() ) / 100 );

		    double decal = Math.pow(10,2);
		    Double valueNmr =new Double(((Math.round(d1.doubleValue()*decal))/decal));

		    nmrField.setText(new String("").valueOf(valueNmr));
		}
	    });	
	
        wbFilled = new JRadioButton(Languages.tb_nodeTab[6]);
	wbFilledSlider = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbFilledSlider.setMajorTickSpacing(5);
	wbFilledSlider.setMinorTickSpacing(1);
	wbFilledSlider.setPaintTicks(true) ;	
	wbFilledValue = new JLabel(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));
	
	wbFilledSlider.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    wbFilledValue.setText(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));

		}
	    });

 	colorFilled = new JRadioButton(Languages.tb_nodeTab[7]);
 	colorFilledCombo = new JasColorComboBox(colorStrings,colorCaption);
	
	
 	wbFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    colorFilled.setSelected(false);
 		    colorFilledCombo.setEnabled(false);
 		    wbFilledSlider.setEnabled(true);
 		}
 	    });
	
 	colorFilled.addActionListener(new ActionListener(){
 		public void actionPerformed(ActionEvent e)
 		{
 		    wbFilled.setSelected(false);
 		    wbFilledSlider.setEnabled(false);
 		    colorFilledCombo.setEnabled(true);
 		}
 	    });

 	if(myGgp.pNfill &&  myGgp.pfillcolor != null)
 	    {
		colorFilled.setSelected(true);
		colorFilledCombo.setEnabled(true);
		colorFilledCombo.setSelectedItem(myGgp.pfillcolor);
		wbFilledSlider.setEnabled(false);
		wbFilled.setSelected(false);
	    }
	else if(myGgp.pNfill &&  myGgp.pfillcolor == null)
	    {
		wbFilled.setSelected(true);
		wbFilledSlider.setEnabled(true);
		colorFilledCombo.setEnabled(false);
		colorFilled.setSelected(false);
		wbFilledValue.setText(Double.toString(myGgp.pfillgray));
		wbFilledSlider.setValue((int) (myGgp.pfillgray * 10));
	    }
	else
	    {
		wbFilled.setSelected(false);
		colorFilled.setSelected(false);
		colorFilledCombo.setEnabled(false);
		wbFilledSlider.setEnabled(false);
	    }

	insertPropertie(Languages.tb_nodeTab[3],scrollL);
	insertPropertie(Languages.tb_nodeTab[4],scrollH);
	insertPropertie(Languages.tb_nodeTab[5],circleLabel);
	insertPropertie(circleSlider,nmrField);
	insertPropertie(wbFilled);
	insertPropertie(wbFilledSlider,wbFilledValue);
	insertPropertie(colorFilled);
	insertPropertie(colorFilledCombo);

    }




    /** Save the fields in the ggp given in parameter
     * @param ggp the target GastexGlobalProperties 
     */
    public void saveGgp(GastexGlobalProperties ggp)
    {
	ggp.pNw = ggp.unitLength2Internal(scrollL.getValue())/ ggp.unitlength;
	ggp.pNh = ggp.unitLength2Internal(scrollH.getValue())/ ggp.unitlength;
	
	double nmr;
	if(nmrField.getText().equals(""))
	    nmr = 0.0;
	else 
	    nmr = Double.parseDouble(nmrField.getText());

	double nw= scrollL.getValue()/2;
	double nh= scrollH.getValue()/2;

	if(nw < nh)
	    {
		if(nw < nmr) ggp.pNmr = ggp.unitLength2Internal(nw)/ ggp.unitlength;
		else ggp.pNmr =  ggp.unitLength2Internal(nmr)/ ggp.unitlength;
	    }
	else
	    {
		if(nh < nmr) ggp.pNmr =  ggp.unitLength2Internal(nh)/ ggp.unitlength;
		else ggp.pNmr = ggp.unitLength2Internal( nmr)/ ggp.unitlength;
	    }

	if(wbFilled.isSelected()) {
	    ggp.pfillgray = Double.parseDouble(wbFilledValue.getText());
	    ggp.pNfill=true;
	} else if(colorFilled.isSelected()) {
	    ggp.pfillcolor = colorFilledCombo.getSelected();
	    ggp.pNfill=true;
	} else 	ggp.pNfill=false;
    }



    /** Update the tab field with the object given in parameter
     * @param object the source JasObject
     */
    public void updateContent(JasObject object)
    {
	scrollX.setValue(object.deprecated_getXTB());
	scrollY.setValue(object.deprecated_getYTB());
	scrollL.setValue(((Node)object).getpNwTB());
	scrollH.setValue(((Node)object).getpNhTB());
	
	updateNodeNmr(((Node)object).getpNmr());
	wbFilledValue.setText(java.lang.Double.toString((wbFilledSlider.getValue())/10.0));

	if( ((Node)object).getpNfill() &&   (((Node)object).getpfillcolor() != null) )
	    {
		colorFilled.setSelected(true);
		colorFilledCombo.setEnabled(true);
		wbFilledSlider.setEnabled(false);
		wbFilled.setSelected(false);
		colorFilledCombo.setSelectedItem(((Node)object).getpfillcolor());
	    }
	
	else if( ((Node)object).getpNfill() && (((Node)object).getpfillcolor() == null))
	    {		
		wbFilled.setSelected(true);
		wbFilledSlider.setEnabled(true);
		colorFilledCombo.setEnabled(false);
		colorFilled.setSelected(false);
		wbFilledValue.setText(Double.toString(((Node)object).getpfillgray()));
		wbFilledSlider.setValue((int) (((Node)object).getpfillgray() * 10));
	    }

	else
	    {
		wbFilled.setSelected(false);
		colorFilled.setSelected(false);
		colorFilledCombo.setEnabled(false);
		wbFilledSlider.setEnabled(false);
	    }
	internalNameLabel.setText(Languages.tb_nodeTab[0] + " : " + ((Node)object).getNodeName());
    }

    
    /** Save the object
     * Write the NodeTab fields value in the Object given in parameter
     * @param object the target object
     */
    public void writeNodeProperties(JasObject object)
    {
	double unit = object.getGgp().unitlength;
 	double offX = sd.getRelativeCoordsOriginX()*Configuration.tailleGrille*unit;
	double offY = - sd.getRelativeCoordsOriginY()*Configuration.tailleGrille*unit;
	
	// mise à jour de X
	debug("[Mise à jour de X] >"+ object.deprecated_getXTB() + " --> " + scrollX.getValue());
	object.deprecated_setXTB(scrollX.getValue()+offX);

	// mise à jour de Y
	debug("[Mise à jour de Y] >"+ object.deprecated_getYTB() + " --> " + scrollY.getValue());
	object.deprecated_setYTB(scrollY.getValue()+offY);

	// mise à jour de pNw
	debug("[Mise à jour de Nw] >"+ ((Node)object).getpNwTB() + " --> " + scrollL.getValue());
	((Node)object).setpNwTB(scrollL.getValue());

	// mise à jour de pNh
	debug("[Mise à jour de Nh] >"+ ((Node)object).getpNhTB() + " --> " + scrollH.getValue());
	((Node)object).setpNhTB(scrollH.getValue());


	//mise à jour de pNmr
	double nmr=Double.parseDouble(nmrField.getText());
	double nw=(double) ((((Node)object).getpNw())/2);
	double nh= (double)((((Node)object).getpNh())/2);;

	if(nw < nh)
	    {
		if(nw < nmr) ((Node)object).setpNmr(nw);
		else ((Node)object).setpNmr(nmr);
	    }
	else
	    {
		if(nh < nmr) ((Node)object).setpNmr(nh);
		else ((Node)object).setpNmr(nmr);
	    }
	debug("[Mise à jour de Nmr] >"+ ((Node)object).getpNmr()  );

	if(wbFilled.isSelected())
	    {
		debug("[Mise à jour de fillgray] >"+ ((Node)object).getpfillgray() + " --> "+ wbFilledValue.getText() );
		((Node)object).setpfillgray(Double.parseDouble(wbFilledValue.getText()));
		debug("[Mise à jour de fillcolor] >"+ ((Node)object).getpfillcolor() + " --> null" );
		((Node)object).setpfillcolor(null);
			
			
		debug(">>> Mise à jour de Nfill : "+ ((Node)object).getpNfill() +" --> true");
		((Node)object).setpNfill(true);
	    }
	else if(colorFilled.isSelected())
	    {
		debug("[Mise à jour de fillcolor] >"+ ((Node)object).getpfillcolor()+ " --> " + colorFilledCombo.getSelected());
		((Node)object).setpfillcolor(colorFilledCombo.getSelected());
			
		debug(">>> Mise à jour de Nfill : "+ ((Node)object).getpNfill() +" --> true");
		((Node)object).setpNfill(true);
			
	    }
    }

    
    public void writeSimpleObjectNodeProperties(JasObject object)
    {
	double unit = object.getGgp().unitlength;
 	double offX = sd.getRelativeCoordsOriginX()*Configuration.tailleGrille*unit;
	double offY = - sd.getRelativeCoordsOriginY()*Configuration.tailleGrille*unit;

	// mise à jour de X
	object.deprecated_setXTB(scrollX.getValue()+offX);

	// mise à jour de Y
	object.deprecated_setYTB(scrollY.getValue()+offY);
	
	if(object instanceof Circle)
	    ((Circle)object).setDiameter(scrollDiameter.getValue());
	
	
	if(object instanceof JasRectangle )
	    {
		// mise à jour de pNw
		((JasRectangle)object).setWidth(scrollL.getValue());
		// mise à jour de pNh
		((JasRectangle)object).setHeight(scrollH.getValue());
	    }
	else if(object instanceof Oval )
	    {
		// mise à jour de pNw
		((Oval)object).setWidth(scrollL.getValue());
		// mise à jour de pNh
		((Oval)object).setHeight(scrollH.getValue());
	    }


	if(object instanceof Oval )
	    {

		//mise à jour de pNmr
		double nmr=Double.parseDouble(nmrField.getText());
		double nw=(double) ((((Oval)object).getWidth())/2);
		double nh= (double)((((Oval)object).getHeight())/2);;
		
		if(nw < nh)
		    {
			if(nw < nmr) ((Oval)object).setMr(nw);
			else ((Oval)object).setMr(nmr);
		    }
		else
		    {
			if(nh < nmr) ((Oval)object).setMr(nh);
			else ((Oval)object).setMr(nmr);
		    }
	    }
	
	if(wbFilled.isSelected())
	    {
		debug("[Mise à jour de fillgray] >"+ object.getpfillgray() + " --> "+ wbFilledValue.getText() );
		object.setpfillgray(Double.parseDouble(wbFilledValue.getText()));
		debug("[Mise à jour de fillcolor] >"+ object.getpfillcolor() + " --> null" );
		object.setpfillcolor(null);
			
			
		debug(">>> Mise à jour de Nfill : "+ object.getpNfill() +" --> true");
		object.setpNfill(true);
	    }
	else if(colorFilled.isSelected())
	    {
		debug("[Mise à jour de fillcolor] >"+ object.getpfillcolor()+ " --> " + colorFilledCombo.getSelected());
		object.setpfillcolor(colorFilledCombo.getSelected());
			
		debug(">>> Mise à jour de Nfill : "+ object.getpNfill() +" --> true");
		object.setpNfill(true);
			
	    }

    }
    


    /** Update the X propertie for the current  Node 
     * @param  x the new value 
     */
    public void updateNodeX(double x)    {	
	double unit = object.getGgp().unitlength;
 	double offX = sd.getRelativeCoordsOriginX()*Configuration.tailleGrille*unit;
	if(scrollX != null)
	    scrollX.setValue((x * unitLength)-offX) ;
    }
    
    /** Update the Y propertie for the current  Node   
     * @param y the new value
     */
    public void updateNodeY(double y)   {	
	double unit = object.getGgp().unitlength;
	double offY = - sd.getRelativeCoordsOriginY()*Configuration.tailleGrille*unit;
	if(scrollY != null)
	    scrollY.setValue((y * unitLength)-offY);    
    }
    
    /** Update the nw (Node width) propertie for the current Node 
    * @param nw the new value 
    */
    public void updateNodeW(double nw)    { 
	if(scrollL != null)
	    scrollL.setValue(nw * unitLength);    
    }
    
    /** Update the nh (Node heigth) propertie for the current Node 
     * @param nh the new value
     */
    public void updateNodeH(double nh) {
	if(scrollH != null)
	    scrollH.setValue(nh * unitLength );    
    }
    


    /** Update the Diameter (for Circle object) propertie
     * @param diam the new value
     */
    public void updateCircleDiameter(double diam) {
	if(scrollDiameter != null)
	    scrollDiameter.setValue(diam);    
    }



    /** Update the nmr propertie for  the current Node 
     * @param nmr the new value
     */
    public void updateNodeNmr(double nmr)   { 
	if(nmrField != null)  {
	double num = (double)Math.round(nmr * 100)/100;
	nmrField.setText(Double.toString(num)); 

	double tmp;
	if(scrollH.getValue() < scrollL.getValue())
	    tmp = scrollH.getValue()/2;
	else 
	    tmp = scrollL.getValue()/2;
	
	
	double pourcent = (num * 100.0 )/tmp;
	circleLabel.setText("("+new Integer((int)pourcent)+"%)");
	circleSlider.setValue((int)pourcent);

	}
    }


    

   public void actionPerformed(ActionEvent e)
     {
	 Double tmp;
	 double tmp2 = 0;
	 double tmp3 = 0;

	 if (e.getActionCommand().equals("plusH"))
	     tmp2 = scrollH.getPas();
	 else if (e.getActionCommand().equals("minusH"))
	     {
		 tmp2 = scrollH.getPas();
		 tmp2 = -tmp2;
	     }	 
	 else if (e.getActionCommand().equals("plusL"))
	     tmp3 = scrollL.getPas();
	 else if (e.getActionCommand().equals("minusL"))
	     {
		 tmp3 = scrollL.getPas();
		 tmp3 = -tmp3;
	     }


	 if(scrollH.getValue()+tmp2 < scrollL.getValue()+tmp3)
	     tmp = new Double((scrollH.getValue()+tmp2)/2);
	 else 
	     tmp = new Double((scrollL.getValue()+tmp3)/2);
		    
	 Double pourcent = new Double(circleSlider.getValue());
		    		    
	 Double d1;
	 if(pourcent.doubleValue()==0) d1=new Double(0);
	 else d1= new Double ((pourcent.doubleValue() * tmp.doubleValue() ) / 100 );

	 double decal = Math.pow(10,2);
	 Double valueNmr =new Double(((Math.round(d1.doubleValue()*decal))/decal));

	 nmrField.setText(new String("").valueOf(valueNmr));	 

     }

}
