package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import jastex.*;
import jastex.old.obj.JasObject;
import jastex.old.obj.ANode;
import jastex.old.obj.RMark;
import jastex.old.obj.Node;
import jastex.JasDash;


import jastex.old.gui.MainWindow;
import jastex.old.gui.JasColorComboBox;
import jastex.gui.JasScrollBox;
import jastex.old.gui.SurfaceDessin;
import jastex.gui.JasComboBox;

public class OJasRMarkTab extends OJasTab implements ActionListener {

    public JasScrollBox  prdist;
    
    /** the gastex 'linewidth' propertie */
    public JasScrollBox lineWidth;
    /** the gastex 'linegray' propertie */
    public JLabel linegray ;
    /** selected if the line is in grayscale */
    public JRadioButton wbline ;
    public JSlider wbLevel ;
    /** selected if the line is in color */
    public JRadioButton colorline;
    /** the gastex 'colorline' propertie */
    public JasColorComboBox colorlist;
    /** the gastex 'dash' propertie */
    public JasComboBox linelist;
    
    public JComboBox rMarksCombo;
    public JButton delRmarkBtn;

    public SurfaceDessin sd;

    public int j;    

    public float[] dash0 = null;
    public float[] dash1 = {2,2,2,3};
    public float[] dash2 = {5,3};
    public float[] dash3 = {9,3};
    public float[] dash4 = {13,3,5,3};
    

    public String[] lineStrings = { "dash_0","dash_1","dash_2","dash_3","dash_4" };
    public JasDash[] dash = { 	new JasDash(dash0,0),
			new JasDash(dash1,0),
			new JasDash(dash2,0),
			new JasDash(dash3,0),
			new JasDash(dash4,0)
    };




    public OJasRMarkTab(String title, JasObject obj, SurfaceDessin sd)
    {
	super(title,obj);
	this.sd = sd;

	ANode a  = ((ANode)obj);
	Vector v = a.getRmarks();
	if(v.size() > 0)
	    createRMarkTabComponents(obj);
	else 
	    {
		JLabel label = new JLabel(Languages.tb_rmarkTab[5]);
		insertPropertie(label);
	    }
		
    }



    public OJasRMarkTab(String title, Vector objects)
    {
	super(title,objects);

	
	prdist = new JasScrollBox(0.1,0.01);
	lineWidth = new JasScrollBox(0.1,0.01);
	wbline = new JRadioButton(Languages.tb_rmarkTab[1]);
	linegray = new JLabel();

	wbLevel = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbLevel.setMajorTickSpacing(5);
	wbLevel.setMinorTickSpacing(1);
	wbLevel.setPaintTicks(true) ;
		
	wbLevel.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    linegray.setText(java.lang.Double.toString((wbLevel.getValue())/10.0));
		}
	    });

	
	colorline = new JRadioButton(Languages.tb_rmarkTab[2]);
	colorlist = new JasColorComboBox(colorStrings,colorCaption);

	wbline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    colorline.setSelected(false);
		    colorlist.setEnabled(false);
		    wbLevel.setEnabled(true);
		    if(linegray.getText().length()==0)
			{
			    linegray.setText("1.0");
			}
		}
	    });
	
	colorline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    wbline.setSelected(false);
		    wbLevel.setEnabled(false);
		    colorlist.setEnabled(true);
		}
	    });

		
	linelist = new JasComboBox(lineStrings,dash);
	insertPropertie(Languages.tb_rmarkTab[0],prdist);
	insertPropertie(Languages.tb_rmarkTab[3],lineWidth);
	insertPropertie(wbline);
	insertPropertie(wbLevel,linegray);
	insertPropertie(colorline);
	insertPropertie(colorlist);
	insertPropertie(Languages.tb_rmarkTab[4]);
	insertPropertie(linelist);
	
    }






  public void saveGgp(GastexGlobalProperties ggp)
    {
	ggp.prdist = prdist.getValue();
    }







    public void updateRMarkTab(RMark object)
    {
	prdist.setValue(object.getprdistTB());
	lineWidth.setValue(object.getplinewidthTB());
	

	if( object.getplinecolor() != null)
	    {
		colorline.setSelected(true);
		colorlist.setEnabled(true);
		wbline.setSelected(false);
		wbLevel.setEnabled(false);
		colorlist.setSelectedItem(object.getplinecolor());
	    }
	
	else if(object.getplinecolor() == null)
	    {
		wbline.setSelected(true);
		wbLevel.setEnabled(true);
		colorline.setSelected(false);
		colorlist.setEnabled(false);
		linegray.setText(Double.toString(object.getplinegray()));
		wbLevel.setValue((int) (object.getplinegray() * 10));
	    }
    }

    
    private void createRMarkTabComponents(JasObject obj)
    {
	ANode a  = ((ANode)obj);
	Vector v = a.getRmarks();
	
	RMark object = (RMark)v.elementAt(0);

	boolean isAppli = MainWindow.isAppli;
	ImageIcon delIcon;
	if(isAppli)
	     delIcon = new ImageIcon("images/delete.gif");

	else   {
	    URL location; 
	    location = OJasRMarkTab.class.getResource("images/delete.gif");
	    delIcon = new ImageIcon(location);
	}
	
	Vector rMarks = new Vector(a.getRmarks().size());
	for(int i = 0 ; i< a.getRmarks().size(); i++)
	    {
		j = i+1;
		rMarks.addElement("RMark n°"+j);
	    }
	rMarksCombo = new JComboBox(rMarks);
	rMarksCombo.setActionCommand("rmark");
	rMarksCombo.addActionListener(this);
	
	delRmarkBtn = new JButton(delIcon);
	delRmarkBtn.setPreferredSize(new Dimension(24,24));
	delRmarkBtn.setActionCommand("del_rmark");
	delRmarkBtn.addActionListener(this);

	prdist = new JasScrollBox(object.getprdistTB(),0.01);
	lineWidth = new JasScrollBox(object.getplinewidthTB(),0.01);
	wbline = new JRadioButton(Languages.tb_rmarkTab[1]);
	linegray = new JLabel();

	wbLevel = new JSlider(JSlider.HORIZONTAL,0,10,10);
	wbLevel.setMajorTickSpacing(5);
	wbLevel.setMinorTickSpacing(1);
	wbLevel.setPaintTicks(true) ;
		
	wbLevel.addChangeListener(new ChangeListener(){
		public void stateChanged(ChangeEvent e)
		{
		    linegray.setText(java.lang.Double.toString((wbLevel.getValue())/10.0));
		}
	    });

	
	colorline = new JRadioButton(Languages.tb_rmarkTab[2]);
	colorlist = new JasColorComboBox(colorStrings,colorCaption);

	wbline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    colorline.setSelected(false);
		    colorlist.setEnabled(false);
		    wbLevel.setEnabled(true);
		    if(linegray.getText().length()==0)
			{
			    linegray.setText("1.0");
			}
		}
	    });
	
	colorline.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    wbline.setSelected(false);
		    wbLevel.setEnabled(false);
		    colorlist.setEnabled(true);
		}
	    });


		if(object.getplinecolor() != null)
		    {
			colorline.setSelected(true);
			colorlist.setEnabled(true);
			colorlist.setSelectedItem(object.getplinecolor());
			wbLevel.setEnabled(false);
			wbline.setSelected(false);
		    }
		
		else if(object.getplinecolor() == null) 
		    {
			wbline.setSelected(true);
			wbLevel.setEnabled(true);
			colorlist.setEnabled(false);
			colorline.setSelected(false);
			linegray.setText(Double.toString(object.getplinegray()));
			wbLevel.setValue((int) (object.getplinegray() * 10));
		    }
		else
		    {
			wbline.setSelected(false);
			colorline.setSelected(false);
			colorlist.setEnabled(false);
			wbLevel.setEnabled(false);
		    }
		
		
	linelist = new JasComboBox(lineStrings,dash);


	JPanel panel = new JPanel();
	panel.add(rMarksCombo);
	panel.add(delRmarkBtn);
	insertPropertie(panel);
	insertPropertie(Languages.tb_rmarkTab[0],prdist);
	insertPropertie(Languages.tb_rmarkTab[3],lineWidth);
	insertPropertie(wbline);
	insertPropertie(wbLevel,linegray);
	insertPropertie(colorline);
	insertPropertie(colorlist);
	insertPropertie(Languages.tb_rmarkTab[4]);
	insertPropertie(linelist);
    }


    public void updateRMarkList(JasObject object)
    {
 	this.object = object;
	rMarksCombo.removeActionListener(this);
	if(((Node)object).getRmarks().size()> 0)
	    {
		prdist.setEnabled(true);
		lineWidth.setEnabled(true);
		rMarksCombo.setEnabled(true);
		delRmarkBtn.setEnabled(true);
		prdist.setEnabled(true);
		lineWidth.setEnabled(true);
		wbline.setEnabled(true);
		wbLevel.setEnabled(true);
		colorline.setEnabled(true);
		colorlist.setEnabled(true);
		linelist.setEnabled(true);

		if( rMarksCombo.getItemCount() != 0) rMarksCombo.removeAllItems();
		for (int i=0; i< ((Node)object).getRmarks().size() ; i++)
		    {
			j = i+1;
			RMark rmark = (RMark) ((Node)object).getRmarks().elementAt(i);
			rMarksCombo.addItem("RMark n°"+j);
		    }
		rMarksCombo.addActionListener(this);    
	rMarksCombo.setSelectedIndex(0);
	    }
	else
	    {
		if( rMarksCombo.getItemCount() != 0) rMarksCombo.removeAllItems();
		prdist.setEnabled(false);
		lineWidth.setEnabled(false);
		rMarksCombo.setEnabled(false);
		delRmarkBtn.setEnabled(false);
		prdist.setEnabled(false);
		lineWidth.setEnabled(false);
		wbline.setEnabled(false);
		wbLevel.setEnabled(false);
		colorline.setEnabled(false);
		colorlist.setEnabled(false);
		linelist.setEnabled(false);
		
	    }

    }


    public void cleanRMarkTab()
    {
	colorline.setSelected(false);
	colorlist.setEnabled(false);
	wbline.setSelected(true);
	wbLevel.setEnabled(true);
    }
	


    public void updateContent(JasObject object)
    {
    
    }


    public void writeRMarksProperties(JasObject obj)
    {
	ANode a  = ((ANode)obj);
	Vector v = a.getRmarks();
	debug("Mise à jour des RMarks");
	if(v.size() > 0)
	    {
		if( rMarksCombo.getSelectedIndex() <= v.size())
		    {
			RMark object = (RMark)v.elementAt(rMarksCombo.getSelectedIndex());
			debug("[Mise à jour de rdist] >"+ object.getprdistTB() +" --> " + prdist.getValue());
			object.setprdistTB(prdist.getValue());
		
			debug("[Mise à jour de linewidth] >"+ object.getplinewidthTB() +" --> " + lineWidth.getValue());
			object.setplinewidthTB(lineWidth.getValue());
			if(wbline.isSelected())
			    {
				debug("[Mise à jour de linegray] >"+ object.getplinegray() + " --> " + linegray.getText());
				object.setplinegray(Double.parseDouble(linegray.getText()));
				debug("[Mise à jour de linecolor] >"+ object.getplinecolor() + " --> null" );
				object.setplinecolor(null);
			    }
			else if(colorline.isSelected())
			    {
				debug("[Mise à jour de linecolor] >"+ object.getplinecolor() + " --> " + colorlist.getSelected());
				object.setplinecolor(colorlist.getSelected());
			    }
			
			debug("[Mise à jour des dash]");
			JasDash tmp = linelist.getSelectedDash();
			object.setpdash_length(tmp.getDashLength());
			object.setpdash_empty(tmp.getDashEmpty());

		    }
		
	    }
	
	
    }


    

    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if(cmd.equals("rmark"))
	    {
		JComboBox combo = (JComboBox)e.getSource();
		if(combo.getSelectedIndex() < ((Node)object).getRmarks().size())
		    updateRMarkTab((RMark) ((Node)object).getRmarks().elementAt(combo.getSelectedIndex()));
		else
		    cleanRMarkTab();
		
	    }
	else if(cmd.equals("del_rmark"))
	    {
		if(rMarksCombo.getSelectedIndex() <= ((Node)object).getRmarks().size()){
		    sd.rmvDefinitivelyObject((RMark) ((Node)object).getRmarks().elementAt(rMarksCombo.getSelectedIndex()));
		    ((Node)object).delRMark((RMark) ((Node)object).getRmarks().elementAt(rMarksCombo.getSelectedIndex()));
		    updateRMarkList(object);
		    sd.fromToolBoxRefresh(object);
		}
	    }
    }
    






}
