package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import jastex.old.obj.JasObject;

public class OJasTab extends Component {
    public String title;
    public boolean debug = false;
    
    public JPanel topPanel;
    protected GridBagLayout layout;
    protected GridBagConstraints c;
    protected int numElements;
    public JasObject object;
    public Vector objects;

    /* filename*/
    public String[] colorStrings = { "color_black", "color_blue", "color_brown", "color_cyan", 
			      "color_gray", "color_green", "color_magenta", "color_red", 
			      "color_yellow", "color_white", "color_blank" };
    
    /*caption in the JasComboBox */
    public String[] colorCaption = { "Black", "Blue", "Brown", "Cyan", 
			      "Gray", "Green", "Magenta", "Red",
			      "Yellow", "White", "Personnalisée" };

    
    public double unitLength;



    /** Constructor : Instanciate a new Tab
     * @param title the tab caption
     */
    public OJasTab(String title)
    {
	super();
	numElements = 0;

	topPanel = new JPanel();
	layout = new GridBagLayout();
	c = new GridBagConstraints();
	topPanel.setLayout(layout);
	this.title = title;
	c.anchor = GridBagConstraints.WEST;
    }
    


    /** Constructor : Instanciate a new Tab
     * @param title the tab caption
     * @param object the JasObject filling the JasTab field
     */
    public OJasTab(String title, JasObject object)
    {
	super();
	this.object = object ;
	unitLength = object.getGgp().getUnitLength();

	numElements = 0;

	topPanel = new JPanel();
	layout = new GridBagLayout();
	c = new GridBagConstraints();
	topPanel.setLayout(layout);
	this.title = title;
	c.anchor = GridBagConstraints.WEST;
    }
    
    
    /** Constructor : Instanciate a new Tab
     * @param title the tab caption
     * @param objects Vector objects for GGP Tab
     */
    public OJasTab(String title, Vector objects)
    {
	super();
	this.objects = objects ;
	numElements = 0;
	topPanel = new JPanel();
	layout = new GridBagLayout();
	c = new GridBagConstraints();
	topPanel.setLayout(layout);
	this.title = title;
	c.anchor = GridBagConstraints.WEST;
    }



    /** return the tab title */
    public String getTabTitle()    {	return title;    }


    public void  setTabTitle(String title) { this.title = title ;}

    /** return the number of composant in the tab  */
    private int getNumElement()    {	return numElements;    }

    /** increment tab's element number  */
    public void incNumElement()    {	numElements++;    }    
    

    
    /** Add a new couple (caption, component) */
    public void insertPropertie(String libelle, Component champs)
    {
	JLabel label = new JLabel(libelle);
	c.gridx=0;
	c.gridy=getNumElement();
	layout.setConstraints(label,c);
	topPanel.add(label);
	c.gridx=1;
	c.gridy=getNumElement();
	c.insets = new Insets(1,0,1,1);
	layout.setConstraints(champs,c);
	topPanel.add(champs);
	incNumElement();
    }


    /** add a new caption in the tab */
    public void insertPropertie(String libelle)
    {
	JLabel label = new JLabel(libelle);
	
	c.gridx=0;
	c.gridy=getNumElement();
	layout.setConstraints(label,c);
	topPanel.add(label);
		
	incNumElement();
    }


    /** add a new component in the tab */
    public void insertPropertie(Component champs)
    {
	c.gridx=0;
	c.gridy=getNumElement();
	c.insets = new Insets(1,0,1,1);
	layout.setConstraints(champs,c);
	topPanel.add(champs);
	
	incNumElement();
    }
    

    
    /** add a couple of caption to the tab */
   public void insertPropertie(Component champs1, Component champs2)
    {
	
	c.gridx=0;
	c.gridy=getNumElement();
	layout.setConstraints(champs1,c);
	topPanel.add(champs1);
	
	c.gridx=1;
	c.gridy=getNumElement();
	c.insets = new Insets(1,0,1,1);
	layout.setConstraints(champs2,c);
	topPanel.add(champs2);
	
	incNumElement();
    }



    /** return the topPanel of the tab */
    public JPanel getPanel()
    {
	return topPanel;
    }




    protected void debug(String msg)
    {
	if(debug)
	    System.out.println(msg);
	
    }

   protected void debug(int i)
    {
	if(debug)
	    System.out.println(i);
    }

    
}
