package jastex.old.obj;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;
import jastex.old.gui.JasObjectToolBox;


public abstract class AEdge extends JasObject {
    /** Properties */

    /** ArrowHead */

    /** number of arrowhead(s) at the end of edges */
    public int pAHnb;
    /** distance between two arrowheads */
    public double pAHdist;
    /** angle between the edge and the arrowhead side */
    public double pAHangle;
    /**  Length of the arrowhead side */
    public double pAHLength;
    /** length defining the shape of the arrowhead */
    public double pAHlength;
    /** Starting point x offset */
    public double psxo;
    /** Starting point y offset */
    public double psyo;

    /** Ending point x offset */
    public double pexo;
    /** Ending point y offset */
    public double peyo;
   
    /** the starting node of the edge */
    public ANode startingpoint;
    /** the ending node of the edge
     * null for an imark and equals to starting point for a loop*/
    public ANode endingpoint;   
                         
    /** the label of the edge */
    public EdgeLabel label;

    /** the position of the label */
    public Point2D curvePosLabel;
    public Point2D curvePosLabel2;

    /** set if a label has been recently added */
    public boolean newlabeladded=false;
    public boolean marked;

    /** Simple constructor, maybe useless
     * @param sn the starting node
     * @param en the ending node
     * @see ANode
     */
    public AEdge(ANode sn, ANode en) {
	super();
	startingpoint = sn;
	endingpoint = en;
    }

    /** Simple constructor, maybe useless
     * @param _ggp the GastexGlobalProperties used to initialise the fields
     * @see GastexGlobalProperties
     */
 //    AEdge(GastexGlobalProperties _ggp) {
// 	super();
// 	setGgpValues(_ggp);
//     }
    
    
   /** Simple constructor, maybe useless
     * @param sn the starting node
     * @param en the ending node
     * @param _ggp the GastexGlobalProperties used to initialise the fields
     * @see GastexGlobalProperties
     * @see ANode
     */
    public AEdge(GastexGlobalProperties _ggp, ANode sn, ANode en) {
	this(sn,en);
	setGgpValues(_ggp);

    }

    /** Set the internal value to the one of the GastexGlobalProperties
     * @param _ggp the GastexGlobaProperties used to initialize values
     * @see GastexGlobalProperties
     */ 
    public void setGgpValues(GastexGlobalProperties _ggp){
	super.setGgpValues(_ggp);
	pAHnb = _ggp.pAHnb;
	pAHdist = _ggp.pAHdist;
	pAHangle = _ggp.pAHangle;
	pAHLength = _ggp.pAHLength;
	pAHlength = _ggp.pAHlength;
 	psxo = _ggp.psxo;
	psyo = _ggp.psyo;
	pexo = _ggp.pexo;
	peyo = _ggp.peyo;
    }

    /** Return the Gastex Code associated with the current fields values
     * @return a String containing the properties modified compare to 
     * the current GastexGlobalProperties, beginning with a comma or 
     * the empty string ("")
     */
   public String getLatexCodeProperties() {
	String lProp = super.getLatexCodeProperties(false);
	if (label != null) {
	    lProp += label.getLatexCodeProperties(false);
	}
	if (pAHnb != globalProp.pAHnb) {
	    lProp += ",AHnb="+(int)pAHnb;
	}
	if (pAHdist != globalProp.pAHdist) {
	    lProp += ",AHdist="+roundDouble(getpAHdist());
	}
	if (pAHangle != globalProp.pAHangle) {
	    lProp += ",AHangle="+roundDouble(getpAHangle());
	}
	
	if (pAHLength != globalProp.pAHLength) {
	    lProp += ",AHLength="+roundDouble(getpAHLength());
	}
	if (pAHlength != globalProp.pAHlength) {
	    lProp += ",AHlength="+roundDouble(getpAHlength());
	}
	if (psxo != globalProp.psxo) {
	    lProp += ",sxo="+roundDouble(getpsxo());
	}
	if (psyo != globalProp.psyo) {
	    lProp += ",syo="+roundDouble(getpsyo());
	}
	if (pexo != globalProp.pexo) {
	    lProp += ",exo="+roundDouble(getpexo());
	}
	if (peyo != globalProp.peyo) {
	    lProp += ",eyo="+roundDouble(getpeyo());
	}
	
	return lProp;
    }

    public int getpAHnb() { return pAHnb; }
    public void setpAHnb(int pAHnb) { this.pAHnb = pAHnb;}
    
    public double getpAHdist() {
	return globalProp.internal2UnitLength(pAHdist); 
    }
    public void setpAHdist(double pAHdist) {
	this.pAHdist = globalProp.unitLength2Internal(pAHdist);
    }

    public double getpAHdistTB() {
	return globalProp.internal2UnitLength(pAHdist) *
	    globalProp.unitlength; 
    }
    public void setpAHdistTB(double pAHdist) {
	this.pAHdist = globalProp.unitLength2Internal(pAHdist) /
	    globalProp.unitlength;
    }
    

    public double getpAHangle() {
	return Math.toDegrees(pAHangle);
    }
    public void setpAHangle(double pAHangle) {
	this.pAHangle = Math.toRadians(pAHangle);
    }

    public double getpAHLength() {
	return globalProp.internal2UnitLength(pAHLength);
    }
    public void setpAHLength(double pAHLength) {
	this.pAHLength = globalProp.unitLength2Internal(pAHLength);
    }

    public double getpAHlength() {
	return globalProp.internal2UnitLength(pAHlength);
    }
    public void setpAHlength(double pAHlength) {
	this.pAHlength = globalProp.unitLength2Internal(pAHlength);
    }

    public double getpsxo() {
	return globalProp.internal2UnitLength(psxo);
    }
    public double getpsyo() {
	return globalProp.internal2UnitLength(psyo);
    }
    public double getpexo() {
	return globalProp.internal2UnitLength(pexo);
    }
    public double getpeyo() {
	return globalProp.internal2UnitLength(peyo);
    }
    public void setpsxo(double _psxo) {
	psxo = globalProp.unitLength2Internal(_psxo);
    }
    public void setpsyo(double _psyo) {
	psyo = globalProp.unitLength2Internal(_psyo);
    }
    public void setpexo(double _pexo) {
	pexo = globalProp.unitLength2Internal(_pexo);
    }
    public void setpeyo(double _peyo) {
	peyo = globalProp.unitLength2Internal(_peyo);
    }
    public double getInternalpsxo() {
	return psxo;
    }
    public double getInternalpsyo() {
	return psyo;
    }
    public double getInternalpexo() {
	return pexo;
    }
    public double getInternalpeyo() {
	return peyo;
    }
    public ANode getStartingNode() { return startingpoint; }
    public void setStartingNode(ANode startingpoint) {
	this.startingpoint = startingpoint;
    }

    public ANode getEndingNode() { return endingpoint; }
    public void setEndingNode(ANode endingpoint) {
	this.endingpoint = endingpoint;
    }

    /** add a label
     * @param l the label
     */
     public void addLabel(String l) {
	label = new EdgeLabel(globalProp,this,l);
	newlabeladded=true;
     }

    /** delete a label
     * @param jl a specified NodeLabel to remove
     */
    public void removeLabel() {
	label = null;
    }
    /** @return the label */
    public EdgeLabel getLabel() {
	return label;
    }
    /** set the label
     * @param l the EdgeLabel which will become the edge EdgeLabel
     */
    public void setLabel(EdgeLabel l) {
	if (label==null) newlabeladded=true;
	label =l;
    }

    public void updateLabelManager(Vector vmanager){
	if (label==null) return;
	vmanager.add(label);
	newlabeladded=false;
    }
 
    /** @return the Position of the label */
    public Point2D getcurvePosLabel(){
	return curvePosLabel;
    }
    public Point2D getcurvePosLabel2(){
	return curvePosLabel2;
    }


    /** set the Position of the label
     * @param percent the position in percent of the label as in Gastex
     */
    public abstract void setcurvePosLabel(double percent);
    public abstract void setcurvePosLabelInternal(double t,double dist);
    /* @return true if the label must be translated */
    public abstract boolean getCurveLabelSide(); 


    /** Callback to update the ToolBox when the object move
     *  Called by SurfaceDessin, disabled for edges
     *  @param tooBox the ToolBox to Warn
     *  @param manager the ObjectManager
     */
    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager){}

    /** Create a new instance of the same object */
    public Object clone() {
	AEdge e = null;
	e = (AEdge) this.clone(startingpoint, endingpoint);
	return e;
    }

    /** Create a new instance of the same object
     * @param sn the starting node assignated to the edge
     * @param en the ending node assignated to the edge
     */
    public Object clone(ANode sn, ANode en) {
	AEdge e = null;
	e = (AEdge) super.clone();
	if (e == null) {
	    return null;
	}
	e.setStartingNode(sn);
	e.setEndingNode(en);
	if (sn != null) {
	    sn.addEdge(e);
	}
	if (en != null) {
	    en.addEdge(e);
	}

	if (label != null) {
	    e.setLabel((EdgeLabel)label.clone(e));
	}	    
	return e;
    }

    public abstract Selection getObjectSelection(Rectangle slct);
    public Point2D getTangante(double t2){return null;}

    public void setMarked(boolean b){marked=b;}
    public boolean getMarked(){return marked;}
}
