package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;

import jastex.*;
import jastex.old.gui.MainWindow;
import jastex.old.gui.JasObjectToolBox;


public class EdgeLabel extends JasObject implements INELabel{
    public String label;
    public AEdge  edge;
    /** Label */
    public double pELside;      // label on the left(0) or right(1) side of the edge
    public double pELpos;       // position of the label along the edge
                      //   0 : starting node
                      //   50 : middle of the edge
                      //   100 : ending node

    public double pELdist;   // distance in unitlength between the label and the edge
    /** The distance is between the center of the label and the edge */
    public boolean pELdistC;

    public Graphics gContext=null;

    // added by Teo 
    public TextLayout layout;
    public Point2D layoutOrigin;
    public int insertionIndex;
    public int oldindex;
    public boolean updattinfFromTB=true;

    public Rectangle2D virtualAreaText;
    public String msgText="Latex Code";
    public boolean isEditable=true;
    public double virtualW=-1;
    public double virtualH=-1;
    public boolean isVirtualActive=false;
    // --
    public LatexHandler lh;
    public boolean enableLH;
    //    double tpos; // t position



    public EdgeLabel(AEdge e, String l) {
	label = l;
	edge = e;
	cursor=new Cursor(Cursor.TEXT_CURSOR);
	insertionIndex=-1;
	if (!MainWindow.isAppli) {
	    enableLH = false;
	} else {
	    enableLH = Configuration.enableLH;
	}
	if (enableLH) {
	    lh = new LatexHandler(l);
	}
    }

    public EdgeLabel(GastexGlobalProperties _ggp, AEdge e, String l) {
	this(e,l);
	setGgpValues(_ggp);
	if (enableLH) {
	    virtualW = lh.getWidth(_ggp.getUnitLength(),
				   _ggp.getUnitName());
	    virtualW = globalProp.unitLength2Internal(virtualW);
	    virtualH = lh.getHeight(_ggp.getUnitLength(),
				    _ggp.getUnitName());
	    virtualH = globalProp.unitLength2Internal(virtualH);
	}
    }
    
    public EdgeLabel(GastexGlobalProperties _ggp, AEdge e, String l, double side, double pos, double dist) {
	this(_ggp,e,l);
	pELside = side;
	pELpos = pos;
	pELdist = globalProp.unitLength2Internal(dist);
    }

    /** Set the internal value to the one of the GastexGlobalProperties
     * @param _ggp the GastexGlobaProperties used to initialize values
     * @see GastexGlobalProperties
     */ 
    public void setGgpValues(GastexGlobalProperties _ggp){
	super.setGgpValues(_ggp);
	pELside = _ggp.pELside;
	pELpos = _ggp.pELpos;
	pELdist = _ggp.pELdist;
// 	pELdistC = ggp.pELdistC;
	pELdistC = true;
    }
    public Rectangle2D getStringBounds2D(Graphics g) {
	if (g==null) return null;
	double coeff;
	coeff = Configuration.scale;
	Font ft = g.getFont();
	Font cft = new Font(ft.getFontName(), ft.getStyle(), (int)(12*coeff));
	g.setFont(cft);
	Rectangle2D r = (g.getFontMetrics().getStringBounds(label, g));
	r=adjustVirtual(r);
	return r;
    }

    public void draw(Graphics g) {
	TextLayout virtualT;
	Point2D posLabel;
	Graphics2D g2=(Graphics2D) g;
	double pELdist2;
	pELdist2 = ((pELside ==0)?-pELdist:pELdist);
	edge.setcurvePosLabelInternal(pELpos,pELdist2);
	//** setting the gContext
	if (gContext==null) setContext(g);
	int posX, posY;
	double coeff;
	coeff = Configuration.scale;
	Font ft = g.getFont();
	Font cft = new Font(ft.getFontName(), ft.getStyle(), (int)(12*coeff));
	g.setFont(cft);

	// added by Teo
	FontRenderContext frc = g2.getFontRenderContext();
	if(updattinfFromTB){
	    if(label.equals("")) label=" ";
	    layout = new TextLayout(label, cft, frc);
	    updattinfFromTB=false;
	    isEditable=true;
	}

	// --
	Rectangle2D r = layout.getBounds();
	Rectangle2D rprime;
	rprime=adjustVirtual(r);
	if(isVirtualActive){
	    virtualT = new TextLayout(msgText , cft, frc);
	    r = virtualT.getBounds();
	    
	}
	// --


	g.setColor(Color.black);
	posLabel = edge.getcurvePosLabel();
	//g.drawString(label,(int)posLabel.getX(),(int)posLabel.getY());
// 	boolean isWrongSide = edge.getCurveLabelSide();
// 	if ((pELside == 0 && isWrongSide) || (pELside == 1 && !isWrongSide)) {
// 	    //need to translate the Label
// 	    double x = posLabel.getX();
// 	    if(!isVirtualActive) {
// 		x -= layout.getBounds().getWidth();
// 	    } else {
// 		x -= rprime.getWidth();
// 	    }
// 	    posLabel.setLocation(x, posLabel.getY());
// 	}
	layoutOrigin=new Point2D.Double((int)posLabel.getX(),(int)posLabel.getY());
	if(!isVirtualActive){
	    layout.draw(g2,
			(int)(posLabel.getX()-layout.getBounds().getWidth()/2),
			(int)(posLabel.getY()+layout.getBounds().getHeight()/2) );
	} else {
	    rprime.setRect(posLabel.getX(),
			   posLabel.getY()-rprime.getHeight(),
			   rprime.getWidth(), 
			   rprime.getHeight());
	    g2.setColor(Color.gray);
	    g2.fill(rprime);
	    g2.setColor(Color.yellow);
	    g2.drawString(msgText, (int)posLabel.getX(),(int) posLabel.getY());
	    g2.setColor(Color.black);
	}

	if (insertionIndex!=-1){
	    g2.translate(layoutOrigin.getX()-layout.getBounds().getWidth()/2, 
			 layoutOrigin.getY()+layout.getBounds().getHeight()/2);
	    Shape[] carets = layout.getCaretShapes(insertionIndex);
	    g2.setColor(Color.red);
	    g2.draw(carets[0]);
	    if (carets[1] != null) {
		g2.setColor(Color.black);
		g2.draw(carets[1]);
	    }
	    g2.translate(-layoutOrigin.getX()+layout.getBounds().getWidth()/2,
			 -layoutOrigin.getY()-layout.getBounds().getHeight()/2);
	    oldindex=insertionIndex;
	    insertionIndex=-1;
	}	
    }

   public String getLatexCodeProperties(boolean isStandAlone) {
	String lProp = "";
	if (pELside != globalProp.pELside) {
	    lProp += ",ELside="+(pELside==0?"l":"r");
	}
	if ( pELpos!= globalProp.pELpos) {
	    lProp += ",ELpos="+Math.round(pELpos);
	}
	if ( pELdist!= globalProp.pELdist) {
	    lProp += ",ELdist="+roundDouble(getpELdist());
	}
	if (lProp.equals("")) {
	    return "";
	} else {
	    if (isStandAlone) {
		//cut the first comma
		return ("[" + lProp.substring(1) + "]");
	    } else {
		return (lProp);
	    }
	}
    }

    public Rectangle getBounds() {
	double hDist, vDist;
	Rectangle2D r= getStringBounds2D(gContext);	
	if (r==null) return null;
	Rectangle rbis=new Rectangle((int) r.getX(),
				     (int) r.getY(),
				     (int) r.getWidth(),
				     (int) r.getHeight());
	
	
	//rbis.setLocation((int)layoutOrigin.getX(),(int)layoutOrigin.getY());
	rbis.setLocation((int)(layoutOrigin.getX()-r.getWidth()/2),
			 (int)(layoutOrigin.getY()-r.getHeight()/2));
	return rbis;
    }

    public double getMinDistance(int x,int y) {
	if (getBounds().contains((double) x,(double) y)) return 0;
	else return 1000; 
    }

    public boolean isInsideRectangle(Rectangle r) { 
	Rectangle rr=getBounds();
	boolean reallyIs=r.intersects(rr.getX(),rr.getY(),rr.getWidth(),rr.getHeight());
	return reallyIs;
    }

    public void setpELside(double pELs) {
	pELside = pELs;
    }
    public double getpELside() {
	return pELside;
    }
    public void setpELpos(double pELp) {
	pELpos = pELp;
    }
    public double getpELpos() {
	return pELpos;
    }
    public void setpELdist(double pELd) {
	pELdist = globalProp.unitLength2Internal(pELd);
    }
    public void setpELdistInternal(double pELd) {
	pELdist = pELd;
    }
    public double getpELdistInternal(){ return pELdist; }

    public double getpELdist() {
	return globalProp.internal2UnitLength(pELdist);
    }

    public void setpELdistC(boolean pELdC) {
	pELdistC =  pELdC;
    }

    public boolean getpELdistC(){ return pELdistC;}

    public void setEdge(AEdge e) { edge = e; }
    public AEdge getEdge() { return edge; }

    public void setContext(Graphics g){
	gContext=g;
    }
    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager){
	//System.out.println("Okok");
	tooBox.updateLabel(getLabel());
    }

    public void setPos(int px,int py) {
	deprecated_x=px;
	deprecated_y=py;
    }

    public void setLabel(String l) {
	label = l;
	if (enableLH) {
	    lh = new LatexHandler(l);
	    virtualW = lh.getWidth(globalProp.getUnitLength(),
				   globalProp.getUnitName());
	    virtualW = globalProp.unitLength2Internal(virtualW);
	    virtualH = lh.getHeight(globalProp.getUnitLength(),
				    globalProp.getUnitName());
	    virtualH = globalProp.unitLength2Internal(virtualH);
	}
	updattinfFromTB=true;
    }
    public String getLabel() { return label; }

    public Object clone() {
	EdgeLabel el = null;
	el = (EdgeLabel) this.clone(null);
	el.setLabel(label);
	return el;
    }
    
    public Object clone(AEdge e) {
	EdgeLabel el = null;
	el = (EdgeLabel) super.clone();
	if (el == null)
	    return null;
	el.setEdge(e);
	return el;
    }
  
    public boolean getLHstate() {
	return enableLH;
    }
    public void setLHstate(boolean state) {
	if (MainWindow.isAppli) {
	    enableLH = state;
	    if (enableLH) {
		lh = new LatexHandler(label);
		virtualW = lh.getWidth(globalProp.getUnitLength(),
				       globalProp.getUnitName());
		virtualW = globalProp.unitLength2Internal(virtualW);
		virtualH = lh.getHeight(globalProp.getUnitLength(),
					globalProp.getUnitName());
		virtualH = globalProp.unitLength2Internal(virtualH);
	    }
	} else {
	    enableLH = false;
	}
    }	

    
    public Rectangle2D adjustVirtual(Rectangle2D virtr){
	isVirtualActive=false;
	double virtw,virth;
	if ( enableLH && lh.isDone() && 
	     (virtr.getWidth()>virtualW+100 ||  virtr.getHeight()>virtualH+20)){
	    isVirtualActive=true;
	    isEditable=false;
	    if ( virtr.getWidth()>virtualW) virtw=virtualW;
	    else virtw=virtr.getWidth();
	    if ( virtr.getHeight()>virtualH) virth=virtualH;
	    else virth=virtr.getHeight();
	    return (new Rectangle2D.Double(virtr.getX(), virtr.getY(),
					   virtw, virth));
	}
	return virtr;
    }
    
    public boolean editable() { return isEditable; }

    public TextLayout getActualLayout(){return layout;}
    public int getOldIndex(){ return oldindex; }
    public void setInsertionIndex(int index){
	insertionIndex=index;
    }
    public void suppr(int avalAmout){
	int str1limit=(oldindex==0)?0:oldindex-avalAmout;
	int strl=label.length();
	int str2limit=oldindex+(avalAmout+1)%2;
	if(str2limit>strl) {
	    insertionIndex=str2limit-1;
	    return;
	}

	String debut=label.substring(0,str1limit);
	String fin=label.substring(str2limit);
	label=new String(debut+fin);
	updattinfFromTB=true;
	insertionIndex=str1limit;
    } 

    public void editTextInsert(char c){
    //	setCaretPosition(int position);
	//System.out.println(oldindex);
	String debut="";
	String fin="";
	if (label.equals(" ")) {
	    oldindex=0;
	} else {
	    debut=label.substring(0,oldindex);
	    fin=label.substring(oldindex); 
	}
	oldindex++;
	label=new String(debut+c+fin);
	updattinfFromTB=true;
	insertionIndex=oldindex;
    }


    public Selection getObjectSelection(Rectangle slct){
	slct.grow(10,10);
	return (new SelectEdgeLabel(this));
    }

    public void setLabelPos(Point2D pt){
	Point2D originOnCurve=getEdge().getcurvePosLabel2();
	Point2D vecttang=getEdge().getTangante(getpELpos());
	//System.out.println(getpELpos());
	double carre=Math.sqrt(vecttang.getX()*vecttang.getX()
			       +vecttang.getY()+vecttang.getY());
	if(carre==0) {
	    setpELdistInternal(0);
	    return;
	}

	double vectX=vecttang.getX()/carre;
	double vectY=vecttang.getY()/carre;

	double det=-vectY*vectY-vectX*vectX;
	
	double a=-pt.getX()*vectY+pt.getY()*vectX;
	double b=originOnCurve.getX()*vectX
	    +originOnCurve.getY()*vectY;
	double det1=a*vectY-b*vectX;
	double det2=-b*vectY-a*vectX;
	
	Point2D pp=new Point.Double(det1/det,det2/det);
	setpELdistInternal(pp.distance(originOnCurve));
	
	double vsens=vectX*(pp.getY()-originOnCurve.getY())
	    -vectY*(pp.getX()-originOnCurve.getX());
	//System.out.println(vsens);
	if(vsens<0) setpELside(0);
	else setpELside(1);
	
    }
}
