package jastex.old.obj;

import java.awt.geom.*;
import java.awt.*;
import javax.swing.*;

import jastex.*;
import jastex.parsing.OptionVal;



public class ExtendedCubic extends BezierCubicCurve implements SimpleObjectE {

    public ExtendedCubic(GastexGlobalProperties _ggp, 
		  ANode sn, Point2D pc1,
		  ANode en, Point2D pc2) {
	super(_ggp,sn,pc1,en,pc2);
	psxo = pexo = psyo = peyo = 0;
    }
    
    public ExtendedCubic(GastexGlobalProperties _ggp,OptionVal param[],
		  InvisibleNode sn,
		  double x1, double y1,
		  double x2, double y2,
		  InvisibleNode en) {
	super(_ggp,param,sn,x1,y1,en,x2,y2,"",false);
	psxo = pexo = psyo = peyo = 0;
    }

    public void setPos(int x,int y) {
	startingpoint.setPos(startingpoint.deprecated_oldx+x,startingpoint.deprecated_oldy+y);
	endingpoint.setPos(endingpoint.deprecated_oldx+x,endingpoint.deprecated_oldy+y);
	return;	
    }

    public void moveIt(Point pt) {
	savePos();
	startingpoint.moveIt(pt);
	endingpoint.moveIt(pt);
    }

    public void moveIt(int px,int py){
	startingpoint.moveIt(px,py);
	endingpoint.moveIt(px,py);	
    }

	       
    public void savePos() {
	startingpoint.savePos();
	endingpoint.savePos();
    }
    
    public String getLatexCode(double oriX, double oriY) {
	String bcCode = "";
	bcCode = "\\drawcbezier"+getLatexCodeProperties(true)+
	    "("+roundDouble(startingpoint.deprecated_getULX()-oriX)+","+
	    roundDouble(startingpoint.deprecated_getULY()-oriY)+","+
	    roundDouble(globalProp.internal2UnitLength(pc1.getX())-oriX)+","+
	    roundDouble(globalProp.internal2UnitLength(-pc1.getY())-oriY)+","+
	    roundDouble(globalProp.internal2UnitLength(pc2.getX())-oriX)+","+
	    roundDouble(globalProp.internal2UnitLength(-pc2.getY())-oriY)+","+
	    roundDouble(endingpoint.deprecated_getULX()-oriX)+","+
	    roundDouble(endingpoint.deprecated_getULY()-oriY)+")";
	return bcCode;
    }

    public Selection getObjectSelection(Rectangle slct){
	return (new SelectExtendedCubic(this));
    }
}
