package jastex.old.obj;

import java.awt.geom.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import jastex.*;
import jastex.parsing.OptionVal;



public class ExtendedEdge extends Edge implements SimpleObjectE {

    public ExtendedEdge(GastexGlobalProperties _ggp, 
		  ANode sn, ANode en) {
	super(_ggp,sn,en,0);
	psxo = pexo = psyo = peyo = 0;
    }
    
    public ExtendedEdge(GastexGlobalProperties _ggp,  OptionVal param[],
		 InvisibleNode sn,
		 InvisibleNode en) {
	super(_ggp,param,sn,en,"");
	pcurvedepth = 0;
	psxo = pexo = psyo = peyo = 0;
    }

    public void setPos(int x,int y) {
	// in fact very useful for dragging the object in free mode
	//Point2D pt=new Point2D.Double(x,y);
	//updateAngle(pt);
	
	//double dx=startingpoint.oldx-x;
	//double dy=startingpoint.oldy-y;
	//Point p=new Point(x,y);
	//startingpoint.moveIt((int)dx,(int)dy);
	//endingpoint.moveIt((int)dx,(int)dy);
	startingpoint.setPos(startingpoint.deprecated_oldx+x,startingpoint.deprecated_oldy+y);
	endingpoint.setPos(endingpoint.deprecated_oldx+x,endingpoint.deprecated_oldy+y);
	return;	
    }

    public void moveIt(Point pt) {
	savePos();
	setPos((int)pt.getX(),(int)pt.getY());
     }

    public void moveIt(int px,int py){
	startingpoint.moveIt(px,py);
	endingpoint.moveIt(px,py);	
    }

   public void savePos() {
	startingpoint.savePos();
	endingpoint.savePos();
    }

  /** Fonction which is used to get the Gastex Code
     * associated with the JasObject
     * @param oriX the X coordinate of the origin
     * @param oriY the Y coordinate of the origin
     * @return the associated latex code
     */     
    public String getLatexCode(double oriX, double oriY) {
	String edgeCode = "\\drawline"+getLatexCodeProperties()+"("+
	    roundDouble(startingpoint.deprecated_getULX()-oriX)+","+
	    roundDouble(startingpoint.deprecated_getULY()-oriY)+")("+
	    roundDouble(endingpoint.deprecated_getULX()-oriX)+","+
	    roundDouble(endingpoint.deprecated_getULY()-oriY)+")";
	return edgeCode;
    }


    public Selection getObjectSelection(Rectangle slct){
	return (new SelectExtendedEdge(this));
    }
}
