package jastex.old.obj;

import java.awt.geom.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import jastex.*;
import jastex.parsing.OptionVal;



public class ExtendedQuad extends BezierQuadCurve implements SimpleObjectE{

    public ExtendedQuad(GastexGlobalProperties _ggp, 
		 ANode sn, ANode en, Point2D pc) {
	super(_ggp,sn,en,pc);
	psxo = pexo = psyo = peyo = 0;
    }
    
    public ExtendedQuad(GastexGlobalProperties _ggp, OptionVal param[],
		 InvisibleNode sn,
		 double x1, double y1,
		 InvisibleNode en) {
	super(_ggp,param,sn,en,x1,y1,"",false);
	psxo = pexo = psyo = peyo = 0;
    }
    

    
    public void setPos(int x,int y) {
	startingpoint.setPos(startingpoint.deprecated_oldx+x,startingpoint.deprecated_oldy+y);
	endingpoint.setPos(endingpoint.deprecated_oldx+x,endingpoint.deprecated_oldy+y);
	return;	
    }

    public void moveIt(Point pt) {
	savePos();
	setPos((int)pt.getX(),(int)pt.getY());
     }

    public void moveIt(int px,int py){
	startingpoint.moveIt(px,py);
	endingpoint.moveIt(px,py);	
    }
    public void savePos() {
	startingpoint.savePos();
	endingpoint.savePos();
    }

  /** Fonction which is used to get the Gastex Code
     * associated with the JasObject
     * @param oriX the X coordinate of the origin
     * @param oriY the Y coordinate of the origin
     * @return the associated latex code
     */     
    public String getLatexCode(double oriX, double oriY) {
	String bezierCode = "\\drawqbezier"+getLatexCodeProperties()+"("+
	    roundDouble(startingpoint.deprecated_getULX()-oriX)+","+
	    roundDouble(startingpoint.deprecated_getULY()-oriY)+","+
	    roundDouble(globalProp.internal2UnitLength(pc1.getX())-oriX)+","+
	    roundDouble(globalProp.internal2UnitLength(-pc1.getY())-oriY)+","+
	    roundDouble(endingpoint.deprecated_getULX()-oriX)+","+
	    roundDouble(endingpoint.deprecated_getULY()-oriY)+")";
	return bezierCode;
    }	


    public Selection getObjectSelection(Rectangle slct){
	return (new SelectExtendedQuad(this));
    }    
}
