package jastex.old.obj;

import java.awt.geom.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import jastex.*;
import jastex.parsing.OptionVal;



public class Loop extends BezierCubicCurve {
    /** For Loop */
     public double ploopdiam;    // diameters in unitlength of loops
     public double ploopangle;   // direction in degree of loops
     public boolean ploopCW;  // boolean flag defining whether 
                       //   loops are in clockwise direction or not

    public Loop(ANode n) {
	super(n,n);
	//Little hask to not count it twice
	n.rmvEdge(this);
	currentCurve = new CubicCurve2D.Double();
    }

    public Loop(GastexGlobalProperties _ggp,ANode n) {
	this(n);
	setGgpValues(_ggp);
	adjustCtrlPts();
	currentCurve.setCurve(n.pos2Point2D(), pc1, pc2, n.pos2Point2D());
    }
 
//     Loop(ANode n,
// 	 double diam, double angle, boolean cw) {
// 	this(n);
// 	ploopdiam = globalProp.unitLength2Internal(diam);
// 	ploopangle = Math.toRadians(angle);
// 	ploopCW = cw;
//     }
 
    public Loop(GastexGlobalProperties _ggp,ANode n,
	 double diam, double angle, boolean cw) {
	this(n);
	setGgpValues(_ggp);
	ploopdiam = globalProp.unitLength2Internal(diam);
	ploopangle = Math.toRadians(angle);
	ploopCW = cw;
	adjustCtrlPts();
	currentCurve.setCurve(n.pos2Point2D(), pc1, pc2, n.pos2Point2D());
    }

     // constructeur needed by parser
    public Loop(GastexGlobalProperties _ggp,OptionVal param[],ANode n,String edname){
	this(_ggp,n);
	
	if(param!=null) {
	    // curving option
	    if(!(param[16].optEmpty())){ setploopdiam(param[16].od); }
	    if(!(param[17].optEmpty())){
		ploopangle = Math.toRadians(param[17].od);
	    }
	    if(!(param[18].optEmpty())){ ploopCW = param[18].ob; }
	    // arrow param
	    if(!(param[20].optEmpty())){ setpAHnb(param[20].oi); }
	    if(!(param[21].optEmpty())){ setpAHdist(param[21].od); }
	    if(!(param[22].optEmpty())){ setpAHangle(param[22].od); }
	    if(!(param[23].optEmpty())){ setpAHLength(param[23].od); }
	    if(!(param[24].optEmpty())){ setpAHlength(param[24].od); }
	    // line param
	    if(!(param[28].optEmpty())){ setplinegray(param[28].od); }
	    if(!(param[30].optEmpty())){ setplinecolor(param[30].otxt); }
	    if(!(param[32].optEmpty())){ setplinewidth(param[32].od); }
	    if(!(param[33].optEmpty())){
		// dash option
		setpdash_length(param[33].oflist); 
		setpdash_empty(param[33].of); 
	    }
	    // *xo and *yo options
	    if(!(param[34].optEmpty())){ setpsxo(param[34].od); }
	    if(!(param[35].optEmpty())){ setpsyo(param[35].od); }
	    if(!(param[36].optEmpty())){ setpexo(param[36].od); }
	    if(!(param[37].optEmpty())){ setpeyo(param[37].od); }	    
	}

	// TODO Label
	// edge label
	if(!(edname.equals(""))){
	    // we have to add a label
	    addLabel(edname);
	    // param for label
	    if(param!=null) {
		if(!(param[25].optEmpty())){ getLabel().setpELside(param[25].oi); }
		if(!(param[26].optEmpty())){ getLabel().setpELpos(param[26].od); }
		if(!(param[27].optEmpty())){ getLabel().setpELdist(param[27].od); }
	    }
	}
    }


    /** Set the internal value to the one of the GastexGlobalProperties
     * @param _ggp the GastexGlobaProperties used to initialize values
     * @see GastexGlobalProperties
     */ 

    public void setGgpValues(GastexGlobalProperties _ggp){
	super.setGgpValues(_ggp);
	ploopdiam = _ggp.ploopdiam;
	ploopangle = _ggp.ploopangle;
	ploopCW = _ggp.ploopCW;
    }

    public Point2D getLineIntersection(ANode n, Line2D.Double l) {
	double tolerance = 2;
	Point2D.Double ptExt, ptInt;
	Point2D.Double ptCen, pt1;
	double diffX, diffY;

	ptExt = (Point2D.Double)l.getP2();
	pt1 = ptExt;
	ptInt = (Point2D.Double)l.getP1();
	if (ptExt.equals(ptInt)) {
	    return ptInt;
	}
	if (!n.contains(ptInt)) {
	    ptExt = ptInt;
	    ptInt = pt1;
	    pt1 = ptExt;
	    // 	    ptInt = n.pos2Point2D();
	}
	//extends the line if it is too small
	while(n.contains(ptExt)) {
	    //tranlate the line and make it longer
	    pt1.setLocation(ptExt.getX(), ptExt.getY());
	    ptExt.setLocation(ptExt.getX()+(ptExt.getX()-ptInt.getX()), ptExt.getY()+(ptExt.getY()-ptInt.getY()));
	    //  	    ptInt.setLocation(pt1.getX(), pt1.getY());
	}
	diffX = (ptExt.getX()+ptInt.getX())/2;
	diffY = (ptExt.getY()+ptInt.getY())/2;

	ptCen = new Point2D.Double(diffX,
				   diffY);
	//starting dichotomy
	//ptExt is the last point seen outside
	//ptInt is the last point seen inside
	//ptCen is the center of ptExt and ptInt
	while (ptExt.distance(ptInt) > tolerance) {
	    ptCen = new Point2D.Double(diffX,
				       diffY);
	    if(n.contains(ptCen)) {
		ptInt = ptCen;
	    } else {
		ptExt = ptCen;
	    }
	    diffX = (ptExt.getX()+ptInt.getX())/2;
	    diffY = (ptExt.getY()+ptInt.getY())/2;
	}
	return ptCen;
    }
    public void adjustCtrlPts() {
	Point2D p1, p2, pInter;
	double a,b,c1,c2, nd, cos, sin;
	double xb,yb,xc,yc;
	double p1x,p1y,hyp2;
	double pNh, pNw;
	double angle;
	p1 = startingpoint.pos2Point2D();
	p1x = p1.getX();
	p1y = p1.getY();
	pNh = startingpoint.getActualHeight();
	pNw = startingpoint.getActualWidth();
	angle = -ploopangle;
	//get an external point to get the intersection point
	hyp2 = Math.sqrt(pNw*pNw+pNh*pNh);
	p2 = new Point2D.Double(p1x + hyp2*Math.cos(angle),
				p1y + hyp2*Math.sin(angle));

	pInter = getLineIntersection(startingpoint, new Line2D.Double(p1,p2));

	nd = p1.distance(pInter)*2;
	cos = Math.cos(angle);
	sin = Math.sin(angle);

	a = 2 * (nd + 2 * ploopdiam * Configuration.scale) /3;
	//FIXME: do not calculate it each time
	b = ploopdiam * Math.sqrt(3) *Configuration.scale; 
	
	/* Rotation */
	c1 = p1x + a * cos - b * sin;
	c2 = p1x + a * cos + b * sin;
	if (!ploopCW) {
	    xb = c1;
	    xc = c2;
	} else {
	    xc = c1;
	    xb = c2;
	}

	c1 = p1y + a * sin + b * cos;
	c2 = p1y + a * sin - b * cos;
	if (!ploopCW) {
	    yb = c1;
	    yc = c2;
	} else {
	    yc = c1;
	    yb = c2;
	}
	
	setCtrlPt1(new Point2D.Double(xb,yb));
 	setCtrlPt2(new Point2D.Double(xc,yc));
    }

    public void adjustCurve () {
	adjustCtrlPts();
	super.adjustCurve ();
    }

    public double getploopdiam() {
	return globalProp.internal2UnitLength(ploopdiam);
    }
    public void   setploopdiam(double ploopdiam) {  
	this.ploopdiam = globalProp.unitLength2Internal(ploopdiam);
    }

    public double getploopangle() {
	return Math.toDegrees(ploopangle);
    }
    public void setploopangle(double angle) {
	ploopangle = Math.toRadians(angle);
    }

    public boolean getploopCW() {
	return  ploopCW;
    }
    public void setploopCW(boolean  ploopCW) {
	this.ploopCW = ploopCW;
    }


    public Point2D getDemiPoint(){
	
	Point2D p0, p1, p2, p3;
       	p0 = currentCurve.getP1();
	p1 = currentCurve.getCtrlP1();
	p2 = currentCurve.getCtrlP2();
	p3 = currentCurve.getP2();
	
	// set the two equations x(t),y(t)
	double p0x=p0.getX(); double p0y=p0.getY();
	double p3x=p3.getX(); double p3y=p3.getY();
	double pc1x=p1.getX(); double pc1y=p1.getY();
	double pc2x=p2.getX(); double pc2y=p2.getY();
	// WARNING ax^3+bx^2+cx+d
	// { d,c,b,a }
	double[] eqnx={ p0x, -3*p0x+3*pc1x, 3*p0x-6*pc1x+3*pc2x, -p0x+3*pc1x-3*pc2x+p3x};
	double[] eqny={ p0y, -3*p0y+3*pc1y, 3*p0y-6*pc1y+3*pc2y, -p0y+3*pc1y-3*pc2y+p3y};
	return (new Point2D.Double(getEqnValue(eqnx,0.5),
				   getEqnValue(eqny,0.5)));
    }
    
    public void updateAngle(Point2D pt) {
	//ploopangle
	Point2D center = startingpoint.pos2Point2D();
	//Point2D temp = new Point2D.Double(pt.getX(),center.getY());
	double ltan=center.getY()-pt.getY();
	double ray=pt.getX()-center.getX();
	double newangle=Math.atan(ltan/(ray));
	if (center.getX()>pt.getX())
	    newangle=Math.PI+newangle;
// 	newangle=180*newangle/Math.PI;
	ploopangle=newangle;
    }

   
    public void setPos(int x,int y) {
	// in fact very useful for dragging the object in free mode
	Point2D pt=new Point2D.Double(x,y);
	updateAngle(pt);
	return;
    } 

    public String getLatexCodeProperties() {
	String lProp = super.getLatexCodeProperties(false);
	if (ploopdiam != globalProp.ploopdiam) {
	    lProp += ",loopdiam="+roundDouble(getploopdiam());
	}
	if (ploopangle != globalProp.ploopangle) {
	    lProp += ",loopangle="+roundDouble(getploopangle());
	}
	if (ploopCW != globalProp.ploopCW) {
	    lProp += ",loopCW="+(ploopCW?"y":"n");
	}

	if (lProp.equals("")) {
	    return "";
	} else {
	//cut the first comma
	return ("[" + lProp.substring(1) + "]");
	}
    }

    public String getLatexCode(double oriX, double oriY) {
	String bqCode = "\\drawloop"+getLatexCodeProperties()+"("+startingpoint.getNodeName()+"){"+(label==null?"":label.getLabel())+"}\n";
	return bqCode;
    }

    public Selection getObjectSelection(Rectangle slct){
	return (new SelectLoop(this));
    } 

}





