package jastex.old.obj;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import java.awt.Cursor;

import jastex.*;
import jastex.old.gui.JasObjectToolBox;


public class MiniBox extends JasObject {

    public static int boxdim =5 ;

    public int oldx;

    public int oldy;
    public int sens=0;
    public JasObject depends;

    public int offsetx = 0;

    public int offsety = 0;

    // this force the MiniBox to be drawn elsewhere than
    // its current Position
    public boolean invisibleMode=false;
    public int fakePosX;
    public int fakePosY;

    // default Color
    public Color boxcolor=Color.red;


    public MiniBox() {}
    
    public MiniBox(Cursor c,int xx,int yy) {
	cursor=c;
	deprecated_x=xx;
	deprecated_y=yy;
    }

    public MiniBox(int xx,int yy) {
	deprecated_x=xx;
	deprecated_y=yy;
    }

    public void setSensitive(boolean b){
	// if Minibox is unsensitive , we cannot move it
	sens=b?0:1000;
    }

    public void setoffset(int ox,int oy){
	offsetx=ox;
	offsety=oy;
    }
    
    public void draw(Graphics g) {
	//if ((depends!=null) && (depends instanceof ANode)){
	//    setPos(((ANode) depends).getX(),((ANode) depends).getY());
	//}

	int cx=deprecated_x;
	int cy=deprecated_y;

	if(invisibleMode){
	    //System.out.println("OK");
	    cx=fakePosX;
	    cy=fakePosY;
	}

	g.setColor(Color.white);
	g.fillRect(0+cx-boxdim/2, 0+cy-boxdim/2, boxdim, boxdim);
	g.setColor(boxcolor);
	g.drawRect(0+cx-boxdim/2, 0+cy-boxdim/2, boxdim, boxdim);
    }

    public void setPos(int posx, int posy) {
	deprecated_x=(int) ((posx+offsetx)/Configuration.scale); // SCALE/Configuration.scale
	deprecated_y=(int) ((posy+offsety)/Configuration.scale);//  /Configuration.scale
    }

    public void savePos() {
	oldx=deprecated_x;
	oldy=deprecated_y;
    }

    public double getMinDistance(int gx,int gy) {
	// ex getlongueur
	int demi=boxdim/2;
	Point uple=new Point(deprecated_x-demi,deprecated_y-demi);
	Point uprg=new Point(deprecated_x+demi,deprecated_y-demi);
	Point btle=new Point(deprecated_x-demi,deprecated_y+demi);
	Point btrg=new Point(deprecated_x+demi,deprecated_y+demi);
	Point center=new Point(deprecated_x,deprecated_y);


	if ( center.distance(gx,gy) < demi )
	    return 0+sens;
	if (gx < deprecated_x-demi && gy < deprecated_y-demi) return uple.distance(gx,gy)+sens;
	if (gx < deprecated_x-demi && gy > deprecated_y+demi) return btle.distance(gx,gy)+sens;
	if (gx > deprecated_x+demi && gy < deprecated_y-demi) return uprg.distance(gx,gy)+sens;
	if (gx > deprecated_x+demi && gy > deprecated_y+demi) return btrg.distance(gx,gy)+sens;
	if (gx < deprecated_x-demi) return deprecated_x-gx-demi+sens;
	if (gx > deprecated_x+demi) return gx-deprecated_x+demi+sens;
	if (gy < deprecated_y-demi) return deprecated_y-gy+demi+sens;
	if (gy > deprecated_y+demi) return gy-deprecated_y-demi+sens;
	return 0+sens;
    }

    public boolean isInsideRectangle(Rectangle r){return false;}
    public Rectangle getBounds(){
	Rectangle rec;
	if(invisibleMode){
	    rec=new Rectangle(0+fakePosX-boxdim/2, 
			      0+fakePosY-boxdim/2, 
			      boxdim, boxdim);
	} 
	else {
	    rec=new Rectangle(0+deprecated_x-boxdim/2, 0+deprecated_y-boxdim/2, boxdim, boxdim);
	}
	if(depends instanceof Selection){
	    rec.add(depends.getBounds());
	    if (!(depends instanceof SelectIMark)) rec.grow(50,50);
	}
	return rec;
    }

    public void setDepends(JasObject jo){
	depends=jo;
    }

    public void updatingSelection() {
	// a call to this method makes some changes
	// in the object selected
	((Selection) depends).updatingSelection(this);
    } 
    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager){
	if (depends instanceof Selection)
	    depends.updatingWhenMove(tooBox,manager);
    }
    public Selection getObjectSelection(Rectangle slct){return null;}

    public void setInvisibleMode(boolean b){
	invisibleMode=b;
	fakePosX=deprecated_x;
	fakePosY=deprecated_y;
    }

    public void setColor(Color bxc){
	boxcolor=bxc;
    }

    public void setFakePos(int fx,int fy){
	fakePosX=fx;
	fakePosY=fy;
    }

    public void reAdjustFromFake(){
	if(invisibleMode)  setPos((int)(fakePosX/Configuration.scale),
				  (int)(fakePosY/Configuration.scale));
    }

    public int getFakeX(){ return fakePosX; }
    public int getFakeY(){ return fakePosY; }
    public Point2D.Double pos2Point2DFake() {
	return (new Point2D.Double(getFakeX(), getFakeY()));
    }

    public Point2D getRelativeMB(){
	MiniBox brelative;
	if(depends==null) return new Point2D.Double(deprecated_getX(),deprecated_getY());
	if(depends instanceof SelectExtendedEdge){
	    brelative=((SelectExtendedEdge) depends).getRelativeMB(this);
	    return new Point2D.Double(brelative.deprecated_getX(),brelative.deprecated_getY());   
	} else if (depends instanceof SelectExtendedCubic){
	    brelative=((SelectExtendedCubic) depends).getRelativeMB(this);
	    return new Point2D.Double(brelative.deprecated_getX(),brelative.deprecated_getY()); 
	} else if (depends instanceof SelectExtendedQuad){
	    brelative=((SelectExtendedQuad) depends).getRelativeMB(this);
	    return new Point2D.Double(brelative.deprecated_getX(),brelative.deprecated_getY()); 
	}
	return new Point2D.Double(deprecated_getX(),deprecated_getY());    
    }
}

