package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;

import jastex.*;
import jastex.old.gui.MainWindow;
import jastex.old.gui.JasObjectToolBox;
import jastex.parsing.OptionVal;


public class NodeLabel extends JasObject implements INELabel{
    public String label;
    public ANode   node;

    public boolean pExtNL;   // boolean flag defining whether node labels are external or not
    public double pNLangle;     // direction in degree of node labels
    public double pNLdist;      // The meaning depends on the ExtNL flag.
                      //   If the flag is set to "n" then NLdist defines the distance
                      //   in unitlength between the node center and the label center.
                      //   If the flag is set to "y" then NLdist defines the distance
                      //   in unitlength between the node frame and the label box.
    // GastexGlobalProperties ggp;
    public Graphics gContext=null;
    public TextLayout layout;
    public Point2D layoutOrigin;
    public int insertionIndex;
    public int oldindex;
    public boolean updattinfFromTB=true;

    public boolean inside;
    //TextComponent textcp;

    // virtual box    
    public Rectangle2D virtualAreaText;
    public String msgText="Latex Code";
    public boolean isEditable=true;
    public double virtualW=-1;
    public double virtualH=-1;
    public boolean isVirtualActive=false;
    public LatexHandler lh;
    public boolean enableLH;
    
    public NodeLabel(ANode n, String l) {
	super();
	node = n;
	label = l;
	cursor=new Cursor(Cursor.TEXT_CURSOR);
	inside= false;
	insertionIndex=-1;
	if (!MainWindow.isAppli) {
	    enableLH = false;
	} else {
	    enableLH = Configuration.enableLH;
	}
	if (enableLH) {
	    lh = new LatexHandler(l);
	}
    }	
    public NodeLabel(GastexGlobalProperties _ggp, ANode n, String l) {
	this(n, l);
	setGgpValues(_ggp);
	pExtNL = _ggp.pExtNL ;
	pNLangle = _ggp.pNLangle;
	pNLdist = _ggp.pNLdist;
	if (enableLH) {
	    virtualW = lh.getWidth(_ggp.getUnitLength(),
				   _ggp.getUnitName());
	    virtualW = globalProp.unitLength2Internal(virtualW);
	    virtualH = lh.getHeight(_ggp.getUnitLength(),
				    _ggp.getUnitName());
	    virtualH = globalProp.unitLength2Internal(virtualH);
	}
    }

    public NodeLabel(GastexGlobalProperties _ggp, ANode n, String l,
	      boolean pExt, double pAngle, double pDist) {
	this(_ggp, n, l);
	pExtNL = pExt;
	pNLangle = Math.toRadians(pAngle);
	pNLdist = globalProp.unitLength2Internal(pDist);
    }

    // Needed by parser
    public NodeLabel(GastexGlobalProperties _ggp,OptionVal param[],
	      ANode n, String l){
	this(_ggp, n, l);
	if(param!=null) {
	    if(!(param[7].optEmpty())){ setpExtNL(param[7].ob); }
	    if(!(param[8].optEmpty())){ setpNLangle(param[8].od); }
	    if(!(param[9].optEmpty())){ setpNLdist(param[9].od); }
	}
    }
    
    /** Set the internal value to the one of the GastexGlobalProperties
     * @param _ggp the GastexGlobaProperties used to initialize values
     * @see GastexGlobalProperties
     */ 

    public void setGgpValues(GastexGlobalProperties _ggp){
	super.setGgpValues(_ggp);
	pExtNL = _ggp.pExtNL;
 	pNLangle = _ggp.pNLangle;
 	pNLdist = _ggp.pNLdist;
    }

    public Rectangle2D getStringBounds2D(Graphics g) {
	return getStringBounds2D(g,label);
    }

    public Rectangle2D getStringBounds2D(Graphics g,String s) {
	double coeff;
	coeff = Configuration.scale;
	Font ft = g.getFont();
	Font cft = new Font(ft.getFontName(), ft.getStyle(), (int)(12*coeff));
	g.setFont(cft);
	Rectangle2D r = (g.getFontMetrics().getStringBounds(s, g));
	r=adjustVirtual(r);
	return r;
    }


    public void   draw(Graphics g) {
	
	Graphics2D g2=(Graphics2D) g;
	int posX, posY;
	double hDist, vDist;
	double coeff;
	coeff = Configuration.scale;

	TextLayout virtualT;
	Font ft = g.getFont();
	Font cft = new Font(ft.getFontName(), ft.getStyle(), (int)(12*coeff));
	g.setFont(cft);


	/* stop here */
/*
	Rectangle2D r = g.getFontMetrics().getStringBounds(label, g);
	if (pExtNL) {
	    hDist = ( ((node.getpNw()/2 + pNLdist) * coeff + r.getWidth()/2)
		      * Math.cos(Math.toRadians(-pNLangle)) );
	    vDist = ( ((node.getpNh()/2 + pNLdist) * coeff + r.getHeight()/2)
		      * Math.sin(Math.toRadians(-pNLangle)) );
	    posX = (int)(node.getX()- r.getWidth()/2 + hDist);
	    posY = (int)(node.getY()+ r.getHeight()/2 + vDist);
	} else {
	    hDist = ( pNLdist * coeff * Math.cos(Math.toRadians(-pNLangle)) );
	    vDist = ( pNLdist * coeff * Math.sin(Math.toRadians(-pNLangle)) );
	    posX = (int)(node.getX()- r.getWidth()/2 + hDist);
	    posY = (int)(node.getY()+ r.getHeight()/2 + vDist);
	    }
	g.setColor(Color.black);
	g.drawString(label,posX, posY);*/
	//((Graphics2D)g).draw(getBounds());


	/* next step here */
	//Font font = Font.getFont("Helvetica-bold-italic");
	FontRenderContext frc = g2.getFontRenderContext();
	//** setting the gContext && the Layout
	if (gContext==null){
	    setContext(g);
	    //Font cft = new Font(ft.getFontName(), ft.getStyle(), (int)(3*coeff));
	    //layout = new TextLayout(label, cft, frc);
	}
	if(updattinfFromTB){
	    if(label.equals("")) label=" ";
	    layout = new TextLayout(label, cft, frc);
	    updattinfFromTB=false;
	    isEditable=true;
	}

	Rectangle2D r = layout.getBounds();
	Rectangle2D rprime;
	rprime=adjustVirtual(r);
	// virtual box
	if(isVirtualActive){
	    virtualT = new TextLayout(msgText , cft, frc);
	    r = virtualT.getBounds();
	    
	}
	

	if (pExtNL) {
	    hDist = ( ((node.getWidth()/2 + pNLdist) * coeff+ r.getWidth()/2)
		      * Math.cos(-pNLangle) );
	    vDist = ( ((node.getHeight()/2 + pNLdist) * coeff + r.getHeight()/2)
		      * Math.sin(-pNLangle) );
	    posX = (int)(node.deprecated_getX()- r.getWidth()/2 + hDist);
	    posY = (int)(node.deprecated_getY()+ r.getHeight()/2 + vDist);
	} else {
	    hDist = ( pNLdist * coeff * Math.cos(-pNLangle) );
	    vDist = ( pNLdist * coeff * Math.sin(-pNLangle) );
	    posX = (int)(node.deprecated_getX()- r.getWidth()/2 + hDist);
	    posY = (int)(node.deprecated_getY()+ r.getHeight()/2 + vDist);
	}

	g.setColor(Color.black);

	layoutOrigin=new Point2D.Double(posX,posY);
	if(!isVirtualActive){
	    layout.draw(g2, posX, posY);
	} else {
	    
	    rprime.setRect(node.deprecated_getX()- rprime.getWidth()/2 + hDist,
			   node.deprecated_getY()- rprime.getHeight()/2 + vDist, 
			   rprime.getWidth(), 
			   rprime.getHeight());
	    g2.setColor(Color.gray);
	    g2.fill(rprime);
	    g2.setColor(Color.yellow);
	    g2.drawString(msgText, posX, posY);
	    g2.setColor(Color.black);
	}

	if (insertionIndex!=-1){
	    g2.translate(layoutOrigin.getX(), layoutOrigin.getY()-2);
	    Shape[] carets = layout.getCaretShapes(insertionIndex);
	    g2.setColor(Color.red);
	    g2.draw(carets[0]);
	    if (carets[1] != null) {
		g2.setColor(Color.black);
		g2.draw(carets[1]);
	    }
	    g2.translate(-layoutOrigin.getX(), -layoutOrigin.getY()+2);
	    oldindex=insertionIndex;
	    insertionIndex=-1;
	}



	/* only draw the Bounds */
	/*
	Rectangle2D bounds = layout.getBounds();
	bounds.setRect(bounds.getX()+getX(),
		       bounds.getY()+getY(),
		       bounds.getWidth(),
		       bounds.getHeight());
	g2.draw(bounds);
	*/


    }

    public String getLatexCodeProperties(boolean isStandAlone) {
	String lProp = "";
	if (pExtNL != globalProp.pExtNL) {
	    lProp += ",ExtNL="+(pExtNL?"y":"n");
	}
	if (pNLangle != globalProp.pNLangle) {
	    lProp += ",NLangle="+roundDouble(getpNLangle());
	}
	if (pNLdist != globalProp.pNLdist) {
	    lProp += ",NLdist="+roundDouble(getpNLdist());
	}
	if (lProp.equals("")) {
	    return "";
	} else {
	    if (isStandAlone) {
		//cut the first comma
		return ("[" + lProp.substring(1) + "]");
	    } else {
		return (lProp);
	    }
	}
    }
	

    public String getLatexCode() {
	String labelCode;
	labelCode = "\\nodelabel"+
	    getLatexCodeProperties(true)+
	    "("+node.getNodeName()+")"+
	    "{"+label+"}" + "\n";
	return labelCode;
}
    
    public Rectangle getBounds() {
	double hDist, vDist;
	double coeff;
	coeff = Configuration.scale;
	Rectangle2D r= getStringBounds2D(gContext);	
	//r=adjustVirtual(r);


	Rectangle rbis=new Rectangle((int) r.getX(),
				     (int) r.getY(),
				     (int) r.getWidth(),
				     (int) r.getHeight());
	if (pExtNL) {
	    hDist = ( ((node.getWidth()/2 + pNLdist) * coeff + r.getWidth()/2)
		      * Math.cos(-pNLangle) );
	    vDist = ( ((node.getHeight()/2 + pNLdist) * coeff + r.getHeight()/2)
		      * Math.sin(-pNLangle) );
	    deprecated_x = (int)(node.deprecated_getX() - r.getWidth()/2 + hDist);
	    deprecated_y = (int)(node.deprecated_getY() - r.getHeight()/2 + vDist);
	} else {
	    hDist = ( pNLdist * coeff * Math.cos(-pNLangle) );
	    vDist = ( pNLdist * coeff * Math.sin(-pNLangle) );
	    deprecated_x = (int)(node.deprecated_getX()- r.getWidth()/2 + hDist);
	    deprecated_y = (int)(node.deprecated_getY()- r.getHeight()/2 + vDist);
	}
	rbis.setLocation(deprecated_x, deprecated_y); 
	return rbis;
    }

    public double getMinDistance(int x,int y) {
	if (getBounds().contains((double) x,(double) y)) return 0;
	else return 1000; 
    }

    public void setPos(int px,int py) {
	deprecated_x=px;
	deprecated_y=py;
    }
    
    public boolean isInsideRectangle(Rectangle r) { 
	Rectangle rr=getBounds();
	boolean reallyIs=r.intersects(rr.getX(),rr.getY(),rr.getWidth(),rr.getHeight());
	return reallyIs;
    }

    public void    setLabel(String l) { 
	this.label = l;
	//textcp.setText(l);
	updattinfFromTB=true;
	if (enableLH) {
	    lh = new LatexHandler(l);
	    virtualW = lh.getWidth(globalProp.getUnitLength(),
				   globalProp.getUnitName());
	    virtualW = globalProp.unitLength2Internal(virtualW);
	    virtualH = lh.getHeight(globalProp.getUnitLength(),
				    globalProp.getUnitName());
	    virtualH = globalProp.unitLength2Internal(virtualH);
	}
    }
    public String  getLabel() { return label;
	//return textcp.getText(); 
    }

    public void    setpExtNL(boolean pExtNL) {
	this.pExtNL = pExtNL;
    }
    public boolean getpExtNL() {
	return pExtNL;
    }
    
    public void   setpNLangle(double pNLangle){
	this.pNLangle = Math.toRadians(pNLangle);
    }
    public double getpNLangle() {
	return Math.toDegrees(pNLangle);
    }
    public void   setpNLangleTB(double pNLangle){ 
	this.pNLangle = Math.toRadians(pNLangle);
    }
    public double getpNLangleTB() {
	return Math.toDegrees(pNLangle);
    }


    public void   setpNLdist(double pNLdist){
	this.pNLdist = globalProp.unitLength2Internal(pNLdist);
    }
    public double getpNLdist() {
	return globalProp.internal2UnitLength(pNLdist);
    }
    public void   setpNLdistTB(double pNLdist){ 
	this.pNLdist = globalProp.unitLength2Internal(pNLdist) / 
	    globalProp.unitlength;
    }
    public double getpNLdistTB() {
	return globalProp.internal2UnitLength(pNLdist) *
	    globalProp.unitlength;
    }



    public void setInside(boolean in) { inside = in; }
    public boolean isInside() { return inside; }
    public ANode getNode(){ return node; }
    public void setNode(ANode n){ node = n; }
    public void setContext(Graphics g){
	gContext=g;
    }

    public void updateAngle(Point2D pt) {
	Point2D center = node.pos2Point2D();
	Point2D temp = new Point2D.Double(pt.getX(),center.getY());

	double newangle;
	double hypotenuse = center.distance(pt);
	double adjacent  =center.distance(temp);
	if (hypotenuse==0){ 
	    setpNLangle(90); 
	    return;
	}
	newangle=Math.acos(adjacent/hypotenuse)*180/Math.PI;
	newangle=(pt.getX()<center.getX())?180-newangle:newangle;
	newangle=(pt.getY()>center.getY())?360-newangle:newangle;
	setpNLangle(newangle);
    } 
    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager){
	//tooBox.updateLabel(getLabel());
	tooBox.updateNodeLabelList(getNode());
    }
    public TextLayout getActualLayout(){return layout;}

    public void editTextInsert(char c){
    //	setCaretPosition(int position);
	//System.out.println(oldindex);
	String debut="";
	String fin="";
	if (label.equals(" ")) {
	    oldindex=0;
	} else {
	    debut=label.substring(0,oldindex);
	    fin=label.substring(oldindex); 
	}
	oldindex++;
	label=new String(debut+c+fin);
	updattinfFromTB=true;
	insertionIndex=oldindex;
    }

    public void suppr(int avalAmout){
	int str1limit=(oldindex==0)?0:oldindex-avalAmout;
	int strl=label.length();
	int str2limit=oldindex+(avalAmout+1)%2;
	if(str2limit>strl) {
	    insertionIndex=str2limit-1;
	    return;
	}

	String debut=label.substring(0,str1limit);
	String fin=label.substring(str2limit);
	label=new String(debut+fin);
	updattinfFromTB=true;
	insertionIndex=str1limit;
    }

    public void removeFromNode(){ 
	node.delLabel(this);
    }

   public Object clone(){
       NodeLabel nl = null;
       nl = (NodeLabel) super.clone();
       return nl;
  
   }

    public Object clone(ANode n){
	NodeLabel nl = null;
	nl = (NodeLabel) this.clone();
	nl.setNode(n);
	nl.setLabel(label);
	return nl; 
    }

    public boolean getLHstate() {
	return enableLH;
    }
    public void setLHstate(boolean state) {
	if (MainWindow.isAppli) {
	    enableLH = state;
	    if (enableLH) {
		lh = new LatexHandler(label);
		virtualW = lh.getWidth(globalProp.getUnitLength(),
				       globalProp.getUnitName());
		virtualW = globalProp.unitLength2Internal(virtualW);
		virtualH = lh.getHeight(globalProp.getUnitLength(),
					globalProp.getUnitName());
		virtualH = globalProp.unitLength2Internal(virtualH);
	    }
	} else {
	    enableLH = false;
	}
    }	

    public Rectangle2D adjustVirtual(Rectangle2D virtr){
	isVirtualActive=false;
	double virtw,virth;
	if ( enableLH && lh.isDone() && 
		(virtr.getWidth()>virtualW+100 ||  virtr.getHeight()>virtualH+20)){
	    isVirtualActive=true;
	    isEditable=false;
	    virtw=virtualW;
	    // else virtw=virtr.getWidth();
	    virth=virtualH;
	    // else virth=virtr.getHeight();
	    return (new Rectangle2D.Double(virtr.getX(), virtr.getY(),
					   virtw, virth));
	}
	return virtr;
    }

    public boolean editable() { return isEditable; }

    public int getOldIndex(){ return oldindex; }
    public void setInsertionIndex(int index){
	insertionIndex=index;
    }

    

    public Selection getObjectSelection(Rectangle slct){
	slct.grow(10,10);
	return (new SelectNodeLabel(this));
    }
}



