package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;
import jastex.old.gui.JasObjectToolBox;
import jastex.parsing.OptionVal;


public class RMark extends JasObject {
    public double prdist;
    //FIXME:Anode or extends Node
    public Node node;

    public RMark (ANode n) {
	super();
	node = (Node)n;
    }
	
    public RMark (GastexGlobalProperties _ggp, ANode n) {
	this(n);
	setGgpValues(_ggp);
    }
    public RMark (GastexGlobalProperties _ggp, ANode n, double prd) {
	this(_ggp, n);
	prdist = globalProp.unitLength2Internal(prd);
    }

    // Constructor Needed by Parser
    public RMark(GastexGlobalProperties _ggp,OptionVal param[],ANode n){
	this(_ggp, n);
	if(param!=null) {
	    if(!(param[15].optEmpty())){ setprdist(param[15].od); }
	    if(!(param[28].optEmpty())){ setplinegray(param[28].od); }
	    if(!(param[30].optEmpty())){ setplinecolor(param[30].otxt); }
	    if(!(param[32].optEmpty())){ setplinewidth(param[32].od); }
	    if(!(param[33].optEmpty())){
		// dash option
		setpdash_length(param[33].oflist); 
		setpdash_empty(param[33].of); 
	    }
	}
    }

    /** Set the internal value to the one of the GastexGlobalProperties
     * @param _ggp the GastexGlobaProperties used to initialize values
     * @see GastexGlobalProperties
     */ 
    public void setGgpValues(GastexGlobalProperties _ggp){
	super.setGgpValues(_ggp);
	prdist = _ggp.prdist;
	
    }

    public void draw(Graphics g) {
	double actualWidth, actualHeight;
	int ulx, uly, width, height,arc;
	Stroke s, olds;
	double coeff;
	coeff = Configuration.scale;
	actualWidth =  node.getActualWidth(g)  + prdist*coeff*2; // 0.5 HACK 
	actualHeight=  node.getActualHeight(g) + prdist*coeff*2; // prevent from rounding
	arc  = (int)((node.getInternalpNmr()
		     + prdist)*coeff);
	width = (int)(actualWidth+1);
	height = (int)(actualHeight+1);

	deprecated_x = node.deprecated_getX();
	deprecated_y = node.deprecated_getY();

	ulx = (int)((deprecated_x-(actualWidth+0.5)/2));
	uly = (int)((deprecated_y-(actualHeight+0.5)/2));

	olds = ((Graphics2D)g).getStroke();
	//draw its frame with the chosen color or graylevel if needed,
	g.setColor(getLineColor());
	if(selectStatus()) g.setColor(slctColor);
	if (pdash_length == null) {
	    s = new BasicStroke((float)(plinewidth*coeff));
	} else {
	    int len = pdash_length.length;
	    float[] pdash_length2 = new float[len];
	    for (int i = 0; i < len; i++) {
		pdash_length2[i] = (float)(pdash_length[i]*coeff);
	    }
	    s =  new BasicStroke((float)(plinewidth*coeff),
				 BasicStroke.CAP_BUTT,
				 BasicStroke.JOIN_BEVEL,
				 0,   // Miter limit
				 pdash_length2,
				     (float)(pdash_empty*coeff));
	}
	
	((Graphics2D)g).setStroke(s);

	if (arc != 0) {    
	    //if(node.pNw>=10) {
		// HACK -- BUG DRAWING
	    //width=(x-ulx)*2;
	    //height=(y-uly)*2;
		//}
	    g.drawRoundRect(ulx, uly, width, height, arc*2, arc*2);
	} else {
	    g.drawRect(ulx, uly, width, height);
	}
	((Graphics2D)g).setStroke(olds);
    }

    public boolean isInsideRectangle(Rectangle r) {
	double coeff;
	double actualWidth, actualHeight, pNmr;
	coeff = Configuration.scale;
	actualWidth =  node.getActualWidth()  + prdist*coeff*2;
	actualHeight=  node.getActualHeight() + prdist*coeff*2;
	pNmr  = (node.getpNmr() + prdist)*coeff;

	deprecated_x = node.deprecated_getX();
	deprecated_y = node.deprecated_getY();
	RoundRectangle2D.Double rr = 
	    new RoundRectangle2D.Double(deprecated_x-(actualWidth+plinewidth*coeff)/2,
					deprecated_y-(actualHeight+plinewidth*coeff)/2,
					(actualWidth+plinewidth*coeff),
					(actualHeight+plinewidth*coeff),
					pNmr*2,
					pNmr*2);
	return rr.intersects(r.getX(),r.getY(),r.getWidth(),r.getHeight());
    }

   public Rectangle getBounds() {
	double coeff;
	double actualWidth, actualHeight, pNmr;
	coeff = Configuration.scale;
	actualWidth =  node.getActualWidth()  + prdist*coeff*2;
	actualHeight=  node.getActualHeight() + prdist*coeff*2;
	pNmr  = (node.getpNmr() + prdist)*coeff;

	deprecated_x = node.deprecated_getX();
	deprecated_y = node.deprecated_getY();
	RoundRectangle2D.Double rr = 
	    new RoundRectangle2D.Double(deprecated_x-(actualWidth+plinewidth*coeff)/2,
					deprecated_y-(actualHeight+plinewidth*coeff)/2,
					(actualWidth+plinewidth*coeff),
					(actualHeight+plinewidth*coeff),
					pNmr*2,
					pNmr*2);
	Rectangle rect=rr.getBounds();
	rect.grow(2,2);
	return rect;
    }

    public double getMinDistance(int gx,int gy) {
	return 1000.0;
	/*
	double coeff;
	double actualWidth, actualHeight, pNmr;
	coeff = globalProp.ratio*Configuration.scale;
	actualWidth =  node.getActualWidth()  + prdist*coeff*2;
	actualHeight=  node.getActualHeight() + prdist*coeff*2;
	pNmr  = (node.getpNmr() + prdist)*coeff;

	x = node.getX();
	y = node.getY();
        RoundRectangle2D.Double rr =
	   new RoundRectangle2D.Double(x-(actualWidth+plinewidth*coeff)/2-5,
		 			y-(actualHeight+plinewidth*coeff)/2-5,
			 		(actualWidth+plinewidth*coeff)+10,
				 	(actualHeight+plinewidth*coeff)+10,
					pNmr*2,
					pNmr*2);
	if (rr.contains(gx, gy)) return 0;
	return 1000;
	*/
    }

    public boolean contains(double gx, double gy) {
	double coeff;
	double actualWidth, actualHeight, pNmr;
	coeff = Configuration.scale;
	actualWidth =  node.getActualWidth()  + prdist*coeff*2;
	actualHeight=  node.getActualHeight() + prdist*coeff*2;
	pNmr  = (node.getpNmr() + prdist)*coeff;

	deprecated_x = node.deprecated_getX();
	deprecated_y = node.deprecated_getY();
	RoundRectangle2D.Double rr =
	    new RoundRectangle2D.Double(deprecated_x-(actualWidth+plinewidth*coeff)/2,
					deprecated_y-(actualHeight+plinewidth*coeff)/2,
					(actualWidth+plinewidth*coeff),
					(actualHeight+plinewidth*coeff),
					pNmr*2,
					pNmr*2);
	return rr.contains(gx, gy);
    }

    public boolean contains (Point2D pt) {
	return contains(pt.getX(), pt.getY());
    }

    public String getLatexCodeProperties(boolean isStandAlone) {
	String lProp = super.getLatexCodeProperties(false);
	if (prdist != globalProp.prdist) {
	    lProp += ",rdist="+roundDouble(getprdist());
	}
	if (lProp.equals("")) {
	    return "";
	} else {
	    if (isStandAlone) {
		//cut the first comma
		return ("[" + lProp.substring(1) + "]");
	    } else {
		return (lProp);
	    }
	}
	
    }
    public String getLatexCode() {
	String lpCode = getLatexCodeProperties(true);
	String markCode;
	markCode = "\\rmark" + 
	    lpCode + 
	    "("+node.getNodeName()+")"+"\n";
	return markCode;
    }

    public void setPos(int x, int y) {}
    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager){
    }
    
    public double getprdist() {
	return globalProp.internal2UnitLength(prdist);
    }
    public void setprdist(double prd) {
	prdist = globalProp.unitLength2Internal(prd);
    }


    public double getprdistTB() {
	return globalProp.internal2UnitLength(prdist) * globalProp.unitlength ;
    }
    public void setprdistTB(double prd) {
	prdist = globalProp.unitLength2Internal(prd) / globalProp.unitlength;
    }


    public void setNode(ANode n) {
	node = (Node)n;
    }
    public ANode getNode() {
	return node;
    }

   public Object clone(ANode n){
       RMark rm = null;
       rm = (RMark) this.clone();
       rm.setNode(n);

       return rm;
    }
   public Object clone(){
       RMark rm = null;
       rm = (RMark) super.clone();
       return rm;
    }

    public Selection getObjectSelection(Rectangle slct){return null;}
}
