package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;



/* Extension of the file Selection.java
   easier to read
*/
public class SelectBezierQuadCurve extends Selection {

    public MiniBox b1;

    public MiniBox b2;

    public MiniBox b3;
    public BezierQuadCurve rCurve;

    public SelectBezierQuadCurve(){}

    public SelectBezierQuadCurve(BezierQuadCurve rc){
	rCurve=rc;
	miniB=new Vector();
	b1=new MiniBox(rc.startingpoint.deprecated_getX(),rc.startingpoint.deprecated_getY());
	b2=new MiniBox(rc.endingpoint.deprecated_getX(),rc.endingpoint.deprecated_getY());
	b3=new MiniBox((int)rc.getCtrlPt().getX(),(int)rc.getCtrlPt().getY());
	miniB.addElement(b1);
	miniB.addElement(b2);
	miniB.addElement(b3);
	b1.setSensitive(false); // box 1 is not movable
	b2.setSensitive(false); // box 2 is not movable
	b1.setColor(Color.orange);
	b2.setColor(Color.orange);

	b3.setSensitive(true);
	b3.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b3.setDepends(this);

	b1.setInvisibleMode(true);
	b2.setInvisibleMode(true);
	b3.setInvisibleMode(true);
    }

    public double getMinDistance(int gx,int gy){ return 1000.0; }

    public void setOffset(int posx,int posy) {}
    public void setPos(int posx,int posy) {}
    public void draw(Graphics g){
	Graphics2D g2=(Graphics2D) g ;
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.blue);

	Point2D e1=rCurve.startingpoint.pos2Point2D(rCurve.psxo,rCurve.psyo);
	Point2D e2=rCurve.endingpoint.pos2Point2D(rCurve.pexo,rCurve.peyo);
	//	Point2D e1=rCurve.currentCurve.getP1();
	//Point2D e2=rCurve.currentCurve.getP2();
	Point2D e3=rCurve.getCtrlPt();


	Line2D.Double one2two=new Line2D.Double(e1,e2);
	Line2D.Double one2control=new Line2D.Double(e1,e3);
	Line2D.Double two2control=new Line2D.Double(e2,e3);
	
	QuadCurve2D.Double currentCurve2=
	    new QuadCurve2D.Double(e1.getX(),e1.getY(),
				   e3.getX(),e3.getY(),
				   e2.getX(),e2.getY());


	g2.draw(one2two);
	g2.draw(one2control);
	g2.draw(two2control);
	g2.draw(rCurve.currentCurve);

	g2.setColor(Color.red);
	g2.draw(currentCurve2);
	g2.setStroke(new BasicStroke()); 
    }

    public Rectangle getBounds(){
	Rectangle r=new Rectangle(rCurve.getBounds());
	r.add(b1.pos2Point2DFake());
	r.add(b2.pos2Point2DFake());
	r.add(b3.pos2Point2DFake());
	r.grow(5,5);
	return r;
    }

    public void updatingSelection(){
	rCurve.setCtrlPt(b3.pos2Point2D());
 	rCurve.adjustCurve();

	b3.setFakePos((int)rCurve.getCtrlPt().getX(),
		      (int)rCurve.getCtrlPt().getY());
    } 
    public void updatingSelection(MiniBox mb){ updatingSelection(); }
    public void recadre(){}
    public Point returnDeplacement() {return null;}   
}
