package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;



/* Extension of the file Selection.java
   easier to read
*/
public class SelectEdge extends Selection {

    // two control point
    // to be noticed : straight Edge is unmovable

    public Point2D p1;

    public Point2D p2;

    public MiniBox b1;

    public MiniBox b2;

    public MiniBox b3;
    public Edge sEdge;
    public Point2D pc;
    public double cSign;
    //Rectangle r;
    public int offsetx=0;

    public int offsety = 0;
    public boolean curved=false;
    public boolean straight=false;
    //Line2D.Double debug;

    public SelectEdge(){}

    public SelectEdge(Edge se){
	miniB=new Vector();
	b1=new MiniBox(se.startingpoint.deprecated_getX(),se.startingpoint.deprecated_getY());
	b2=new MiniBox(se.endingpoint.deprecated_getX(),se.endingpoint.deprecated_getY());
	miniB.addElement(b1);
	miniB.addElement(b2);
	b1.setSensitive(false); // box 1 is not movable
	b2.setSensitive(false); // box 2 is not movable
	b1.setColor(Color.orange);
	b2.setColor(Color.orange);
	b1.setInvisibleMode(true);
	b2.setInvisibleMode(true);



	sEdge=se;
	if((pc=se.getCtrlPt())!=null){
	    curved=true;
	    b3=new MiniBox((int) pc.getX(),(int) pc.getY());
	    miniB.addElement(b3);
	    b3.setSensitive(true);
	    b3.cursor=new Cursor(Cursor.MOVE_CURSOR);
	    b3.setDepends(this);
	    cSign=(sEdge.getpcurvedepth()>0)?1:-1;
	    if (sEdge.getpcurvedepth()==0) { straight=true; }
	    b3.setInvisibleMode(true);
	}
    }

    public double getMinDistance(int gx,int gy){
	return 1000.0;
    }

    public void setOffset(int posx,int posy) {}

    public void setPos(int posx,int posy) {}
    public void draw(Graphics g){
	Graphics2D g2=(Graphics2D) g ;
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.blue);
// 	if (sEdge.getCtrlPt==null) {
// 	    Point2D e1=sEdge.startingpoint.pos2Point2D();
// 	    Point2D e2=sEdge.endingpoint.pos2Point2D();
	    
// 	    Line2D.Double one2two=new Line2D.Double(e1,e2);
// 	    g2.draw(one2two);
// 	} else {
	    //drawing curve
	Point2D e1=sEdge.startingpoint.pos2Point2D(sEdge.psxo,sEdge.psyo);
	Point2D e2=sEdge.endingpoint.pos2Point2D(sEdge.pexo,sEdge.peyo);
	//	Point2D e1=rCurve.currentCurve.getP1();
	//Point2D e2=rCurve.currentCurve.getP2();
	Point2D e3=sEdge.getCtrlPt();
	
	
	Line2D.Double one2two=new Line2D.Double(e1,e2);
	Line2D.Double one2control=new Line2D.Double(e1,e3);
	Line2D.Double two2control=new Line2D.Double(e2,e3);
	
	Point2D e4=new Point2D.Double((e1.getX()+e2.getX())/2,
				      (e1.getY()+e2.getY())/2);
	
	Line2D.Double control2opposite=new Line2D.Double(e3,e4);
	
	QuadCurve2D.Double currentCurve2=
	    new QuadCurve2D.Double(e1.getX(),e1.getY(),
				   e3.getX(),e3.getY(),
				   e2.getX(),e2.getY());
	     
	
	g2.draw(one2two);
	g2.draw(one2control);
	g2.draw(two2control);
	g2.draw(control2opposite);
	g2.draw(sEdge.currentCurve);
	
	g2.setColor(Color.red);
	g2.draw(currentCurve2);
	//g2.draw(debug);
	// 	}
	
	// ------DEBUGGGGGG
	//	MiniBox bb1=new MiniBox((int)sEdge.bouhA.getX(),(int)sEdge.bouhA.getY());
	//MiniBox bb2=new MiniBox((int)sEdge.bouhB.getX(),(int)sEdge.bouhB.getY());
	//MiniBox bbb1=new MiniBox((int)sEdge.pc1adjusted.getX(),(int)sEdge.pc1adjusted.getY());
	//MiniBox bbb2=new MiniBox((int)sEdge.pc2adjusted.getX(),(int)sEdge.pc2adjusted.getY());

	//bb1.draw(g2);
	//bb2.draw(g2);
	//bbb1.draw(g2);
	//bbb2.draw(g2);
	//CubicCurve2D.Double cccc=
	//   new CubicCurve2D.Double(e1.getX(),e1.getY(),
	//			    sEdge.bouhA.getX(),sEdge.bouhA.getY(),
	//		    sEdge.bouhB.getX(),sEdge.bouhB.getY(),
	//		    e2.getX(),e2.getY());
	// ----END DEBUGGGG
    //g2.draw(cccc);		    
						      

	
	g2.setStroke(new BasicStroke()); 
	     
    }

    public Rectangle getBounds(){
	Rectangle r=new Rectangle(sEdge.getBounds());
	r.add(b1.pos2Point2DFake());
	r.add(b2.pos2Point2DFake());
	if(curved){
	    r.add(b3.pos2Point2DFake());
	}
	r.grow(5,5);
	return r;
    }

    public void updatingSelection(){


	p1 =sEdge.startingpoint.pos2Point2D();
	p2 =sEdge.endingpoint.pos2Point2D();
	Line2D.Double one2two=new Line2D.Double(p1,p2);

	if (straight) {
	    // we have to set the cSign value
	    pc=b3.pos2Point2D();//ptLineDist(Point2D pt)

	    double det=(p2.getX()-p1.getX())*(pc.getY()-p1.getY())
		-(pc.getX()-p1.getX())*(p2.getY()-p1.getY());


	    cSign=(det>0)?-1:1;

	    straight=false;
	    //System.out.println("Bizarr");
	}

	Point2D punct=b3.pos2Point2D();
	Line2D.Double temp=new Line2D.Double(pc,punct);
	//debug=temp;

	if ((one2two.ptLineDist(pc))==0) { 
	    // little hack
	    straight=true;
	}
	double unit=sEdge.getGgp().ratio*Configuration.scale;
	double curvalue=(one2two.ptLineDist(punct))/(2*unit);
	if(temp.intersectsLine(one2two)){
	    // if intersection , change sign
	    //System.out.println("kjsdfjkhsdf");
       	    curvalue=-curvalue;
	}
	sEdge.setpcurvedepth(curvalue*cSign);
	//System.out.println(curvalue*cSign);
	
 	//Point2D pcbis=sEdge.getCtrlPt();
	//b3.setoffset((int) (pcbis.getX()-punct.getX()), (int) (pcbis.getY()-punct.getY()));

	//b3.setPos((int) pcbis.getX(), (int) pcbis.getY());
	b3.setFakePos((int) sEdge.getCtrlPt().getX(),
		      (int) sEdge.getCtrlPt().getY());

    }

    public void updatingSelection(MiniBox mb){ 
	if(curved)
	    updatingSelection();	
    }

    public void recadre(){}
    public Point returnDeplacement() {return null;}   
}



