package jastex.parsing;
import java.util.Vector;
import java.io.*;
import javax.swing.*;

import jastex.*;
import jastex.old.gui.MessageBox;
import jastex.old.gui.MainWindow;
import jastex.old.gui.SurfaceDessin;
import jastex.old.gui.JasTextPane;
import jastex.old.obj.ExtendedQuad;
import jastex.old.obj.JasRectangle;
import jastex.old.obj.Node;
import jastex.old.obj.BezierQuadCurve;
import jastex.old.obj.IFMark;
import jastex.old.obj.BezierCubicCurve;
import jastex.old.obj.InvisibleNode;
import jastex.old.obj.JasObject;
import jastex.old.obj.Circle;
import jastex.old.obj.Loop;
import jastex.old.obj.Edge;
import jastex.old.obj.ExtendedEdge;
import jastex.old.obj.NodeLabel;
import jastex.old.obj.EdgeLabel;
import jastex.old.obj.RMark;
import jastex.old.obj.ExtendedCubic;
import jastex.old.obj.Oval;



public class JasParser2 {


    public String gastexCode;
    public int gastexCodeSize;
    public int currentline;
    public int currentGlobalPosition;
    public int currentPosition;
    public Vector bufferStack;   // pile
    public boolean syntaxError;
    public String currentbuffer;
    public String erreurString;
    public Vector bufferStack2;
    public Vector bufferStack3;
    public int nbOptionP=39;

    public boolean gassetIsLastAction=false;
    public GastexGlobalProperties ggp;
    public OptionVal[] ggpOpt;
    public GastexGlobalProperties actual_ggp;

    public String actionsequence;

    public Vector nodeNameVector;
    public Vector vectorOfNode;

    public boolean _COMMIT_=false;
    public ObjetManager manager;
    //    SurfaceDessin surface=null;

    // HIGHLIGHTING OPTION
    public JasTextPane latexCode=null;
    public int[] startingCarret;
    public int[] endingCarret;
    public static int bufferCarret=100;
    public int highlightindex=0;
    public int carretOffset=0;
    // ---------------

    public float dash1[];
    public float dash2;

    // this boolean set the sensibility Nodename option
    // if true, this option force this parser to bypass unknow balise
    // and unexpected character
    public boolean _LATEXCOMP=true;
    public boolean nsens=false;

    public boolean pictureStarted=false;
    public boolean firstBeginPicture=true;
   
    public GastexGlobalProperties ggpBeforeFirstBegin=null;    
    public static String jpaneName;
    public static int jpaneInc=1;



    public static String[] gasParameter={"Nw","Nh","Nmr","Nadjust","Nadjustdist",
				  "Nframe","Nfill","ExtNL","NLangle","NLdist",
				  "Nmarks","ilength","iangle","flength","fangle",
				  "rdist","loopdiam","loopangle","loopCW","curvedepth",
				  "AHnb","AHdist","AHangle","AHLength","AHlength",
				  "ELside","ELpos","ELdist","linegray","fillgray",
				  "linecolor","fillcolor","linewidth","dash",
				  "sxo","syo","exo","eyo","ELdistC"};
    // IMPORTANT NOTES
    // TO ADD IN ALL JASOBJECTS : Constructor with vector parameter containing optional sets

    public static String[] gasAction={"unitlength","gasset","node","imark","fmark","rmark",
			       "nodelabel","drawedge","drawqbedge","drawbpedge",
			       "drawbcedge","drawloop","drawcircle","drawrect",
			       "drawoval","drawline","drawqbezier",
			       "drawcbezier","drawqbpedge","end",
			       "begin","usepackage", //20
			       "compatiblegastexun","compatiblepspictpg"};


    public double offx;

    public double offy;

    public double w;

    public double h;
    public boolean slide=false;
    public static MainWindow mw;
    public Vector erreurStack=new Vector();


    public JasParser2(){}


    public JasParser2(String code){
        gastexCode=code;
	currentline=1;
	currentGlobalPosition=0;
	currentPosition=0;
	bufferStack=new Vector();
	bufferStack2=new Vector();
	gastexCodeSize=code.length();
	ggp=new GastexGlobalProperties(); // set the default property
	erreurString=new String("");
	ggpOpt=new OptionVal[nbOptionP];
	nodeNameVector=new Vector();
	vectorOfNode=new Vector();
	offx=0;
	offy=0;
	startingCarret=new int[bufferCarret];
	endingCarret=new int[bufferCarret];
    }

    public JasParser2(String code,MainWindow mw){
	this(code);
	this.mw=mw;
    }


    public Node getNode(String nodename){
	int sz=vectorOfNode.size();
	Node ntemp;
	// We consider that the most recent Node is probably
	// the node we are looking for.
	for(int i=sz-1;i>=0;i--){
	    ntemp=(Node) (vectorOfNode.elementAt(i));
	    if((ntemp.getNodeName()).equals(nodename)) return ntemp;
	}
	return null;
    }


    public void setJText(JasTextPane jta){
	latexCode=jta;
    }

    public void setHighlight(){
	/*
	if (latexCode==null) return;
	try {
	    latexCode.select(latexCode.getLineStartOffset(currentline),latexCode.getLineEndOffset(currentline));
	} catch (javax.swing.text.BadLocationException e){}
	*/
    }

    public void setHighlight(int spos,int epos){
	if (latexCode==null) return;
	latexCode.select(spos+carretOffset,epos+carretOffset);
	latexCode.requestFocus();
    }

    public void setHighlight(int index){
	if (latexCode==null) return;
	latexCode.select(startingCarret[index]+carretOffset,
			 endingCarret[index]  +carretOffset);
	latexCode.requestFocus();
    }

    // *************************************
    public void commit(SurfaceDessin sf){
	Configuration.scale=1;
	sf.setScale(1);
	ggpBeforeFirstBegin=null;
	pictureStarted=false;
	firstBeginPicture=true;
	slide=false;
	_LATEXCOMP=true;
	gassetIsLastAction=false;

	currentline=1;
	currentGlobalPosition=0;
	currentPosition=0;
	bufferStack=new Vector();
	bufferStack2=new Vector();
	gastexCodeSize=gastexCode.length();
	ggp=new GastexGlobalProperties(); // set the default property
	actual_ggp=null;
	erreurString=new String("");
	ggpOpt=new OptionVal[nbOptionP];
	nodeNameVector=new Vector();
	_COMMIT_=true;
	this.manager=sf.getManager();
	removeAllObject(sf);
	//offx=sf.getWidth()/2/Configuration.ratioJ2G;
	//offy=sf.getHeight()/2/Configuration.ratioJ2G;
	offx=0;
	offy=0;	
	startingCarret=new int[bufferCarret];
	endingCarret=new int[bufferCarret];
	parse();
	updateAllNode();
	
    }







    // **************************************
    public boolean isNodeNameExist(String s){
	return nodeNameVector.contains(s);
    }

    public boolean isNodeNameExist2(String s){
	if (!isNodeNameExist(s)){
	    erreurString+="\nline"+(currentline-1)+" SyntaxError the Node "+s+" does not exist";
	    syntaxError=true;
	    return false;
	}
	return true;
    }

    public boolean addNodeName(String s){
	if (nsens){
	    if (isNodeNameExist(s)){
		erreurString+="\nline"+(currentline-1)
		    +" SyntaxError a node with the name "+s
		    +" has already been defined";
		syntaxError=true;
		return true;
	    }
	}
	nodeNameVector.add(s);
	return false;
    }

    // ***************************************
    public int getIndexGasParameter(String cle){
	int z=0;
	while(z<nbOptionP && !cle.equals(gasParameter[z])) z++;
	if (z==nbOptionP){
	    erreurString+="\nline "+ (currentline-1) +" : SyntaxError unknown parameter "+ cle;
	    syntaxError=true;
	    return -1;
	}
	return z;
    }

    public int getIndexGasAction(String cle){
	int z=0;
	int sz=gasAction.length;
	while(z<sz && !cle.equals(gasAction[z])) z++;
	if (z==sz){
	    // added for block
	    if (cle.charAt(0)=='{') {
		//System.out.println("Index Action = 20");
		return 50;
	    }
	    // --
	    if(!_LATEXCOMP){
		erreurString+="\nline "+ (currentline-1) +" : SyntaxError unknown action "+ cle;
		syntaxError=true;
	    }
	    return -1;
	}
	return z;
    }
    
    public double getNumber(String value){
	double val;
	try {
	    val=Double.parseDouble(value);
	} catch (NumberFormatException e) {
	    erreurString+="\nline "+ (currentline-1) +" : SyntaxError in parsing number " + value;
	    syntaxError=true;
	    return 0;
	}
	return val;
    }

    public int getNumber2(String value){
	int val;
	try {
	    val=Integer.parseInt(value);
	} catch (NumberFormatException e) {
	    erreurString="\nline "+ currentline +" : SyntaxError in parsing number " + value;
	    syntaxError=true;
	    return 0;
	}
	return val;
    }

    public OptionVal parseDash(String value){
	int oldPos=1,tempPos=0;
	char lastc,c;
	Vector temp=new Vector();
	Vector temp1=new Vector();
	int sz=value.length();

	if(sz==0){
	    erreurString="\nline "+ currentline +" : SyntaxError 01 in parsing dash " + value;
	    syntaxError=true;
	    return null;
	}
	
	//System.out.println("STOOOOOOOOOOOOOOOOOOOOPP "+value);
	if(value.charAt(tempPos)!='{'){
	    erreurString="\nline "+ currentline +" : SyntaxError 02 in parsing dash " + value;
	    syntaxError=true;
	    return null;
	}
	tempPos++;
	lastc='{';
	while(tempPos<sz && (c=value.charAt(tempPos))!='}'){
	    if(c==' '){
		if(lastc!=' ' && lastc!='{'){
		    temp.add(value.substring(oldPos,tempPos));
		    //System.out.println("*"+value.substring(oldPos,tempPos)+"*");
		}
		oldPos=tempPos+1;
	    }
	    tempPos++;
	    lastc=c;
	}
	if (tempPos==sz) {
	    erreurString="\nline "+ currentline +" : SyntaxError 03 in parsing dash " + value;
	    syntaxError=true;
	    return null;
	} else {
	    if(lastc!=' ' && lastc!='{'){
		temp.add(value.substring(oldPos,tempPos));
		//System.out.println("*"+value.substring(oldPos,tempPos)+"*");
	    }
	}

	// second list
	tempPos++;
	oldPos=tempPos+1;

	if(tempPos==sz){
	    erreurString="\nline "+ currentline +" : SyntaxError 04 in parsing dash " + value;
	    syntaxError=true;
	    return null;
	}
	if(value.charAt(tempPos)!='{'){
	    temp1.add(value.substring(oldPos-1));
	    //System.out.println("*"+value.substring(oldPos-1)+"*");
	} else {
	    tempPos++;
	    lastc='{';
	    while(tempPos<sz && (c=value.charAt(tempPos))!='}'){
		if(c==' '){
		    if(lastc!=' ' && lastc!='{'){
			temp1.add(value.substring(oldPos,tempPos));
			//System.out.println("*"+value.substring(oldPos,tempPos)+"*");
		    }
		    oldPos=tempPos+1;
		}
		tempPos++;
		lastc=c;
	    }
	    if (tempPos==sz) {
		erreurString="\nline "+ currentline +" : SyntaxError 05 in parsing dash " + value;
		syntaxError=true;
		return null;
	    } else {
		if(lastc!=' '){
		    temp1.add(value.substring(oldPos,tempPos));
		    //System.out.println("*"+value.substring(oldPos,tempPos)+"*");
		}
	    }

	    if (tempPos+1!=sz) {
		erreurString="\nline "+ currentline +" : SyntaxError 06 in parsing dash " + value;
		syntaxError=true;
		return null;
	    }
	}

	OptionVal optval=new OptionVal(temp,temp1);
	if(optval.initiateArray()){
	    erreurString="\nline "+ currentline +" : SyntaxError in parsing dash float " + value;
	    syntaxError=true;
	    return null;
	}
	return optval;	
    }

    public boolean isErrorDetected(){
	if (syntaxError) {
	    //System.out.println(erreurString);
	    return true;
	}
	return false;
    }

    public int combinaisonMark(String val){
	int len=val.length();
	//    1 : initial mark on nodes
	//    2 : final mark on nodes
	//    4 : repeated mark on nodes
	//    0 : no mark on nodes
	char c;
	int finalvalue=0;
	int already=0;
	for (int i=0;i<len;i++){
	    c=val.charAt(i);
	    switch(c){
	    case 'n':
		if((already & 8)!=8){
		    finalvalue|=0;
		    already |= 8;
		}
		break;
	    case 'i':
		if((already & 1)!=1){
		    finalvalue|=1;
		    already |= 1;
		}
		break;
	    case 'f':
		if((already & 2)!=2){
		    finalvalue|=2;
		    already |= 2;
		}
		break;
	    case 'r':
		if((already & 4)!=4){
		    finalvalue|=4;
		    already |= 4;
		}
		break;
	    default:
		erreurString+="\nline "+ currentline +" : SyntaxError in " + val + " Illegal character "+ c +": Expected Combinaison of i,f,r,n";
		syntaxError=true;
		return -1;
	    }
	}
	return finalvalue;
    }



    public int combinaisonWHN(String val){
	int len=val.length();
	//    1 : initial mark on nodes
	//    2 : final mark on nodes
	//    4 : repeated mark on nodes
	//    0 : no mark on nodes
	char c;
	int finalvalue=0;
	int already=0;
	for (int i=0;i<len;i++){
	    c=val.charAt(i);
	    switch(c){
	    case 'n':
		if((already & 4)!=4){
		    finalvalue|=0;
		    already |= 4;
		}
		break;
	    case 'w':
		if((already & 1)!=1){
		    finalvalue|=1;
		    already |= 1;
		}
		break;
	    case 'h':
		if((already & 2)!=2){
		    finalvalue|=2;
		    already |= 2;
		}
		break;
	    default:
		erreurString+="\nline "+ currentline +" : SyntaxError in " + val + " Illegal character "+ c +": Expected Combinaison of w,h,n";
		syntaxError=true;
		return -1;
	    }
	}
	return finalvalue;
    }
    


    public OptionVal[] makeVectorParamIni(){
	OptionVal[] temp=new OptionVal[nbOptionP];
	//modifyOptionalParams(e,"Nw","dsg");
	for(int i=0;i< nbOptionP;i++) temp[i]=new OptionVal(); // initialisation
	return temp;
    }

    public int modifyOptionalParams(OptionVal[] v,String cle,String value){
	if(!_COMMIT_)
	    System.out.print("Setting optional options : " + cle + " ... ");
	int index=getIndexGasParameter(cle);
	double val=0;
	int integerVal=0;
	boolean bval=false;
	OptionVal optval=null;

	if (isErrorDetected()) { return -1; }
	switch(index){
	case 0:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 1:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 2:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 3:
	    integerVal= combinaisonWHN(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(integerVal);
	    break;
	case 4:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break; 
	case 5:
	    if(value.equals("y")) {
		bval=true;
	    } else if (value.equals("n")) {
		bval=false;
	    } else {
		erreurString+="\nSyntaxError near " + value+ " : Expected y or n";
		syntaxError=true;
		return -1 ;
	    }
	    v[index]=new OptionVal(bval);
	    break;
	case 6:
	    if(value.equals("y")) {
		bval=true;
	    } else if (value.equals("n")) {
		bval=false;
	    } else {
		erreurString+="\nSyntaxError near " + value+ " : Expected y or n";
		syntaxError=true;
		return  -1;
	    }
	    v[index]=new OptionVal(bval);
	    break;
	case 7:
	    if(value.equals("y")) {
		bval=true;
	    } else if (value.equals("n")) {
		bval=false;
	    } else {
		erreurString+="\nSyntaxError near " + value+ " : Expected y or n";
		syntaxError=true;
		return -1 ;
	    }
	    v[index]=new OptionVal(bval);
	    break;
	case 8:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 9:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 10:
	    integerVal= combinaisonMark(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(integerVal);
	    break;
	case 11:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 12:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 13:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 14:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 15:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 16:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 17:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 18:
	    if(value.equals("y")) {
		bval=true;
	    } else if (value.equals("n")) {
		bval=false;
	    } else {
		erreurString+="\nSyntaxError near " + value+ " : Expected y or n";
		syntaxError=true;
		return  -1;
	    } 
	    v[index]=new OptionVal(bval);
	    break;
	case 19:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 20:
	    integerVal= getNumber2(value);
	    if (isErrorDetected()) { return -1; }
	    if (integerVal<0){
		erreurString+="\nSyntaxError near " + value+ " : Expected positive integer";
		syntaxError=true;
		return -1 ;
	    }
	    v[index]=new OptionVal(integerVal);
	    break;
	case 21:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 22:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 23:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 24:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 25:
	    int rval;
	    if(value.equals("l")) {
		rval=0;
	    } else if (value.equals("r")) {
		rval=1;
	    } else {
		erreurString+="\nSyntaxError near " + value+ " : Expected l or r";
		syntaxError=true;
		return -1 ;
	    }
	    v[index]=new OptionVal(rval);
	    break;
	case 26:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    if (val<0 || val >100){
		erreurString+="\nSyntaxError near " + value+ " : Expected value between 0..100";
		syntaxError=true;
		return  -1;
	    }
	    v[index]=new OptionVal(val);
	    break;
	case 27:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 28:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    if (val<0 || val >1){
		erreurString+="\nSyntaxError near " + value+ " : Expected value between 0..1";
		syntaxError=true;
		return -1 ;
	    }
	    v[index]=new OptionVal(val);
	    break;
	case 29:
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    if (val<0 || val >1){
		erreurString+="\nSyntaxError near " + value+ " : Expected value between 0..1";
		syntaxError=true;
		return -1;
	    }
	    v[index]=new OptionVal(val);
	    break;
	case 30:
	    //linecolor=ColorName
	    v[index]=new OptionVal(value);
	    break;
	case 31:
	    //fillColor=ColorName
	    v[index]=new OptionVal(value);
	    break;
	case 32:
	    //linewidth=number
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 33:
	    //dash
	    if ((optval=parseDash(value))==null) { return -1; }
	    v[index]=optval;
	    break;
	case 34:
	    //sxo
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 35:
	    //syo
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);	    
	    break;
	case 36:
	    //exo
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 37:
	    //eyo
	    val= getNumber(value);
	    if (isErrorDetected()) { return -1; }
	    v[index]=new OptionVal(val);
	    break;
	case 38:
	    // ELdistC
	    if(value.equals("y")) {
		bval=true;
	    } else if (value.equals("n")) {
		bval=false;
	    } else {
		erreurString+="\nSyntaxError near " + value+ " : Expected y or n";
		syntaxError=true;
		return  -1;
	    } 
	    v[index]=new OptionVal(bval);
	    break;
	}
	if(!_COMMIT_)
	    System.out.println(" Success");
	return index;


    }
    // ***************************************






    // *** GASSET PROPERTY
    public void modifyProp(String cle,String value){
	if(!_COMMIT_)
	    System.out.print("Gasset ");
	int index;
	if ((index=modifyOptionalParams(ggpOpt,cle,value))==-1) return; // ereur detecter
	switch(index){
	case 0:
	    ggp.pNw=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 1:
	    ggp.pNh=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 2:
	    ggp.pNmr=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 3:
	    ggp.pNadjust=ggpOpt[index].oi;
	    break;
	case 4:
	    ggp.pNadjustdist=ggp.unitLength2Internal(ggpOpt[index].od);
	    break; 
	case 5:
	    ggp.pNframe=ggpOpt[index].ob;	   
	    break;
	case 6:
	    ggp.pNfill=ggpOpt[index].ob;
	    break;
	case 7:
	    ggp.pExtNL=ggpOpt[index].ob;
	    break;
	case 8:
	    ggp.pNLangle=Math.toRadians(ggpOpt[index].od);
	    break;
	case 9:
	    ggp.pNLdist=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 10:
	    ggp.pNmarks=ggpOpt[index].oi;
	    break;
	case 11:
	    ggp.pilength=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 12:
	    ggp.piangle=Math.toRadians(ggpOpt[index].od);
	    break;
	case 13:
	    ggp.pflength=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 14:
	    ggp.pfangle=Math.toRadians(ggpOpt[index].od);
	    break;
	case 15:
	    ggp.prdist=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 16:
	    ggp.ploopdiam=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 17:
	    ggp.ploopangle=Math.toRadians(ggpOpt[index].od);
	    break;
	case 18:
	    ggp.ploopCW=ggpOpt[index].ob;
	    break;
	case 19:
	    ggp.pcurvedepth=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 20:
	    ggp.pAHnb=ggpOpt[index].oi;
	    break;
	case 21:
	    ggp.pAHdist=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 22:
	    ggp.pAHangle=Math.toRadians(ggpOpt[index].od);
	    break;
	case 23:
	    ggp.pAHLength=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 24:
	    ggp.pAHlength=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 25:
	    ggp.pELside=ggpOpt[index].oi;
	    break;
	case 26:
	    ggp.pELpos=ggpOpt[index].od;
	    break;
	case 27:
	    ggp.pELdist=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 28:
	    ggp.plinegray=ggpOpt[index].od;
	    break;
	case 29:
	    ggp.pfillgray=ggpOpt[index].od;
	    ggp.pNfill=true;
	    break;
	case 30:
	    ggp.plinecolor=ggpOpt[index].otxt;
	    break;
	case 31:
	    ggp.pfillcolor=ggpOpt[index].otxt;
	    ggp.pNfill=true;
	    break;
	case 32:
	    ggp.plinewidth=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 33:
	    ggp.setpdash_length(ggpOpt[index].oflist); //ggp.pdash_length=
	    ggp.setpdash_empty(ggpOpt[index].of); //ggp.pdash_empty=
	    break;
	case 34:
	    ggp.psxo=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 35:
	    ggp.psyo=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 36:
	    ggp.pexo=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 37:
	    ggp.peyo=ggp.unitLength2Internal(ggpOpt[index].od);
	    break;
	case 38:
	    ggp.pELdistC=ggpOpt[index].ob;
	    break;  
	default:
	    // parameter not in gasset
	    erreurString+="\nline "+ (currentline-1) +" : SyntaxError unknown parameter "+ cle;
	    syntaxError=true;
	    break;

	}
    }
    // *** END GASSET PROPERTY

    // *** PARSING routine





    private boolean comment(){
	char nextC;
	do {
	    nextC=gastexCode.charAt(currentGlobalPosition);
	    currentGlobalPosition++;
	} while (nextC!='\n' &&  currentGlobalPosition<gastexCodeSize);
	if(nextC=='\n') currentline++;
	return true;
    }

    public boolean isAlphaNumerique(char c){
	if ((c>='a' && c<='z') || (c>='A' && c<='Z') || (c>='0' && c<='9')) return true;
	return false;
    }

    public boolean isSpace(char c){
	if (c==' ' || c=='\n' || c=='\t') return true;
	return false;
    }

    public boolean isSeparator(char c){
	if (c=='{' || c=='[' || c=='(' || c==',' || c=='=') return true;
	return false;
    }

    
    private boolean action(){
	// \action
	currentGlobalPosition--;
	stockPosition();
	currentGlobalPosition++;
	char nextC;
	String buf="";
	boolean isNotSimpleAction=true;
	nextC=gastexCode.charAt(currentGlobalPosition);
	if(!isAlphaNumerique(nextC)){
	    // no erraor anymore just escape character
	    bufferStack.add(nextC+"");
	    currentGlobalPosition++;
	    //erreurString+="\nParsing Error line "+currentline+" : no action";
	    //syntaxError=true;
	    return false;
	}
	currentGlobalPosition++;
	do {
	    buf+=nextC;
	    nextC=gastexCode.charAt(currentGlobalPosition);
	    currentGlobalPosition++;
	} while ( isAlphaNumerique(nextC) &&  currentGlobalPosition<gastexCodeSize);
	if (currentGlobalPosition==gastexCodeSize) {
	    erreurString+="\nParsing Error line "+currentline+" : Unexpected EOF";
	    syntaxError=true;
	    return false;
	}
	//nextC=gastexCode.charAt(currentGlobalPosition);

	// COMMENTED for single action
	if(!isSeparator(nextC)){
	//    erreurString+="\nParsing Error line "+currentline+" : Expected after action [ or {";
	//    syntaxError=true;
	//    return false;
	    isNotSimpleAction=false;
	}

	bufferStack.add(buf);
	//System.out.println("action : "+ buf);
	currentGlobalPosition--;
	return isNotSimpleAction;
    }

    public void stockPosition(){
	erreurStack.add(currentGlobalPosition+"");
    }

    private boolean block(char c){
	// error detecting ...
	//stockPosition();

	int ending=1;
	String buf="";
	char nextC;
	nextC=c;
	do {
	    buf+=nextC;
	    nextC=gastexCode.charAt(currentGlobalPosition);
	    currentGlobalPosition++;
	    if(nextC==c) ending++;
	    if(c=='(' && nextC==')') ending--;
	    if(c=='{' && nextC=='}') ending--;
	    if(c=='[' && nextC==']') ending--;
	    if(c=='=' && isSpace(nextC)) ending--;
	    if(nextC=='\n') currentline++;
	} while (ending!=0 &&  currentGlobalPosition<gastexCodeSize);

	if (currentGlobalPosition==gastexCodeSize && ending!=0) {
	    erreurString+="\nParsing Error 987 line "+currentline+" : Unexpected EOF";
	    syntaxError=true;
	    return false;
	}
	if(c=='=') System.out.println(buf);
	bufferStack.add(buf);
	//	System.out.println("block $"+currentline+" : "+ buf);
	return true;

    }


    public int getNextBlock(){
	char nextC;
	boolean spaceallowed=true;
	actionsequence=new String("");
	bufferStack.clear();
	boolean possibleEndingSequence=false;
	boolean actionstarted=false;
        int startB=1;


	while(currentGlobalPosition<gastexCodeSize){
	    nextC=gastexCode.charAt(currentGlobalPosition);
	    currentGlobalPosition++;
	    switch(nextC) {
	    case '%':
		comment();  // dropping comments
		break;
	    case '\n':
		currentline++;  // counting line
		if(actionstarted){
		    possibleEndingSequence=true;
		    actionstarted=false;
		}
		break;
	    case '\\':
		
		if(actionsequence.equals("")){
		    startingCarret[0]=currentGlobalPosition-1;
		    if(!action()){
			// 2 possible case
			// first , an error occured
			if(bufferStack.size()==0) return -1;
			// simple action
			//endingCarret[0]=currentGlobalPosition;
			return bufferStack.size();
		    }
		    spaceallowed=false;
		    actionstarted=true;
		    // paring detection
		    //stockPosition();
		    // action carret
		    
		} else {
		    currentGlobalPosition--;
		    endingCarret[0]=currentGlobalPosition;
		    return bufferStack.size();
		}		
		break;
	    case '(':
		if(!actionstarted){
		    // bypass now

		    //erreurString+="\nSyntax Error : Unexpected ( "+currentline;
		    //syntaxError=true;
		    //setHighlight(currentGlobalPosition-1,currentGlobalPosition);
		    //return -1;
		} else {
		if(!block('(')){return -1;}
		if(possibleEndingSequence){
		    erreurString+="\nSyntax Error : Space not allowed line "+currentline;
		    syntaxError=true;
		    return -1;
		}
		actionsequence+="(";
		}
		break;
	    case '[':
		if(!actionstarted){
		    // bypass now
		    //erreurString+="\nSyntax Error : Unexpected [ "+currentline;
		    //syntaxError=true;
		    //setHighlight(currentGlobalPosition-1,currentGlobalPosition);
		    //return -1;
		} else {
		if(!block('[')){return -1;}
		if(possibleEndingSequence){
		    erreurString+="\nSyntax Error : Space not allowed line "+currentline;
		    syntaxError=true;
		    return -1;
		}
		actionsequence+="[";
		}
		break;
	    case '{':
		if(!actionstarted){
		    //--
		    //erreurString+="\nSyntax Error : Unexpected { "+currentline;
		    //syntaxError=true;
		    //return -1;
		    // parse this block...
		    if(possibleEndingSequence){
			currentGlobalPosition--;
			return bufferStack.size();
		    }
		    //stockPosition();
		    if(!block('{')){return -1;}
		    if(!_COMMIT_)
			System.out.println("Yopyop"+bufferStack.elementAt(0));
		    return bufferStack.size();
		}
		if(!block('{')){return -1;}
		if(possibleEndingSequence){
		    erreurString+="\nSyntax Error : Space not allowed line "+currentline;
		    syntaxError=true;
		    return -1;
		}
		actionsequence+="{";
		break;
	    case '=':
		if(actionstarted){
		    // testing block unitlength
		    if(!block('=')){return -1;}
		    possibleEndingSequence=true;
		    actionsequence+="=";
		    actionstarted=false;
		}
		break;
	    default:
		if(!spaceallowed){
		    //if(isSpace(nextC)){ // REMOVED for LATEXCOMP
		    if(nextC!='}' && nextC!=')' && nextC!=']'){
			possibleEndingSequence=(!possibleEndingSequence)?true:false;
			actionstarted=false;
		    } else {
			erreurString+="\nSyntax Error : Unexpected char '"+nextC+"'line : "+currentline;
			syntaxError=true;
			setHighlight();
			return -1;
		    }
		} //else {
		//  erreurString+="\nSyntax Error : Space not allowed line "+currentline;
		//    syntaxError=true;
		//    return -1;
		//}
		break;
	    }
	}
	if(bufferStack.size()!=0) {
	    endingCarret[0]=currentGlobalPosition;
	    return bufferStack.size();
	}
	return -1;
    }


    public void droppingHeader(){
	// no use
	return;
    }



    public int chopParameter(String par){
	String bufferedTemp="";
	// separate , and =
	int pos=0;
	char c;
	int taille=par.length();
	boolean waiting2ndpar=false;
	boolean waitingPar=false;
	int level=0;
	String dashExpr=new String();

	while(pos<taille){
	    c=par.charAt(pos);
	    if(isSpace(c) && !waiting2ndpar && bufferedTemp.equals("")){
		//System.out.println("merdee");
		pos++;
	    } else if(isSpace(c)){
		 erreurString+="\nline "+(currentline-1)+" SyntaxError space is only allowed after a comma ";
		 syntaxError=true;
		 return -1;
	    } else {
		pos++;
		switch(c){
		case '=':
		    if(bufferedTemp.equals("") || waiting2ndpar){
			erreurString+="\nline "+(currentline-1)+" SyntaxError lvalue expected";
			syntaxError=true;
			return -1;
		    } else {
			bufferStack2.add(bufferedTemp);
			//System.out.println("Key : " + bufferedTemp +"$$$");
			waiting2ndpar=true;
			bufferedTemp="";
			// delete space
			while (pos<taille && isSpace(par.charAt(pos))) pos++;
			//
			break;
		    }
		case ',':
		    if(bufferedTemp.equals("") || !waiting2ndpar){
			erreurString+="\nline "+(currentline-1)+" SyntaxError lvalue expected";
			syntaxError=true;
			return -1;
		    } else {
			bufferStack2.add(bufferedTemp);
			//System.out.println("Val : " + bufferedTemp +"$$$");
			waiting2ndpar=false;
			waitingPar=true;
			bufferedTemp="";
			break;
		    }
		case '{':
		    // for dash option
		    level++;
		    if(level<3){
			//c=par.charAt(pos);
			while(pos<taille && (c=par.charAt(pos))!='}'){
			    // fill the temp buffer
			    dashExpr+=c;
			    pos++;
			}
			if(pos==taille){
			    // Error occured
			    erreurString+="\nline "+(currentline-1)+" SyntaxError in lvalue } expected "+dashExpr;
			    syntaxError=true;
			    return -1;
			}
			// if passed continue ...
			bufferedTemp+="{"+dashExpr+"}";
			dashExpr="";
			//System.out.println(bufferedTemp);
			pos++;
		    } else {
			// error occured
			erreurString+="\nline "+(currentline-1)+" SyntaxError in lvalue ";
			syntaxError=true;
			return -1;
		    }
		    break;
		default:
		    bufferedTemp+=c;
		}
	    }
	}
	if(bufferedTemp.length()!=0 && waiting2ndpar) {
	    bufferStack2.add(bufferedTemp);
	    //System.out.println("Val : " + bufferedTemp +"$$$");
	    waiting2ndpar=false;
	    waitingPar=false;
	}
	
	if(waiting2ndpar || waitingPar) {
	    erreurString+="\nline "+(currentline-1)+" SyntaxError lvalue expected";
	    syntaxError=true;
	    return -1;
	}
	return bufferStack2.size()/2;
    }


    public int chopEl(String par){
	String bufferedTemp="";
	// separate ,
	int pos=0;
	char c;
	int taille=par.length();
	boolean waiting2ndpar=false;
	while(pos<taille){
	    c=par.charAt(pos);
	    if(isSpace(c)  && bufferedTemp.equals("")){
		//System.out.println("merdee");
		pos++;
	    } else if(isSpace(c)){
		 erreurString+="\nline"+(currentline-1)+" SyntaxError space is only allowed after a comma ";
		 syntaxError=true;
		 return -1;
	    } else {
		pos++;
		switch(c){
		case ',':
		    if(bufferedTemp.equals("")){
			erreurString+="\nline"+(currentline-1)+" SyntaxError parameter expected";
			syntaxError=true;
			return -1;
		    } else {
			bufferStack2.add(bufferedTemp);
			//System.out.println("Val : " + bufferedTemp +"$$$");
			bufferedTemp="";
			waiting2ndpar=true;
			break;
		    }
		default:
		    bufferedTemp+=c;
		}
	    }
	}
	if(bufferedTemp.length()!=0) {
	    bufferStack2.add(bufferedTemp);
	    //System.out.println("Val : " + bufferedTemp +"$$$");
	    waiting2ndpar=false;
	}
	
	if(waiting2ndpar) {
	    erreurString+="\nline"+(currentline-1)+" SyntaxError lvalue expected";
	    syntaxError=true;
	    return -1;
	}
	return bufferStack2.size();
    }









    // *** END PARSING ROUTINE





    public boolean parse(){
	droppingHeader();
	if(isErrorDetected()){
	    System.out.println(erreurString); 
	    showMessageBox();
	    return false;
	}
	int nnn;
	while((nnn=getNextBlock())!=-1){
	    if(isErrorDetected()) {
		System.out.println(erreurString);
		showMessageBox();
		return false;
	    }
	    if(!parsingAction()) { 
		System.out.println(erreurString);
		showMessageBox();
		return false;
	    }
	}
	// last verif
	if(isErrorDetected()){
	    System.out.println(erreurString); 
	    showMessageBox();
	    return false;
	}
	return true;
    }

    public void showMessageBox(){
	int start=0;
	if(erreurStack.size()!=0){
	    try {
		start=Integer.parseInt((String) erreurStack.lastElement());
	    }catch (NumberFormatException e) {start=0;}
	}
	System.out.println(start+" "+currentGlobalPosition);
	String eR=gastexCode.substring(start,currentGlobalPosition);
	MessageBox mb = 
	    new MessageBox("Parsing Error", eR+erreurString, 0);
    }

    public void parseUnkwowAction(){
	int sz=bufferStack.size();
	String blockToParse;
	for(int i=0;i<sz;i++){
	    blockToParse=(String)bufferStack.elementAt(i);
	    if(blockToParse.charAt(0)=='{'){
		blockToParse=blockToParse.substring(1);
		// parsing this block....
		// TODO
		if(!_COMMIT_)
		    System.out.println("Parsing Block ... "+blockToParse);
		
		JasParser2 jparseb=new JasParserBlock(blockToParse,ggp,offx,offy,
						      w,h,vectorOfNode,nodeNameVector,
						      pictureStarted);
		// jparseb.pictureStarted=pictureStarted;
		jparseb._COMMIT_=_COMMIT_;
		jparseb.manager=manager;
		if(!jparseb.parse()) {
		    syntaxError=true;
		    return;
		}
		// ....
	    }
	}
	return;
    }



    public boolean parsingAction(){
	String action,buf1,buf2,buf3,nodename,nodelabel,edgelabel;
	OptionVal[] toption;
	int taille;

	Node node,node1,node2;
	IFMark ifm;
	RMark rm;
	Edge edge;
	Loop loop;
	BezierQuadCurve quadCurve;
	BezierCubicCurve cubicCurve;
	NodeLabel nodel;
	EdgeLabel edgel;
	ExtendedQuad exQuad;
	ExtendedCubic exCubic;
	ExtendedEdge exEdge;
	InvisibleNode invN1,invN2;
	Circle circle;
	Oval oval;
	JasRectangle jasrectangle;
	int strl;

	String nstr1,nstr2;
	double x,y;
	double sa,sr,ea,er;
	double x0,y0,x1,y1,x2,y2,x3,y3,radius;

	action=(String) bufferStack.firstElement();
	bufferStack.removeElementAt(0);
	int index=getIndexGasAction(action);  // get the action index
	if(isErrorDetected()) return false; // id errors occured

	if(actual_ggp==null && index>1 && index<19) {
	    // no actual ggp AND the action is not gasset
	    actual_ggp=new GastexGlobalProperties(ggp);
	    if(_COMMIT_){ 
		// adding to manager the new ggp
		addPropGGP();
	    } else {
		System.out.println("Create new ggp");
	    }
	}

	if(index>1 && index<19 && !pictureStarted){
	    // bypass (outside a \begin{picture} corps)
	    return true;
	}

	switch(index){
	case -1:
	    // unknow action has been parsed
	    parseUnkwowAction();
	    if(isErrorDetected()) return false;
	    break;

	case 0:
	    // unitlength
	    //System.out.println("SettingUnitLength");
	    if (!(actionsequence.equals("="))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for unitlength";
		syntaxError=true;
		return false;
	    }
	    buf1=(String) bufferStack.firstElement();
	   
	    // parsing mm/in
	    strl=buf1.length();
	    if(strl<4){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect Value for unitlength";
		syntaxError=true;
		return false;
	    }

	    //buf1.substring(1);
	    //strl--;

	    try {
		x=Double.parseDouble(buf1.substring(1,strl-2));
	    } catch (NumberFormatException e) {
		erreurString+="\nline "+(currentline-2)+" SyntaxError: Incorrect Value for unitlength : "+buf1.substring(1,strl-1);
		syntaxError=true;
		return false;
	    }
	    ggp.setUnitLength(x);
	    nstr1=buf1.substring(strl-2);
	    if(!nstr1.equals("mm") && !nstr1.equals("in")) {
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect Unit "+buf1.substring(strl-2);
		syntaxError=true;
		return false;
	    }
	    ggp.setUnitName(nstr1);
	    actual_ggp=null;
	    break;

	case 1:
	    // gasset signature {
	    if (!(actionsequence.equals("{"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for gasset";
		syntaxError=true;
		return false;
	    }
	    buf1=(String) bufferStack.firstElement();
	    chopParameter(buf1.substring(1));
	    if(isErrorDetected()) return false;
	    while(bufferStack2.size()!=0){
		buf2=(String) bufferStack2.firstElement();
		bufferStack2.removeElementAt(0);
		buf3=(String) bufferStack2.firstElement();
		bufferStack2.removeElementAt(0);
		modifyProp(buf2,buf3);
		if(isErrorDetected()) return false;
	    }
	    bufferStack2.clear();
	    //gassetIsLastAction=true;
	    actual_ggp=null;
	    break;

	case 2:
	    // node
	    toption=null;
	    if (!(actionsequence.equals("(({") || actionsequence.equals("[(({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		setHighlight(0);
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[(({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // ** end setting
	    buf1=(String) bufferStack.firstElement();
	    nodename=buf1.substring(1);
	    if(addNodeName(nodename)) return false;

	    bufferStack.removeElementAt(0);
	    paramIni("dd");
	    if(isErrorDetected()) return false;
	    x=((OptionVal)bufferStack3.elementAt(0)).od;
	    y=((OptionVal)bufferStack3.elementAt(1)).od;
	   
	    buf1=(String) bufferStack.firstElement();
	    nodelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);

	    // ready to create the node
	    if(_COMMIT_){
		//System.out.println((int)(x+offx) +" "+(int)(y+offy));
		manager.addObject(node=new Node(actual_ggp,
						toption,nodename,
						x+offx,
						-y+offy,nodelabel));
		vectorOfNode.add(node);
		// flush is made in ObjetManager during addObject
	    } else {
		System.out.println("Creating node "+nodename+"("+x+","+y+","+nodelabel+") ... Success");
	    }
	    break;

	case 3:
	    // imark
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // ** end setting
	    buf1=(String) bufferStack.firstElement();
	    nodename=buf1.substring(1);
	    if(!isNodeNameExist2(nodename)) return false;

	    // ready to create the ifmark
	    if(_COMMIT_){
		node=getNode(nodename);
		ifm=new IFMark(actual_ggp,toption,node,true);
		node.addIFmark(ifm);
	    } else {
		System.out.println("Creating imark on node "+nodename+" ... Success");
	    }
	    break;

	case 4:
	    // fmark
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // ** end setting
	    buf1=(String) bufferStack.firstElement();
	    nodename=buf1.substring(1);
	    if(!isNodeNameExist2(nodename)) return false;

	    // ready to create the ifmark
	    if(_COMMIT_){
		node=getNode(nodename);
		ifm=new IFMark(actual_ggp,toption,node,false);
		node.addIFmark(ifm);
	    } else {
		System.out.println("Creating fmark on node "+nodename+" ... Success");
	    }
	    break;

	case 5:
	    // rmark
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // ** end setting
	    buf1=(String) bufferStack.firstElement();
	    nodename=buf1.substring(1);
	    if(!isNodeNameExist2(nodename)) return false;

	    // ready to create the ifmark
	    if(_COMMIT_){
		node=getNode(nodename);
		rm=new RMark(actual_ggp,toption,node);
		node.addRmark(rm);
	    } else {
		System.out.println("Creating rmark on node "+nodename+" ... Success");
	    }
	    break;

	case 6:
	    // node label
	    toption=null;
	    if (!(actionsequence.equals("({") || actionsequence.equals("[({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // ** end setting
	    buf1=(String) bufferStack.firstElement();
	    nodename=buf1.substring(1);
	    if(!isNodeNameExist2(nodename)) return false;
	    bufferStack.removeElementAt(0);
	    buf1=(String) bufferStack.firstElement();
	    nodelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);

	    // ready to create the node label
	    if(_COMMIT_){
		node=getNode(nodename);
		nodel=new NodeLabel(actual_ggp,toption,node,nodelabel);
		node.addLabel(nodel);
	    } else {
	    // uncomment the next line when parser is ready
	    // new Node(actual_ggp,x,y,toption);
		System.out.println("Creating node label on node : "
				   +nodename+" with string : "+
				   nodelabel+" ... Success");
	    }
	    break;

	case 7:
	    // draw edge
	    toption=null;
	    if (!(actionsequence.equals("({") || actionsequence.equals("[({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	   
	    // get the two node
	    paramIni("nn");
	    if(isErrorDetected()) return false;
	    nstr1=((OptionVal)bufferStack3.elementAt(0)).otxt;
	    nstr2=((OptionVal)bufferStack3.elementAt(1)).otxt;

	    if(!isNodeNameExist2(nstr1)) return false;
	    if(!isNodeNameExist2(nstr2)) return false;
	    // end getting node
	    // finding node str1,str2
	    //  --> TODO
	    // end finding node
	    buf1=(String) bufferStack.firstElement();
	    edgelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);

	    // ready to create Edge
	    if(_COMMIT_){
		node1=getNode(nstr1);
		node2=getNode(nstr2);
		edge=new Edge(actual_ggp,toption,node1,node2,edgelabel);
		manager.addObject(edge);		
		manager.updateEdge(edge);
	    } else {
		System.out.println("Creating Edge from "+ nstr1+" to "+
				   nstr2+" with string : "+edgelabel+" ... Success");
	    }
	    break;

	case 8:
	    // drawqbedge
	    toption=null;
	    if (!(actionsequence.equals("({") || actionsequence.equals("[({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	   
	    // get the two node
	    paramIni("nddn");
	    if(isErrorDetected()) return false;
	    nstr1=((OptionVal)bufferStack3.elementAt(0)).otxt;
	    x=((OptionVal)bufferStack3.elementAt(1)).od;
	    y=((OptionVal)bufferStack3.elementAt(2)).od;
	    nstr2=((OptionVal)bufferStack3.elementAt(3)).otxt;
	    if(!isNodeNameExist2(nstr1)) return false;
	    if(!isNodeNameExist2(nstr2)) return false;
	    // end getting node
	    // finding node str1,str2
	    //  --> TODO
	    // end finding node
	    buf1=(String) bufferStack.firstElement();
	    edgelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);

	    // ready to create Edge
	    if(_COMMIT_){
		node1=getNode(nstr1);
		node2=getNode(nstr2);
		//pc=new Point2D.Double(x,y);
		quadCurve=new BezierQuadCurve(actual_ggp,toption,
					      node1,node2,x+offx,-y+offy,
					      edgelabel,false);
		manager.addObject(quadCurve);
		manager.updateEdge(quadCurve);
	    } else {
		System.out.println("Creating QuadEdge from "
				   + nstr1+" to "+nstr2+" with string : "
				   + edgelabel+" controlpoint("+x+","+y+") ... Success");
	    }
	    break;

	case 9:
	    // drawbpedge
	    toption=null;
	    if (!(actionsequence.equals("({") || actionsequence.equals("[({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	   
	    // get the two node
	    paramIni("nddndd");
	    if(isErrorDetected()) return false;
	    nstr1=((OptionVal)bufferStack3.elementAt(0)).otxt;
	    sa=((OptionVal)bufferStack3.elementAt(1)).od;
	    sr=((OptionVal)bufferStack3.elementAt(2)).od;
	    nstr2=((OptionVal)bufferStack3.elementAt(3)).otxt;
	    ea=((OptionVal)bufferStack3.elementAt(4)).od;
	    er=((OptionVal)bufferStack3.elementAt(5)).od;
	    if(!isNodeNameExist2(nstr1)) return false;
	    if(!isNodeNameExist2(nstr2)) return false;

	    // end getting node
	    // finding node str1,str2
	    //  --> TODO
	    // end finding node
	    buf1=(String) bufferStack.firstElement();
	    edgelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);

	    // ready to create Edge
	    if(_COMMIT_){
		node1=getNode(nstr1);
		node2=getNode(nstr2);
		//pc=new Point2D.Double(x,y);

		cubicCurve=new BezierCubicCurve(actual_ggp,toption,
						node1,-sa,sr,
						node2,-ea,er,
						edgelabel,true);
		manager.addObject(cubicCurve);
		manager.updateEdge(cubicCurve);
	    } else {
		System.out.println("Creating PolarBPEdge from "
				   + nstr1+" to "+nstr2+" with string : "
				   +edgelabel+" controlpoint("+sa+","+sr
				   +")("+ea+","+er+") ... Success");
	    }
	    break;

	case 10:
	    // drawbcedge
	    toption=null;
	    if (!(actionsequence.equals("({") || actionsequence.equals("[({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	   
	    // get the two node
	    paramIni("nddndd");
	    if(isErrorDetected()) return false;
	    nstr1=((OptionVal)bufferStack3.elementAt(0)).otxt;
	    sa=((OptionVal)bufferStack3.elementAt(1)).od;
	    sr=((OptionVal)bufferStack3.elementAt(2)).od;
	    nstr2=((OptionVal)bufferStack3.elementAt(3)).otxt;
	    ea=((OptionVal)bufferStack3.elementAt(4)).od;
	    er=((OptionVal)bufferStack3.elementAt(5)).od;
	    if(!isNodeNameExist2(nstr1)) return false;
	    if(!isNodeNameExist2(nstr2)) return false;

	    // end getting node
	    // finding node str1,str2
	    //  --> TODO
	    // end finding node
	    buf1=(String) bufferStack.firstElement();
	    edgelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);

	    // ready to create Edge
	    if(_COMMIT_){
		node1=getNode(nstr1);
		node2=getNode(nstr2);
		//pc=new Point2D.Double(x,y);
		cubicCurve=new BezierCubicCurve(actual_ggp,toption,
						node1,sa+offx,-sr+offy,
						node2,ea+offx,-er+offy,
						edgelabel,false);
		manager.addObject(cubicCurve);
		manager.updateEdge(cubicCurve);
	    } else {
		System.out.println("Creating CartesianBezierEdge from "
				   + nstr1+" to "+nstr2+" with string : "
				   +edgelabel+" controlpoint("+sa+","+sr
				   +")("+ea+","+er+") ... Success");
	    }
	    break;

	case 11:
	    // drawloop
	    toption=null;
	    if (!(actionsequence.equals("({") || actionsequence.equals("[({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options
	    buf1=(String) bufferStack.firstElement();
	    nodename=buf1.substring(1);
	    if(!isNodeNameExist2(nodename)) return false;

	    bufferStack.removeElementAt(0);
	    buf1=(String) bufferStack.firstElement();
	    edgelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);
	    if(_COMMIT_){
		node=getNode(nodename);
		loop=new Loop(actual_ggp,toption,node,edgelabel);
		manager.addObject(loop);
		manager.updateEdge(loop);
	    } else {
		System.out.println("Creating Loop on node : "+ 
				   nodename +" with string : "+edgelabel+" ... Success");
	    }
	    break;
	    
	case 12:
	    // drawcircle
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for drawqbezier";
		syntaxError=true;
		return false;
	    }
	    
	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	    
	    paramIni("ddd");
	    if(isErrorDetected()) return false;
	    x0=((OptionVal)bufferStack3.elementAt(0)).od;
	    y0=((OptionVal)bufferStack3.elementAt(1)).od;
	    radius=((OptionVal)bufferStack3.elementAt(2)).od;
	    
	    
	    // ready to create Edge
	    if(_COMMIT_){
		circle=new Circle(actual_ggp,toption,x0+offx,-y0+offy,radius);
		manager.addObject(circle);
	    } else {
		System.out.println("Drawing Circle ("
				   + x0 + ", "+y0+", "
				   + radius + ") ... Success");
	    }
	    break;

	case 13:
	    // drawrect
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for drawqbezier";
		syntaxError=true;
		return false;
	    }
	    
	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	    
	    paramIni("dddd");
	    if(isErrorDetected()) return false;
	    x0=((OptionVal)bufferStack3.elementAt(0)).od;
	    y0=((OptionVal)bufferStack3.elementAt(1)).od;
	    x1=((OptionVal)bufferStack3.elementAt(2)).od;
	    y1=((OptionVal)bufferStack3.elementAt(3)).od;
	    
	    // ready to create Edge
	    if(_COMMIT_){
		jasrectangle=new JasRectangle(actual_ggp,toption,x0+offx,
					      -y0+offy,x1+offx,-y1+offy);
		manager.addObject(jasrectangle);
	    } else {
		System.out.println("Drawing Rectangle ("
				   + x0 + ", "+y0+")("
				   + x1 + ", "+y1+") ... Success");
	    }   
	    break;

	case 14:
	    // drawoval
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for drawqbezier";
		syntaxError=true;
		return false;
	    }
	    
	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	    
	    paramIni("ddddd");
	    if(isErrorDetected()) return false;
	    x0=((OptionVal)bufferStack3.elementAt(0)).od;
	    y0=((OptionVal)bufferStack3.elementAt(1)).od;
	    x1=((OptionVal)bufferStack3.elementAt(2)).od;
	    y1=((OptionVal)bufferStack3.elementAt(3)).od;
	    radius=((OptionVal)bufferStack3.elementAt(4)).od;

	    // ready to create Edge
	    if(_COMMIT_){
		oval=new Oval(actual_ggp,toption,x0+offx,-y0+offy,x1,y1,radius);
		manager.addObject(oval);
	    } else {
		System.out.println("Drawing Oval ("
				   + x0 + ", "+y0+", "+
				   + x1 + ", "+y1+", "+radius+") ... Success");
	    } 
	    break;
	    
	case 15:
	    // drawline
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for drawqbezier";
		syntaxError=true;
		return false;
	    }
	    
	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	    
	    paramIni("dddd");
	    if(isErrorDetected()) return false;
	    x0=((OptionVal)bufferStack3.elementAt(0)).od;
	    y0=((OptionVal)bufferStack3.elementAt(1)).od;
	    x1=((OptionVal)bufferStack3.elementAt(2)).od;
	    y1=((OptionVal)bufferStack3.elementAt(3)).od;
	    
	    // ready to create Edge
	    if(_COMMIT_){
		invN1=new InvisibleNode(actual_ggp,x0+offx,-y0+offy);
		invN2=new InvisibleNode(actual_ggp,x1+offx,-y1+offy);
		exEdge=new ExtendedEdge(actual_ggp,toption,
					invN1,
					invN2);
		manager.addObject(exEdge);
	    } else {
		System.out.println("Creating ExtendedEdge from ("
				   + x0 + ", "+y0+") to ("
				   + x1 + ", "+y1+") ... Success");
	    }
	    break;

	case 16:
	    // drawqbezier
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for drawqbezier";
		syntaxError=true;
		return false;
	    }
	    
	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	    
	    paramIni("dddddd");
	    if(isErrorDetected()) return false;
	    x0=((OptionVal)bufferStack3.elementAt(0)).od;
	    y0=((OptionVal)bufferStack3.elementAt(1)).od;
	    x1=((OptionVal)bufferStack3.elementAt(2)).od;
	    y1=((OptionVal)bufferStack3.elementAt(3)).od;
	    x2=((OptionVal)bufferStack3.elementAt(4)).od;
	    y2=((OptionVal)bufferStack3.elementAt(5)).od;
	    
	    // ready to create Edge
	    if(_COMMIT_){
		invN1=new InvisibleNode(actual_ggp,x0+offx,-y0+offy);
		invN2=new InvisibleNode(actual_ggp,x2+offx,-y2+offy);
		exQuad=new ExtendedQuad(actual_ggp,toption,
					invN1,
					x1+offx,-y1+offy,
					invN2);
		manager.addObject(exQuad);
	    } else {
		System.out.println("Creating BezierQuadEx from ("
				   + x0 + ", "+y0+") to ("
				   + x2 + ", "+y2+") with controlpoint("
				   + x1 + ", "+y1+") ... Success");
	    }
	    break;

	case 17:
	    //drawcbezier
	    toption=null;
	    if (!(actionsequence.equals("(") || actionsequence.equals("[("))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for drawqbezier";
		syntaxError=true;
		return false;
	    }
	    
	    // setting optional parameters
	    if(actionsequence.equals("[(")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	    
	    paramIni("dddddddd");
	    if(isErrorDetected()) return false;
	    x0=((OptionVal)bufferStack3.elementAt(0)).od;
	    y0=((OptionVal)bufferStack3.elementAt(1)).od;
	    x1=((OptionVal)bufferStack3.elementAt(2)).od;
	    y1=((OptionVal)bufferStack3.elementAt(3)).od;
	    x2=((OptionVal)bufferStack3.elementAt(4)).od;
	    y2=((OptionVal)bufferStack3.elementAt(5)).od;
	    x3=((OptionVal)bufferStack3.elementAt(6)).od;
	    y3=((OptionVal)bufferStack3.elementAt(7)).od;
	    
	    // ready to create Edge
	    if(_COMMIT_){
		invN1=new InvisibleNode(actual_ggp,x0+offx,-y0+offy);
		invN2=new InvisibleNode(actual_ggp,x3+offx,-y3+offy);
		exCubic=new ExtendedCubic(actual_ggp,toption,
					  invN1,
					  x1+offx,-y1+offy,
					  x2+offx,-y2+offy,
					  invN2);
		manager.addObject(exCubic);
	    } else {
		System.out.println("Creating BezierCubicEx from ("
				   + x0 + ", "+y0+") to ("
				   + x3 + ", "+y3+") with controlpoint("
				   + x1 + ", "+y1+") && ("
				   + x2 + ", "+y2+") ... Success");
	    }
	    break;

	case 18:
	    // drawqbpedge
	    // POLAR
	    toption=null;
	    if (!(actionsequence.equals("({") || actionsequence.equals("[({"))){
		erreurString+="\nline "+(currentline-1)+" SyntaxError: Incorrect parameter for node";
		syntaxError=true;
		return false;
	    }

	    // setting optional parameters
	    if(actionsequence.equals("[({")){ 
		toption=optIni();
		if(isErrorDetected()) return false;
	    }
	    // end setting options

	   
	    // get the two node
	    paramIni("ndnd");
	    if(isErrorDetected()) return false;
	    nstr1=((OptionVal)bufferStack3.elementAt(0)).otxt;
	    x=((OptionVal)bufferStack3.elementAt(1)).od;
	    y=((OptionVal)bufferStack3.elementAt(3)).od;
	    nstr2=((OptionVal)bufferStack3.elementAt(2)).otxt;
	    if(!isNodeNameExist2(nstr1)) return false;
	    if(!isNodeNameExist2(nstr2)) return false;
	    // end getting node
	    // finding node str1,str2
	    //  --> TODO
	    // end finding node
	    buf1=(String) bufferStack.firstElement();
	    edgelabel=buf1.substring(1);
	    bufferStack.removeElementAt(0);

	    // ready to create Edge
	    if(_COMMIT_){
		node1=getNode(nstr1);
		node2=getNode(nstr2);
		//pc=new Point2D.Double(x,y);

		// TOCORRECT
		quadCurve=new BezierQuadCurve(actual_ggp,toption,
					      node1,node2,x,y,
					      edgelabel,true);
		// TO CORRECT
		manager.addObject(quadCurve);
		manager.updateEdge(quadCurve);
	    } else {
		System.out.println("Creating QuadEdge in Polar from "
				   + nstr1+" to "+nstr2+" with string : "
				   + edgelabel+" controlpoint("+x+","+y+") ... Success");
	    }
	    break;

	case 19:
	    // end
	    if (actionsequence.equals("{")){
		buf1=(String) bufferStack.firstElement();
		buf1=buf1.substring(1);
		if(buf1.equals("picture") && pictureStarted){
		    pictureStarted=false;
		    // no object have been created 
		    // or a gasset before an \end , we
		    // stilll have to create the actual
		    // ggp for manager.
		    if (actual_ggp==null){			
			if(_COMMIT_){ 
			    actual_ggp=new GastexGlobalProperties(ggp);
			    addPropGGP();
			} else {
			    System.out.println("Create new ggp");
			}
		    }
		}
	    }
	    return true;
	case 20:
	    // begin
	    String picture;
	    if (actionsequence.equals("{((")){
		// parsing the begin picture sequence
		// bufferStack.removeElementAt(0);
		buf1=(String) bufferStack.firstElement();
		picture=buf1.substring(1);
		if (picture.equals("picture")) {
		    if(pictureStarted){
			erreurString+="\nbegin{picture} Level Error";
			syntaxError=true;
			return false;
		    }
		    bufferStack.removeElementAt(0);
		    paramIni("dd");
		    if(isErrorDetected()) {
			erreurString+="\nSyntaxError near begin{picture}";
			syntaxError=true;
			return false;
		    }
			    
		    w=((OptionVal)bufferStack3.elementAt(0)).od;
		    h=((OptionVal)bufferStack3.elementAt(1)).od;			
		    
		    paramIni("dd");
		    if(isErrorDetected()) {
			erreurString+="\nSyntaxError near begin{picture}";
			syntaxError=true;
			return false;
		    }
		    offx=-((OptionVal)bufferStack3.elementAt(0)).od;
		    offy=h+((OptionVal)bufferStack3.elementAt(1)).od;
		    // before returning set the slide option
		    //if(slide) {
				// DEPORTED 
		    //}
		    //if(getNextBlock()==-1) break;
		    //return; 
		    if (ggpBeforeFirstBegin==null) {
			// default ggp for the document.
			ggpBeforeFirstBegin=new GastexGlobalProperties(ggp);
			if(_COMMIT_){
			    jpaneName=mw.getMDI().getDocumentTitle();
			    // Initial Gasset Prop
			    manager.resetProp();
			    if(slide) manager.setSlide(true);
			    manager.addProp(ggpBeforeFirstBegin);
			    //static int jpaneInc=1;
			    //setDocumentTitle
			}
		    } else {
			// not null begin{picture} >=2
			// reinitialising Node vector
			nodeNameVector=new Vector();
			vectorOfNode=new Vector();
			ggp=new GastexGlobalProperties(ggpBeforeFirstBegin);
			actual_ggp=null;
			if(_COMMIT_){
			    // create a new instance of SurfaceDessin
			    // and consequently a new manager
			    mw.addDocument();
			    //mw.getMDI().getLastCreated();
			    //manager=mw.getMDI().getJasTabbedPane().getDrawing().getManager();
			    manager=mw.getManager();
			    mw.getMDI().setDocumentTitle(jpaneName+"("+jpaneInc+")");
			    jpaneInc++;
			    if(slide) manager.setSlide(true);
			    // Initial Gasset Prop
			    manager.resetProp();
			    manager.addProp(ggpBeforeFirstBegin);
			}
		    }
		    //addPropGGP();
		    
		    pictureStarted=true;
		}
		// end parsing
	    }
	    break;
	case 21:
	    String slide1,slide2;
	    // "usepackage"
	    if (actionsequence.equals("[{")){
		//bufferStack.removeElementAt(0);
		buf1=(String) bufferStack.firstElement();
		buf2=(String) bufferStack.elementAt(1);
		slide1=buf1.substring(1);
		slide2=buf2.substring(1);
		if(slide1.equals("slide") && slide2.equals("gastex")){
		    slide=true;
		    System.out.print("Slide detected ,setting GGP ...");
		    bufferStack.clear();
		    bufferStack.add("gasset");
		    bufferStack.add("{Nw=12,Nh=12,Nmr=6,ilength=8,flength=8,rdist=1,loopdiam=12,linewidth=0.21,AHdist=2.1,AHLength=2.25,AHlength=2.1");
		    actionsequence="{";			    
		    if(!parsingAction()) { 
			erreurString+="\nError Fatal : internal error";
			syntaxError=true;
			return false;
		    }
		}		    
	    }
	    break;
	case 22:
	    // "compatiblegastexun"
	    System.out.println("compatiblegastexun block");
	    break;
	case 23:
	    // "compatiblepspictpg"
	    System.out.println("compatiblepspictpg block");
	    break;
	case 24:
	    break;

	case 50:
	    // parsing a block
	    // System.out.println("Block");
	    // buf1=(String) bufferStack.firstElement();
	    buf1=action.substring(1);
	    JasParser2 jparseb=new JasParserBlock(buf1,ggp,offx,offy,
						  w,h,vectorOfNode,nodeNameVector,
						  pictureStarted);
	    // jparseb.pictureStarted=pictureStarted;
	    jparseb._COMMIT_=_COMMIT_;
	    jparseb.manager=manager;
	    if(!jparseb.parse()) return false;
	    break;
	}



	return true;


    }


    public OptionVal[] optIni(){
	String buf1,buf2,buf3;
	OptionVal[] temp=makeVectorParamIni();
	
	buf1=(String) bufferStack.firstElement();
	chopParameter(buf1.substring(1));
	if(isErrorDetected()) return null;
	while(bufferStack2.size()!=0){
	    buf2=(String) bufferStack2.firstElement();
	    bufferStack2.removeElementAt(0);
	    buf3=(String) bufferStack2.firstElement();
	    bufferStack2.removeElementAt(0);
	    modifyOptionalParams(temp,buf2,buf3);
	    if(isErrorDetected()) return null;
	}
	bufferStack2.clear();
	bufferStack.removeElementAt(0);
	return temp;
    }

    public void paramIni(String sequence){
	// i for int
	// d for double
	// n for node
	int nbparam=sequence.length();
	String buf1,buf2;
	int count=0;
	char x;
	bufferStack3=new Vector();
	buf1=(String) bufferStack.firstElement();
	bufferStack.removeElementAt(0);
	chopEl(buf1.substring(1));
	if(isErrorDetected()) return;
	if(nbparam>bufferStack2.size()){
	    erreurString+="\nline "+(currentline-1)+" Error: Not enough parameters";
	    syntaxError=true;
	    return;
	}
	if(nbparam<bufferStack2.size()){
	    erreurString+="\nline "+(currentline-1)+" Error: Too much parameters";
	    syntaxError=true;
	    return;
	}

	double dvalue;
	String txt;


	// verify data type accumulated
	while(bufferStack2.size()!=0){
	    buf2=(String) bufferStack2.firstElement();
	    bufferStack2.removeElementAt(0);
	    x=sequence.charAt(count);
	    switch(x){
	    case 'i':
		// TODO if necessary 
		break;
	    case 'd':
		dvalue=getNumber(buf2);
		if(isErrorDetected()) return;
		bufferStack3.add(new OptionVal(dvalue));
		break;
	    case 'n':
		bufferStack3.add(new OptionVal(buf2));
		break;
	    }
	    count++;
	}

	// do not clear the bufferStack3
	bufferStack2.clear();
	return;
    }


    public void removeAllObject(SurfaceDessin sf){
	// remove the selection if there is.
	ObjetManager om=sf.getManager();
	JasObject comp;
	// removing all object
	sf.select=om.removeAreaSelected(sf.select);
	while (om.countObject()!=0){
	    comp=om.myObjectAt(0);
	    om.rmvDefinitivelyObject(comp);
	}
	return;
    }

    public void updateAllNode(){
	int sz=vectorOfNode.size();
	for(int i=0;i<sz;i++){
	    manager.updateVector((Node) (vectorOfNode.elementAt(i)));
	}
    }


    public void addPropGGP(){
	mw.getManager().addProp(actual_ggp);
    }
    
    /*   
    // * main *
    public static void main (String[] args) {
	String f;
	
        f=args[0];
	
	BufferedReader br = null;
	FileReader fr = null;
	try {
	    br = new BufferedReader(fr = new FileReader(f));
	} catch (FileNotFoundException e) {
	    System.out.println("Erreur");
	    return;
	}
	String text = "";
	String str = null;
	String ls = System.getProperty("line.separator");
	try {
	    while (null != (str = br.readLine())) {
		text = text + str + ls;
	    }
	    br.close();
	    fr.close();
	} catch (IOException e) {
	    try { br.close(); fr.close(); } catch (IOException ex) {}
	    return;
	}
	
	
	JasParser2 parse = new JasParser2(text);
	parse.parse();
    }
    */

}
