package jastex.parsing;

import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.io.StringReader;
import javax.swing.text.*;

import jastex.*;

import jastex.old.gui.*;



public class JasTabbedPane extends JTabbedPane implements ChangeListener,ActionListener {
    public JPanel pDrawingSurface;
    public JPanel pLatexCode;
    public JasTextPane latexCode;
    public JButton parseButton;
    public SurfaceDessin sDrawing;
    public boolean parsingError;
    public int currentTab;
    public MainWindow mw;
    public String lastLatexCode;
    public String modifiedLatexCode;
    public boolean replace;
    /** Store the current opened file name */
    private File currentFile;
    public boolean _NEWPARSER_=true;
    public parser p;

    public JasTabbedPane(MainWindow mainWindow) {
	pDrawingSurface = new JPanel(new BorderLayout());
	pLatexCode = new JPanel(new BorderLayout());
	latexCode = new JasTextPane();
	sDrawing = new SurfaceDessin();
	parseButton = new JButton("Parse");
	parseButton.setActionCommand("parse");
	parseButton.addActionListener(this);
//  	pDrawingSurface.setPreferredSize(new Dimension(800,600));

	JScrollPane sp1 = new JScrollPane (sDrawing,
			      JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
			      JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	JScrollPane sp2 = new JScrollPane (latexCode,
			      JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
			      JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

	pDrawingSurface.add(sp1, BorderLayout.CENTER);
	pLatexCode.add(sp2, BorderLayout.CENTER);
	if (Configuration.oldparsing){
	    pLatexCode.add(parseButton, BorderLayout.SOUTH);
	}
	// Need Some icons
	addTab(Languages.tp_tab_names[Languages.TP_TAB_DRAW], null, pDrawingSurface, Languages.tp_tab_tooltips[Languages.TP_TAB_DRAW]);
	addTab(Languages.tp_tab_names[Languages.TP_TAB_LATEX], null, pLatexCode, Languages.tp_tab_tooltips[Languages.TP_TAB_LATEX]);
	setSelectedIndex(0);
	
	addChangeListener(this);
	parsingError=false;
	currentTab = 0;
	mw = mainWindow;
	replace = true;
	lastLatexCode = "";
	currentFile = null;
		
    }

    public void setLatexCode(String s) {
	latexCode.setText(s);
    }


    public String getLatexCode() {
	if (isDrawingArea()) {
	if (sDrawing.isThereAnyObjects()) {
	    return generateLatexCode();
	} else {
	    return "";
	 }
	} else {
	    return latexCode.getText();
	} 
    }

    public String getLastLatexCode() {
	return lastLatexCode;
    }
    public void setLastLatexCode(String s) {
       lastLatexCode = s;
    }

    public void stateChanged(ChangeEvent e) {
	currentTab = this.getSelectedIndex();

	if (currentTab==1) { // && !parsingError) {
	    //here it latex window
	    if (replace) {
		if (sDrawing.isThereAnyObjects()) {
		    lastLatexCode = generateLatexCode();
		    setLatexCode(lastLatexCode);
		} else {
		    setLatexCode("");
		}
	    } else {
		setLatexCode(modifiedLatexCode);
	    }
	    mw.changeDrawingItemsState(false);
	} else {
	    modifiedLatexCode = latexCode.getText();
	    if (!lastLatexCode.equals(modifiedLatexCode)) {
		if (!Configuration.oldparsing){
		    if(!parseText(latexCode.getText())){
			
			setSelectedIndex(1);
			latexCode.setText(modifiedLatexCode);
			lastLatexCode = "";
			
		    } else { 
			mw.changeDrawingItemsState(true);
			replace = true;
		    }
		    
		} else {
		
		    MessageBox mb = 
			new MessageBox(Languages.mb_Question_TextChanged_Title,
				       Languages.mb_Question_TextChanged_Text, 1);
		    if (mb.reply == 2) {
			replace = false;
			setSelectedIndex(1);
		    } else {
			mw.changeDrawingItemsState(true);
			replace = true;
		    }
		
		}


	    } else {
		mw.changeDrawingItemsState(true);
		replace = true;
	    }
	} 
    }

    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if (cmd.equals("parse")) { // Button
	    parseText(latexCode.getText());
	}
    }

    public boolean parseText(String text) {
	if (!Configuration.oldparsing){
	    Yylex yy=new Yylex(new StringReader(latexCode.getText()));
	    p=new parser(yy);
	    p.setMainWindow(mw);
	    p.initialiseJP(sDrawing);
	     try {
		p.parse();
		} catch (Exception e) {
		    String err;
		    err=yy.geterr();
		    err+="line " +yy.getline() +" : "+e;
		    MessageBox mb = new MessageBox("Parsing Error", err, 0);
		    //latexCode.select(spos+carretOffset,epos+carretOffset);
		    //System.out.println("LineNr: " + textPane.getStyledDocument().getDefaultRootElement()
		    //	       .getElementIndex(textPane.getCaretPosition()));                             

		    latexCode.requestFocus();
		    return false;
		}
	     //int r=p.pTreeVector.size();
	     /*
	    System.out.println("NumberofPic "+p.pTreeVector.size());
	    for(int cre=0;cre<r;cre++){
		((parseTree)(p.pTreeVector.elementAt(cre))).createDoc(mw,(cre==0)?false:true);
	    }
	    lastLatexCode = text;
	    setSelectedIndex(0);
	     */

	    // Parsing OK
	    int r=p.pTreeVector.size();
	    if(r>1){
		// Asking comfirmation for multiple doc
		MessageBox mb = 
		    new MessageBox("Multiple picture - Confirmation",
				   "This code contains more than one picture section\nJasTeX is going to create a tab foreach picture.\nDo you want to continue?", 1);
		if (mb.reply == 2) {
		    
		    return false;
		}
		else {
		    for(int cre=0;cre<r;cre++){
			((parseTree)(p.pTreeVector.elementAt(cre))).createDoc(mw,(cre==0)?false:true);
		    }
		    lastLatexCode = text; // evite la deuxieme question.
		    // setSelectedIndex(0);
		}
	    } else {
		((parseTree)(p.pTreeVector.elementAt(0))).createDoc(mw,false);
		lastLatexCode = text; // evite la deuxieme question.
	    }
	    return true;

	} else {
	    JasParser2 jparse=new JasParser2(text,mw);
	    jparse.setJText(latexCode);
	    if (jparse.parse()){
		lastLatexCode = text;
		jparse.commit(sDrawing);
		setSelectedIndex(0);
	    }
	}
	return true;
    }

    public void applyParse(){
	int r=p.pTreeVector.size();
	//System.out.println("NumberofPic "+p.pTreeVector.size());
	for(int cre=0;cre<r;cre++){
	    ((parseTree)(p.pTreeVector.elementAt(cre))).createDoc(mw,(cre==0)?false:true);
	}
	//lastLatexCode = text;
	setSelectedIndex(0);
    }

    public SurfaceDessin getDrawing() {
	return sDrawing;
    }
    public JasTextPane getTextArea() {
	return latexCode;
    }

    public String generateLatexCode() {
	String latexCode;
	String prefix = generateLatexCodePrefix();
	String suffix = generatedLatexCodeSuffix();
	latexCode = prefix;
	latexCode += sDrawing.getLatexCode() + "\n";
	latexCode += suffix;
	return latexCode;
    }
    
    public String generateLatexCodePrefix() {
	String prefix;
	prefix = "% Generated by Jastex \n\n";
	
	prefix += "\\documentclass{article}\n";
	prefix += "\\usepackage[usenames]{color}";
	prefix += "% delete this line if you don't use colors\n";
	prefix += "\n";
	if (sDrawing.getSlide())
	    prefix += "\\usepackage[slide]{gastex}\n";
	else
	    prefix += "\\usepackage{gastex}\n";
	prefix += "\\begin{document}\n";
	prefix += "\n";
// 	prefix += "\\begin{picture}(200,200)\n";
// 	prefix += "\\put(0,0){\\framebox(200,200){}}\n";
	prefix +="\n";
	
	return prefix;
    }
	    
    public String generatedLatexCodeSuffix() {
	String suffix;
	suffix  = "\n";
	suffix += "\\end{picture}\n";
	suffix += "\\end{document}\n";
	return suffix;
    }

    public boolean isDrawingArea() {
	return (currentTab == 0);
    }

    public void initLanguage() {
	setTitleAt(0,Languages.tp_tab_names[Languages.TP_TAB_DRAW]);
	setToolTipTextAt(0,Languages.tp_tab_tooltips[Languages.TP_TAB_DRAW]);
	setTitleAt(1,Languages.tp_tab_names[Languages.TP_TAB_LATEX]);
	setToolTipTextAt(0,Languages.tp_tab_tooltips[Languages.TP_TAB_LATEX]);
    }


    public File getCurrentFile() {
	return currentFile;
    }
    public void setCurrentFile(File f) {
	currentFile = f;
    }

}
