package jastex.parsing;

import java.lang.*;
import java.util.Vector;
import jastex.old.obj.JasObject;
import jastex.old.obj.AEdge;
import jastex.old.obj.SimpleObjectE;
import jastex.old.gui.MainWindow;
import jastex.*;

public class parseTree {

    public boolean slide; // specify if slide options must be set
    public GastexGlobalProperties mainGGP; // the GGP before any object is created

    public double w;

    public double h; // picture parameters

    public double offx;

    public double offy;
    public String titleDoc; // doc title

    public Vector ggpVector; // all ggp of this picture

    public Vector jasobjectVector; // all jasObject created in this picture
                            // Note that object is in the order of thier creation
    // Note : not all actually. All with referencement
    // FIX ME : add in JasObject a method see below

    public parseTree(){}

    public parseTree(GastexGlobalProperties ggp){
	mainGGP=new GastexGlobalProperties(ggp);
	ggpVector=new Vector();
	jasobjectVector=new Vector();
    }

    public parseTree(GastexGlobalProperties ggp,String title){
	this(ggp);
	titleDoc=title;
    }

    public void addGGP(GastexGlobalProperties ggp){ ggpVector.add(ggp);}
    public void addObject(JasObject j){ jasobjectVector.add(j); }

    public void setSlide(boolean b){
	slide=b;
    }

    public void createDoc(MainWindow mw,boolean newtab){
	int sz;
	ObjetManager manager=mw.getManager();
	JasObject jo;
	
	// create a tab (multidoc)
	if(newtab){
	    mw.addDocument();
	    manager=mw.getManager();
	    mw.getMDI().setDocumentTitle(titleDoc);		
	}

	// slide option
	if(slide) manager.setSlide(true);

	// Initial Gasset Prop
	manager.resetProp();
	manager.addProp(mainGGP);

	// add ggpVector
	sz=ggpVector.size();
	for(int i=0;i<sz;i++)
	    manager.addProp((GastexGlobalProperties)(ggpVector.elementAt(i)));

	
	// add jasobject
	// contains those type :
	// ------------
	// Node
	// JasRectangle
	// Oval
	// ExtendedEdge
	// ExtendedQuad
	// ExtendedCubic
	// ------------
	// for this categorie , a manager.updateEdge(JasObject) is needed
	// ------------
	// Edge
	// BezierQuadCurve
	// BezierCubicCurve
	// Loop
	// ------------
	
	sz=jasobjectVector.size();
	for(int i=0;i<sz;i++){
	    jo=(JasObject)(jasobjectVector.elementAt(i));
	    manager.addObject(jo);
	    if((jo instanceof AEdge) && !(jo instanceof SimpleObjectE)) manager.updateEdge((AEdge)jo); // doute
	    // sur le dernier cast AEdge
	}
	
    }
}
