package jastex.test;

import jastex.GastexGlobalProperties;
import jastex.gui.IEditable;
import jastex.obj.graph.FMark;
import jastex.obj.graph.RMark;
import jastex.obj.graph.StdEdge;
import jastex.obj.graph.StdNode;
import jastex.gui.JasDrawingArea;
import jastex.gui.JasObjectToolBox;

/*
 * JFrameTest.java
 *
 * Created on 22 mars 2005, 09:46
 */

/**
 *
 * @author  sglondu
 */
public class JFrameTest extends javax.swing.JFrame {
    
    public JasDrawingArea jDrawingArea;
    public JasObjectToolBox tb;
    StdNode n0, n1;
    StdEdge e0;
    RMark m0;
    FMark fi0;
    
    /** Creates new form JFrameTest */
    public JFrameTest() {
        initComponents();
        jDrawingArea = new JasDrawingArea();
        tb = new JasObjectToolBox(this, "Test");
        jDrawingArea.tb = tb;
        jPanelDrawing.add(jDrawingArea);
        setSize(800, 600);
        
        // double dpi = Toolkit.getDefaultToolkit().getScreenResolution();
        // jTextZoomFactor.setText(Double.toString(dpi/25.4));
        
        GastexGlobalProperties ggp = jDrawingArea.ggp;
        n0 = new StdNode(ggp, 64, 64);
        n1 = new StdNode(ggp, 128, 128);
        m0 = new RMark(ggp, n0, 2);
        n0.rMarks.add(m0);
        fi0 = new FMark(ggp, n0, false);
        n0.fiMarks.add(fi0);
        e0 = new StdEdge(ggp, n0, n1, 8);
        jDrawingArea.jasVector.add(n0);
        jDrawingArea.jasVector.add(n1);
        jDrawingArea.jasVector.add(e0);
        jButtonZoomActionPerformed(null);
        jComboSelected.addItem(null);
        jComboSelected.addItem(n0);
        jComboSelected.addItem(n1);
        jComboSelected.addItem(e0);
        
        jDrawingArea.editableObjects.add(n0);
        jDrawingArea.editableObjects.add(n1);
        jDrawingArea.editableObjects.add(e0);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanelControls = new javax.swing.JPanel();
        jTextZoomFactor = new javax.swing.JTextField();
        jButtonZoom = new javax.swing.JButton();
        jComboSelected = new javax.swing.JComboBox();
        jPanelDrawing = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Test nouveau JasTeX");
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jTextZoomFactor.setText("4");
        jTextZoomFactor.setMinimumSize(new java.awt.Dimension(50, 25));
        jTextZoomFactor.setPreferredSize(new java.awt.Dimension(50, 25));
        jTextZoomFactor.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextZoomFactorKeyPressed(evt);
            }
        });

        jPanelControls.add(jTextZoomFactor);

        jButtonZoom.setText("Zoom");
        jButtonZoom.setMaximumSize(new java.awt.Dimension(100, 25));
        jButtonZoom.setMinimumSize(new java.awt.Dimension(100, 25));
        jButtonZoom.setPreferredSize(new java.awt.Dimension(100, 25));
        jButtonZoom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZoomActionPerformed(evt);
            }
        });

        jPanelControls.add(jButtonZoom);

        jComboSelected.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboSelectedActionPerformed(evt);
            }
        });

        jPanelControls.add(jComboSelected);

        jSplitPane1.setLeftComponent(jPanelControls);

        jPanelDrawing.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setRightComponent(jPanelDrawing);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void jComboSelectedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboSelectedActionPerformed
        // TODO add your handling code here:
        jDrawingArea.selEditable = (IEditable)jComboSelected.getSelectedItem();
        jDrawingArea.repaint();
    }//GEN-LAST:event_jComboSelectedActionPerformed

    private void jTextZoomFactorKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextZoomFactorKeyPressed
        // TODO add your handling code here:
        if (evt.getKeyCode() == evt.VK_ENTER) jButtonZoomActionPerformed(null);
    }//GEN-LAST:event_jTextZoomFactorKeyPressed

    private void jButtonZoomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomActionPerformed
        // TODO add your handling code here:
        try {
            jDrawingArea.zoomFactor = Float.parseFloat(jTextZoomFactor.getText());
            jDrawingArea.repaint();
        } catch (NumberFormatException e) {
            jTextZoomFactor.setText(Double.toString(jDrawingArea.zoomFactor));
        }
    }//GEN-LAST:event_jButtonZoomActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JFrameTest().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonZoom;
    private javax.swing.JComboBox jComboSelected;
    private javax.swing.JPanel jPanelControls;
    private javax.swing.JPanel jPanelDrawing;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTextField jTextZoomFactor;
    // End of variables declaration//GEN-END:variables
    
}
